package tofly.revenue.code_gen;

import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.config.OutputFile;
import com.baomidou.mybatisplus.generator.config.rules.DbColumnType;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;

import java.sql.Types;
import java.util.Collections;

public class UdbMain {

    public static void main(String[] args) {
//        String url = "jdbc:postgresql://192.168.2.225:5432/thingskit";
//        String username = "postgres";
//        String password = "example";
        String url = "jdbc:oracle:thin:@192.168.2.23:1521/orcl?currentSchema=TF_DCSW_UDB";
        String username = "TF_DCSW_UDB";
        String password = "TF_DCSW_UDB";
        FastAutoGenerator.create(url, username, password)
                .globalConfig(builder -> {
                    builder.author("decai") // 设置作者
                            .enableSwagger() // 开启 swagger 模式
                            .fileOverride() // 覆盖已生成文件
                            .outputDir("java"); // 指定输出目录
                })
                .dataSourceConfig(builder ->
                        builder.schema("TF_DCSW_UDB").typeConvertHandler((globalConfig, typeRegistry, metaInfo) -> {
                            int typeCode = metaInfo.getJdbcType().TYPE_CODE;
                            int length = metaInfo.getLength();
                            int scale = metaInfo.getScale();
                            boolean nullable = metaInfo.isNullable();
                            if (typeCode == Types.DECIMAL) {
                                if (length == 0) {
                                    return nullable ? DbColumnType.LONG : DbColumnType.BASE_LONG;
                                }
                                if (scale > 0) {
                                    return nullable ? DbColumnType.DOUBLE : DbColumnType.BASE_DOUBLE;
                                }
                                // 自定义类型转换
                                return nullable ? DbColumnType.INTEGER : DbColumnType.BASE_INT;
                            }
                            if (typeCode == Types.TIMESTAMP) {
                                // 自定义类型转换
                                return DbColumnType.DATE;
                            }
                            return typeRegistry.getColumnType(metaInfo);

                        }))
                .packageConfig(builder -> {
                    builder.parent("com.tofly.feesapi.udb") // 设置父包名
                            .moduleName("smpn") // 设置父包模块名
                            //.moduleName("yhgl") // 设置父包模块名
                            //.moduleName("bjgl") // 设置父包模块名
                            .pathInfo(Collections.singletonMap(OutputFile.xml, "resources/udb/smpn")); // 设置mapperXml生成路径
                })
                .strategyConfig(builder -> {
                    builder.controllerBuilder()
                            .enableRestStyle()
                            .enableFileOverride();

                    builder.entityBuilder()
                            .enableLombok()
                            .convertFileName(entityName -> entityName)
                            .enableColumnConstant()
                            .enableFileOverride();

                    builder.mapperBuilder().enableFileOverride();

                    builder.serviceBuilder().enableFileOverride();


                    builder.addInclude("TF_SMPN_COMPANY_X") // 设置需要生成的表名
                            .addTablePrefix("TF_SMPN_").addTableSuffix("_X"); // 设置过滤表前缀
                })
                .templateEngine(new FreemarkerTemplateEngine()) // 使用Freemarker引擎模板，默认的是Velocity引擎模板
                .execute();
    }
}
