package com.tofly.feesapi.bjgl.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.entity.YhCbkxx2;
import com.tofly.feesapi.bjgl.entity.YhDaCbkxxSelect;
import com.tofly.feesapi.bjgl.entity.dto.*;
import com.tofly.feesapi.bjgl.entity.vo.YhCbkxxSelect2;
import com.tofly.feesapi.bjgl.entity.vo.YhCbkxxView;
import com.tofly.feesapi.bjgl.entity.vo.YhHbUpdate;
import com.tofly.feesapi.bjgl.mapper.YhCbkxxMapper;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.constant.CbbzEnum;
import com.tofly.feesapi.common.constant.JsbzEnum;
import com.tofly.feesapi.common.constant.ShbzEnum;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.mapper.YhKhjbxxMapper;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import com.tofly.feesapi.znbgl.service.ZnbDaLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

@RestController
@AllArgsConstructor
@RequestMapping("api/bjgl/yhcbkxx")
@Api(tags = "水表档案-水表档案")
public class YhCbkxxController {

    private final YhCbkxxService yhCbkxxService;
    private final YhCbkxxMapper yhCbkxxMapper;

    private final YhKhjbxxService yhKhjbxxService;

    private final YhKhjbxxMapper yhKhjbxxMapper;

    private final YyCblrService yyCblrService;

    private final ZnbDaLogService znbDaLogService;

    @ApiOperationSupport(order = 5)
    @GetMapping("/page")
    @ApiOperation(value = "查询普表水表档案（分页）", tags = {"抄表序号调整", "批量设置水价", "用户换表"})
    public ResultRespone<PageResult<YhCbkxxSelect2>> getPage(@ModelAttribute PageDto pageDto, @ModelAttribute YhCbkxxFilter filter) {
        return ResultRespone.success(yhCbkxxService.getPage(pageDto, filter, List.of("0")));
    }

    @ApiOperationSupport(order = 6)
    @GetMapping("/page2")
    @ApiOperation(value = "查询智能表水表档案（分页）", tags = {"智能表阀控管理"})
    public ResultRespone<PageResult<YhCbkxxSelect2>> getPage2(@ModelAttribute PageDto pageDto, @ModelAttribute YhCbkxxFilter filter) {
        return ResultRespone.success(yhCbkxxService.getPage(pageDto, filter, List.of("2", "3")));
    }


    @GetMapping("/{yhbh}")
    @ApiOperation(value = "查看水表档案", tags = {"综合查询"})
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String")
    })
    public ResultRespone<YhCbkxxView> getById(@PathVariable("yhbh") String yhbh) {
        return ResultRespone.success(yhCbkxxService.getViewById(yhbh));
    }

    @GetMapping("/{yhbh}/{cbkh}")
    @ApiOperation(value = "水表-用户编号、抄表卡号查看")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String"),
            @ApiImplicitParam(name = "cbkh", value = "抄表卡号", required = true, dataType = "String")
    })
    public ResultRespone getDaMeter(@PathVariable("yhbh") String yhbh, @PathVariable("cbkh") String cbkh) {

        YhCbkxx2 yhCbkxx2 = yhCbkxxMapper.SelectYhcbkxx(yhbh, cbkh);

        return ResultRespone.success(yhCbkxx2);
    }


    @GetMapping("/hbgl/{yhbh}/{cbkh}")
    @ApiOperation(value = "换表-用户编号、抄表卡号查看")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String"),
            @ApiImplicitParam(name = "cbkh", value = "抄表卡号", required = true, dataType = "String")
    })
    public ResultRespone getDaMeter2(@PathVariable("yhbh") String yhbh, @PathVariable("cbkh") String cbkh) {

        YhDaCbkxxSelect yhDaCbkxxSelect = yhCbkxxMapper.SelectYhdaSbda(yhbh, cbkh);
        return ResultRespone.success(yhDaCbkxxSelect);
    }


    @GetMapping("/hbgl/page")
    @ApiOperation(value = "换表page分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", required = false, dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", required = false, dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", required = false, dataType = "String")
    })
    public ResultRespone getDaCustomerPage(Page page, String sscbpq, String sscbb, String searchText) {
        //自定义查询用户档案
        //用户编号、用户姓名、用户地址、联系电话
        //片区、抄表本、水表型号、用水性质、用户状态、是否垃圾费、建档日期、抄表人员
        IPage<YhDaCbkxxSelect> yhdaPage = yhCbkxxMapper.getYhdaSbdaPage(page, sscbpq, sscbb, searchText);
        return ResultRespone.success(yhdaPage);
    }


    @ToFlyAppLog(title = "新增用户表计信息")
    @ApiOperation(value = "新增用户表计信息")
    @Transactional(rollbackFor = Exception.class)
    @PostMapping
    public ResultRespone save(@RequestBody YhCbkxx yhCbkxx,
                              @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        //水表类别不等于卡表时才添加抄表计划
        if (yhCbkxx.getSblb() != "1") {
            //查询当前用户的用户档案实体
            YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(yhCbkxx.getYhbh());

//            int count = yhKhjbxxMapper.selectExistCbkxx(yhCbkxx.getYhbh());
//            if (count > 0) {
//                return ResultRespone.failed("禁止添加多只水表");
//            }

            //region 抄表计划实体赋值
            //抄表计划添加
            YyCblr yyCblr = new YyCblr();

            yyCblr.setYhbh(yhKhjbxx.getYhbh());
            yyCblr.setCbkh(yhCbkxx.getCbkh());
            yyCblr.setCbkid(yhCbkxx.getCbkid());

            //财务日期
            Map<String, Object> mapcwrq = yhKhjbxxMapper.selectCwrq();//获取财务日期
            String strcwrq = mapcwrq.get("cwrq").toString();//202305
            // String strYearMonth = SysConfigUtils.getBillYearMonth("1");

            yyCblr.setCwrq(strcwrq);

            yyCblr.setJsbz(JsbzEnum.未算费);
            yyCblr.setJfzt("1");
            yyCblr.setCbbz(CbbzEnum.未抄表);
            yyCblr.setShbz(ShbzEnum.未审核);
            yyCblr.setSsgs(yhKhjbxx.getSsgs());
            yyCblr.setSscbpq(yhKhjbxx.getSscbpq());
            yyCblr.setSscbb(yhKhjbxx.getSscbb());
            yyCblr.setXbqd(BigDecimal.valueOf(yhCbkxx.getSbqs()));
            //endregion

            if (yyCblrService.save(yyCblr) && yhCbkxxService.save(yhCbkxx)) {
                if (yhCbkxx.getSblb().equals("2") || yhCbkxx.getSblb().equals("3")) {
                    if (znbDaLogService.addznbDaLog(yhKhjbxx, yhCbkxx, "0", czyUserDetails)) {
                        return ResultRespone.success(true);
                    } else {
                        return ResultRespone.failed("智能表档案记录添加失败！");
                    }
                } else {
                    return ResultRespone.success(true);
                }
            } else {
                return ResultRespone.failed("添加失败！");
            }
        } else {
            return ResultRespone.success(yhCbkxxService.save(yhCbkxx));
        }
    }


    @ApiOperationSupport(order = 6)
    @ApiOperation(value = "修改水表档案")
    @PutMapping
    public ResultRespone<Boolean> update(@RequestBody YhCbkxx yhCbkxx,
                                         @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        QueryWrapper<YhCbkxx> queryWrapper = new QueryWrapper<>();
        if (StringUtils.isBlank(yhCbkxx.getCbkh()) || StringUtils.isBlank(yhCbkxx.getYhbh())) {
            return ResultRespone.failed("修改失败，cbkh或yhbh不能为空！");
        } else {
            queryWrapper.eq("yhbh", yhCbkxx.getYhbh()).and(i -> i.eq("cbkh", yhCbkxx.getCbkh()));
        }
        YhCbkxx oldyhCbkxx = yhCbkxxService.getOne(queryWrapper);
        if (!oldyhCbkxx.getSblb().equals(yhCbkxx.getSblb())) {
            return ResultRespone.failed("修改失败，不能修改水表类型！");
        }
        if (yhCbkxxService.update(yhCbkxx, queryWrapper)) {
            if (yhCbkxx.getSblb().equals("2") || yhCbkxx.getSblb().equals("3")) {
                YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(yhCbkxx.getYhbh());
                if (znbDaLogService.addznbDaLog(yhKhjbxx, yhCbkxx, "1", czyUserDetails)) {
                    return ResultRespone.success(true);
                } else {
                    return ResultRespone.failed("添加智能表档案记录失败！");
                }
            } else {
                return ResultRespone.success(true);
            }
        }
        return ResultRespone.failed("修改水表档案失败！");
    }

    @ApiOperationSupport(order = 8)
    @ToFlyAppLog(title = "删除水表档案")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "用户编号", required = true)
    })
    @DeleteMapping("/{id}")
    public ResultRespone<Boolean> delById(@PathVariable String id,
                                          @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.delById(id, czyUserDetails));
    }

    @ApiOperationSupport(order = 9)
    @ApiOperation(value = "批量删除水表档案")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "用户编号，多个以逗号隔开", required = true)
    })
    @DeleteMapping("/delByIds")
    public ResultRespone<Boolean> delByIds(@RequestParam String ids,
                                           @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.delByIds(Arrays.asList(ids.split(",")), czyUserDetails));
    }

    /**
     * 作废水表档案
     */
    @ApiOperationSupport(order = 20)
    @ToFlyAppLog(title = "作废水表档案")
    @ApiOperation(value = "作废水表档案")
    @PutMapping("/{yhbh}/disable")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "yhbh", required = true, dataType = "String")
    })
    public ResultRespone<Boolean> disable(@PathVariable("yhbh") String yhbh,
                                          @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.disable(yhbh, czyUserDetails));
    }

    /**
     * 恢复作废水表档案
     */
    @ApiOperationSupport(order = 21)
    @ApiOperation(value = "恢复作废水表档案")
    @PutMapping("/{yhbh}/enable")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "yhbh", required = true, dataType = "String")
    })
    public ResultRespone<Boolean> enable(@PathVariable("yhbh") String yhbh,
                                         @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.enable(yhbh, czyUserDetails));
    }

    @ApiOperationSupport(order = 26)
    @ApiOperation(value = "批量设置抄表序号", tags = "抄表序号调整")
    @PutMapping("/cbxh")
    public ResultRespone<Boolean> updateCbxh(@RequestBody YhCbkxxCbxhUpdate update,
                                             @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.updateCbxh(update, czyUserDetails));
    }

    @ApiOperationSupport(order = 27)
    @ApiOperation(value = "批量撤销抄表序号", tags = "抄表序号调整")
    @PutMapping("/cxcbxh")
    public ResultRespone<Boolean> cancelCbxh(@RequestBody YhCbkxxCbxhCancel cancel,
                                             @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.cancelCbxh(cancel, czyUserDetails));
    }

    @ApiOperationSupport(order = 27)
    @ApiOperation(value = "上下移动抄表序号", tags = "抄表序号调整")
    @PutMapping("/sxydcbxh")
    public ResultRespone<Boolean> sxydCbxh(@RequestBody YhCbkxxCbxhSxyd sxyd,
                                           @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.sxydCbxh(sxyd, czyUserDetails));
    }

    @ApiOperationSupport(order = 28)
    @ApiOperation(value = "批量设置水价禁用", tags = "批量设置水价禁用")
    @PutMapping("/sj")
    public ResultRespone<Boolean> updateSj(@RequestBody YhCbkxxSjUpdate update,
                                           @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.updateSj(update, czyUserDetails));
    }

    @ApiOperationSupport(order = 29)
    @ApiOperation(value = "批量设置水价", tags = "批量设置水价")
    @PutMapping("/plsz_sj")
    public ResultRespone<Boolean> updatePlSzSj(@RequestBody YhCbkxxSjUpdate update,
                                               @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        for (YhCbkxxSjUpdateItem yhbhcbkhs : update.getYhbhcbkhs()) {
            String yhbh = yhbhcbkhs.getYhbh();

        }
        return ResultRespone.success(yhCbkxxService.updateSj(update, czyUserDetails));
    }

    @ApiOperationSupport(order = 30)
    @ApiOperation(value = "用户换表", tags = "用户换表")
    @PutMapping("/hb")
    public ResultRespone<Boolean> hb(@RequestBody YhHbUpdate update,
                                     @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhCbkxxService.hb(update, czyUserDetails));
    }
}
