/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.bjgl.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.bjgl.entity.YhCbkxxLog;
import com.tofly.feesapi.bjgl.service.YhCbkxxLogService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 水表档案日志记录表
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("api/bjgl/yhcbkxxlog")
@Api(tags="水表档案-水表档案日志记录表接口")
public class YhCbkxxLogController {

    private final  YhCbkxxLogService yhCbkxxLogService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param yhCbkxxLog 水表档案日志记录表
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getYhCbkxxLogPage(Page page, @ModelAttribute YhCbkxxLog yhCbkxxLog) {
      return ResultRespone.success(yhCbkxxLogService.page(page, Wrappers.query(yhCbkxxLog)));
    }


    /**
     * 通过id查询水表档案日志记录表
     * @param ljfbz id
     * @return ResultRespone
     */
    @GetMapping("/{ljfbz}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ljfbz", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("ljfbz" ) String ljfbz) {
      return ResultRespone.success(yhCbkxxLogService.getById(ljfbz));
    }

    /**
     * 新增水表档案日志记录表
     * @param yhCbkxxLog 水表档案日志记录表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增水表档案日志记录表" )
    @ApiOperation(value = "新增水表档案日志记录表")
    @PostMapping
    public ResultRespone save(@RequestBody YhCbkxxLog yhCbkxxLog) {
      return ResultRespone.success(yhCbkxxLogService.save(yhCbkxxLog));
    }

    /**
     * 修改水表档案日志记录表
     * @param yhCbkxxLog 水表档案日志记录表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改水表档案日志记录表" )
    @ApiOperation(value = "修改水表档案日志记录表")
    @PutMapping
    public ResultRespone updateById(@RequestBody YhCbkxxLog yhCbkxxLog) {
      return ResultRespone.success(yhCbkxxLogService.updateById(yhCbkxxLog));
    }

    /**
     * 通过id删除水表档案日志记录表
     * @param ljfbz id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除水表档案日志记录表" )
    @ApiOperation(value = "通过ID删除水表档案日志记录表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ljfbz", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{ljfbz}" )
    public ResultRespone removeById(@PathVariable String ljfbz) {
      return ResultRespone.success(yhCbkxxLogService.removeById(ljfbz));
    }

    /**
     * 通过id批量删除水表档案日志记录表
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除水表档案日志记录表" )
    @ApiOperation(value = "通过ID批量删除水表档案日志记录表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yhCbkxxLogService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
