/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.bjgl.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.bjgl.entity.YkHbLog;
import com.tofly.feesapi.bjgl.entity.YkHblogExcel;
import com.tofly.feesapi.bjgl.service.YkHbLogService;
import com.tofly.feesapi.bmgl.entity.BmSblb;
import com.tofly.feesapi.bmgl.entity.BmSbsccj;
import com.tofly.feesapi.bmgl.mapper.BmSblbMapper;
import com.tofly.feesapi.bmgl.mapper.BmSbsccjMapper;
import com.tofly.feesapi.bmgl.mapper.BmSbxhMapper;
import com.tofly.feesapi.bmgl.service.BmSblbService;
import com.tofly.feesapi.common.Excel.ExcleFileUtil;
import com.tofly.feesapi.yhgl.entity.YhhLog;
import com.tofly.feesapi.yhgl.entity.vo.YhkhjbxxSelect2;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.security.core.parameters.P;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 换表（含普表换表）
 *
 * @author sxb
 * @date Mon Mar 04 00:00:00 CST 2024
 */
@RestController
@AllArgsConstructor
@RequestMapping("api/yhgl/ykhblog")
@Api(tags="水表档案-换表（含普表换表）日志接口")
public class YkHbLogController {

    private final  YkHbLogService ykHbLogService;

    private  final BmSblbService bmSblbService;
    private  final BmSblbMapper bmSblbMapper;
    private  final BmSbxhMapper bmSbxhMapper;
    private  final BmSbsccjMapper bmSbsccjMapper;

    /**
    * 分页查询
    * @param page 分页对象
    * @param
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "ksrq", value = "开始时间", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束时间", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(编号、姓名、电话、地址)", dataType = "String")
    })
    public ResultRespone getYkHbLogPage(Page page, String ksrq, String jsrq, String searchText) {
        // 遍历查询结果进行赋值
        QueryWrapper<YkHbLog> queryWrapper = SelectHbLog( ksrq, jsrq, searchText);
        IPage<YkHbLog> YkHbPage = ykHbLogService.page(page,queryWrapper);
        // 遍历查询结果进行赋值
        List<YkHbLog> YkHbList = YkHbPage.getRecords();
        for (YkHbLog Hb : YkHbList) {
          if(Hb.getNewSbcj()!=""&&Hb.getNewSbcj()!=null)
          {
              Hb.setNewSbcj(bmSbsccjMapper.selectName(Hb.getNewSbcj()).getName());
          }
          if(Hb.getOldSbcj()!=""&&Hb.getOldSbcj()!=null)
          {
              Hb.setOldSbcj(bmSbsccjMapper.selectName(Hb.getOldSbcj()).getName());
          }
          if(Hb.getOldSblb()!=""&&Hb.getOldSblb()!="")
          {
              Hb.setOldSblb(bmSblbMapper.selectName(Hb.getOldSblb()).getName());
          }
          if(Hb.getNewSblb()!=""&&Hb.getNewSblb()!=null)
          {
              Hb.setNewSblb(bmSblbMapper.selectName(Hb.getNewSblb()).getName());
          }
          if(Hb.getOldSbxh()!=""&&Hb.getOldSbxh()!=null)
          {
              Hb.setOldSbxh(bmSbxhMapper.selectName(Hb.getOldSbxh()).getName());
          }
          if(Hb.getNewSbxh()!=""&& Hb.getNewSbxh()!=null)
          {
              Hb.setNewSbxh(bmSbxhMapper.selectName(Hb.getNewSbxh()).getName());
          }

        }


      return ResultRespone.success(YkHbPage);

    }

    @GetMapping("/export")
    @ApiOperation(value = "export导出")
    @ApiImplicitParams({

            @ApiImplicitParam(name = "ksrq", value = "开始时间", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束时间", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(编号、姓名、电话、地址)", dataType = "String")
    })
    public void export(HttpServletResponse response,String ksrq, String jsrq, String searchText) throws IOException {
        // 遍历查询结果进行赋值
        QueryWrapper<YkHbLog> queryWrapper = SelectHbLog( ksrq, jsrq, searchText);
        // 遍历查询结果进行赋值
        List<YkHbLog> list = ykHbLogService.list(queryWrapper);



        //导出excle
        ExcleFileUtil.exportExcel(response, list, YkHbLog.class, "用户换表.xlsx");
    }

    private QueryWrapper<YkHbLog> SelectHbLog( String ksrq, String jsrq, String searchText) {
        QueryWrapper<YkHbLog> queryWrapper = new QueryWrapper<>();

        queryWrapper.eq("1", 1);
        if (!StringUtils.isEmpty(ksrq) && !StringUtils.isEmpty(jsrq)) {
            queryWrapper.and(i -> i.apply("hbrq BETWEEN to_date({0},'yyyy-mm-dd hh24:mi:ss') AND to_date({1},'yyyy-mm-dd hh24:mi:ss')", ksrq, jsrq));
        }
        if (!StringUtils.isEmpty(searchText)) {
            queryWrapper.like("yhbh", searchText)
                    .or()
                    .like("yhdz", searchText)
                    .or()
                    .like("lxdh", searchText)
                    .or()
                    .like("yhxm", searchText);
        }

        return queryWrapper;
    }

    private QueryWrapper<YkHbLog> SelectHbLogPage( String ksrq, String jsrq, String searchText) {
        QueryWrapper<YkHbLog> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("1", 1);
        if (!StringUtils.isEmpty(ksrq) && !StringUtils.isEmpty(jsrq)) {
            queryWrapper.and(i -> i.apply("hbrq BETWEEN to_date({0},'yyyy-mm-dd hh24:mi:ss') AND to_date({1},'yyyy-mm-dd hh24:mi:ss')", ksrq, jsrq));
        }
        if (!StringUtils.isEmpty(searchText)) {
            queryWrapper.like("yhbh", searchText)
                    .or()
                    .like("yhdz", searchText)
                    .or()
                    .like("lxdh", searchText)
                    .or()
                    .like("yhxm", searchText);
        }
        return queryWrapper;
    }
    /**
     * 通过id查询换表（含普表换表）
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(ykHbLogService.getById(id));
    }

    /**
     * 新增换表（含普表换表）
     * @param ykHbLog 换表（含普表换表）
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增换表（含普表换表）" )
    @ApiOperation(value = "新增换表（含普表换表）")
    @PostMapping
    public ResultRespone save(@RequestBody YkHbLog ykHbLog) {
      return ResultRespone.success(ykHbLogService.save(ykHbLog));
    }

    /**
     * 修改换表（含普表换表）
     * @param ykHbLog 换表（含普表换表）
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改换表（含普表换表）" )
    @ApiOperation(value = "修改换表（含普表换表）")
    @PutMapping
    public ResultRespone updateById(@RequestBody YkHbLog ykHbLog) {
      return ResultRespone.success(ykHbLogService.updateById(ykHbLog));
    }

    /**
     * 通过id删除换表（含普表换表）
     * @param id id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除换表（含普表换表）" )
    @ApiOperation(value = "通过ID删除换表（含普表换表）")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(ykHbLogService.removeById(id));
    }

    /**
     * 通过id批量删除换表（含普表换表）
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除换表（含普表换表）" )
    @ApiOperation(value = "通过ID批量删除换表（含普表换表）")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(ykHbLogService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
