package com.tofly.feesapi.bjgl.controller_easy;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.common.BaseController;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.enums.SysEnum;
import com.tofly.feesapi.common.model.PageLink;
import com.tofly.feesapi.common.BaseController;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.model.PageLink;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.text.MessageFormat;

import static com.tofly.feesapi.common.ControllerConstants.*;
import static com.tofly.feesapi.common.ControllerConstants.PAGE_NUMBER_PARA_NAME;


/**
 * 水表档案简易处理类
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/meterprofilemgt/dameter")
@Api(tags = "水表档案-用户表计信息接口(easy)")
public class DaMeterEasyController extends BaseController {

    @ApiOperation(value = "通过用户编号查询水表档案列表")
    @PostMapping("/getMeterListByCustomerNo")
    public ResultRespone getMeterListByCustomerNo(@ApiParam(value = "用户编号", required = true) @RequestParam String yhbh) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        PageLink pg = createPageLink(20, 1);

        String strSql = String.format("select yhbh,cbkh,cbkid,sblb,b.name as sblbmc,a.sbsccj,c.name as sbsccjmc"
                + ",sbxh,d.name as sbxhmc,sbccrq,sbbh,ybdjbz"
                + ",lgysbz,sjbm,slbl,sjbm1,slbl1,sjbm2,slbl2,"
                + "jfzt,(case when jfzt='1' then '正常' when jfzt='2' then '停用' else '' end) jfztmc"
                + ",cbpl,sbqs,sbkj,sblc,jddj,bjwz,kkbz"
                + ",kkrq,ssfm,ickid,ljfbz,ljfje,wsfbz,a.bz,a.czryxm,a.czrybm,a.czsj,ljffs"
                + " from yh_cbkxx a "
                + "left join bm_sblb b on a.sblb=b.code "
                + "left join bm_sbsccj c on a.sbsccj=c.code "
                + "left join bm_sbxh d on a.sbxh=d.code  "
                + "where yhbh='%s' order by cbkh", yhbh);
        Object obj = db.getPage(pg, strSql, SysEnum.MyBatis.getName());
       // String objString = String.valueOf(obj); // 将对象转换为字符串
        //String lowerCaseObjString = objString.toLowerCase(); // 将字符串转换为小写
        return ResultRespone.success(obj);
    }
}
