package com.tofly.feesapi.bjgl.controller_easy;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.entity.YkHbLog;
import com.tofly.feesapi.bjgl.mapper.YhCbkxxMapper;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.bjgl.service.YkHbLogService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.BaseController;
import com.tofly.feesapi.common.constant.CbbzEnum;
import com.tofly.feesapi.common.constant.JsbzEnum;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.dbhelper.PageSortHelper;
import com.tofly.feesapi.common.enums.SysEnum;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.common.model.PageLink;

import com.tofly.feesapi.common.util.GuidGenerator;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.text.MessageFormat;
import java.util.Date;

import static com.tofly.feesapi.common.ControllerConstants.*;
import static com.tofly.feesapi.common.ControllerConstants.SORT_ORDER_ALLOWABLE_VALUES;

/**
 * 水表更换简易处理类
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/meterprofilemgt/ykYhbgHb")
@Api(tags = "水表档案-用户水表更换接口(easy)")
public class ykYhbgHbEasyController extends BaseController {

    private final YhCbkxxService yhCbkxxService;
    private final YhCbkxxMapper yhCbkxxMapper;
    private  final YkHbLogService ykYhbgLogService;
    private final YyCblrService yyCblrService;
    
    
    @ApiOperation(value = "水表更换数据列表接口")
    @PostMapping("/getMeterListForChange")
    public ResultRespone getMeterListForChange(
            @ApiParam(value = "所属公司") @RequestParam(required = false) String ssgs,
            @ApiParam(value = "所属片区") @RequestParam(required = false) String sscbpq,
            @ApiParam(value = "所属表册") @RequestParam(required = false) String sscbb,
            @ApiParam(value = "关键字（用户编号、姓名、地址、电话）") @RequestParam(required = false) String searchText,
            @ApiParam(value = PAGE_SIZE_DESCRIPTION, required = true, defaultValue = "10") @RequestParam(value = PAGE_SIZE_PARA_NAME, required = true) int pageSize,
            @ApiParam(value = PAGE_NUMBER_DESCRIPTION, required = true, defaultValue = "1") @RequestParam(value = PAGE_NUMBER_PARA_NAME, required = true) int page,
            @ApiParam(value = SORT_PROPERTY_DESCRIPTION) @RequestParam(required = false) String sortProperty,
            @ApiParam(value = SORT_ORDER_DESCRIPTION, allowableValues = SORT_ORDER_ALLOWABLE_VALUES) @RequestParam(required = false) String sortOrder)
            throws Exception {

        //region 分页、排序
        DbHelper db = DbHelper.getDbHelper();
        PageLink pg = createPageLink(pageSize, page);

        //tring strOrder = StringUtils.isBlank(sortProperty) ? "a.yhbh asc" : sortProperty + " " + sortOrder;

        String[] arrExcludeColumns = {
                "y_sblb", "y_sbccj", "y_sbxh", "y_sbccrq", "y_sbkj"
                , "y_sbbh", "y_sblc", "y_bcds", "y_scds"
        };
        String strOrder = PageSortHelper.setPageSort(sortProperty, sortOrder, arrExcludeColumns);

        //endregion
        if (StringUtils.isBlank(sortProperty)) {
            strOrder= "a.yhbh asc";
        }
        //region 查询条件
        String strWhere = "";
        //所属公司
        if (!StringUtils.isBlank(ssgs)) {
            strWhere += String.format(" and a.ssgs='%s'", ssgs);
        }
        //所属片区
        if (!StringUtils.isBlank(sscbpq)) {
            strWhere += String.format(" and a.sscbpq='%s'", sscbpq);
        }
        //所属表册
        if (!StringUtils.isBlank(sscbb)) {
            strWhere += String.format(" and a.sscbb='%s'", sscbb);
        }
        //关键字
        if (!StringUtils.isBlank(searchText)) {
            strWhere += MessageFormat.format("and (a.yhbh like ''%{0}%'' or a.yhxm like ''%{0}%'' "
                    + "or a.yhdz like ''%{0}%'' or a.lxdh like ''%{0}%'')", searchText);
        }
        //endregion

        //region 查询数据
        String strSql = MessageFormat.format("SELECT\n" +
                "\ta.yhbh,\n" +
                "\tb.cbkh,\n" +
                "\tb.cbkid,\n" +
                "\tyhxm,\n" +
                "\tyhdz,\n" +
                "\tlxdh,\n" +
                "\tsblb AS \"old_sblb\",\n" +
                "\tsbsccj AS \"old_sbsccj\",\n" +
                "\tsbxh AS \"old_sbxh\",\n" +
                "\tsbccrq AS \"old_sbccrq\",\n" +
                "\tsbkj AS \"old_sbkj\",\n" +
                "\tsbbh AS \"old_sbbh\",\n" +
                "\tsblc AS \"old_sblc\",\n" +
                "\tnvl(bcds,0) AS \"old_sbds\",\n" +
                "\tnvl(scds, 0) AS \"old_sbqs\"\n" +
                "FROM\n" +
                "\tYH_CBKXX b\n" +
                "LEFT JOIN YH_KHJBXX a ON\n" +
                "\tb.YHBH = a.YHBH\n" +
                "LEFT JOIN YY_CBLR c ON\n" +
                "\tb.CBKID = c.CBKID\n" +
                "\tWHERE a.YHZT IN(0,1,2)" +
                " {0} order by {1}", strWhere, strOrder);

        Object obj = db.getPage(pg, strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
        //endregion
    }

    @ApiOperation(value = "水表更换数据存储")
    @PostMapping("/saveMeterChange")
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public ResultRespone saveMeterChange(@RequestBody YkHbLog log)

            throws Exception {

        //region 必填验证
        String strNewMeterType = log.getNewSblb();
        if (StringUtils.isBlank(strNewMeterType)) {
            return ResultRespone.failed("「新表类别」不能为空！");
        }

        String strNewMeterFactory = log.getNewSbcj();
        if (StringUtils.isBlank(strNewMeterFactory)) {
            return ResultRespone.failed("「新表厂家」不能为空！");
        }

        String strNewMeterModel = log.getNewSbxh();
        if (StringUtils.isBlank(strNewMeterModel)) {
            return ResultRespone.failed("「新表型号」不能为空！");
        }

        String strNewMeterCaliber = log.getNewSbcj();
        if (StringUtils.isBlank(strNewMeterCaliber)) {
            return ResultRespone.failed("「新表口径」不能为空！");
        }

        String meterCardId = log.getCbkh().toString();
        if (StringUtils.isBlank(meterCardId)) {
            return ResultRespone.failed("「抄表卡号」不能为空！");
        }
        String yhbh = log.getYhbh();
        if (StringUtils.isBlank(yhbh)) {
            return ResultRespone.failed("「用户编号」不能为空！");
        }
        String cbkh = log.getCbkh().toString();
        if (StringUtils.isBlank(cbkh)) {
            return ResultRespone.failed("「抄表卡号」不能为空！");
        }
        //endregion

        //region 数据存储
        Date dtNow = new Date();

        //换表记录，依次为：录入时间
        log.setId(GuidGenerator.getGuid().substring(0, 8));
        log.setLrrq(dtNow);

        //水表档案更新，依次为：水表编号、水表类别、水表厂家、水表型号、水表口径、水表量程、出厂日期
        String cbkid = log.getCbkid();
        YhCbkxx yhCbkxx = yhCbkxxService.getById(cbkid);
        if (yhCbkxx == null) ResultRespone.failed("抄表卡不存在");
        yhCbkxx.setSbbh(log.getNewSbbh());
        yhCbkxx.setSblb(log.getNewSblb());
        yhCbkxx.setSbsccj(log.getNewSbcj());
        yhCbkxx.setSbxh(log.getNewSbxh());
        yhCbkxx.setSbkj(log.getNewSbkj());
        yhCbkxx.setSblc(log.getNewSblc());
        yhCbkxx.setSbccrq(log.getNewSbccrq());

        //更新抄表计划
        YyCblr yyCblr = yyCblrService.getById(cbkid);
        if (yhCbkxx == null) ResultRespone.failed("抄表录入不存在");
        yyCblr.setScds(log.getNewSbds());
        yyCblr.setBcds(log.getNewSbqs());
        yyCblr.setJbzd(log.getOldSbds());
        yyCblr.setXbqd(log.getNewSbqs());
        yyCblr.setCbbz(CbbzEnum.已抄表);
        yyCblr.setJsbz(JsbzEnum.未算费);
        yyCblr.setCbrq(dtNow);
        yyCblr.setLrrq(dtNow);
        yyCblr.setLrrybm(log.getLrry());
        yyCblr.setLrryxm(log.getLrryxm());

        yyCblr.setCblx("3");
       // yyCblr.setSl(ykYhbgHb.gets());
        QueryWrapper<YhCbkxx> queryWrapper = new QueryWrapper<YhCbkxx>();
        queryWrapper.eq("yhbh",log.getYhbh())
                .and(i->i.eq("cbkh",log.getCbkh()));
        QueryWrapper<YyCblr> queryWrapper_cblr = new QueryWrapper<YyCblr>();
        queryWrapper_cblr.eq("yhbh",log.getYhbh())
                .and(i->i.eq("cbkh",log.getCbkh()));
         if(ykYhbgLogService.save(log)&&yhCbkxxService.update(yhCbkxx,queryWrapper)&&yyCblrService.update(yyCblr,queryWrapper_cblr)) {
             return ResultRespone.success("操作成功！");
         }
         else {
             return ResultRespone.failed("操作失败！");
         }
//        //数据库存储处理
//        DbHelper db = DbHelper.getDbHelper();
//        //换表记录insert sql
//        db.addTransactionSql(ProduceSql.getInsertSql(ykYhbgLog, TableIdEnum.GUID));
//        //更新水表档案表sql
//        db.addTransactionSql(ProduceSql.getUpdateSql(yhCbkxx, "cbkh='" + ykYhbgLog.getCbkh() + "'"));
//        //更新抄表录入表sql
//        db.addTransactionSql(ProduceSql.getUpdateSql(yyCblr, "cbkh='" + ykYhbgLog.getCbkh() + "'"));
//
//        boolean isSuccess = db.executeTransaction();
//        String strMsg = isSuccess ? "换表信息保存成功！" : "错误：换表信息保存失败！";
//        return ResultRespone.success(isSuccess, strMsg);
        //endregion
    }
}

