package com.tofly.feesapi.bjgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.JfztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Date;

@Getter
@Setter
@ApiModel(value = "换表用户档案水表档案", description = "用户表计信息换表")
public class YhCbkxxHb implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户编号")
    @TableId(type = IdType.INPUT)
    private String yhbh;
    @ApiModelProperty("用户姓名")
    private String yhxm;
    @ApiModelProperty("用户地址")
    private String yhdz;
    @ApiModelProperty("联系电话")
    private String lxdh;
    @ApiModelProperty("抄表卡号")
    private String cbkh;
    @ApiModelProperty("换表人员名称")
    private String czrymc;
    @ApiModelProperty("换表人员编码")
    private String czrybm;
    @ApiModelProperty("换表日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private LocalDate hbrq;

    @ApiModelProperty("换表余额")
    private String hbye;
    @ApiModelProperty("备注")
    private String bz;

    //水表档案更新，依次为：水表编号、水表类别、水表厂家、水表型号、水表口径、水表量程、出厂日期



    @ApiModelProperty("新-水表类别(bm_sblb)")
    private String x_sblb;

    @ApiModelProperty("新-水表生产厂家(bm_sbsccj)")
    private String x_sbsccj;

    @ApiModelProperty("新-水表出厂日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date x_sbccrq;

    @ApiModelProperty("新-水表型号(bm_sbxh)")
    private String x_sbxh;

    @ApiModelProperty("新-水表口径(sys_child_code,pcid='12')")
    private String x_sbkj;

    @ApiModelProperty("新-水表编号")
    private String x_sbbh;

    @ApiModelProperty("新-水表量程(sys_child_code,pcid='13')")
    private String x_sblc;

    @ApiModelProperty("新-表计位置(sys_child_code,pcid='15')")
    private String x_bjwz;

    @ApiModelProperty("新-精度等级(sys_child_code,pcid='14')")
    private String x_jddj;

    @ApiModelProperty("旧-水表类别(bm_sblb)")
    private String j_sblb;

    @ApiModelProperty("旧-水表生产厂家(bm_sbsccj)")
    private String j_sbsccj;

    @ApiModelProperty("旧-水表出厂日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private LocalDate j_sbccrq;

    @ApiModelProperty("旧-水表型号(bm_sbxh)")
    private String j_sbxh;

    @ApiModelProperty("旧-水表口径(sys_child_code,pcid='12')")
    private String j_sbkj;

    @ApiModelProperty("旧-水表编号")
    private String j_sbbh;

    @ApiModelProperty("旧-水表量程(sys_child_code,pcid='13')")
    private String j_sblc;

    @ApiModelProperty("旧-表计位置(sys_child_code,pcid='15')")
    private String j_bjwz;

    @ApiModelProperty("旧-精度等级(sys_child_code,pcid='14')")
    private String j_jddj;

    @ApiModelProperty("新-水表起数（底数）")
    private BigDecimal x_sbqs;
    @ApiModelProperty("旧-水表止读")
    private BigDecimal j_sbzd;

}
