/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bjgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 水表档案日志记录表
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "YH_CBKXX_LOG", resultMap = "yhCbkxxLogMap")
@KeySequence("YH_CBKXX_LOG")
@ApiModel
public class YhCbkxxLog extends Model<YhCbkxxLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 垃圾费标志
     */
    @ApiModelProperty(value = "垃圾费标志")
    private String ljfbz;
    /**
     * IC 卡no
     */
    @ApiModelProperty(value = "IC 卡no")
    private String ickno;
    /**
     * 日志ID
     */
    @TableId(value = "log_Id", type = IdType.INPUT)
    @ApiModelProperty(value = "日志ID")
    private String logId;
    /**
     * 日志流水编号
     */
    @ApiModelProperty(value = "日志流水编号")
    private String logLsh;
    /**
     * 日志操作人员编码
     */
    @ApiModelProperty(value = "日志操作人员编码")
    private String logCzrybm;
    /**
     * 日志操作人员姓名
     */
    @ApiModelProperty(value = "日志操作人员姓名")
    private String logCzryxm;
    /**
     * 日志操作时间
     */
    @ApiModelProperty(value = "日志操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date logCzsj;
    /**
     * 操作类型：增加、修改、删除、作废
     */
    @ApiModelProperty(value = "操作类型：增加、修改、删除、作废")
    private String logCzlx;
    /**
     * 处理类型：增加后、修改前、修改后、删除前、作废前、作废后
     */
    @ApiModelProperty(value = "处理类型：增加后、修改前、修改后、删除前、作废前、作废后")
    private String logCllx;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String logBz;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号")
    private String cbkh;
    /**
     * ID号，唯一
     */
    @ApiModelProperty(value = "ID号，唯一")
    private String cbkid;
    /**
     * 水表类别(bm_sblb)
     */
    @ApiModelProperty(value = "水表类别(bm_sblb)")
    private String sblb;
    /**
     * 水表生产厂家(bm_sbsccj)
     */
    @ApiModelProperty(value = "水表生产厂家(bm_sbsccj)")
    private String sbsccj;
    /**
     * 水表出厂日期
     */
    @ApiModelProperty(value = "水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date sbccrq;
    /**
     * 水表型号(bm_sbxh)
     */
    @ApiModelProperty(value = "水表型号(bm_sbxh)")
    private String sbxh;
    /**
     * 水表口径(sys_child_code,pcid='12')
     */
    @ApiModelProperty(value = "水表口径(sys_child_code,pcid='12')")
    private String sbkj;
    /**
     * 水表编号
     */
    @ApiModelProperty(value = "水表编号")
    private String sbbh;
    /**
     * 水表量程(sys_child_code,pcid='13')
     */
    @ApiModelProperty(value = "水表量程(sys_child_code,pcid='13')")
    private String sblc;
    /**
     * 表计位置(sys_child_code,pcid='15')
     */
    @ApiModelProperty(value = "表计位置(sys_child_code,pcid='15')")
    private String bjwz;
    /**
     * 精度等级(sys_child_code,pcid='14')
     */
    @ApiModelProperty(value = "精度等级(sys_child_code,pcid='14')")
    private String jddj;
    /**
     * 抄表频率
     */
    @ApiModelProperty(value = "抄表频率")
    private String cbpl;
    /**
     * 水表起数（底数）
     */
    @ApiModelProperty(value = "水表起数（底数）")
    private BigDecimal sbqs;
    /**
     * 抄表序号
     */
    @ApiModelProperty(value = "抄表序号")
    private BigDecimal cbxh;
    /**
     * 一表多价标志
     */
    @ApiModelProperty(value = "一表多价标志")
    private String ybdjbz;
    /**
     * 水价编码
     */
    @ApiModelProperty(value = "水价编码")
    private String sjbm;
    /**
     * 水量比例
     */
    @ApiModelProperty(value = "水量比例")
    private Double slbl;
    /**
     * 水价编码1
     */
    @ApiModelProperty(value = "水价编码1")
    private String sjbm1;
    /**
     * 水量比例1
     */
    @ApiModelProperty(value = "水量比例1")
    private Double slbl1;
    /**
     * 水价编码2
     */
    @ApiModelProperty(value = "水价编码2")
    private String sjbm2;
    /**
     * 水量比例2
     */
    @ApiModelProperty(value = "水量比例2")
    private Double slbl2;
    /**
     * 水价编码3
     */
    @ApiModelProperty(value = "水价编码3")
    private String sjbm3;
    /**
     * 水量比例3
     */
    @ApiModelProperty(value = "水量比例3")
    private Double slbl3;
    /**
     * 污水费标志
     */
    @ApiModelProperty(value = "污水费标志")
    private String wsfbz;
    /**
     * 总分表ID（yh_cbkxx.cbkid）
     */
    @ApiModelProperty(value = "总分表ID（yh_cbkxx.cbkid）")
    private String fbid;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 计费状态（1正常，0停用）
     */
    @ApiModelProperty(value = "计费状态（1正常，0停用）")
    private String jfzt;
    /**
     * 开卡标志（bm_kkzt）
     */
    @ApiModelProperty(value = "开卡标志（bm_kkzt）")
    private String kkbz;
    /**
     * 开卡日期
     */
    @ApiModelProperty(value = "开卡日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date kkrq;
    /**
     * IC卡ID
     */
    @ApiModelProperty(value = "IC卡ID")
    private String ickid;
    /**
     * 写卡次数
     */
    @ApiModelProperty(value = "写卡次数")
    private BigDecimal xkcs;
    /**
     * 补卡次数
     */
    @ApiModelProperty(value = "补卡次数")
    private BigDecimal bkcs;
    /**
     * 总购水量
     */
    @ApiModelProperty(value = "总购水量")
    private Long zgsl;
    /**
     * 总购水金额（金额表）
     */
    @ApiModelProperty(value = "总购水金额（金额表）")
    private Double zgsje;
    /**
     * 本年累计水量
     */
    @ApiModelProperty(value = "本年累计水量")
    private BigDecimal bnljsl;
    /**
     * 本年累计金额
     */
    @ApiModelProperty(value = "本年累计金额")
    private Double bnljje;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String czrybm;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String czryxm;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;
    /**
     * 最新抄表日期
     */
    @ApiModelProperty(value = "最新抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date zxcbrq;
    /**
     * 所属阀门(sys_child_code,pcid='23')
     */
    @ApiModelProperty(value = "所属阀门(sys_child_code,pcid='23')")
    private String ssfm;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private BigDecimal ickqyh;
    /**
     * 定检日期
     */
    @ApiModelProperty(value = "定检日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date djrq;
    /**
     * 水表止读
     */
    @ApiModelProperty(value = "水表止读")
    private BigDecimal sbzd;
    /**
     * 修改人员编码
     */
    @ApiModelProperty(value = "修改人员编码")
    private String xgrybm;
    /**
     * 修改日期
     */
    @ApiModelProperty(value = "修改日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date xgrq;
    /**
     * 超定量
     */
    @ApiModelProperty(value = "超定量")
    private Long cdl;
    /**
     * 两高一剩标志:0 否，1 是
     */
    @ApiModelProperty(value = "两高一剩标志:0 否，1 是")
    private String lgysbz;
    /**
     * 安装人员
     */
    @ApiModelProperty(value = "安装人员")
    private String azry;
    /**
     * 安装时间
     */
    @ApiModelProperty(value = "安装时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date azrq;
    /**
     * 铅封号(管线号)
     */
    @ApiModelProperty(value = "铅封号(管线号)")
    private String gxh;
    /**
     * 垃圾费收取方式
     */
    @ApiModelProperty(value = "垃圾费收取方式")
    private String ljffs;
    /**
     * 垃圾费金额
     */
    @ApiModelProperty(value = "垃圾费金额")
    private Double ljfje;

}
