package com.tofly.feesapi.bjgl.entity;


import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.JfztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.apache.ibatis.type.JdbcType;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

@Getter
@Setter
@ApiModel(value = "用户档案水表档案列表VO", description = "用户表计信息")
public class YhDaCbkxxSelect implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户编号")
    @TableId(type = IdType.INPUT)
    private String yhbh;
    @ApiModelProperty("用户姓名")
    private String yhxm;
    @ApiModelProperty("用户地址")
    private String yhdz;
    @ApiModelProperty("联系电话")
    private String lxdh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;
    @ApiModelProperty("ID号，唯一")
    private String cbkid;

    @ApiModelProperty("水表类别(bm_sblb)")
    private String sblb;

    @ApiModelProperty("水表生产厂家(bm_sbsccj)")
    private String sbsccj;

    @ApiModelProperty("水表出厂日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private LocalDate sbccrq;

    @ApiModelProperty("水表型号(bm_sbxh)")
    private String sbxh;

    @ApiModelProperty("水表口径(sys_child_code,pcid='12')")
    private String sbkj;

    @ApiModelProperty("水表编号")
    private String sbbh;

    @ApiModelProperty("水表量程(sys_child_code,pcid='13')")
    private String sblc;

    @ApiModelProperty("表计位置(sys_child_code,pcid='15')")
    private String bjwz;

    @ApiModelProperty("精度等级(sys_child_code,pcid='14')")
    private String jddj;

    @ApiModelProperty("抄表频率")
    private String cbpl;

    @ApiModelProperty("水表起数（底数）")
    private int sbqs = 0;
    @ApiModelProperty("水表止读")
    private Short sbzd;
    @ApiModelProperty("计费状态（1正常，2停用）")
    private JfztEnum jfzt;

    @ApiModelProperty("用户状态（1正常，2停用）")
    private JfztEnum yhzt;



}
