/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bjgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 校表管理
 *
 * @author sxb
 * @date Wed Aug 09 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "YH_XBGL", resultMap = "yhbglMap")
@KeySequence("YH_XBGL")
@ApiModel
public class Yhbgl extends Model<Yhbgl> {
    private static final long serialVersionUID = 1L;

    /**
     * 流水编号
     */
    @TableId(value = "LSBH", type = IdType.INPUT)
    @ApiModelProperty(value = "流水编号")
    private String lsbh;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 用户名
     */
    @ApiModelProperty(value = "用户名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 水表厂家
     */
    @ApiModelProperty(value = "水表厂家")
    private String sbcj;
    /**
     * 水表型号
     */
    @ApiModelProperty(value = "水表型号")
    private String sbxh;
    /**
     * 水表口径
     */
    @ApiModelProperty(value = "水表口径")
    private String sbkj;
    /**
     * 校表说明
     */
    @ApiModelProperty(value = "校表说明")
    private String xbbz;
    /**
     * 数表止数
     */
    @ApiModelProperty(value = "数表止数")
    private String sbzs;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String czry;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;

}
