/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bjgl.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 换表（含普表换表）
 *
 * @author sxb
 * @date Mon Mar 04 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "YK_HB_LOG", resultMap = "ykHbLogMap")
@KeySequence("YK_HB_LOG")
@ApiModel
public class YkHbLog extends Model<YkHbLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 记录ID
     */
    @ColumnWidth(20)
    @ExcelProperty("记录ID")
    @ExcelIgnore
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "记录ID")
    private String id;
    /**
     * 用户号
     */
    @ColumnWidth(20)
    @ExcelProperty("用户号")
    @ApiModelProperty(value = "用户号")
    private String yhbh;
    /**
     * 原客户编号
     */
    @ColumnWidth(20)
    @ExcelProperty("原客户编号")
    @ApiModelProperty(value = "原客户编号")
    private String ykhbh;
    /**
     * 用户姓名
     */
    @ColumnWidth(30)
    @ExcelProperty("用户姓名")
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ColumnWidth(30)
    @ExcelProperty("用户地址")
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ColumnWidth(30)
    @ExcelProperty("联系电话")
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 抄表卡号
     */
    @ColumnWidth(30)
    @ExcelProperty("抄表卡号")
    @ExcelIgnore
    @ApiModelProperty(value = "抄表卡号")
    private BigDecimal cbkh;
    /**
     * 抄表卡ID
     */
    @ColumnWidth(30)
    @ExcelProperty("抄表卡ID")
    @ExcelIgnore
    @ApiModelProperty(value = "抄表卡ID")
    private String cbkid;
    /**
     * 原_水表厂家
     */
    @ColumnWidth(30)
    @ExcelProperty("原_水表厂家")
    @ApiModelProperty(value = "原_水表厂家")
    private String oldSbcj;
    /**
     * 原_水表出厂日期
     */
    @ColumnWidth(30)
    @ExcelProperty("原_水表厂家")
    @ExcelIgnore
    @ApiModelProperty(value = "原_水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date oldSbccrq;
    /**
     * 原_水表口径
     */
    @ColumnWidth(30)
    @ExcelProperty("原_水表口径")
    @ApiModelProperty(value = "原_水表口径")
    private String oldSbkj;
    /**
     * 原水表型号
     */
    @ColumnWidth(30)
    @ExcelProperty("原水表型号")
    @ApiModelProperty(value = "原水表型号")
    private String oldSbxh;
    /**
     * 原_水表编号
     */
    @ColumnWidth(30)
    @ExcelProperty("原_水表编号")
    @ApiModelProperty(value = "原_水表编号")
    private String oldSbbh;
    /**
     * 原_ICKID
     */
    @ColumnWidth(30)
    @ExcelProperty("原_ICKID")
    @ExcelIgnore
    @ApiModelProperty(value = "原_ICKID")
    private String oldIckid;
    /**
     * 原_水表读数
     */
    @ColumnWidth(30)
    @ExcelProperty("原_水表读数")
    @ApiModelProperty(value = "原_水表读数")
    private BigDecimal oldSbds;
    /**
     * 原_IC表剩余水量
     */
    @ColumnWidth(30)
    @ExcelProperty("原_IC表剩余水量")
    @ExcelIgnore
    @ApiModelProperty(value = "原_IC表剩余水量")
    private BigDecimal oldIcbsysl;
    /**
     * 原_机械表用水量
     */
    @ColumnWidth(30)
    @ExcelProperty("原_机械表用水量")

    @ApiModelProperty(value = "原_机械表用水量")
    private BigDecimal oldJxbysl;
    /**
     * 新_水表厂家
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表厂家")
    @ApiModelProperty(value = "新_水表厂家")
    private String newSbcj;
    /**
     * 新_水表出厂日期
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表厂家")
    @ExcelIgnore
    @ApiModelProperty(value = "新_水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date newSbccrq;
    /**
     * 新_水表口径
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表口径")
    @ApiModelProperty(value = "新_水表口径")
    private String newSbkj;
    /**
     * 新_水表型
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表型")
    @ApiModelProperty(value = "新_水表型")
    private String newSbxh;
    /**
     * 新_水表编号
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表编号")
    @ApiModelProperty(value = "新_水表编号")
    private String newSbbh;
    /**
     * 新_ICKID
     */
    @ColumnWidth(30)
    @ExcelProperty("新_ICKID")
    @ExcelIgnore
    @ApiModelProperty(value = "新_ICKID")
    private String newIckid;
    /**
     * 新_水表读数
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表读数")
    @ApiModelProperty(value = "新_水表读数")
    private BigDecimal newSbds;
    /**
     * 审批人员
     */
    @ColumnWidth(30)
    @ExcelProperty("新_水表读数")
    @ExcelIgnore
    @ApiModelProperty(value = "审批人员")
    private String spry;
    /**
     * 换表人员
     */
    @ColumnWidth(30)
    @ExcelProperty("换表人员")
    @ApiModelProperty(value = "换表人员")
    private String hbry;
    /**
     * 换表日期
     */
    @ColumnWidth(30)
    @ExcelProperty("换表日期")
    @ApiModelProperty(value = "换表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date hbrq;
    /**
     * 录入人员
     */
    @ColumnWidth(30)
    @ExcelProperty("录入人员")
    @ExcelIgnore
    @ApiModelProperty(value = "录入人员")
    private String lrry;
    /**
     * 录入日期
     */
    @ColumnWidth(30)
    @ExcelProperty("录入日期")
    @ExcelIgnore
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lrrq;
    /**
     * 备注
     */
    @ColumnWidth(30)
    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 原水表起度
     */
    @ColumnWidth(30)
    @ExcelProperty("原水表起度")
    @ApiModelProperty(value = "原水表起度")
    private BigDecimal oldSbqs;
    /**
     * 新水表起度
     */
    @ColumnWidth(30)
    @ExcelProperty("新水表起度")
    @ApiModelProperty(value = "新水表起度")
    private BigDecimal newSbqs;
    /**
     * 录入人员
     */
    @ColumnWidth(30)
    @ExcelProperty("录入人员")
    @ApiModelProperty(value = "录入人员")
    private String lrryxm;
    /**
     * 原水表类别
     */
    @ColumnWidth(30)
    @ExcelProperty("原水表类别")
    @ApiModelProperty(value = "原水表类别")
    private String oldSblb;
    /**
     * 新水表类别
     */
    @ColumnWidth(30)
    @ExcelProperty("新水表类别")
    @ApiModelProperty(value = "新水表类别")
    private String newSblb;
    /**
     * 原水表量程
     */
    @ColumnWidth(30)
    @ExcelProperty("原水表量程")
    @ApiModelProperty(value = "原水表量程")
    private String oldSblc;
    /**
     * 新水表量程
     */
    @ColumnWidth(30)
    @ExcelProperty("新水表量程")
    @ApiModelProperty(value = "新水表量程")
    private String newSblc;

}
