package com.tofly.feesapi.bjgl.entity.vo;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.tofly.feesapi.common.constant.FmztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

@Getter
@Setter
@ApiModel(value = "水表档案列表2VO", description = "用户表计信息")
public class YhCbkxxSelect2 implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "用户编号", position = 1)
    private String yhbh;

    @ApiModelProperty(value = "抄表卡号", position = 2)
    private Short cbkh;

    @ApiModelProperty(value = "ID号，唯一", position = 3)
    private String cbkid;

    @ApiModelProperty(value = "用户姓名", position = 4)
    private String yhxm;

    @ApiModelProperty(value = "用户地址", position = 5, example = "13-1-8（29号）")
    private String yhdz;

    @ApiModelProperty(value = "一表多价标志", position = 6, example = "1")
    private String ybdjbz;

    @ApiModelProperty(value = "污水费标志", position = 7, example = "1")
    private String wsfbz;

    @ApiModelProperty(value = "水价编码", hidden = true)
    @JsonIgnore
    private String sjbm;

    @ApiModelProperty(value = "水价名称", position = 8, example = "居民用水")
    private String sjmc;

    @ApiModelProperty(value = "水价", position = 9, example = "2.6")
    private String sj;

    @ApiModelProperty(value = "水价编码1", hidden = true)
    @JsonIgnore
    private String sjbm1;

    @ApiModelProperty(value = "水价名称1", position = 10, example = "居民用水")
    private String sjmc1;

    @ApiModelProperty(value = "水价1", position = 11, example = "2.6")
    private String sj1;

    @ApiModelProperty(value = "水量比例1", position = 12, example = "0.5")
    private BigDecimal slbl1;

    @ApiModelProperty(value = "水价编码2", hidden = true)
    @JsonIgnore
    private String sjbm2;

    @ApiModelProperty(value = "水价名称2", position = 13, example = "居民用水")
    private String sjmc2;

    @ApiModelProperty(value = "水价2", position = 14, example = "2.6")
    private String sj2;

    @ApiModelProperty(value = "水量比例2", position = 15, example = "0.5")
    private BigDecimal slbl2;

    @ApiModelProperty(value = "水价编码3", hidden = true)
    @JsonIgnore
    private String sjbm3;

    @ApiModelProperty(value = "水价名称3", position = 16, example = "居民用水")
    private String sjmc3;

    @ApiModelProperty(value = "水价3", position = 17, example = "2.6")
    private String sj3;

    @ApiModelProperty(value = "水量比例3", position = 18, example = "0.5")
    private BigDecimal slbl3;

    @ApiModelProperty(value = "抄表序号", position = 19, example = "0")
    private Integer cbxh;

    @ApiModelProperty(value = "所属抄表册名称",position = 21)
    private String sscbbmc;

    @ApiModelProperty(value = "所属抄表片区名称",position = 22)
    private String sscbpqmc;

    @ApiModelProperty(value = "联系电话", position = 24)
    private String lxdh;

    @ApiModelProperty(value = "水表编号", position = 25)
    private String sbbh;

    @ApiModelProperty(value = "水表类别", position = 27)
    private String sblbmc;

    @ApiModelProperty(value = "阀门状态(0关阀 1处理中 2开阀)", position = 28)
    private FmztEnum fmzt;

}
