package com.tofly.feesapi.bjgl.entity.vo;

import com.tofly.feesapi.common.constant.JfztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;

/**
 * <p>
 * 用户表计信息
 * </p>
 *
 * @author decai
 * @since 2024-01-10
 */
@Getter
@Setter
@ApiModel(value = "水表档案查看VO", description = "用户表计信息")
public class YhCbkxxView implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "用户编号", position = 1)
    private String yhbh;

    @ApiModelProperty(value = "抄表卡号", position = 2)
    private Short cbkh;

    @ApiModelProperty(value = "ID号，唯一", position = 3)
    private String cbkid;

    @ApiModelProperty(value = "水表类别", position = 4)
    private String sblb;

    @ApiModelProperty(value = "水表生产厂家", position = 5)
    private String sbsccj;

    @ApiModelProperty(value = "水表出厂日期(yyyy-MM-dd)", position = 6)
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate sbccrq;

    @ApiModelProperty(value = "水表型号", position = 7)
    private String sbxh;

    @ApiModelProperty(value = "水表口径", position = 8)
    private String sbkj;

    @ApiModelProperty(value = "水表编号", position = 9)
    private String sbbh;

    @ApiModelProperty(value = "计费状态", position = 11)
    private JfztEnum jfzt;

    @ApiModelProperty(value = "抄表频率", position = 12)
    private String cbpl;

    @ApiModelProperty(value = "水表起数（底数）", position = 13)
    private int sbqs = 0;

    @ApiModelProperty(value = "精度等级(sys_child_code,pcid='14')", position = 14)
    private String jddj;

    @ApiModelProperty(value = "表计位置(sys_child_code,pcid='15')", position = 15)
    private String bjwz;

    @ApiModelProperty(value = "开卡标志（bm_kkzt）", position = 16)
    private String kkbz;

    @ApiModelProperty(value = "所属阀门(sys_child_code,pcid='23')", position = 17)
    private String ssfm;


    // ------------------------水价---------------------
    @ApiModelProperty(value = "水价编码", position = 30)
    private String sjbm;

    @ApiModelProperty(value = "水量比例", position = 31)
    private BigDecimal slbl;

    @ApiModelProperty(value = "水价编码1", position = 32)
    private String sjbm1;

    @ApiModelProperty(value = "水量比例1", position = 33)
    private BigDecimal slbl1;

    @ApiModelProperty(value = "水价编码2", position = 34)
    private String sjbm2;

    @ApiModelProperty(value = "水量比例2", position = 35)
    private BigDecimal slbl2;

    @ApiModelProperty(value = "水价编码3", position = 36)
    private String sjbm3;

    @ApiModelProperty(value = "水量比例3", position = 37)
    private BigDecimal slbl3;

    @ApiModelProperty(value = "垃圾费标志", position = 40)
    private String ljfbz;

    @ApiModelProperty(value = "污水费标志", position = 41)
    private String wsfbz;

    @ApiModelProperty(value = "一表多价标志", position = 42)
    private String ybdjbz;

    @ApiModelProperty(value = "备注", position = 50)
    private String bz;
}
