package com.tofly.feesapi.bjgl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.entity.YhCbkxxLog;
import com.tofly.feesapi.bjgl.entity.dto.*;
import com.tofly.feesapi.bjgl.entity.vo.*;
import com.tofly.feesapi.bjgl.mapper.YhCbkxxMapper;
import com.tofly.feesapi.bjgl.service.YhCbkxxLogService;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.bmgl.entity.BmSj;
import com.tofly.feesapi.bmgl.entity.vo.BmSjSelect;
import com.tofly.feesapi.bmgl.service.BmSjService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.CjService;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.constant.JfztEnum;
import com.tofly.feesapi.common.constant.JtjslxEnum;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxInsert;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import com.tofly.feesapi.znbgl.service.ZnbDaLogService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * 用户表计信息
 */
@Service("yhCbkxxService")
public class YhCbkxxServiceImpl extends ServiceImpl<YhCbkxxMapper, YhCbkxx> implements YhCbkxxService {
    @Autowired
    private YhCbkxxLogService yhCbkxxLogService;

    @Autowired
    private YyCblrService yyCblrService;

    @Autowired
    private YhKhjbxxService yhKhjbxxService;

    @Autowired
    private BmSjService sjService;
    @Autowired
    private ZnbDaLogService znbDaLogService;

    @Autowired(required = false)
    private Map<String, CjService> cjServices;

    @Override
    public List<YhCbkxxSelect> getList(String yhbh) {
        return this.baseMapper.getList(yhbh);
    }

    @Override
    public YhCbkxxView getViewById(String yhbh) {
        YhCbkxxView view = new YhCbkxxView();
        YhCbkxx yhCbkxx = this.getById(yhbh);
        if (yhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        BeanUtils.copyProperties(yhCbkxx, view);
        return view;
    }

    @Override
    public boolean delByIds(List<String> ids, CzyUserDetails czyUserDetails) {
        ids.forEach(id -> delById(id, czyUserDetails));
        return true;
    }

    @Override
    public boolean delById(String id, CzyUserDetails czyUserDetails) {
        YhCbkxx yhCbkxx = this.getById(id);
        if (yhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        saveLog(null, yhCbkxx, czyUserDetails, "删除");
        this.removeById(id);
        return true;
    }

    @Override
    public YhCbkxx save(CzyUserDetails czyUserDetails, YhKhjbxxInsert insert, String yhbh) {
        YhCbkxx cbkxx = new YhCbkxx();
        BeanUtils.copyProperties(insert.getYhCbkxx(), cbkxx);
        String czrybm = insert.getCzrybm();
        String czryxm = insert.getCzryxm();
        Date czsj = insert.getCzsj();
        cbkxx.setYhbh(yhbh);//用户编号
        cbkxx.setCzrybm(czrybm);
        cbkxx.setCzryxm(czryxm);
        cbkxx.setCzsj(czsj);
        //水表档案
        String cbkh = "1";
        cbkxx.setCbkh(cbkh);//抄表卡号
        String strcbkh = yhbh + cbkh;
        cbkxx.setCbkid(strcbkh);//抄表卡ID
        cbkxx.setJfzt(JfztEnum.正常.toString());//计费状态（1正常，2停用）
        check(cbkxx);
        this.save(cbkxx);
        saveLog(cbkxx, null, czyUserDetails, "添加");//添加水表档案操作历史
        yyCblrService.save(czyUserDetails, insert, cbkxx);
        return cbkxx;
    }

    @Override
    public boolean update(YhCbkxxUpdate update, CzyUserDetails czyUserDetails) {
        String yhbh = update.getYhbh();
        if (StringUtils.isBlank(yhbh)) throw new FeesException("用户编号不能为空", FeesErrorCode.BUSINESS_ERROR);
        YhCbkxx oldYhCbkxx = this.getById(yhbh);
        if (oldYhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        YhCbkxx yhCbkxx = new YhCbkxx();
        BeanUtils.copyProperties(oldYhCbkxx, yhCbkxx);
        BeanUtils.copyProperties(update, yhCbkxx);
        check(yhCbkxx);
        if (czyUserDetails != null) {
            yhCbkxx.setCzrybm(czyUserDetails.getUsername());
        }
        this.updateById(yhCbkxx);
        saveLog(yhCbkxx, oldYhCbkxx, czyUserDetails, "修改");
        return true;
    }

    @Override
    public boolean disable(String yhbh, CzyUserDetails czyUserDetails) {
        YhCbkxx oldYhCbkxx = getById(yhbh);
        if (oldYhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        YhCbkxx yhCbkxx = new YhCbkxx();
        BeanUtils.copyProperties(oldYhCbkxx, yhCbkxx);
        yhCbkxx.setJfzt(JfztEnum.停用.toString());
        this.updateById(yhCbkxx);
        saveLog(yhCbkxx, oldYhCbkxx, czyUserDetails, "作废");
        return true;
    }

    @Override
    public boolean enable(String yhbh, CzyUserDetails czyUserDetails) {
        YhCbkxx yhCbkxx = getById(yhbh);
        if (yhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        yhCbkxx.setJfzt(JfztEnum.正常.toString());
        this.updateById(yhCbkxx);
        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateCbxh(YhCbkxxCbxhUpdate update, CzyUserDetails czyUserDetails) {
        List<YhCbkxxCbxhYhlist> yhCbkxxCbxhYhlists = update.getList();
        if (yhCbkxxCbxhYhlists == null || yhCbkxxCbxhYhlists.size() == 0) return false;
        Set<String> cbbs = new HashSet<>();
        String crdzhYhbh = update.getCrdzhYhbh();
        //Map<String, YhKhjbxx> yhxxMap = new HashMap<>();
        yhCbkxxCbxhYhlists.forEach(item -> {
            YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(item.getYhbh());
            if (yhKhjbxx == null)
                throw new FeesException(String.format("用户档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
            YhCbkxx yhCbkxx = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
                    .eq(YhCbkxx::getYhbh, item.getYhbh())
                    .eq(YhCbkxx::getCbkh, item.getCbkh())
            );
            if (yhCbkxx == null)
                throw new FeesException(String.format("水表档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
            String sscbb = yhKhjbxx.getSscbb();
            if (sscbb == null)
                throw new FeesException(String.format("用户档案未分配抄表册:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
            cbbs.add(sscbb);
            //yhxxMap.put(yhKhjbxx.getYhbh(), yhKhjbxx);
        });
        if (cbbs.size() > 1) throw new FeesException("用户档案不在同一个抄表本（册）", FeesErrorCode.BUSINESS_ERROR);
        String sscbb = cbbs.stream().findFirst().get();
        List<String> cbbYhbhs = getCbbYhbhs(sscbb);
        if (StringUtils.isBlank(crdzhYhbh)) {//未提供插入位置
            int cbxhStart = getMaxCbxh(cbbYhbhs);
            for (YhCbkxxCbxhYhlist item : yhCbkxxCbxhYhlists) {
                this.lambdaUpdate()
                        .eq(YhCbkxx::getYhbh, item.getYhbh())
                        .eq(YhCbkxx::getCbkh, item.getCbkh())
                        .set(YhCbkxx::getCbxh, ++cbxhStart).update();
            }
            ;
        } else {
            YhCbkxx insertAfter = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
                    .eq(YhCbkxx::getYhbh, crdzhYhbh)
                    .eq(YhCbkxx::getCbkh, update.getCrdzhCbkh())
            );
            if (insertAfter == null)
                throw new FeesException(String.format("水表档案不存在:%s", crdzhYhbh), FeesErrorCode.BUSINESS_ERROR);
            int cbxh = insertAfter.getCbxh();
            if (cbxh == 0) throw new FeesException("水表档案未分配序号", FeesErrorCode.BUSINESS_ERROR);

            YhCbkxx next = getNext(cbbYhbhs, cbxh);
            if (next != null) {
                this.lambdaUpdate()
                        .ge(YhCbkxx::getCbxh, next.getCbxh())
                        .in(YhCbkxx::getYhbh, cbbYhbhs)
                        .setSql("cbxh = cbxh + " + yhCbkxxCbxhYhlists.size())
                        .update();
            }
            int cbxhStart = cbxh;
            for (YhCbkxxCbxhYhlist item : yhCbkxxCbxhYhlists) {
                this.lambdaUpdate()
                        .eq(YhCbkxx::getYhbh, item.getYhbh())
                        .eq(YhCbkxx::getCbkh, item.getCbkh())
                        .set(YhCbkxx::getCbxh, ++cbxhStart).update();
            }
            ;
        }
        yyCblrService.lambdaUpdate()
                .eq(YyCblr::getSscbb, sscbb)
                .setSql("cbxh=(select a.cbxh from yh_cbkxx a where a.yhbh=yy_cblr.yhbh and a.cbkh=yy_cblr.cbkh)")
                .update();
        return true;
    }

    /**
     * 获取抄表本最大抄表序号
     *
     * @param cbbYhbhs 抄表本用户编号
     * @return
     */
    private int getMaxCbxh(List<String> cbbYhbhs) {
        if (cbbYhbhs == null || cbbYhbhs.isEmpty()) return 0;
        return this.baseMapper.getMaxCbxh(cbbYhbhs);
    }

    @Override
    public PageResult<YhCbkxxSelect2> getPage(PageDto pageDto, YhCbkxxFilter filter, List<String> sblbs) {
        PageDto<YhCbkxxSelect2> page = this.baseMapper.getPage(pageDto, filter, sblbs);
        List<BmSjSelect> list = sjService.getList();
        Map<String, BmSjSelect> sjMap = list.stream().collect(Collectors.toMap(BmSjSelect::getCode, e -> e));
        PageResult<YhCbkxxSelect2> pageResult = page.toVo();
        pageResult.getRecords().forEach(e -> {
            String ybdjbz = e.getYbdjbz();
            if (ybdjbz == null) {
                ybdjbz = "0";
                e.setYbdjbz(ybdjbz);
            }
            if ("0".equals(ybdjbz)) {
                if (e.getSjbm() != null) {
                    BmSjSelect bmsj = sjMap.get(e.getSjbm());
                    if (bmsj != null) {
                        e.setSj(bmsj.getHjtsj());
                        e.setSjmc(bmsj.getName());
                    }
                }
            } else {
                if (e.getSjbm1() != null) {
                    BmSjSelect bmsj = sjMap.get(e.getSjbm1());
                    if (bmsj != null) {
                        e.setSj1(bmsj.getHjtsj());
                        e.setSjmc1(bmsj.getName());
                    }
                }
                if (e.getSjbm2() != null) {
                    BmSjSelect bmsj = sjMap.get(e.getSjbm2());
                    if (bmsj != null) {
                        e.setSj2(bmsj.getHjtsj());
                        e.setSjmc2(bmsj.getName());
                    }
                }
                if (e.getSjbm3() != null) {
                    BmSjSelect bmsj = sjMap.get(e.getSjbm3());
                    if (bmsj != null) {
                        e.setSj3(bmsj.getHjtsj());
                        e.setSjmc3(bmsj.getName());
                    }
                }
            }

        });
        return pageResult;
    }

    @Override
    public boolean updateSj(YhCbkxxSjUpdate update, CzyUserDetails czyUserDetails) {
        List<YhCbkxxSjUpdateItem> yhbhcbkhs = update.getYhbhcbkhs();
        check(update);
        for (YhCbkxxSjUpdateItem yhbhcbkh : yhbhcbkhs) {
            YhCbkxx yhCbkxx = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
                    .eq(YhCbkxx::getCbkh, yhbhcbkh.getCbkh())
                    .eq(YhCbkxx::getYhbh, yhbhcbkh.getYhbh())
            );
            YhCbkxx oldYhCbkxx = yhCbkxx;
            if (yhCbkxx == null) throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
            BeanUtils.copyProperties(update, yhCbkxx);
            this.updateById(yhCbkxx);
            saveLog(yhCbkxx, oldYhCbkxx, czyUserDetails, "修改");
//            if (yhCbkxx.getSblb().equals("2") || yhCbkxx.getSblb().equals("3")) {
//                YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(yhCbkxx.getYhbh());
//                if (!znbYhdaService.updateZnbYhda(yhKhjbxx, yhCbkxx, "1", czyUserDetails)) {
//                    throw new FeesException("智能表档案修改失败", FeesErrorCode.BUSINESS_ERROR);
//                }
//            }
        }
        return true;
    }

    @Override
    public boolean hb(YhHbUpdate update, CzyUserDetails czyUserDetails) {
        String cbkid = update.getCbkid();
        if (StringUtils.isBlank(cbkid))
            throw new FeesException("抄表卡ID不能为空", FeesErrorCode.BUSINESS_ERROR);
        YhCbkxx oldYhCbkxx = this.getById(update.getCbkid());
        if (oldYhCbkxx == null)
            throw new FeesException("水表档案不存在", FeesErrorCode.BUSINESS_ERROR);
        YhCbkxx yhCbkxx = new YhCbkxx();
        BeanUtils.copyProperties(oldYhCbkxx, yhCbkxx);
        BeanUtils.copyProperties(update, yhCbkxx);
        checkJbcs(yhCbkxx);
        if (czyUserDetails != null) {
            yhCbkxx.setCzrybm(czyUserDetails.getUsername());
        }
        yhCbkxx.setCzsj(new Date());
        this.updateById(yhCbkxx);

        yyCblrService.lambdaUpdate()
                .set(YyCblr::getScds, update.getSbqs())
                .set(YyCblr::getBcds, update.getSbqs())
                .set(YyCblr::getJjl, update.getSbqs())
                .set(YyCblr::getSl, update.getSbqs())
                .eq(YyCblr::getCbkid, update.getCbkid());
        if (yhCbkxx.getSblb().equals("2") || yhCbkxx.getSblb().equals("3")) {
            YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(yhCbkxx.getYhbh());
            znbDaLogService.addznbDaLog(yhKhjbxx, yhCbkxx, "2", czyUserDetails);
        }
        saveLog(yhCbkxx, oldYhCbkxx, czyUserDetails, "换表");
        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean cancelCbxh(YhCbkxxCbxhCancel cancel, CzyUserDetails czyUserDetails) {
        List<YhCbkxxCbxhYhlist> yhCbkxxCbxhYhlists = cancel.getList();
        if (yhCbkxxCbxhYhlists.size() == 0) {
            return false;
        }
        yhCbkxxCbxhYhlists.forEach(item -> {
            YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(item.getYhbh());
            if (yhKhjbxx == null)
                throw new FeesException(String.format("用户档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
            YhCbkxx yhCbkxx = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
                    .eq(YhCbkxx::getYhbh, item.getYhbh())
                    .eq(YhCbkxx::getCbkh, item.getCbkh())
            );
            if (yhCbkxx == null)
                throw new FeesException(String.format("水表档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
        });
        yhCbkxxCbxhYhlists.forEach(e -> {
            this.lambdaUpdate()
                    .eq(YhCbkxx::getYhbh, e.getYhbh())
                    .eq(YhCbkxx::getCbkh, e.getCbkh())
                    .set(YhCbkxx::getCbxh, 0).update();
        });
        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public boolean sxydCbxh(YhCbkxxCbxhSxyd sxyd, CzyUserDetails czyUserDetails) {
        List<YhCbkxxCbxhYhlist> list = sxyd.getList();
        if (list.size() == 0) {
            return false;
        }
        list.forEach(item -> {
            YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(item.getYhbh());
            if (yhKhjbxx == null)
                throw new FeesException(String.format("用户档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
            YhCbkxx yhCbkxx = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
                    .eq(YhCbkxx::getYhbh, item.getYhbh())
                    .eq(YhCbkxx::getCbkh, item.getCbkh())
            );
            if (yhCbkxx == null)
                throw new FeesException(String.format("水表档案不存在:%s", item.getYhbh()), FeesErrorCode.BUSINESS_ERROR);
        });
        List<YyCblr> yyCblrList = yyCblrService.list(new QueryWrapper<YyCblr>().lambda()
                .in(YyCblr::getYhbh, list.stream().map(YhCbkxxCbxhYhlist::getYhbh).collect(Collectors.toList()))
                .select(YyCblr::getSscbb)
                .groupBy(YyCblr::getSscbb)
        );
        if (yyCblrList.size() == 1) {
            Boolean ydfx = sxyd.getYdfx();
            var t = yyCblrService.lambdaUpdate();
            list.forEach(e -> {
                t.or(
                        t1 -> t1.eq(YyCblr::getYhbh, e.getYhbh())
                                .eq(YyCblr::getCbkh, e.getCbkh())
                );
            });
            t.setSql(ydfx ? "cbxh=cbxh-1.5" : "cbxh=cbxh+1.5");
            if (t.update()) {
                String cbbbm = yyCblrList.get(0).getSscbb();
                yyCblrList = yyCblrService.list(new QueryWrapper<YyCblr>().lambda()
                        .eq(YyCblr::getSscbb, cbbbm)
                        .gt(YyCblr::getCbxh, 0)
                        .select(YyCblr::getYhbh, YyCblr::getCbkh, YyCblr::getCbxh)
                        .orderByAsc(YyCblr::getCbxh, YyCblr::getYhbh, YyCblr::getCbkh)
                );
                List<YyCblr> finalYyCblrList = yyCblrList;
                IntStream.range(0, yyCblrList.size())
                        .forEach(index -> {
                            YyCblr item = finalYyCblrList.get(index);
                            yyCblrService.lambdaUpdate()
                                    .set(YyCblr::getCbxh, index + 1)
                                    .set(YyCblr::getSscbb, cbbbm)
                                    .eq(YyCblr::getYhbh, item.getYhbh())
                                    .eq(YyCblr::getCbkh, item.getCbkh())
                                    .update();
                            this.lambdaUpdate()
                                    .set(YhCbkxx::getCbxh, index + 1)
                                    .eq(YhCbkxx::getYhbh, item.getYhbh())
                                    .eq(YhCbkxx::getCbkh, item.getCbkh())
                                    .update();
                        });
            }
        } else {
            throw new FeesException("用户所属抄表册有误!", FeesErrorCode.BUSINESS_ERROR);
        }

        return true;

//        String yhbh = sxyd.getYhbh();
//        if (yhbh == null) return false;
//        YhKhjbxx yhKhjbxx = yhKhjbxxService.getById(yhbh);
//        if (yhKhjbxx == null)
//            throw new FeesException(String.format("用户档案不存在:%s", yhbh), FeesErrorCode.BUSINESS_ERROR);
//        Boolean ydfx = sxyd.getYdfx();
//        String sscbb = yhKhjbxx.getSscbb();
//        if (sscbb == null)
//            throw new FeesException(String.format("用户档案未分配抄表册:%s", yhbh), FeesErrorCode.BUSINESS_ERROR);
//        YhCbkxx yhCbkxx = this.getOne(new QueryWrapper<YhCbkxx>().lambda()
//                .eq(YhCbkxx::getYhbh, yhbh)
//                .eq(YhCbkxx::getCbkh, sxyd.getCbkh())
//        );
//        if (yhCbkxx == null)
//            throw new FeesException(String.format("水表档案不存在:%s", yhbh), FeesErrorCode.BUSINESS_ERROR);
//        if (ydfx) {//上移
//            int cbxh = yhCbkxx.getCbxh();
//            YhCbkxx up = this.baseMapper.getUp(sscbb, cbxh);
//            if (up != null) {
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, yhCbkxx.getYhbh())
//                        .set(YhCbkxx::getCbxh, up.getCbxh()).update();
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, up.getYhbh())
//                        .set(YhCbkxx::getCbxh, cbxh).update();
//            } else {
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, yhCbkxx.getYhbh())
//                        .set(YhCbkxx::getCbxh, cbxh - 1).update();
//            }
//        } else {
//            int cbxh = yhCbkxx.getCbxh();
//            YhCbkxx down = this.baseMapper.getDown(sscbb, cbxh);
//            if (down != null) {
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, yhCbkxx.getYhbh())
//                        .set(YhCbkxx::getCbxh, down.getCbxh()).update();
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, down.getYhbh())
//                        .set(YhCbkxx::getCbxh, cbxh).update();
//            } else {
//                this.lambdaUpdate()
//                        .eq(YhCbkxx::getYhbh, yhCbkxx.getYhbh())
//                        .set(YhCbkxx::getCbxh, cbxh + 1).update();
//            }
//        }
//        return true;
    }

    @Override
    public void updateSblc(String yhbh, String sblcbm) {
        this.lambdaUpdate()
                .eq(YhCbkxx::getYhbh, yhbh)
                .set(YhCbkxx::getSblc, sblcbm).update();
    }

    @Override
    public List<YhCbkxx> getListByAfterCbkid(String sblb, String sbsccj, String afterCbkid, int limit) {
        PageDto<YhCbkxx> page1 = new PageDto<>();
        page1.setSize(limit);
        page1.setCurrent(1);
        PageDto<YhCbkxx> page = this.page(page1, Wrappers.lambdaQuery(YhCbkxx.class)
                .eq(sblb != null, YhCbkxx::getSblb, sblb)
                .eq(sbsccj != null, YhCbkxx::getSbsccj, sbsccj)
                .gt(afterCbkid != null, YhCbkxx::getCbkid, afterCbkid)
                .orderByAsc(YhCbkxx::getCbkid));
        return page.getRecords();
    }

    @Override
    public long count(String sblb, String sbsccj) {
        return this.list(Wrappers.lambdaQuery(YhCbkxx.class)
                .select(YhCbkxx::getCbkid)
                .eq(sblb != null, YhCbkxx::getSblb, sblb)
                .eq(sbsccj != null, YhCbkxx::getSbsccj, sbsccj)
                .last("for update")).stream().count();
    }

    @Override
    public void lockTable() {
        this.baseMapper.lockTable();
    }

    @Override
    public void updateLjsl(String cbkid, BigDecimal ljsl) {
        if (cbkid == null) return;
        this.lambdaUpdate()
                .set(YhCbkxx::getLjsl, ljsl)
                .eq(YhCbkxx::getCbkid, cbkid)
                .update();
    }

    @Override
    public void updateSyje(String cbkid, BigDecimal syje) {
        if (cbkid == null) return;
        this.lambdaUpdate()
                .set(YhCbkxx::getSyje, syje)
                .eq(YhCbkxx::getCbkid, cbkid)
                .update();
    }

    @Override
    public void znbSync() {
        if (cjServices == null || cjServices.isEmpty()) return;
        cjServices.forEach((serviceName, cjService) -> {
            if (Thread.interrupted()) return;
            String[] nameParts = serviceName.split("#");
            if (nameParts.length < 2) {
                log.error("厂家服务名称错误");
                return;
            }
            String sbsccj = nameParts[1];
            List<YhCbkxxSync> cbkxxSyncs = this.getBySbsccj(sbsccj);
            cjService.syncMeters(cbkxxSyncs);
        });
    }

    @Override
    public List<YhCbkxxSync> getBySbsccj(String sbsccj) {
        if (sbsccj == null) return new ArrayList<>();
        return this.baseMapper.getBySbsccj(sbsccj);
    }

    /**
     * 获取用户编号所在抄表本（册）的所有用户编号
     *
     * @param sscbb 用户编号
     * @return
     */
    private List<String> getCbbYhbhs(String sscbb) {

        if (sscbb == null) return new ArrayList<>();
        List<YhKhjbxx> list = yhKhjbxxService.lambdaQuery()
                .eq(YhKhjbxx::getSscbb, sscbb)
                .select(YhKhjbxx::getYhbh)
                .list();
        return list.stream().map(e -> e.getYhbh()).collect(Collectors.toList());//抄表本（册）用户编号
    }

    private YhCbkxx getNext(List<String> yhbhs, int cbxh) {
        return this.lambdaQuery().eq(YhCbkxx::getCbxh, cbxh + 1).in(YhCbkxx::getYhbh, yhbhs).one();
    }


    private void check(YhCbkxx cbkxx) {
        checkJbcs(cbkxx);

        String ybdjbz = cbkxx.getYbdjbz();
        String wsfbz = cbkxx.getWsfbz();
        String sjbm1 = cbkxx.getSjbm1();
        BigDecimal slbl1 = cbkxx.getSlbl1();
        String sjbm2 = cbkxx.getSjbm2();
        BigDecimal slbl2 = cbkxx.getSlbl2();
        String sjbm3 = cbkxx.getSjbm3();
        BigDecimal slbl3 = cbkxx.getSlbl3();
        String sjbm = cbkxx.getSjbm();
        checkFycs(ybdjbz, wsfbz, sjbm, sjbm1, slbl1, sjbm2, slbl2, sjbm3, slbl3);
    }

    /**
     * 检查基本参数
     *
     * @param cbkxx
     */
    private void checkJbcs(YhCbkxx cbkxx) {
        if (StringUtils.isEmpty(cbkxx.getSbbh())) {
            throw new FeesException("水表编号不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(cbkxx.getSblb())) {
            throw new FeesException("水表类别不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(cbkxx.getSbsccj())) {
            throw new FeesException("水表厂家不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(cbkxx.getSbxh())) {
            throw new FeesException("水表型号不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(cbkxx.getSbkj())) {
            throw new FeesException("水表口径不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
    }

    /**
     * 检查费用参数
     *
     * @param ybdjbz
     * @param wsfbz
     * @param sjbm
     * @param sjbm1
     * @param slbl1
     * @param sjbm2
     * @param slbl2
     * @param sjbm3
     * @param slbl3
     */
    private void checkFycs(String ybdjbz, String wsfbz, String sjbm, String sjbm1, BigDecimal slbl1, String sjbm2, BigDecimal slbl2, String sjbm3, BigDecimal slbl3) {

        List<String> bzValues = List.of("1", "0");
        if (ybdjbz != null && !bzValues.contains(ybdjbz))
            throw new FeesException("是否一表多价标志无效", FeesErrorCode.BUSINESS_ERROR);
        if (wsfbz != null && !bzValues.contains(wsfbz))
            throw new FeesException("污水费标志无效", FeesErrorCode.BUSINESS_ERROR);
        if ("1".equals(ybdjbz)) {

            if (StringUtils.isEmpty(sjbm1)) throw new FeesException("水价1编码不能为空", FeesErrorCode.BUSINESS_ERROR);
            if (StringUtils.isEmpty(sjbm2)) throw new FeesException("水价2编码不能为空", FeesErrorCode.BUSINESS_ERROR);
            BigDecimal slbl = BigDecimal.ZERO;//不大于1的比例
            List<BmSj> bmSjs = new ArrayList<>();
            BmSj bmSj1 = sjService.getById(sjbm1);
            if (bmSj1 == null) throw new FeesException("水价1编码不存在", FeesErrorCode.BUSINESS_ERROR);
            if (slbl1 == null || slbl1.compareTo(BigDecimal.ZERO) < 0)
                throw new FeesException("水量比例1不能小于0", FeesErrorCode.BUSINESS_ERROR);

            bmSjs.add(bmSj1);

            if (slbl1.compareTo(BigDecimal.ONE) <= 0) {
                slbl = slbl.add(slbl1);
            }


            BmSj bmSj2 = sjService.getById(sjbm2);
            if (bmSj2 == null) throw new FeesException("水价2编码不存在", FeesErrorCode.BUSINESS_ERROR);
            if (slbl2 == null || slbl2.compareTo(BigDecimal.ZERO) < 0)
                throw new FeesException("水量比例2不能小于0", FeesErrorCode.BUSINESS_ERROR);
            bmSjs.add(bmSj2);
            if (slbl2.compareTo(BigDecimal.ONE) <= 0) {
                slbl = slbl.add(slbl2);
            }

            BmSj bmSj3 = null;
            if (StringUtils.isNotEmpty(sjbm3)) {
                bmSj3 = sjService.getById(sjbm3);
                if (bmSj3 == null) throw new FeesException("水价3编码不存在", FeesErrorCode.BUSINESS_ERROR);
                if (slbl3 == null || slbl3.compareTo(BigDecimal.ZERO) < 0)
                    throw new FeesException("水量比例3不能小于0", FeesErrorCode.BUSINESS_ERROR);
                bmSjs.add(bmSj3);
                if (slbl3.compareTo(BigDecimal.ONE) <= 0) {
                    slbl = slbl.add(slbl3);
                }
            }
            if (slbl.compareTo(BigDecimal.ONE) != 0)
                throw new FeesException("水量比例之和不等于1", FeesErrorCode.BUSINESS_ERROR);
            long count = bmSjs.stream().filter(e -> e.getJtjslx() == JtjslxEnum.年阶梯).count();
            if (count > 1) throw new FeesException("一表多价最多支持一种年阶梯水价", FeesErrorCode.BUSINESS_ERROR);
        } else {

            if (StringUtils.isEmpty(sjbm)) throw new FeesException("水价编码不能为空", FeesErrorCode.BUSINESS_ERROR);
            BmSj bmSj = sjService.getById(sjbm);
            if (bmSj == null) throw new FeesException("水价编码不存在", FeesErrorCode.BUSINESS_ERROR);
        }
    }

    private void check(YhCbkxxSjUpdate sjUpdate) {
        List<YhCbkxxSjUpdateItem> yhbhcbkhs = sjUpdate.getYhbhcbkhs();
        if (yhbhcbkhs == null || yhbhcbkhs.size() == 0)
            throw new FeesException("用户编号不能为空", FeesErrorCode.BUSINESS_ERROR);
        String ybdjbz = sjUpdate.getYbdjbz();
        String wsfbz = sjUpdate.getWsfbz();
        String sjbm1 = sjUpdate.getSjbm1();
        BigDecimal slbl1 = sjUpdate.getSlbl1();
        String sjbm2 = sjUpdate.getSjbm2();
        BigDecimal slbl2 = sjUpdate.getSlbl2();
        String sjbm3 = sjUpdate.getSjbm3();
        BigDecimal slbl3 = sjUpdate.getSlbl3();
        String sjbm = sjUpdate.getSjbm();
        checkFycs(ybdjbz, wsfbz, sjbm, sjbm1, slbl1, sjbm2, slbl2, sjbm3, slbl3);
    }


    /**
     * 水表档案操作日志记录
     *
     * @param cbkxx
     * @param oldCbkxx
     * @param czyUserDetails
     * @param logCzlx
     */
    private void saveLog(YhCbkxx cbkxx, YhCbkxx oldCbkxx, CzyUserDetails czyUserDetails, String logCzlx) {
        String logCzrybm = null;
        String logCzryxm = null;
        if (czyUserDetails != null) {
            logCzrybm = String.valueOf(czyUserDetails.getId());
        }
        Date logCzsj = new Date();
        DateFormat dateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
        String logLsh = dateFormat.format(logCzsj);
        if (oldCbkxx != null) {
            YhCbkxxLog before = new YhCbkxxLog();
            BeanUtils.copyProperties(oldCbkxx, before);
            before.setLogLsh(logLsh);//流水号
            before.setCzsj(logCzsj);//操作时间
            before.setLogCzryxm(logCzryxm);//操作人员
            before.setLogCzrybm(logCzrybm);//操作人员编码
            before.setLogCzsj(logCzsj);
            before.setLogId(GuidGenerator.getGuid());//id
            before.setLogCzlx(logCzlx);
            before.setLogCllx(String.format("%s前", logCzlx));
            yhCbkxxLogService.save(before);
        }
        if (cbkxx != null) {
            YhCbkxxLog after = new YhCbkxxLog();
            BeanUtils.copyProperties(cbkxx, after);
            after.setCzsj(logCzsj);//操作时间
            after.setLogLsh(logLsh);//流水号
            after.setLogCzryxm(logCzryxm);//操作人员
            after.setLogCzrybm(logCzrybm);//操作人员编码
            after.setLogCzsj(logCzsj);
            after.setLogId(GuidGenerator.getGuid());//id
            after.setLogCzlx(logCzlx);
            after.setLogCllx(String.format("%s后", logCzlx));//修改后
            yhCbkxxLogService.save(after);
        }
    }
}
