/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 表本(小区)编码
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_CBB", resultMap = "bmCbbMap")
@KeySequence("BM_CBB")
@ApiModel
public class BmCbb extends Model<BmCbb> {
    private static final long serialVersionUID = 1L;

    /**
     * 表本编码
     */
    @TableId(value = "CBBBM", type = IdType.INPUT)
    @ApiModelProperty(value = "表本编码")
    private String cbbbm;
    /**
     * 表本名称
     */
    @ApiModelProperty(value = "表本名称")
    private String cbbmc;
    /**
     * 表本地址描述
     */
    @ApiModelProperty(value = "表本地址描述")
    private String dz;
    /**
     * 所属抄表员
     */
    @ApiModelProperty(value = "所属抄表员")
    private String cby;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区")
    private String sscbpq;
    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    private String bz;
    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 更新日期
     */
    @ApiModelProperty(value = "更新日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date xdate;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String czry;
    /**
     * 抄表员生效标志(0=当月生效，1=下月生效)
     */
    @ApiModelProperty(value = "抄表员生效标志(0=当月生效，1=下月生效)")
    private String sxbz;
    /**
     * 下月抄表员的编码(仅当sxbz='1'时有效，月末结转时更新)
     */
    @ApiModelProperty(value = "下月抄表员的编码(仅当sxbz='1'时有效，月末结转时更新)")
    private String xycby;

}
