/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 抄表片区
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_CBPQ", resultMap = "bmCbpqMap")
@KeySequence("BM_CBPQ")
@ApiModel
public class BmCbpq extends Model<BmCbpq> {
    private static final long serialVersionUID = 1L;

    /**
     * 抄表片区编码
     */
    @TableId(value = "CBPQBM", type = IdType.INPUT)
    @ApiModelProperty(value = "抄表片区编码")
    private String cbpqbm;
    /**
     * 抄表片区名称
     */
    @ApiModelProperty(value = "抄表片区名称")
    private String cbpqmc;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date xdate;
    /**
     * 修改人员编码
     */
    @ApiModelProperty(value = "修改人员编码")
    private String xgry;

}
