/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;


/**
 * 付费方式
 *
 * @author sxb
 * @date Thu Feb 22 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_FFFS", resultMap = "bmFffsMap")
@KeySequence("BM_FFFS")
@ApiModel
public class BmFffs extends Model<BmFffs> {
    private static final long serialVersionUID = 1L;

    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String ocode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String oname;
    /**
     * 编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "编码")
    private String code;
    /**
     * 付费方式
     */
    @ApiModelProperty(value = "付费方式")
    private String name;
    /**
     * 是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "是否启用：0不启用，1启用")
    private String isdisabled;
    /**
     * yh_khjbxx是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "yh_khjbxx是否启用：0不启用，1启用")
    private String yhIsdisabled;
    /**
     * 余额滚动标志（0=不参与滚动，1=参与滚动）
     */
    @ApiModelProperty(value = "余额滚动标志（0=不参与滚动，1=参与滚动）")
    private String yegdbz;

}
