/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 水表生产厂家
 *
 * @author sxb
 * @date Thu Feb 22 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_SBSCCJ", resultMap = "bmSbsccjMap")
@KeySequence("BM_SBSCCJ")
@ApiModel
public class BmSbsccj extends Model<BmSbsccj> {
    private static final long serialVersionUID = 1L;

    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String czryxm;
    /**
     * 厂家编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "厂家编码")
    private String code;
    /**
     * 厂家名称
     */
    @ApiModelProperty(value = "厂家名称")
    private String name;
    /**
     * 厂家地址
     */
    @ApiModelProperty(value = "厂家地址")
    private String cjdz;
    /**
     * 厂家备注
     */
    @ApiModelProperty(value = "厂家备注")
    private String cjbz;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;
    /**
     * 是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "是否启用：0不启用，1启用")
    private String isdisabled;
    /**
     * 操作人员操作人员名称
     */
    @ApiModelProperty(value = "操作人员操作人员名称")
    private String czry;

}
