/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 水表型号
 *
 * @author sxb
 * @date Thu Feb 22 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_SBXH", resultMap = "bmSbxhMap")
@KeySequence("BM_SBXH")
@ApiModel
public class BmSbxh extends Model<BmSbxh> {
    private static final long serialVersionUID = 1L;

    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String czryxm;
    /**
     * 型号编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "型号编码")
    private String code;
    /**
     * 水表厂家编码bm_sbsccj.code
     */
    @ApiModelProperty(value = "水表厂家编码bm_sbsccj.code")
    private String sbcj;
    /**
     * 型号名称
     */
    @ApiModelProperty(value = "型号名称")
    private String name;
    /**
     * 水表大小
     */
    @ApiModelProperty(value = "水表大小")
    private String sbdx;
    /**
     * 检测参数
     */
    @ApiModelProperty(value = "检测参数")
    private String jccs;
    /**
     * 采样点
     */
    @ApiModelProperty(value = "采样点")
    private String cyd;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String czry;
    /**
     * 是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "是否启用：0不启用，1启用")
    private String isdisabled;

}
