/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 收费渠道
 *
 * @author sxb
 * @date Thu Feb 22 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_SFQD", resultMap = "bmSfqdMap")
@KeySequence("BM_SFQD")
@ApiModel
public class BmSfqd extends Model<BmSfqd> {
    private static final long serialVersionUID = 1L;

    /**
     * 操作人员名称
     */
    @ApiModelProperty(value = "操作人员名称")
    private String xgryxm;
    /**
     * 是否外部单位（0：否；1：是）
     */
    @ApiModelProperty(value = "是否外部单位（0：否；1：是）")
    private String isextunit;
    /**
     * 营业点编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "营业点编码")
    private String code;
    /**
     * 营业点名称
     */
    @ApiModelProperty(value = "营业点名称")
    private String name;
    /**
     * 营业时间
     */
    @ApiModelProperty(value = "营业时间")
    private String yysj;
    /**
     * 负责人
     */
    @ApiModelProperty(value = "负责人")
    private String fzr;
    /**
     * 电话
     */
    @ApiModelProperty(value = "电话")
    private String lxdh;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 修改日期
     */
    @ApiModelProperty(value = "修改日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date xdate;
    /**
     * 修改人员
     */
    @ApiModelProperty(value = "修改人员")
    private String xgry;

}
