package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

import com.tofly.feesapi.common.constant.JtjslxEnum;
import com.tofly.feesapi.common.constant.JtsffsEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 
 * </p>
 *
 * @author decai
 * @since 2024-02-01
 */
@Getter
@Setter
@TableName("BM_SJLS")
@ApiModel(value = "BmSjls对象", description = "水价历史")
public class BmSjls implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键id")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty("财务日期")
    private String cwrq;

    @ApiModelProperty("编码")
    private String code;

    @ApiModelProperty("名称")
    private String name;

    @ApiModelProperty("基本水价")
    private BigDecimal sj;

    @ApiModelProperty("用水类型")
    private String yslx;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("操作人员")
    private String czry;

    @ApiModelProperty("创建时间")
    private LocalDateTime czsj;

    @ApiModelProperty("IC卡充值限量(吨)")
    private Long czxl;

    @ApiModelProperty("IC卡年充值限量(吨)")
    private Long nxl;

    @ApiModelProperty("阶梯标志（1是，0否）")
    private String jtbz;

    @ApiModelProperty("阶梯1水量止数")
    private BigDecimal jt1Zs;

    @ApiModelProperty("阶梯1算费水价")
    private BigDecimal jt1Sj;

    @ApiModelProperty("阶梯2水量止数")
    private BigDecimal jt2Zs;

    @ApiModelProperty("阶梯2算费水价")
    private BigDecimal jt2Sj;

    @ApiModelProperty("阶梯3水量止数")
    private BigDecimal jt3Zs;

    @ApiModelProperty("阶梯3算费水价")
    private BigDecimal jt3Sj;

    @ApiModelProperty("阶梯4水量止数")
    private BigDecimal jt4Zs;

    @ApiModelProperty("阶梯4算费水价")
    private BigDecimal jt4Sj;

    @ApiModelProperty("污水费单价")
    private BigDecimal wsfdj;

    @ApiModelProperty("垃圾费单价")
    private BigDecimal ljfdj;

    @ApiModelProperty("备注")
    private String bz;

    @ApiModelProperty("是否启用：0不启用，1启用")
    private String isdisabled;

    @ApiModelProperty("修改日期")
    private LocalDateTime xgrq;

    @ApiModelProperty("阶梯计算类型（0：正常；1：月阶梯；2：年阶梯）")
    private JtjslxEnum jtjslx;

    @ApiModelProperty("阶梯算费方式（SL：按水量；BL：按比例）")
    private JtsffsEnum jtsffs;

    @ApiModelProperty("税率：单位（%）0,3,6,13")
    private Integer taxrate;

    public static final String ID = "ID";

    public static final String CWRQ = "CWRQ";

    public static final String CODE = "CODE";

    public static final String NAME = "NAME";

    public static final String SJ = "SJ";

    public static final String YSLX = "YSLX";

    public static final String SSGS = "SSGS";

    public static final String CZRY = "CZRY";

    public static final String CZSJ = "CZSJ";

    public static final String CZXL = "CZXL";

    public static final String NXL = "NXL";

    public static final String JTBZ = "JTBZ";

    public static final String JT1_ZS = "JT1_ZS";

    public static final String JT1_SJ = "JT1_SJ";

    public static final String JT2_ZS = "JT2_ZS";

    public static final String JT2_SJ = "JT2_SJ";

    public static final String JT3_ZS = "JT3_ZS";

    public static final String JT3_SJ = "JT3_SJ";

    public static final String JT4_ZS = "JT4_ZS";

    public static final String JT4_SJ = "JT4_SJ";

    public static final String WSFDJ = "WSFDJ";

    public static final String LJFDJ = "LJFDJ";

    public static final String BZ = "BZ";

    public static final String ISDISABLED = "ISDISABLED";

    public static final String XGRQ = "XGRQ";

    public static final String JTJSLX = "JTJSLX";

    public static final String JTSFFS = "JTSFFS";

    public static final String TAXRATE = "TAXRATE";
}
