package com.tofly.feesapi.bmgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.models.auth.In;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用水类型
 *
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "BM_YSLX", resultMap = "bmYslxMap")
@KeySequence("BM_YSLX")
@ApiModel
public class BmYslx extends Model<BmYslx> {
    private static final long serialVersionUID = 1L;

    /**
     * 编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "编码")
    private String code;

    /**
     * 名称
     */
    @ApiModelProperty(value = "名称")
    private String name;

    /**
     * 违约金费率
     */
    @ApiModelProperty(value = "违约金费率")
    private BigDecimal znj;

    /**
     * 违约金收取方式
     */
    @ApiModelProperty(value = "违约金收取方式")
    private String znjbm;

    /**
     * 天数、日期
     */
    @ApiModelProperty(value = "天数、日期")
    private Integer znjday;

    /**
     * 所属公司编码
     */
    @ApiModelProperty(value = "所属公司编码")
    private String ssgs;

    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    private String bz;

    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String czry;

    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;

}
