package com.tofly.feesapi.bmgl.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
@ApiModel("抄表本(册)查询列表VO")
public class BmCbbSelect {

    @ApiModelProperty(value = "抄表本(册)编码", position = 4)
    private String cbbbm;

    /**
     * 表本名称
     */
    @ApiModelProperty(value = "抄表本(册)名称", position = 5)
    private String cbbmc;

    /**
     * 表本地址描述
     */
    @ApiModelProperty(value = "抄表本(册)地址描述", position = 6)
    private String dz;

    /**
     * 所属抄表员
     */
    @ApiModelProperty(value = "所属抄表员", position = 7)
    private String cby;

    /**
     * 所属抄表员
     */
    @ApiModelProperty(value = "所属抄表员名称", position = 8)
    private String cbymc;

    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司编码", position = 9)
    private String ssgs;

    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司名称", position = 10)
    private String ssgsmc;

    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区编码", position = 11)
    private String sscbpq;

    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区名称", position = 12)
    private String sscbpqmc;

    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明", position = 21)
    private String bz;

    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期", position = 22)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date cdate;

    /**
     * 更新日期
     */
    @ApiModelProperty(value = "更新日期", position = 23)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date xdate;

    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员", position = 25)
    private String czry;

    /**
     * 抄表员生效标志(0=当月生效，1=下月生效)
     */
    @ApiModelProperty(value = "抄表员生效标志(0=当月生效，1=下月生效)", position = 26)
    private String sxbz;

    /**
     * 下月抄表员的编码(仅当sxbz='1'时有效，月末结转时更新)
     */
    @ApiModelProperty(value = "下月抄表员的编码(仅当sxbz='1'时有效，月末结转时更新)", position = 27)
    private String xycby;

    /**
     * 下月抄表员的编码(仅当sxbz='1'时有效，月末结转时更新)
     */
    @ApiModelProperty(value = "下月抄表员的名称(仅当sxbz='1'时有效，月末结转时更新)", position = 28)
    private String xycbymc;
}

