package com.tofly.feesapi.bmgl.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDateTime;

@Getter
@Setter
@ApiModel(value = "水价列表VO", description = "水价信息")
public class BmSjSelect implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "所属公司", position = 3)
    private String ssgsmc;

    @ApiModelProperty(value = "水价编码", position = 4)
    private String code;

    @ApiModelProperty(value = "水价名称",position = 5)
    private String name;

    @ApiModelProperty(value = "用水类型", position = 6, example = "居民生活用水")
    private String yslxmc;

    @ApiModelProperty(value = "水价(含阶梯)", position = 7)
    private String hjtsj;

    @ApiModelProperty(value = "阶梯标志（1是，0否）", position = 8)
    private String jtbz;

    @ApiModelProperty(value = "污水费单价", position = 10)
    private String wsfdj;

    @ApiModelProperty(value = "垃圾费单价", position = 11)
    private String ljfdj;

    @ApiModelProperty(value = "创建时间", position = 12, example = "2024-01-30 15:16:36")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime czsj;
}

