package com.tofly.feesapi.bmgl.entity.vo;

import com.tofly.feesapi.common.constant.JtjslxEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

@Getter
@Setter
@ApiModel(value = "水价查看VO", description = "水价信息")
public class BmSjView implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "所属公司编码", position = 3, example = "1")
    private String ssgs;

    @ApiModelProperty(value = "用水类型编码", position = 4, example = "1")
    private String yslx;

    @ApiModelProperty(value = "水价名称", position = 5, example = "居民用水")
    private String name;

    @ApiModelProperty(value = "水价", position = 6, example = "5.2")
    private BigDecimal sj;

    @ApiModelProperty(value = "IC卡充值限量(方)", position = 7,  example = "999999999")
    private Long czxl;

    @ApiModelProperty(value = "IC卡年充值限量(方)", position = 8, example = "999999999")
    private Long nxl;

    //-----------------------------------------------------------

    @ApiModelProperty(value = "阶梯标志（1是，0否）", position = 20, example = "0")
    private String jtbz = "0";

    @ApiModelProperty(value = "阶梯计算类型", position = 21, example = "正常")
    private JtjslxEnum jtjslx;

    @ApiModelProperty(value = "阶梯1水量止数", position = 22, example = "20")
    private BigDecimal jt1Zs;

    @ApiModelProperty(value = "阶梯1算费水价", position = 23, example = "3.2")
    private BigDecimal jt1Sj;

    @ApiModelProperty(value = "阶梯2水量止数", position = 24, example = "40")
    private BigDecimal jt2Zs = BigDecimal.ZERO;

    @ApiModelProperty(value = "阶梯2算费水价", position = 25, example = "4.3")
    private BigDecimal jt2Sj = BigDecimal.ZERO;

    @ApiModelProperty(value = "阶梯3水量止数", position = 26, example = "50")
    private BigDecimal jt3Zs = BigDecimal.ZERO;

    @ApiModelProperty(value = "阶梯3算费水价", position = 27,  example = "6.4")
    private BigDecimal jt3Sj = BigDecimal.ZERO;

    @ApiModelProperty(value = "阶梯4水量止数", position = 28, example = "80")
    private BigDecimal jt4Zs = BigDecimal.ZERO;

    @ApiModelProperty(value = "阶梯4算费水价", position = 29, example = "9.0")
    private BigDecimal jt4Sj = BigDecimal.ZERO;

    //-----------------------------------------------------------
    @ApiModelProperty(value = "污水费单价", position = 35, example = "8")
    private BigDecimal wsfdj = BigDecimal.ZERO;

    @ApiModelProperty(value = "垃圾费单价", position = 36, example = "21")
    private BigDecimal ljfdj = BigDecimal.ZERO;
}
