package com.tofly.feesapi.bmgl.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDateTime;

@Getter
@Setter
@ApiModel(value = "水价历史记录列表VO", description = "水价信息")
public class BmSjlsSelect implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "历史记录ID", position = 1, example = "0451c679bb259efba7a4a9f3f47e592e")
    private String id;

    @ApiModelProperty(value = "水价名称", position = 5, example = "居民用水")
    private String name;

    @ApiModelProperty(value = "用水类型", position = 6, example = "居民生活用水")
    private String yslxmc;

    @ApiModelProperty(value = "阶梯标志（1是，0否）", position = 7, example = "1")
    private String jtbz;

    @ApiModelProperty(value = "修改日期", position = 12, example = "2024-01-30 15:16:36")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime xgrq;
}

