package com.tofly.feesapi.bmgl.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bmgl.entity.BmCbb;
import com.tofly.feesapi.bmgl.entity.dto.BmCbbFilter;
import com.tofly.feesapi.bmgl.entity.dto.BmCbbSelect;
import com.tofly.feesapi.bmgl.entity.dto.BmCbbSelect2;
import com.tofly.feesapi.bmgl.mapper.BmCbbMapper;
import com.tofly.feesapi.bmgl.service.BmCbbService;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.udb.smpn.entity.Company;
import com.tofly.feesapi.udb.smpn.entity.User;
import com.tofly.feesapi.udb.smpn.service.ICompanyService;
import com.tofly.feesapi.udb.smpn.service.IUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("bmCbbService")
public class BmCbbServiceImpl extends ServiceImpl<BmCbbMapper, BmCbb> implements BmCbbService {

    @Autowired
    private IUserService userService;

    @Autowired
    private ICompanyService companyService;

    @Override
    public PageResult<BmCbbSelect> getPage(PageDto pageDto, BmCbbFilter filter) {
        PageDto<BmCbbSelect> page = this.baseMapper.getPage(pageDto, filter);
        page.getRecords().forEach(e -> {
            if (e.getCby() != null) {
                User user = userService.get(Long.valueOf(e.getCby()));
                if (user != null) {
                    e.setCbymc(user.getRealName());
                } else {
                    e.setCbymc(e.getCby());
                }
            }
            if (e.getXycby() != null) {
                User user = userService.get(Long.valueOf(e.getXycby()));
                if (user != null) {
                    e.setXycbymc(user.getRealName());
                } else {
                    e.setXycbymc(e.getXycby());
                }
            }
            if (e.getSsgs() != null) {
                Company company = companyService.get(Long.valueOf(e.getSsgs()));
                if (company != null) {
                    e.setSsgsmc(company.getCompanyName());
                } else {
                    e.setSsgsmc(e.getSsgs());
                }
            }

        });
        return page.toVo();
    }

    @Override
    public PageResult<BmCbbSelect2> getPage2(PageDto pageDto, BmCbbFilter filter) {
        PageDto<BmCbbSelect2> page = this.baseMapper.getPage2(pageDto, filter);
        return page.toVo();
    }
}
