package com.tofly.feesapi.bmgl.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bmgl.entity.BmCbpq;
import com.tofly.feesapi.bmgl.entity.dto.BmCbpqFilter;
import com.tofly.feesapi.bmgl.entity.dto.BmCbpqSelect;
import com.tofly.feesapi.bmgl.mapper.BmCbpqMapper;
import com.tofly.feesapi.bmgl.service.BmCbpqService;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.udb.smpn.entity.User;
import com.tofly.feesapi.udb.smpn.service.IUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("bmCbpqService")
public class BmCbpqServiceImpl extends ServiceImpl<BmCbpqMapper, BmCbpq> implements BmCbpqService {

    @Autowired
    private IUserService userService;

    @Override
    public PageResult<BmCbpqSelect> getPage(PageDto pageDto, BmCbpqFilter filter) {
        PageDto<BmCbpqSelect> page = this.baseMapper.getPage(pageDto, filter);
        page.getRecords().forEach(e -> {
            if (e.getXgry() == null) return;
            User user = userService.get(Long.valueOf(e.getXgry()));
            if (user != null) {
                e.setXgrymc(user.getRealName());
            } else {
                e.setXgrymc(e.getXgry());
            }
        });
        return page.toVo();
    }
}
