package com.tofly.feesapi.bmgl.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bmgl.entity.BmYslx;
import com.tofly.feesapi.bmgl.entity.dto.BmYslxFilter;
import com.tofly.feesapi.bmgl.entity.vo.BmYslxSelect;
import com.tofly.feesapi.bmgl.service.BmYslxService;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.udb.smpn.entity.Company;
import com.tofly.feesapi.udb.smpn.service.ICompanyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.tofly.feesapi.bmgl.mapper.BmYslxMapper;

@Service("bmYslxService")
public class BmYslxServiceImpl extends ServiceImpl<BmYslxMapper, BmYslx> implements BmYslxService {


    @Autowired
    private ICompanyService companyService;

    @Override
    public PageResult<BmYslxSelect> getPage(PageDto pageDto, BmYslxFilter filter) {
        PageResult<BmYslxSelect> result = this.baseMapper.getPage(pageDto, filter).toVo();
        result.getRecords().forEach(e -> {
            if (e.getSsgs() != null) {
                Company company = companyService.get(Long.valueOf(e.getSsgs()));
                if (company != null) {
                    e.setSsgsmc(company.getCompanyName());
                } else {
                    e.setSsgsmc(e.getSsgs());
                }
            }
        });
        return result;
    }
}
