package com.tofly.feesapi.cbgl.controller;

import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.cbgl.entity.ZnbZlLog;
import com.tofly.feesapi.cbgl.entity.dto.ZnbFkFilter;
import com.tofly.feesapi.cbgl.entity.dto.ZnbZlLogFilter;
import com.tofly.feesapi.cbgl.entity.vo.ZnbZlLogSelect;
import com.tofly.feesapi.cbgl.service.IZnbZlLogService;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.security.model.CzyUserDetails;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

/**
 * <p>
 * 智能表指令明细 前端控制器
 * </p>
 *
 * @author decai
 * @since 2024-04-10
 */
@AllArgsConstructor
@RestController
@RequestMapping("/api/cbgl/znbZlLog")
@Api(tags = "智能表指令明细")
public class ZnbZlLogController {

    private final IZnbZlLogService znbZlLogService;

    @ApiOperationSupport(order = 1)
    @GetMapping("/page")
    @ApiOperation(value = "查询智能表指令明细（分页）")
    public ResultRespone<PageResult<ZnbZlLogSelect>> getPage(@ModelAttribute PageDto pageDto,
                                                             @ModelAttribute ZnbZlLogFilter filter) {
        return ResultRespone.success(znbZlLogService.getPage(pageDto, filter));
    }

    /**
     * 新增智能表指令明细
     *
     * @param znbZlLog 智能表指令明细
     * @return ResultRespone
     */
    @ApiOperationSupport(order = 2)
    @ApiOperation(value = "新增智能表指令明细")
    @PostMapping("/save")
    public ResultRespone save(@RequestBody ZnbZlLog znbZlLog) {
        return ResultRespone.success(znbZlLogService.save(znbZlLog));
    }

    @ApiOperationSupport(order = 3)
    @ApiOperation(value = "智能表阀控")
    @PostMapping
    public ResultRespone<Boolean> ZnbFk(@RequestBody ZnbFkFilter filter, @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        boolean result = znbZlLogService.ZnbFk(filter, czyUserDetails);
        return result ? ResultRespone.success(true, "指令下发成功") : ResultRespone.failed(false, "指令下发失败");
    }
//    @ApiOperationSupport(order = 2)
//    @GetMapping("/export")
//    @ApiOperation(value = "导出智能表指令明细")
//    public void export(HttpServletResponse response, @ModelAttribute ZnbCbLogFilter filter) throws IOException {
//        List<ZnbZlLogSelect> list = znbZlLogService.getList(filter);
//        if (!list.isEmpty()) {
//            ExcleFileUtil.exportExcel(response, list, ZnbZlLogSelect.class, "智能表指令明细.xlsx");
//        }
//    }
}
