package com.tofly.feesapi.cbgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 智能表抄表明细
 * </p>
 *
 * @author decai
 * @since 2024-04-08
 */
@Getter
@Setter
@TableName("ZNB_CB_LOG")
@ApiModel(value = "ZnbCbLog对象", description = "智能表抄表明细")
public class ZnbCbLog implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键id")
    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty("用户编号")
    private String yhbh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ApiModelProperty("抄表卡ID")
    private String cbkid;

    @ApiModelProperty("表具编号")
    private String bjbh;

    @ApiModelProperty("生产厂家")
    private String sccj;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("批次号")
    private String pch;

    @ApiModelProperty("操作人员")
    private String czry;

    @ApiModelProperty("操作时间")
    private LocalDateTime czsj;

    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ApiModelProperty("处理结果（0：未处理；1：成功处理；其它见bm_cb_clbz）")
    private String clCljg;

    @ApiModelProperty("处理人员")
    private String clClry;

    @ApiModelProperty("处理时间")
    private LocalDateTime clClsj;

    @ApiModelProperty("返回代码")
    private String clRecode;

    @ApiModelProperty("返回消息")
    private String clRemessage;

    @ApiModelProperty("所属抄表片区")
    private String sscbpq;

    @ApiModelProperty("所属抄表本")
    private String sscbb;

    @ApiModelProperty("财务日期")
    private String cwrq;

    @ApiModelProperty("上次抄表日期")
    private LocalDate sccbrq;

    @ApiModelProperty("上次读数")
    private BigDecimal scds;

    @ApiModelProperty("本次读数")
    private BigDecimal bcds;

    @ApiModelProperty("抄表人员编码")
    private String cbrybm;

    @ApiModelProperty("抄表人员姓名")
    private String cbryxm;

    @ApiModelProperty("抄表日期")
    private LocalDate cbrq;

    @ApiModelProperty("抄表-气表止度")
    private BigDecimal cbQbzs;

    @ApiModelProperty("录入人员编码")
    private String lrrybm;

    @ApiModelProperty("录入人员姓名")
    private String lrryxm;

    @ApiModelProperty("录入日期")
    private Date lrrq;

    @ApiModelProperty("购买次数")
    private Integer gmcs;

    @ApiModelProperty("剩余金额")
    private BigDecimal syje;

    @ApiModelProperty("电池电量")
    private String dcdl;

    @ApiModelProperty("电池状态")
    private String dczt;

    @ApiModelProperty("阀门状态")
    private String fmzt;

    @ApiModelProperty("信号")
    private String xh;

    @ApiModelProperty("表状态")
    private String bjzt;

    @ApiModelProperty("设备编号")
    private String sbbh;

    @ApiModelProperty("设备状态")
    private String sbzt;

    public static final String ID = "ID";

    public static final String YHBH = "YHBH";

    public static final String CBKH = "CBKH";

    public static final String CBKID = "CBKID";

    public static final String BJBH = "BJBH";

    public static final String SCCJ = "SCCJ";

    public static final String SSGS = "SSGS";

    public static final String PCH = "PCH";

    public static final String CZRY = "CZRY";

    public static final String CZSJ = "CZSJ";

    public static final String CL_LOCK = "CL_LOCK";

    public static final String CL_CLJG = "CL_CLJG";

    public static final String CL_CLRY = "CL_CLRY";

    public static final String CL_CLSJ = "CL_CLSJ";

    public static final String CL_RECODE = "CL_RECODE";

    public static final String CL_REMESSAGE = "CL_REMESSAGE";

    public static final String SSCBPQ = "SSCBPQ";

    public static final String SSCBB = "SSCBB";

    public static final String CWRQ = "CWRQ";

    public static final String SCCBRQ = "SCCBRQ";

    public static final String SCDS = "SCDS";

    public static final String BCDS = "BCDS";

    public static final String CBRYBM = "CBRYBM";

    public static final String CBRYXM = "CBRYXM";

    public static final String CBRQ = "CBRQ";

    public static final String CB_QBZS = "CB_QBZS";

    public static final String LRRYBM = "LRRYBM";

    public static final String LRRYXM = "LRRYXM";

    public static final String LRRQ = "LRRQ";

    public static final String GMCS = "GMCS";

    public static final String SYJE = "SYJE";

    public static final String DCDL = "DCDL";

    public static final String DCZT = "DCZT";

    public static final String FMZT = "FMZT";

    public static final String XH = "XH";

    public static final String BJZT = "BJZT";

    public static final String SBBH = "SBBH";

    public static final String SBZT = "SBZT";

}
