package com.tofly.feesapi.cbgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 智能表指令明细
 * </p>
 *
 * @author decai
 * @since 2024-04-10
 */
@Getter
@Setter
@TableName("ZNB_ZL_LOG")
@ApiModel(value = "ZnbZlLog对象", description = "智能表指令明细")
public class ZnbZlLog implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键id")
    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty("用户编号")
    private String yhbh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ApiModelProperty("抄表卡ID")
    private String cbkid;

    @ApiModelProperty("表具编号")
    private String bjbh;

    @ApiModelProperty("生产厂家")
    private String sccj;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("批次号")
    private String pch;

    @ApiModelProperty("操作人员")
    private String czry;

    @ApiModelProperty("操作时间")
    private LocalDateTime czsj;

    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ApiModelProperty("处理结果（0：未处理；1：成功处理；其它见bm_cljg）")
    private String clCljg;

    @ApiModelProperty("处理人员")
    private String clClry;

    @ApiModelProperty("处理时间")
    private LocalDateTime clClsj;

    @ApiModelProperty("返回代码")
    private String clRecode;

    @ApiModelProperty("返回消息")
    private String clRemessage;

    @ApiModelProperty("指令类型")
    private String zltype;

    @ApiModelProperty("指令值")
    private String zlvalue;

    @ApiModelProperty("交易流水号")
    private String jylsh;

    public static final String ID = "ID";

    public static final String YHBH = "YHBH";

    public static final String CBKH = "CBKH";

    public static final String CBKID = "CBKID";

    public static final String BJBH = "BJBH";

    public static final String SCCJ = "SCCJ";

    public static final String SSGS = "SSGS";

    public static final String PCH = "PCH";

    public static final String CZRY = "CZRY";

    public static final String CZSJ = "CZSJ";

    public static final String CL_LOCK = "CL_LOCK";

    public static final String CL_CLJG = "CL_CLJG";

    public static final String CL_CLRY = "CL_CLRY";

    public static final String CL_CLSJ = "CL_CLSJ";

    public static final String CL_RECODE = "CL_RECODE";

    public static final String CL_REMESSAGE = "CL_REMESSAGE";

    public static final String ZLTYPE = "ZLTYPE";

    public static final String ZLVALUE = "ZLVALUE";

    public static final String JYLSH = "JYLSH";
}
