package com.tofly.feesapi.cbgl.entity.dto;

import com.tofly.feesapi.common.constant.CbbzEnum;
import com.tofly.feesapi.common.constant.JsbzEnum;
import com.tofly.feesapi.common.constant.ShbzEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

@Data
@ApiModel("抄表录入查询参数DTO")
public class YyCblrFilter {


    @ApiModelProperty(value = "所属公司", position = 2)
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区", position = 3)
    private String sscbpq;

    @ApiModelProperty(value = "所属抄表本(册)", position = 4)
    private String sscbb;

    @ApiModelProperty(value = "抄表方式", position = 5)
    private String cbfs;

    @ApiModelProperty(value = "用水性质（水价编码）", position = 6)
    private String sjbm;

    @ApiModelProperty(value = "水表口径编码", position = 7)
    private String sbkj;

    @ApiModelProperty(value = "抄表人员编码", position = 8)
    private String cbrybm;

    @ApiModelProperty(value = "财务日期", position = 9)
    private String cwrq;

    @ApiModelProperty(value = "抄表标志", position = 10)
    private CbbzEnum cbbz;

    @ApiModelProperty(value = "抄表标志", position = 11)
    private ShbzEnum shbz;

    @ApiModelProperty(value = "计算标志", position = 12)
    private JsbzEnum jsbz;

    @ApiModelProperty(value = "录入开始日期(yyyy-MM-dd HH:mm:ss),示例值(2024-01-01 00:00:00)", position = 13)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime lrrqStart;

    @ApiModelProperty(value = "录入截止日期(yyyy-MM-dd HH:mm:ss),示例值(2024-01-30 23:59:59)", position = 14)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime lrrqEnd;

    @ApiModelProperty(value = "抄表序号", position = 15)
    private Integer cbxh;

    @ApiModelProperty(value = "关键字(用户编号、用户姓名、用户地址)", position = 20)
    private String searchText;

    @ApiModelProperty(value = "用户编号", position = 21)
    private String yhbh;


}
