package com.tofly.feesapi.cbgl.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;

@Data
@ApiModel("远传抄表明细查询参数DTO")
public class ZnbCbDayFilter {


    @ApiModelProperty(value = "所属公司", position = 2)
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区", position = 3)
    private String sscbpq;

    @ApiModelProperty(value = "所属抄表本(册)", position = 4)
    private String sscbb;

    @ApiModelProperty(value = "生产厂家编码", position = 5)
    private String sscj;

    @ApiModelProperty(value = "上传开始日期(yyyy-MM-dd HH:mm:ss)", required = true, position = 13, example = "2023-02-11 00:00:00")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime utimeStart;

    @ApiModelProperty(value = "上传截止日期(yyyy-MM-dd HH:mm:ss)", required = true, position = 14, example = "2023-02-11 23:59:59")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime utimeEnd;

    @ApiModelProperty(value = "关键字(用户编号、用户姓名、用户地址)", position = 20)
    private String searchText;


}
