package com.tofly.feesapi.cbgl.entity.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDateTime;

@Data
@ApiModel("智能表抄表明细查询参数DTO")
public class ZnbCbLogFilter {


    @ApiModelProperty(value = "所属公司", position = 2)
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区", position = 3)
    private String sscbpq;

    @ApiModelProperty(value = "所属抄表本(册)", position = 4)
    private String sscbb;

    @ApiModelProperty(value = "生产厂家编码", position = 5)
    private String sscj;

    @ApiModelProperty(value = "操作开始时间,示例值(2023-02-11 00:00:00)", required = true, position = 13)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime czsjStart;

    @ApiModelProperty(value = "操作截止时间,示例值(2023-02-11 23:59:59)", required = true, position = 14)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime czsjEnd;

    @ApiModelProperty(value = "关键字(用户编号、用户姓名、用户地址)", position = 20)
    private String searchText;

    @ApiModelProperty(value = "水量(>=)", position = 21)
    private BigDecimal slgt;

    @ApiModelProperty(value = "处理结果（0：未处理；1：成功处理；其它见bm_cb_clbz）", position = 22)
    private String clCljg;


}
