package com.tofly.feesapi.cbgl.entity.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDateTime;

@Data
@ApiModel("智能表指令明细查询参数DTO")
public class ZnbZlLogFilter {


    @ApiModelProperty(value = "所属公司", position = 2)
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区", position = 3)
    private String sscbpq;

    @ApiModelProperty(value = "所属抄表本(册)", position = 4)
    private String sscbb;

    @ApiModelProperty(value = "生产厂家编码", position = 5)
    private String sscj;

    @ApiModelProperty(value = "操作开始时间(yyyy-MM-dd HH:mm:ss)", required = true, position = 13, example = "2023-02-11 00:00:00")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime czsjStart;

    @ApiModelProperty(value = "操作截止时间(yyyy-MM-dd HH:mm:ss)", required = true, position = 14, example = "2023-02-11 23:59:59")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime czsjEnd;

    @ApiModelProperty(value = "关键字(用户编号、用户姓名、用户地址)", position = 20)
    private String searchText;

    @ApiModelProperty(value = "处理结果（0：未处理；1：成功处理；其它见bm_cljg）", position = 22)
    private String clCljg;

    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ApiModelProperty("指令(操作)类型编码")
    private String zltype;


}
