package com.tofly.feesapi.cbgl.entity.vo;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;


@Data
@ApiModel("远传抄表明细列表VO")
public class ZnbCbDaySelect {

    @ColumnWidth(20)
    @ExcelProperty("用户编号")
    @ApiModelProperty(value = "用户编号", position = 4)
    private String yhbh;

    @ColumnWidth(20)
    @ExcelProperty("用户姓名")
    @ApiModelProperty(value = "用户姓名", position = 5)
    private String yhxm;

    @ColumnWidth(20)
    @ExcelProperty("用户地址")
    @ApiModelProperty(value = "用户地址", position = 6)
    private String yhdz;

    @ColumnWidth(20)
    @ExcelProperty("所属片区")
    @ApiModelProperty(value = "抄表片区", position = 7)
    private String sscbpqmc;

    @ColumnWidth(20)
    @ExcelProperty("所属表册")
    @ApiModelProperty(value = "抄表本（册）", position = 8)
    private String sscbbmc;

    @ColumnWidth(20)
    @ExcelProperty("水表厂家")
    @ApiModelProperty(value = "水表厂家", position = 9)
    private String sccjmc;

    @ColumnWidth(20)
    @ExcelProperty("水表编号")
    @ApiModelProperty(value = "水表编号", position = 14)
    private String sbbh;

    @ColumnWidth(20)
    @ExcelProperty("财务日期")
    @ApiModelProperty(value = "财务日期", position = 15)
    private String cwrq;

    @ColumnWidth(20)
    @ExcelProperty("上次读数")
    @ApiModelProperty(value = "上次读数", position = 16)
    private BigDecimal scds;

    @ColumnWidth(20)
    @ExcelProperty("本次读数")
    @ApiModelProperty(value = "本次读数", position = 17)
    private BigDecimal bcds;

    @ColumnWidth(20)
    @ExcelProperty("抄回止数")
    @ApiModelProperty(value = "抄回止数", position = 18)
    private BigDecimal chzs;

    @ColumnWidth(20)
    @ExcelProperty("抄表日期")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "抄表日期", position = 19, example = "2024-01-30 15:16:36")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime cbrq;

    @ExcelProperty("上传时间")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "上传时间", position = 20, example = "2024-01-30 15:16:36")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime utime;

}
