package com.tofly.feesapi.cbgl.entity.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;


@Data
@ColumnWidth(10)
@ApiModel("智能表抄表明细列表VO")
public class ZnbCbLogSelect {

    @ExcelIgnore
    @ApiModelProperty("主键id")
    private String id;

    @ExcelProperty(value = "用户编号", order = 1)
    @ApiModelProperty(value = "用户编号", position = 1)
    private String yhbh;

    @ExcelIgnore
    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ExcelIgnore
    @ApiModelProperty("抄表卡ID")
    private String cbkid;

    @ExcelProperty(value = "水表编号", order = 5)
    @ApiModelProperty(value = "表具编号", position = 5)
    private String bjbh;

    @ExcelIgnore
    @ApiModelProperty("生产厂家")
    private String sccj;

    @ExcelIgnore
    @ApiModelProperty("所属公司")
    private String ssgs;

    @ExcelIgnore
    @ApiModelProperty("批次号")
    private String pch;

    @ExcelIgnore
    @ApiModelProperty("操作人员")
    private String czry;

    @ExcelProperty(value = "操作时间", order = 7)
    @ColumnWidth(15)
    @ApiModelProperty(value = "操作时间", example = "2024-01-30 15:16:36")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date czsj;

    @ExcelIgnore
    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ExcelIgnore
    @ApiModelProperty("处理结果（0：未处理；1：成功处理；其它见bm_cb_clbz）")
    private String clCljg;

    @ExcelIgnore
    @ApiModelProperty("处理人员")
    private String clClry;

    @ExcelProperty(value = {"抄表信息", "处理时间"}, order = 12)
    @ColumnWidth(15)
    @ApiModelProperty(value = "处理时间", example = "2024-01-30 15:16:36")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date clClsj;

    @ExcelIgnore
    @ApiModelProperty("返回代码")
    private String clRecode;

    @ExcelIgnore
    @ApiModelProperty("返回消息")
    private String clRemessage;

    @ExcelIgnore
    @ApiModelProperty("所属抄表片区")
    private String sscbpq;

    @ExcelIgnore
    @ApiModelProperty("所属抄表本")
    private String sscbb;

    @ExcelProperty(value = "财务日期", order = 6)
    @ApiModelProperty("财务日期")
    private String cwrq;

    @ExcelIgnore
    @ApiModelProperty("上次抄表日期")
    private Date sccbrq;

    @ExcelProperty(value = {"抄表信息", "起度"}, order = 8)
    @ApiModelProperty("上次读数")
    private BigDecimal scds;

    @ExcelProperty(value = {"抄表信息", "止度"}, order = 9)
    @ApiModelProperty("本次读数")
    private BigDecimal bcds;

    @ExcelProperty(value = {"抄表信息", "水量"}, order = 10)
    @ApiModelProperty("水量")
    private BigDecimal sl;

    @ExcelIgnore
    @ApiModelProperty("抄表人员编码")
    private String cbrybm;

    @ExcelIgnore
    @ApiModelProperty("抄表人员姓名")
    private String cbryxm;

    @ExcelProperty(value = {"抄表信息", "抄表日期"}, order = 11)
    @ApiModelProperty(value = "抄表日期", example = "2024-01-30")
    @DateTimeFormat("yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date cbrq;

    @ExcelIgnore
    @ApiModelProperty("抄表-气表止度")
    private BigDecimal cbQbzs;

    @ExcelIgnore
    @ApiModelProperty("录入人员编码")
    private String lrrybm;

    @ExcelIgnore
    @ApiModelProperty("录入人员姓名")
    private String lrryxm;

    @ExcelIgnore
    @ApiModelProperty("录入日期")
    private Date lrrq;

    @ExcelIgnore
    @ApiModelProperty("购买次数")
    private Integer gmcs;

    @ExcelIgnore
    @ApiModelProperty("剩余金额")
    private BigDecimal syje;

    @ExcelIgnore
    @ApiModelProperty("电池电量")
    private String dcdl;

    @ExcelIgnore
    @ApiModelProperty("电池状态")
    private String dczt;

    @ExcelIgnore
    @ApiModelProperty("阀门状态")
    private String fmzt;

    @ExcelIgnore
    @ApiModelProperty("信号")
    private String xh;

    @ExcelIgnore
    @ApiModelProperty("表状态")
    private String bjzt;

    @ExcelIgnore
    @ApiModelProperty("设备编号")
    private String sbbh;

    @ExcelIgnore
    @ApiModelProperty("设备状态")
    private String sbzt;

    @ExcelProperty(value = "用户姓名", order = 2)
    @ApiModelProperty(value = "用户姓名", position = 2)
    private String yhxm;

    @ExcelIgnore
    @ApiModelProperty(value = "用户地址", position = 6)
    private String yhdz;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表片区", position = 7)
    private String sscbpqmc;

    @ExcelProperty(value = "所属表册", order = 3)
    @ApiModelProperty(value = "抄表本（册）", position = 3)
    private String sscbbmc;

    @ExcelProperty(value = "水表厂家", order = 4)
    @ApiModelProperty(value = "水表厂家", position = 4)
    private String sccjmc;

    @ExcelProperty(value = "结算标志", order = 13)
    @ApiModelProperty(value = "结算标志", position = 13)
    private String jsbz;

    @ExcelProperty(value = {"结算信息", "结算时间"}, order = 14)
    @ApiModelProperty(value = "结算时间", example = "2024-01-30 15:16:36")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date jssj;

    @ExcelProperty(value = {"结算信息", "本次余额"}, order = 15)
    @ApiModelProperty(value = "本次余额", position = 15)
    private BigDecimal bcye;

}
