package com.tofly.feesapi.cbgl.entity.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;


@Data
@ColumnWidth(10)
@ApiModel("智能表指令明细列表VO")
public class ZnbZlLogSelect {

    @ApiModelProperty("主键id")
    private String id;

    @ApiModelProperty("用户编号")
    private String yhbh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ApiModelProperty("抄表卡ID")
    private String cbkid;

    @ApiModelProperty("表具编号")
    private String bjbh;

    @ApiModelProperty("生产厂家")
    private String sccj;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("批次号")
    private String pch;

    @ApiModelProperty("操作人员")
    private String czry;

    @ApiModelProperty("操作时间")
    private LocalDateTime czsj;

    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ApiModelProperty("处理结果（0：未处理；1：成功处理；其它见bm_cljg）")
    private String clCljg;

    @ApiModelProperty("处理人员")
    private String clClry;

    @ApiModelProperty("处理时间")
    private LocalDateTime clClsj;

    @ApiModelProperty("返回代码")
    private String clRecode;

    @ApiModelProperty("返回消息")
    private String clRemessage;

    @ApiModelProperty("指令类型")
    private String zltype;

    @ApiModelProperty("指令值")
    private String zlvalue;

    @ApiModelProperty("交易流水号")
    private String jylsh;

    @ExcelProperty(value = "用户姓名", order = 2)
    @ApiModelProperty(value = "用户姓名", position = 2)
    private String yhxm;

    @ExcelIgnore
    @ApiModelProperty(value = "用户地址", position = 6)
    private String yhdz;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表片区", position = 7)
    private String sscbpqmc;

    @ExcelProperty(value = "所属表册", order = 3)
    @ApiModelProperty(value = "抄表本（册）", position = 3)
    private String sscbbmc;

    @ExcelProperty(value = "水表厂家", order = 4)
    @ApiModelProperty(value = "水表厂家", position = 4)
    private String sccjmc;

    @ExcelProperty(value = "结算标志", order = 13)
    @ApiModelProperty(value = "结算标志", position = 13)
    private String jsbz;

    @ExcelProperty(value = {"结算信息", "结算时间"}, order = 14)
    @ApiModelProperty(value = "结算时间", example = "2024-01-30 15:16:36")
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date jssj;

    @ExcelProperty(value = {"结算信息", "本次余额"}, order = 15)
    @ApiModelProperty(value = "本次余额", position = 15)
    private BigDecimal bcye;

}
