package com.tofly.feesapi.cbgl.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.feesapi.cbgl.entity.YyCblrLs;
import com.tofly.feesapi.cbgl.entity.dto.YyCbycmxFilter;
import com.tofly.feesapi.cbgl.entity.vo.CbSltjSelect;
import com.tofly.feesapi.cbgl.entity.vo.CbltjSelect;
import com.tofly.feesapi.cbgl.entity.vo.YyCbycmxSelect;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;

import java.util.List;

public interface YyCblrLsService extends IService<YyCblrLs> {

    /**
     * 抄表水量统计
     * @param ssgs 所属公司编码
     * @param cwrq 财务日期
     * @param tjlb 统计类别
     * @return
     */
    List<CbSltjSelect> cbsltj(String tjlb, String ssgs, String cwrq);

    /**
     * 抄表率统计
     * @param ssgs 所属公司编码
     * @param cwrq 财务日期
     * @param tjlb 统计类别
     * @return
     */
    List<CbltjSelect> cbltj(String tjlb, String ssgs, String cwrq);

    /**
     * 抄表异常统计(分页)
     * @param pageDto
     * @param filter
     * @return
     */
    PageResult<YyCbycmxSelect> cbycmxPage(PageDto pageDto, YyCbycmxFilter filter);

    /**
     * 抄表异常统计
     * @param filter
     * @return
     */
    List<YyCbycmxSelect> cbycmx(YyCbycmxFilter filter);
}
