/*
 * Author: wangjian
 * 生成Service
 */
package com.tofly.feesapi.cbgl.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.entity.dto.YyCblrFilter;
import com.tofly.feesapi.cbgl.entity.dto.YyCblrUpdate;
import com.tofly.feesapi.cbgl.entity.dto.YyCbycmxFilter;
import com.tofly.feesapi.cbgl.entity.vo.*;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxInsert;

import java.util.List;
import java.util.Map;

/**
 * 抄表计划_抄表录入
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
public interface YyCblrService extends IService<YyCblr> {

    YyCblr save(CzyUserDetails czyUserDetails, YhKhjbxxInsert insert, YhCbkxx cbkxx);

    PageResult<YyCblrSelect> getPage(PageDto pageDto, YyCblrFilter filter);

    YyCblrView getViewById(String yhbh, String cbkh);

    boolean update(YyCblrUpdate update, CzyUserDetails czyUserDetails);

    List<YyCblrSelect> getList(YyCblrFilter filter);

    /**
     * 抄表水量统计
     * @param ssgs 所属公司编码
     * @param cwrq 财务日期
     * @param tjlb 统计类别
     * @return
     */
    List<CbSltjSelect> cbsltj(String ssgs, String cwrq, String tjlb);

    /**
     * 生成抄表录入记录
     */
    void sccblr();

    /**
     * 抄表率统计
     * @param ssgs 所属公司编码
     * @param cwrq 财务日期
     * @param tjlb 统计类别
     * @return
     */
    List<CbltjSelect> cbltj(String ssgs, String cwrq, String tjlb);

    /**
     * 抄表异常明细
     * @param pageDto
     * @param filter
     * @return
     */
    PageResult<YyCbycmxSelect> cbycmx(PageDto pageDto, YyCbycmxFilter filter);

    /**
     * 抄表异常明细
     * @param filter
     * @return
     */
    List<YyCbycmxSelect> cbycmx(YyCbycmxFilter filter);

    void updateJsbz(String cbkid);

    PageResult<YyCblrSelect> getPage2(PageDto pageDto, YyCblrFilter filter);

    Map getCblrMap(String cbkid);

    void cbymjz();
}
