package com.tofly.feesapi.cbgl.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.bmgl.entity.BmCbb;
import com.tofly.feesapi.bmgl.entity.SysChildCode;
import com.tofly.feesapi.bmgl.service.BmCbbService;
import com.tofly.feesapi.bmgl.service.SysChildCodeService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.entity.YyCblrLs;
import com.tofly.feesapi.cbgl.entity.dto.YyCblrFilter;
import com.tofly.feesapi.cbgl.entity.dto.YyCblrUpdate;
import com.tofly.feesapi.cbgl.entity.dto.YyCbycmxFilter;
import com.tofly.feesapi.cbgl.entity.vo.*;
import com.tofly.feesapi.cbgl.mapper.YyCblrMapper;
import com.tofly.feesapi.cbgl.service.YyCblrLsService;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.constant.CbbzEnum;
import com.tofly.feesapi.common.constant.JsbzEnum;
import com.tofly.feesapi.common.constant.ShbzEnum;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.common.util.DateUtils;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.sfgl.service.YyQfmxService;
import com.tofly.feesapi.udb.smpn.entity.User;
import com.tofly.feesapi.udb.smpn.service.IUserService;
import com.tofly.feesapi.xtgl.entity.SysGdcsb;
import com.tofly.feesapi.xtgl.entity.Syscommlog;
import com.tofly.feesapi.xtgl.service.ISysGdcsbService;
import com.tofly.feesapi.xtgl.service.ISyscommlogService;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxInsert;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.support.TransactionTemplate;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.nio.charset.StandardCharsets;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

import static com.tofly.feesapi.common.constant.Constants.PERCENT_FORMAT;

@Service("yyCblrService")
@Slf4j
public class YyCblrServiceImpl extends ServiceImpl<YyCblrMapper, YyCblr> implements YyCblrService {

    @Autowired
    private ISysGdcsbService gdcsbService;
    @Autowired
    private YyCblrLsService cblrLsService;
    @Autowired
    private BmCbbService cbbService;
    @Autowired
    private YhCbkxxService cbkxxService;
    @Autowired
    private YhKhjbxxService khjbxxService;

    @Autowired
    private IUserService userService;

    @Autowired
    private SysChildCodeService sysChildCodeService;

    @Autowired
    private ISyscommlogService syscommlogService;

    @Autowired
    private YyQfmxService yyQfmxService;

    @Autowired
    private YyCblrMapper yyCblrMapper;

    @Override
    public YyCblr save(CzyUserDetails czyUserDetails, YhKhjbxxInsert insert, YhCbkxx cbkxx) {
        String ssgs = insert.getSsgs();
        String sscbpq = insert.getSscbpq();
        String sscbb = insert.getSscbb();
        String yhbh = cbkxx.getYhbh();
        String cbkh = cbkxx.getCbkh();
        String cbkid = cbkxx.getCbkid();
        return savePlan(yhbh, cbkh, cbkid, ssgs, sscbpq, sscbb);//添加抄表计划
    }

    @Override
    public PageResult<YyCblrSelect> getPage(PageDto pageDto, YyCblrFilter filter) {
        PageDto<YyCblrSelect> page = this.baseMapper.getPage(pageDto, filter);
        return page.toVo();
    }

    @Override
    public YyCblrView getViewById(String yhbh, String cbkh) {
        YyCblrView view = this.baseMapper.getViewById(yhbh, cbkh);
        return view;
    }

    @Override
    public boolean update(YyCblrUpdate update, CzyUserDetails czyUserDetails) {
        String yhbh = update.getYhbh();
        String cbkh = update.getCbkh();
        String cblx = update.getCblx();
        if (StringUtils.isBlank(yhbh)) throw new FeesException("用户编号不能为空", FeesErrorCode.BUSINESS_ERROR);
        if (StringUtils.isBlank(cbkh)) throw new FeesException("抄表卡号不能为空", FeesErrorCode.BUSINESS_ERROR);
        if (StringUtils.isBlank(cblx)) throw new FeesException("抄表类型不能为空", FeesErrorCode.BUSINESS_ERROR);
        YyCblr yyCblr = this.getOne(Wrappers.lambdaQuery(YyCblr.class).eq(YyCblr::getYhbh, yhbh).eq(YyCblr::getCbkh, cbkh));
        if (yyCblr.getShbz() != null && yyCblr.getShbz() == ShbzEnum.审核通过) {
            throw new FeesException("审核通过不允许修改", FeesErrorCode.BUSINESS_ERROR);
        }
        if (yyCblr.getJsbz() != null && yyCblr.getJsbz() == JsbzEnum.已算费) {
            throw new FeesException("已算费不允许修改", FeesErrorCode.BUSINESS_ERROR);
        }
        BigDecimal before = yyCblr.getScds();//修改前上次读数
        BeanUtils.copyProperties(update, yyCblr);

        BigDecimal sl = getSjsl(update);
        yyCblr.setSl(sl);
        if (czyUserDetails != null) {
            yyCblr.setCbrybm(String.valueOf(czyUserDetails.getId()));
            yyCblr.setCbryxm(czyUserDetails.getRealName());
            yyCblr.setLrrybm(String.valueOf(czyUserDetails.getId()));
            yyCblr.setLrryxm(czyUserDetails.getRealName());
        }
        yyCblr.setCbrq(new Date());
        yyCblr.setLrrq(yyCblr.getCbrq());
        yyCblr.setCbbz(CbbzEnum.已抄表);
        yyCblr.setCbly(update.getCbly());
        this.updateById(yyCblr);
        String xgds = update.getXgds();
        if ("1".equals(xgds)) {
            Syscommlog log = new Syscommlog();
            log.setTablename("yy_cblr");
            BigDecimal after = update.getScds();
            log.setMstext(String.format("抄表录入-修改底数【用户编号%s，抄表卡号%s，修改前%s，修改后%s】", yhbh, cbkh, before, after));
            if (czyUserDetails != null) {
                log.setUserid(String.valueOf(czyUserDetails.getId()));
            }
            log.setOptype("Modif");
            LocalDateTime now = LocalDateTime.now();
            log.setAddate(now.format(DateTimeFormatter.ISO_DATE_TIME));
            syscommlogService.save(log);
        }
        return true;
    }

    private BigDecimal getSjsl(YyCblrUpdate update) {
        String cblx = update.getCblx();
        BigDecimal sl = null;
        BigDecimal scds = update.getScds();
        BigDecimal bcds = update.getBcds();
        BigDecimal jjl = update.getJjl();
        if (scds == null) throw new FeesException("上次读数不能为空", FeesErrorCode.BUSINESS_ERROR);
        if (bcds == null) throw new FeesException("本次读数不能为空", FeesErrorCode.BUSINESS_ERROR);
        if (jjl == null && !"-3".equals(cblx)) throw new FeesException("加减量不能为空", FeesErrorCode.BUSINESS_ERROR);
        if ("0".equals(cblx)) {//正常
            sl = bcds.subtract(scds).add(jjl);
        } else if ("-2".equals(cblx)) {//表满度
            String sblcbm = update.getSblc();
            if (StringUtils.isBlank(sblcbm))
                throw new FeesException("水表量程编码不能为空", FeesErrorCode.BUSINESS_ERROR);
            SysChildCode sblc = sysChildCodeService.get("13", sblcbm);
            if (sblc == null) throw new FeesException("水表量程不存在", FeesErrorCode.BUSINESS_ERROR);
            int sblccd = Integer.valueOf(sblcbm);
            sl = new BigDecimal(Math.pow(10, sblccd)).subtract(scds).add(bcds).abs().add(jjl);
            String yhbh = update.getYhbh();
            cbkxxService.updateSblc(yhbh, sblcbm);
        } else if ("-3".equals(cblx)) {//洗换表
            BigDecimal jbzd = update.getJbzd();
            BigDecimal xbqd = update.getXbqd();
            sl = jbzd.subtract(scds).add(bcds.subtract(xbqd));
        } else if ("-8".equals(cblx)) {//表倒走
            sl = bcds.subtract(scds).abs().add(jjl);
        }
        return sl;
    }

    @Override
    public List<YyCblrSelect> getList(YyCblrFilter filter) {
        return this.baseMapper.getList(filter);
    }

    @Override
    public List<CbSltjSelect> cbsltj(String ssgs, String cwrq, String tjlb) {
        if (!List.of("cbry", "sjbm").contains(tjlb)) return new ArrayList<>();
        if (ssgs == null) return new ArrayList<>();
        String selectCwrq = gdcsbService.selectCwrq();
        List<CbSltjSelect> cbsltj = null;
        if (selectCwrq.equals(cwrq)) {
            cbsltj = this.cbsltj(tjlb, ssgs);
        } else {
            cbsltj = cblrLsService.cbsltj(tjlb, ssgs, cwrq);
        }
        return cbsltj;
    }

    @Override
    @Transactional
    public void sccblr() {
        List<BmCbb> cbbs = cbbService.lambdaQuery().select(BmCbb::getSsgs, BmCbb::getSscbpq, BmCbb::getCbbbm).list();
        cbbs = cbbs.stream().sorted(Comparator.comparing(BmCbb::getSsgs)
                        .thenComparing(BmCbb::getSscbpq))
                .collect(Collectors.toList());
        cbbs.forEach(cbb -> {
            sccblr(cbb);
        });
    }

    public void cbymjz() {
        Syscommlog syscommlog = new Syscommlog();
        try {
            log.info("月末结转开始");
            String CZRY = "YMJZ";
            //获取已抄表未算费数据
            List<YyCblr> cblrs = this.lambdaQuery()
                    .eq(YyCblr::getCbbz, CbbzEnum.已抄表)
                    .eq(YyCblr::getJsbz, JsbzEnum.未算费)
                    .list();
            //算费
            int count = yyQfmxService.Tasksf(cblrs);
            log.info("调用算费，成功{}条，失败{}条", count, cblrs.size() - count);
            syscommlog.setTablename("yy_qfmx");
            syscommlog.setMstext("月末结转调用Tasksf");
            syscommlog.setAddate(LocalDateTime.now().format(DateTimeFormatter.ISO_DATE_TIME));
            syscommlog.setRemark(String.format("调用算费，成功%s条，失败%s条", count, cblrs.size() - count));
            syscommlog.setUserid(CZRY);
            syscommlogService.save(syscommlog);

            cbymjzDataDis(cblrs, count);
            log.info("月末结转结束");

        } catch (Exception e) {
            log.error("月末结转失败", e);
            syscommlog = new Syscommlog();
            syscommlog.setTablename("yy_qfmx");
            syscommlog.setMstext("月末结转调用Tasksf");
            syscommlog.setAddate(LocalDateTime.now().format(DateTimeFormatter.ISO_DATE_TIME));
            syscommlog.setRemark("月末结转失败：" + e.getMessage());
            syscommlogService.save(syscommlog);
            throw new FeesException("月末结转失败", FeesErrorCode.BUSINESS_ERROR);
        }

    }

    @Transactional(rollbackFor = Exception.class)
    public void cbymjzDataDis(List<YyCblr> cblrs, int count) {
        Syscommlog syscommlog = new Syscommlog();
        try {
            boolean tf = true;
            if (cblrs.size() > 0 && cblrs.size() > count) {
                //失败记录添加到月末结转算费失败表

                tf = yyCblrMapper.YMJZSFSB();
                if (!tf) {
                    log.info("月末结转-失败记录添加到月末结转算费失败表失败");
                    throw new FeesException("失败记录添加到月末结转算费失败表失败", FeesErrorCode.BUSINESS_ERROR);
                }
            }
            //未算费处理成未抄表失败
            cblrs = this.lambdaQuery()
                    .eq(YyCblr::getCbbz, CbbzEnum.已抄表)
                    .eq(YyCblr::getJsbz, JsbzEnum.未算费)
                    .list();
            if (cblrs.size() > 0) {
                tf = this.lambdaUpdate()
                        .set(YyCblr::getCbbz, CbbzEnum.未抄表)
                        .set(YyCblr::getShbz, ShbzEnum.未审核)
                        .set(YyCblr::getJjl, 0)
                        .set(YyCblr::getSl, 0)
                        .setSql("BCDS=SCDS")
                        .eq(YyCblr::getCbbz, CbbzEnum.已抄表)
                        //.eq(YyCblr::getShbz, ShbzEnum.未审核)
                        .eq(YyCblr::getJsbz, JsbzEnum.未算费)
                        .update();
                if (!tf) {
                    log.info("月末结转-未算费处理成未抄表失败");
                    throw new FeesException("未算费处理成未抄表失败", FeesErrorCode.BUSINESS_ERROR);
                }
            }
            //查询当前公司的财务日期
            String selectCwrq = gdcsbService.selectCwrq();
            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM");
            String newCwrq = DateUtils.formatDate(
                    org.apache.commons.lang3.time.DateUtils.addMonths(sdf.parse(selectCwrq), 1)
                    , "yyyyMM");
            //更新上月财务日期
            List<SysGdcsb> sysGdcsbList = gdcsbService.lambdaQuery()
                    .eq(SysGdcsb::getSsgs, "1")
                    .eq(SysGdcsb::getCwrq, selectCwrq)
                    .eq(SysGdcsb::getGdbz, "0")
                    .list();
            if (sysGdcsbList.size() > 0) {
                tf = gdcsbService.lambdaUpdate()
                        .set(SysGdcsb::getGdrq, new Date())
                        .set(SysGdcsb::getGdbz, "1")
                        .eq(SysGdcsb::getSsgs, "1")
                        .eq(SysGdcsb::getCwrq, selectCwrq)
                        .eq(SysGdcsb::getGdbz, "0")
                        .update();
                if (!tf) {
                    log.info("月末结转-更新上月财务日期失败");
                    throw new FeesException("更新上月财务日期失败", FeesErrorCode.BUSINESS_ERROR);
                }
            }
            //新增下月财务日期
            sysGdcsbList = gdcsbService.lambdaQuery()
                    .eq(SysGdcsb::getSsgs, "1")
                    .eq(SysGdcsb::getCwrq, newCwrq)
                    .eq(SysGdcsb::getGdbz, "0")
                    .list();
            if (sysGdcsbList.size() == 0) {
                SysGdcsb gdcsb = new SysGdcsb();
                gdcsb.setSsgs("1");
                gdcsb.setGdbz("0");
                gdcsb.setZwrq(LocalDateTime.now().format(DateTimeFormatter.ISO_DATE));
                gdcsb.setCwrq(newCwrq);
                tf = gdcsbService.save(gdcsb);
                if (!tf) {
                    log.info("月末结转-新增下月财务日期失败");
                    throw new FeesException("新增下月财务日期失败", FeesErrorCode.BUSINESS_ERROR);
                }
            }
            //插入历史抄表明细表
            tf = yyCblrMapper.yyCblrls();
            if (!tf) {
                log.info("月末结转-插入历史抄表明细表失败");
                throw new FeesException("插入历史抄表明细表失败", FeesErrorCode.BUSINESS_ERROR);
            }
            //更新普表、远程表档案中的水表起数、最新抄表日期字段
            tf = yyCblrMapper.updateCbb();
            if (!tf) {
                log.info("月末结转-更新普表、远程表档案中的水表起数、最新抄表日期字段失败");
                throw new FeesException("更新普表、远程表档案中的水表起数、最新抄表日期字段失败", FeesErrorCode.BUSINESS_ERROR);
            }
            //月阶梯累计量清零
            tf = khjbxxService.lambdaUpdate()
                    .set(YhKhjbxx::getJtzqljl, 0)
                    .inSql(YhKhjbxx::getYhbh, "SELECT YHBH FROM YH_CBKXX A INNER JOIN BM_SJ B ON (A.SJBM = B.CODE)  WHERE B.JTJSLX = '1'")
                    .update();
            if (!tf) {
                log.info("月末结转-月阶梯累计量清零失败");
                throw new FeesException("月阶梯累计量清零失败", FeesErrorCode.BUSINESS_ERROR);
            }
            //最后更新抄表计划的数据
            tf = this.lambdaUpdate()
                    .set(YyCblr::getCwrq, newCwrq)
                    .setSql("SCDS=BCDS")
                    .set(YyCblr::getJjl, 0)
                    .set(YyCblr::getSl, 0)
                    .set(YyCblr::getCbryxm, "")
                    .set(YyCblr::getCbrybm, "")
                    .set(YyCblr::getCbrq, "")
                    .set(YyCblr::getLrrq, "")
                    .set(YyCblr::getLrrybm, "")
                    .set(YyCblr::getLrryxm, "")
                    .set(YyCblr::getPhoto, "")
                    .set(YyCblr::getCbbz, CbbzEnum.未抄表)
                    .set(YyCblr::getShbz, ShbzEnum.未审核)
                    .set(YyCblr::getJsbz, JsbzEnum.未算费)
                    .set(YyCblr::getCbcs, 1)
                    .set(YyCblr::getBz, "")
                    .set(YyCblr::getCblx, "0")
                    .set(YyCblr::getCbfs, "01")
                    .set(YyCblr::getCbly, "0")
                    .set(YyCblr::getJbzd, 0)
                    .set(YyCblr::getXbqd, 0)
                    .eq(YyCblr::getSsgs, "1")
                    .update();
            if (!tf) {
                log.info("月末结转-最后更新抄表计划的数据失败");
                throw new FeesException("最后更新抄表计划的数据失败", FeesErrorCode.BUSINESS_ERROR);
            }

        } catch (Exception e) {
            log.error("月末结转失败", e);
            syscommlog = new Syscommlog();
            syscommlog.setTablename("yy_qfmx");
            syscommlog.setMstext("月末结转调用Tasksf");
            syscommlog.setAddate(LocalDateTime.now().format(DateTimeFormatter.ISO_DATE_TIME));
            syscommlog.setRemark("月末结转失败：" + e.getMessage());
            syscommlogService.save(syscommlog);
            throw new FeesException("月末结转失败", FeesErrorCode.BUSINESS_ERROR);
        }
    }

    @Override
    public List<CbltjSelect> cbltj(String ssgs, String cwrq, String tjlb) {
        if (!List.of("cbry", "sscbb").contains(tjlb)) return new ArrayList<>();
        if (ssgs == null) return new ArrayList<>();
        String selectCwrq = gdcsbService.selectCwrq();
        if (selectCwrq.equals(cwrq)) {
            return this.cbltj(tjlb, ssgs);
        } else {
            return cblrLsService.cbltj(tjlb, ssgs, cwrq);
        }
    }

    @Override
    public PageResult<YyCbycmxSelect> cbycmx(PageDto pageDto, YyCbycmxFilter filter) {
        PageResult<YyCbycmxSelect> result = cblrLsService.cbycmxPage(pageDto, filter);
        return result;
    }

    @Override
    public List<YyCbycmxSelect> cbycmx(YyCbycmxFilter filter) {
        return cblrLsService.cbycmx(filter);
    }

    @Override
    public void updateJsbz(String cbkid) {
        this.lambdaUpdate()
                .set(YyCblr::getJsbz, JsbzEnum.已算费)
                .eq(YyCblr::getCbkid, cbkid)
                .update();
    }

    @Override
    public PageResult<YyCblrSelect> getPage2(PageDto pageDto, YyCblrFilter filter) {
        PageDto<YyCblrSelect> page = this.baseMapper.getPage2(pageDto, filter);
        return page.toVo();
    }

    @Override
    public Map getCblrMap(String cbkid) {
        return this.baseMapper.getCblrMap(cbkid);
    }

    private List<CbltjSelect> cbltj(String tjlb, String ssgs) {
        List<CbltjSelect> cbltj = this.baseMapper.cbltj(tjlb, ssgs);
        cbltj.forEach(e -> {
            if ("cbry".equals(tjlb)) {
                String cbrybm = e.getTjlb();
                if (cbrybm != null) {
                    User user = userService.get(Long.valueOf(cbrybm));
                    if (user != null)
                        e.setTjlb(user.getRealName());
                }
            }
            //e.setScbs(20);
            //e.setYcbs(30);
            Integer ycbs = e.getYcbs();
            Integer scbs = e.getScbs();
            e.setWcbs(ycbs - scbs);
            BigDecimal cbl = new BigDecimal(scbs * 100).divide(new BigDecimal(ycbs), 2, RoundingMode.DOWN);
            e.setCbl(PERCENT_FORMAT.format(cbl));
        });

        if (!cbltj.isEmpty()) {
            int ycbs = cbltj.stream().map(e -> e.getYcbs()).reduce(0, (x, y) -> x + y);
            int scbs = cbltj.stream().map(e -> e.getScbs()).reduce(0, (x, y) -> x + y);
            int wcbs = cbltj.stream().map(e -> e.getWcbs()).reduce(0, (x, y) -> x + y);
            BigDecimal cbl = new BigDecimal(scbs * 100).divide(new BigDecimal(ycbs), 2, RoundingMode.DOWN);
            cbltj.add(new CbltjSelect("合计", ycbs, scbs, wcbs, PERCENT_FORMAT.format(cbl)));
        }
        return cbltj;
    }


    private int sccblr(BmCbb cbb) {
        String cbbbm = cbb.getCbbbm();
        String ssgs = cbb.getSsgs();
        String sscbpq = cbb.getSscbpq();
        List<YhCbkxx> cbkxxList = getCbkxxList(cbbbm, ssgs);
        String lastCwrq = LocalDate.now().plusMonths(-1).format(DateTimeFormatter.ofPattern("yyyyMM"));
        List<YyCblr> lastCblrs = getCblrs(cbbbm, ssgs, lastCwrq);
        Map<String, BigDecimal> scdsMap = lastCblrs.stream().collect(Collectors.toMap(YyCblr::getCbkid, YyCblr::getBcds));
        String cwrq = gdcsbService.selectCwrq();
        List<YyCblr> cblrs = cbkxxList.stream()
                .map(e -> createCblr(ssgs, sscbpq, cbbbm, e, scdsMap.getOrDefault(e.getCbkid(), BigDecimal.ZERO), cwrq))
                .collect(Collectors.toList());

        List<YyCblr> currentCblrs = getCblrs(cbbbm, ssgs, cwrq);
        currentCblrs.forEach(e -> this.removeById(e));

        lastCblrs.forEach(e -> this.removeById(e));
        lastCblrs.stream()
                .filter(e -> e.getCbbz() == CbbzEnum.已抄表)
                .forEach(e -> cblrLsService.save(createCblrls(e)));
        cblrs.forEach(e -> this.save(e));
        return cblrs.size();
    }

    private YyCblrLs createCblrls(YyCblr e) {
        YyCblrLs cblrLs = new YyCblrLs();
        BeanUtils.copyProperties(e, cblrLs);
        return cblrLs;
    }

    private YyCblr createCblr(String ssgs, String sscbpq, String cbbbm, YhCbkxx e, BigDecimal scds, String cwrq) {

        YyCblr yyCblr = new YyCblr();
        BeanUtils.copyProperties(e, yyCblr, "bz");
        yyCblr.setSsgs(ssgs);
        yyCblr.setSscbpq(sscbpq);
        yyCblr.setSscbb(cbbbm);
        yyCblr.setCwrq(cwrq);
        yyCblr.setScds(scds);
        return yyCblr;
    }

    private List<YhCbkxx> getCbkxxList(String cbbbm, String ssgs) {
        List<YhKhjbxx> list = khjbxxService.lambdaQuery().select(YhKhjbxx::getYhbh).eq(YhKhjbxx::getSsgs, ssgs).eq(YhKhjbxx::getSscbb, cbbbm).list();
        List<String> yhbhs = list.stream().map(e -> e.getYhbh()).collect(Collectors.toList());
        List<YhCbkxx> cbkxxes = new ArrayList<>();
        if (!yhbhs.isEmpty()) {
            cbkxxes = cbkxxService.lambdaQuery().in(YhCbkxx::getYhbh, yhbhs).list();
        }
        return cbkxxes;
    }

    private List<YyCblr> getCblrs(String cbbbm, String ssgs, String cwrq) {

        List<YyCblr> cblrs = this.lambdaQuery()
                .eq(YyCblr::getSscbb, cbbbm)
                .eq(YyCblr::getSsgs, ssgs)
                .eq(YyCblr::getCwrq, cwrq)
                .list();
        return cblrs;

    }

    private List<CbSltjSelect> cbsltj(String tjlb, String ssgs) {
        List<CbSltjSelect> cbsltj = this.baseMapper.cbsltj(tjlb, ssgs);
        if ("cbry".equals(tjlb)) {
            cbsltj.forEach(e -> {
                String cbrybm = e.getTjlb();
                if (cbrybm != null) {
                    User user = userService.get(Long.valueOf(cbrybm));
                    if (user != null)
                        e.setTjlb(user.getRealName());
                }
            });
        }
        if (!cbsltj.isEmpty()) {
            int cbhs = cbsltj.stream().map(e -> e.getCbhs()).reduce(0, (x, y) -> x + y);
            int cbsl = cbsltj.stream().map(e -> e.getCbsl()).reduce(0, (x, y) -> x + y);
            cbsltj.add(new CbSltjSelect("合计", cbhs, cbsl));
        }
        return cbsltj;
    }

    private YyCblr savePlan(String yhbh, String cbkh, String strcbkh, String ssgs, String sscbpq, String sscbb) {
        YyCblr plan = new YyCblr();
        String strcwrq = gdcsbService.selectCwrq();
        plan.setCwrq(strcwrq);//财务日期
        plan.setJsbz(JsbzEnum.未算费);//计算标志 0未算费，1已算费
        plan.setJfzt("1");//计费状态  1正常，2停用
        plan.setCbbz(CbbzEnum.未抄表);//未抄表状态
        plan.setShbz(ShbzEnum.未审核);//未审核标志

        plan.setYhbh(String.valueOf(yhbh));//用户编号
        plan.setCbkh(cbkh);//抄表卡号
        plan.setCbkid(strcbkh);//抄表卡ID
        plan.setSsgs(ssgs);//公司
        plan.setSscbpq(sscbpq);//片区
        plan.setSscbb(sscbb);//抄表本
        this.save(plan);
        return plan;
    }
}
