package com.tofly.feesapi.common.annotate;

import com.tofly.feesapi.common.annotate.multiRequest.MultiRequestBodyArgumentResolver;
import com.tofly.feesapi.common.annotate.requestPostSingle.RequestPostSingleParamMethodArgumentResolver;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.converter.HttpMessageConverter;
import org.springframework.http.converter.StringHttpMessageConverter;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import java.nio.charset.Charset;
import java.util.List;

/**
 * @description:
 * @Title: WebConfig
 * @Package com.tofly.fees.common.annotate
 * @Date 2023-06-19 10:11
 */

//@Configuration
public class WebConfig implements WebMvcConfigurer {
    @Override
    public void addArgumentResolvers(List<HandlerMethodArgumentResolver> argumentResolvers) {
        // 添加MultiRequestBody参数解析器
        //argumentResolvers.add(new MultiRequestBodyArgumentResolver());
        //argumentResolvers.add(new RequestPostSingleParamMethodArgumentResolver());
        //WebMvcConfigurer.super.addArgumentResolvers(argumentResolvers);
    }

    @Bean
    public HttpMessageConverter<String> responseBodyConverter() {
        // 解决中文乱码问题T
        return new StringHttpMessageConverter(Charset.forName("UTF-8"));
    }

    @Override
    public void configureMessageConverters(List<HttpMessageConverter<?>> converters) {
        converters.add(responseBodyConverter());
    }
}
