package com.tofly.feesapi.common.annotate.repeatableHttpServletRequest;

import javax.servlet.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @description:
 * @Title: RepeatableFilter
 * @Package com.tofly.fees.common.annotate
 * @Author 芝士汉堡
 * @Date 2023-06-27 13:35
 */
public class RepeatableFilter implements Filter {
    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {

        HttpServletRequest httpServletRequest = new RepeatableHttpServletRequest((HttpServletRequest)servletRequest);
        String contentType = httpServletRequest.getContentType();
        HttpServletResponse httpServletResponse = (HttpServletResponse) servletResponse;
       //  filterChain.doFilter(httpServletRequest,httpServletResponse);
        //判断请求类型
        if (contentType == null) {
            //表单请求
            filterChain.doFilter(httpServletRequest, httpServletResponse); 
        } else if (contentType.startsWith("multipart/")) {
            filterChain.doFilter(servletRequest, servletResponse);

        } else if (contentType.startsWith("application/json")) {
            filterChain.doFilter(httpServletRequest, httpServletResponse);
        } else {
            filterChain.doFilter(servletRequest, servletResponse);
        }


    }
}
