package com.tofly.feesapi.common.model;

import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;

/**
 * @description:
 * @Title: DataSourceInfo
 * @Package com.tofly.fees.common.dbhelper
 * @Author xb
 * @Date 2023-06-09 14:45
 */
@Component
@Configuration
@ConfigurationProperties(prefix = "datasource")
@Getter
@Setter
public class DataSourceInfo {
    @Value("${spring.datasource.dynamic.datasource.master.username}")
    private String username;
    @Value("${spring.datasource.dynamic.datasource.master.password}")
    private String password;
    @Value("${spring.datasource.dynamic.datasource.master.url}")
    private String url;
}
