package com.tofly.feesapi.common.model;

import lombok.Data;
import org.apache.ibatis.mapping.ParameterMode;

import java.sql.JDBCType;

/**
 * 存储过程参数实体类
 *
 * @author shudong
 */
@Data
public class ProcParamModel {
    /**
     * 参数名
     */
    private String name;
    /**
     * 出入参类型
     */
    private ParameterMode mode;
    /**
     * 参数数据字段类型
     */
    private JDBCType jdbcType;
    /**
     * 参数对应的值
     */
    private Object value;

    public ProcParamModel(String name, ParameterMode mode, JDBCType jdbcType, Object value) {
        this.name = name;
        this.mode = mode;
        this.jdbcType = jdbcType;
        this.value = value;
    }
}
