package com.tofly.feesapi.common.util;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.*;

public class ToolsUtils {

    /**
     * @MethodName convertList
     * @Description ResultSet转ListMap
     * @Author xb
     * @Date 9:07 2023-06-08
     */
    public static List<Map> convertList(ResultSet rs) throws SQLException {
        List<Map> list = new ArrayList<>();
        ResultSetMetaData md = rs.getMetaData();//获取键名
        int columnCount = md.getColumnCount();//获取列的数量
        while (rs.next()) {
            Map<String, Object> rowData = new HashMap<>();//声明Map
            for (int i = 1; i <= columnCount; i++) {
                rowData.put(md.getColumnName(i), rs.getObject(i));//获取键名及值
            }
            list.add(rowData);
        }
        return list;
    }

    /**
     * @MethodName getGuid
     * @Description 转为大写guid
     * @Author xb
     * @Date 9:10 2023-06-08
     */
    public static String getGuid() {
        UUID uuid = UUID.randomUUID();
        return uuid.toString().replace("-", "").toUpperCase();
    }

    /**
     * @MethodName getLsbh
     * @Description 转为大写Lsbh
     * @Author xb
     * @Date 9:10 2023-06-08
     */
    public static String getLsbh() {
        String lsbh = DateUtils.formatDate(new Date(), "yyyyMMddHHmmssssss");
        return lsbh;
    }

}
