package com.tofly.feesapi.config;

import feign.Logger;
import feign.RequestInterceptor;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

//@EnableFeignClients(basePackages = {"com.tofly.base.baseapi"})
//@Configuration(proxyBeanMethods = false)
public class FeignConfig {

	@Bean
	public Logger.Level feignLoggerLevel() {
		return Logger.Level.BASIC;
	}

	@Bean
	public RequestInterceptor requestInterceptor(){
		return requestTemplate -> {
			ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
			assert attributes != null;
			HttpServletRequest request = attributes.getRequest();
			requestTemplate.header("Authorization", request.getHeader("Authorization"));//传递令牌
		};
	}

}
