package com.tofly.feesapi.file.entity.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDateTime;


@Getter
@ApiModel("文件列表")
@AllArgsConstructor
public class FileStorageItemVo {

    @ApiModelProperty(value = "ID")
    private final String id;

    @ApiModelProperty(value = "文件名称")
    private final String fileName;

    @ApiModelProperty(value = "文件大小")
    private final String fileSize;

    @ApiModelProperty(value = "文件大小")
    private final long size;

    @ApiModelProperty(value = "最近修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private final LocalDateTime lastModified;

}
