package com.tofly.feesapi.file.fileconfiguration;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.feesapi.file.entity.dto.FileStorageQueryDto;
import com.tofly.feesapi.file.entity.dto.FileUploadBase64Dto;
import com.tofly.feesapi.file.entity.dto.FileUploadResponse;
import com.tofly.feesapi.file.entity.vo.FileStorageItemVo;
import com.tofly.feesapi.file.entity.vo.FileStorageStatVo;
import io.minio.Result;
import io.minio.messages.Item;
import org.apache.commons.net.ftp.FTPFile;
import org.springframework.http.ResponseEntity;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public interface FileStorageService {

    /**
     * 上传文件
     *
     * @param file 待上传文件
     * @return {@link FileUploadResponse} 实例对象
     */

    FileUploadResponse upload(MultipartFile file, String Path);

    FileUploadResponse uploadFileBase64(FileUploadBase64Dto file, String Path);


        /**
         * 下载文件
         *
         * @param fileName 待下载文件名
         * @param response {@link HttpServletResponse}
         */
    ResponseEntity<?> download(
            String fileName, HttpServletRequest request, HttpServletResponse response);


    byte[] getByteDataforFile(String fileName);

    InputStream getByteDataforFileInputStream(String fileName);

    Boolean  retrieveFile(String remotePath, OutputStream outputStream);

    String uploadFile(String Path, String fileName, String contentType, InputStream inputStream)
            throws IOException;

    void removeFile(String PathfileName) throws IOException;

    FTPFile[] results(String filePathBean) throws IOException;

}
