package com.tofly.feesapi.file.fileconfiguration;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @author 徐浩然
 * @desc minio配置文件
 * @date 2021/12/1-15:35
 */
@ConfigurationProperties(prefix = "file.storage.minio")
@Component
@Data
public class MinioFileStorageProperties {
  /** minio储存地址 */
  private String minioUrl;
  /** minio账户 */
  private String minioName;
  /** minio访问密码 */
  private String minioPass;
  /** minio储存桶名称 */
  private String bucketName;

  private boolean randomFileName;
}
