package com.tofly.feesapi.file.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.feesapi.file.entity.File;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.util.List;

/**
 * 文件信息处理
 */
public interface IFileInfoService extends IService<File> {
    /**
     * 上传文件,并获取文件id,以 , 隔开
     *
     * @param servletRequest
     * @param filePathBean
     * @param tableID
     * @param tableName
     * @return
     */

    StringBuilder savafile(HttpServletRequest servletRequest, String filePathBean, String tableID, String tableName);
    
    List<File> savafile(HttpServletRequest servletRequest, String filePathBean);

    StringBuilder saveFileList(List<MultipartFile> fileList, String filePathBean, String tableID, String tableName);

    /**
     * 根据文件id列表删除远程文件略表
     *
     * @param fileIdList
     * @return
     */
    Boolean removeFileListById(List<BigDecimal> fileIdList);

    /**
     * 根据文件id列表获取文件路径列表
     *
     * @param fileIdList
     * @return
     */
    List<String> getFilePathList(List<BigDecimal> fileIdList);

    /**
     * 根据文件id列表获取文件对象
     *
     * @param fileIdList
     * @return
     */
    List<File> getFileList(List<BigDecimal> fileIdList);

    Page getFileList(Page page, String tableName, String tableIds);

    Boolean removeFileListByFile(List<File> fileList);

    void removeFileListByTableId(String tableId, String tableName);
}
