package com.tofly.feesapi.security;

import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.security.model.token.RawAccessToken;
import org.springframework.security.authentication.AbstractAuthenticationToken;

public class AccessAuthenticationToken extends AbstractAuthenticationToken {

    private RawAccessToken rawAccessToken;
    private CzyUserDetails securityUser;


    private static final long serialVersionUID = -8487219769037942225L;

    public AccessAuthenticationToken(RawAccessToken unsafeToken) {
        super(null);
        this.rawAccessToken = unsafeToken;
        setAuthenticated(false);
    }

    public AccessAuthenticationToken(CzyUserDetails securityUser) {
        super(securityUser.getAuthorities());
        this.eraseCredentials();
        this.securityUser = securityUser;
        setAuthenticated(true);
    }

    @Override
    public Object getCredentials() {
        return this.rawAccessToken;
    }

    @Override
    public Object getPrincipal() {
        return this.securityUser;
    }
}
