package com.tofly.feesapi.sfgl.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.sfgl.entity.YyQfmxCzls;
import com.tofly.feesapi.sfgl.service.YyQfmxCzlsService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
//@RestController
@AllArgsConstructor
//@RequestMapping("api/sfgl/yyqfmxczls")
//@Api(tags="应收明细(欠费明细)历史记录")
public class YyQfmxCzlsController {

    private final  YyQfmxCzlsService yyQfmxCzlsService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param yyQfmxCzls 
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getYyQfmxCzlsPage(Page page, @ModelAttribute YyQfmxCzls yyQfmxCzls) {
      return ResultRespone.success(yyQfmxCzlsService.page(page, Wrappers.query(yyQfmxCzls)));
    }


    /**
     * 通过id查询
     * @param yswsf id
     * @return ResultRespone
     */
    @GetMapping("/{yswsf}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yswsf", value = "ID", required = true, dataType = "BigDecimal")
    })
    public ResultRespone getById(@PathVariable("yswsf" ) BigDecimal yswsf) {
      return ResultRespone.success(yyQfmxCzlsService.getById(yswsf));
    }

    /**
     * 新增
     * @param yyQfmxCzls 
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增" )
    @ApiOperation(value = "新增")
    @PostMapping
    public ResultRespone save(@RequestBody YyQfmxCzls yyQfmxCzls) {
      return ResultRespone.success(yyQfmxCzlsService.save(yyQfmxCzls));
    }

    /**
     * 修改
     * @param yyQfmxCzls 
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改" )
    @ApiOperation(value = "修改")
    @PutMapping
    public ResultRespone updateById(@RequestBody YyQfmxCzls yyQfmxCzls) {
      return ResultRespone.success(yyQfmxCzlsService.updateById(yyQfmxCzls));
    }

    /**
     * 通过id删除
     * @param yswsf id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除" )
    @ApiOperation(value = "通过ID删除")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yswsf", value = "ID", required = true, dataType = "BigDecimal")
    })
    @DeleteMapping("/{yswsf}" )
    public ResultRespone removeById(@PathVariable BigDecimal yswsf) {
      return ResultRespone.success(yyQfmxCzlsService.removeById(yswsf));
    }

    /**
     * 通过id批量删除
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除" )
    @ApiOperation(value = "通过ID批量删除")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yyQfmxCzlsService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
