/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.sfgl.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.sfgl.entity.YySspjxxCzls;
import com.tofly.feesapi.sfgl.service.YySspjxxCzlsService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 收费明细
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
//@RestController
@AllArgsConstructor
//@RequestMapping("/yysspjxxczls")
//@Api(tags="收费明细接口")
public class YySspjxxCzlsController {

    private final  YySspjxxCzlsService yySspjxxCzlsService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param yySspjxxCzls 收费明细
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getYySspjxxCzlsPage(Page page, @ModelAttribute YySspjxxCzls yySspjxxCzls) {
      return ResultRespone.success(yySspjxxCzlsService.page(page, Wrappers.query(yySspjxxCzls)));
    }


    /**
     * 通过id查询收费明细
     * @param cbryxm id
     * @return ResultRespone
     */
    @GetMapping("/{cbryxm}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "cbryxm", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("cbryxm" ) String cbryxm) {
      return ResultRespone.success(yySspjxxCzlsService.getById(cbryxm));
    }

    /**
     * 新增收费明细
     * @param yySspjxxCzls 收费明细
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增收费明细" )
    @ApiOperation(value = "新增收费明细")
    @PostMapping
    public ResultRespone save(@RequestBody YySspjxxCzls yySspjxxCzls) {
      return ResultRespone.success(yySspjxxCzlsService.save(yySspjxxCzls));
    }

    /**
     * 修改收费明细
     * @param yySspjxxCzls 收费明细
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改收费明细" )
    @ApiOperation(value = "修改收费明细")
    @PutMapping
    public ResultRespone updateById(@RequestBody YySspjxxCzls yySspjxxCzls) {
      return ResultRespone.success(yySspjxxCzlsService.updateById(yySspjxxCzls));
    }

    /**
     * 通过id删除收费明细
     * @param cbryxm id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除收费明细" )
    @ApiOperation(value = "通过ID删除收费明细")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "cbryxm", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{cbryxm}" )
    public ResultRespone removeById(@PathVariable String cbryxm) {
      return ResultRespone.success(yySspjxxCzlsService.removeById(cbryxm));
    }

    /**
     * 通过id批量删除收费明细
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除收费明细" )
    @ApiOperation(value = "通过ID批量删除收费明细")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yySspjxxCzlsService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
