package com.tofly.feesapi.sfgl.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.sfgl.entity.ZnbCsjsLog;
import com.tofly.feesapi.sfgl.entity.dto.ZnbCsjsFilter;
import com.tofly.feesapi.sfgl.entity.dto.ZnbCsjsListFilter;
import com.tofly.feesapi.sfgl.entity.vo.ZnbCsjsSelect;
import com.tofly.feesapi.sfgl.service.IZnbCsjsLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 * 智能表抄收结算明细 前端控制器
 * </p>
 *
 * @author decai
 * @since 2024-04-10
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/sfgl/znbCsjsLog")
@Api(tags = "智能表结算")
public class ZnbCsjsLogController {

    private final IZnbCsjsLogService znbCsjsLogService;

    /**
     * 智能表抄表统计列表
     *
     * @param pageDto 分页对象
     * @param filter  智能表抄表统计列表
     * @return
     */
    @GetMapping("/page")
    @ApiOperation(value = "智能表抄表统计列表")
    public ResultRespone<PageResult<ZnbCsjsSelect>> getPage(@ModelAttribute PageDto pageDto, @ModelAttribute ZnbCsjsFilter filter) {
        return ResultRespone.success(znbCsjsLogService.getPage(pageDto, filter));
    }

    /**
     * 用户用水明细
     *
     * @param filter 智能表抄用户用水明细表参数DTO
     * @return
     */
    @GetMapping("/yhysmx")
    @ApiOperation(value = "用户用水明细")
    public ResultRespone<List<ZnbCsjsLog>> getYhysmxList(@ModelAttribute ZnbCsjsListFilter filter) {
        return ResultRespone.success(znbCsjsLogService.getYhysmxList(filter));
    }
}
