package com.tofly.feesapi.sfgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.SflxEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 收费明细
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "YY_SSPJXX")
@KeySequence("YY_SSPJXX")
@ApiModel
public class YySspjxx extends Model<YySspjxx> {
    private static final long serialVersionUID = 1L;

    /**
     * 实收ID,newid()
     */
    @ApiModelProperty(value = "实收ID")
    @TableId(value = "id", type = IdType.ASSIGN_ID)
    private String id;

    /**
     * 费用类型编码：bm_fylx
     */
    @ApiModelProperty(value = "费用类型编码：bm_fylx")
    private String fylx;
    /**
     * 缴费渠道：01 营业大厅， 02 第三方代收费
     */
    @ApiModelProperty(value = "缴费渠道：01 营业大厅， 02 第三方代收费")
    private String jfqd = "01";
    /**
     * 年度累计量(计算前）
     */
    @ApiModelProperty(value = "年度累计量(计算前）")
    private BigDecimal jtzqljlJsq;
    /**
     * 年度累计量
     */
    @ApiModelProperty(value = "年度累计量")
    private BigDecimal jtzqljl;
    /**
     * 阶梯标准（多人口阶梯）编码，bm_jtrk
     */
    @ApiModelProperty(value = "阶梯标准（多人口阶梯）编码，bm_jtrk")
    private String rks;
    /**
     * 水价2.阶梯1水量
     */
    @ApiModelProperty(value = "水价2.阶梯1水量")
    private BigDecimal sj1Jt1sl;
    /**
     * 水价2.阶梯1水价
     */
    @ApiModelProperty(value = "水价2.阶梯1水价")
    private BigDecimal sj1Jt1sj;
    /**
     * 水价2.阶梯1水费
     */
    @ApiModelProperty(value = "水价2.阶梯1水费")
    private BigDecimal sj1Jt1sf;
    /**
     * 水价2.阶梯2水量
     */
    @ApiModelProperty(value = "水价2.阶梯2水量")
    private BigDecimal sj1Jt2sl;
    /**
     * 水价2.阶梯2水价
     */
    @ApiModelProperty(value = "水价2.阶梯2水价")
    private BigDecimal sj1Jt2sj;
    /**
     * 水价2.阶梯2水费
     */
    @ApiModelProperty(value = "水价2.阶梯2水费")
    private BigDecimal sj1Jt2sf;
    /**
     * 水价2.阶梯3水量
     */
    @ApiModelProperty(value = "水价2.阶梯3水量")
    private BigDecimal sj1Jt3sl;
    /**
     * 水价2.阶梯3水价
     */
    @ApiModelProperty(value = "水价2.阶梯3水价")
    private BigDecimal sj1Jt3sj;
    /**
     * 水价2.阶梯3水费
     */
    @ApiModelProperty(value = "水价2.阶梯3水费")
    private BigDecimal sj1Jt3sf;
    /**
     * 水价2.阶梯4水量
     */
    @ApiModelProperty(value = "水价2.阶梯4水量")
    private BigDecimal sj1Jt4sl;
    /**
     * 水价2.阶梯4水费
     */
    @ApiModelProperty(value = "水价2.阶梯4水费")
    private BigDecimal sj1Jt4sf;
    /**
     * 水价2.阶梯4水价
     */
    @ApiModelProperty(value = "水价2.阶梯4水价")
    private BigDecimal sj1Jt4sj;
    /**
     * 水价3.阶梯1水量
     */
    @ApiModelProperty(value = "水价3.阶梯1水量")
    private BigDecimal sj2Jt1sl;
    /**
     * 水价3.阶梯1水价
     */
    @ApiModelProperty(value = "水价3.阶梯1水价")
    private BigDecimal sj2Jt1sj;
    /**
     * 水价3.阶梯1水费
     */
    @ApiModelProperty(value = "水价3.阶梯1水费")
    private BigDecimal sj2Jt1sf;
    /**
     * 水价3.阶梯2水量
     */
    @ApiModelProperty(value = "水价3.阶梯2水量")
    private BigDecimal sj2Jt2sl;
    /**
     * 水价3.阶梯2水价
     */
    @ApiModelProperty(value = "水价3.阶梯2水价")
    private BigDecimal sj2Jt2sj;
    /**
     * 水价3.阶梯2水费
     */
    @ApiModelProperty(value = "水价3.阶梯2水费")
    private BigDecimal sj2Jt2sf;
    /**
     * 水价3.阶梯3水量
     */
    @ApiModelProperty(value = "水价3.阶梯3水量")
    private BigDecimal sj2Jt3sl;
    /**
     * 水价3.阶梯3水价
     */
    @ApiModelProperty(value = "水价3.阶梯3水价")
    private BigDecimal sj2Jt3sj;
    /**
     * 水价3.阶梯3水费
     */
    @ApiModelProperty(value = "水价3.阶梯3水费")
    private BigDecimal sj2Jt3sf;
    /**
     * 水价3.阶梯4水量
     */
    @ApiModelProperty(value = "水价3.阶梯4水量")
    private BigDecimal sj2Jt4sl;
    /**
     * 水价3.阶梯4水费
     */
    @ApiModelProperty(value = "水价3.阶梯4水费")
    private BigDecimal sj2Jt4sf;
    /**
     * 水价3.阶梯4水价
     */
    @ApiModelProperty(value = "水价3.阶梯4水价")
    private BigDecimal sj2Jt4sj;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 收费序号
     */
    @ApiModelProperty(value = "收费序号")
    private Integer sfxh;
    /**
     * 费用类型名称
     */
    @ApiModelProperty(value = "费用类型名称")
    private String fylxmc;
    /**
     * 是否补差（0：否；1：是）
     */
    @ApiModelProperty(value = "是否补差（0：否；1：是）")
    private String sfbc;
    /**
     * 银行流水号
     */
    @ApiModelProperty(value = "银行流水号")
    private String yhzwlsh;
    /**
     * 收费批次号
     */
    @ApiModelProperty(value = "收费批次号")
    private String sfplh;
    /**
     * 划账日期
     */
    @ApiModelProperty(value = "划账日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date hzrq;
    /**
     * 是否划账（0：否，1是）
     */
    @ApiModelProperty(value = "是否划账（0：否，1是）")
    private String sfhz;
    /**
     * 税率：单位（%）0,3,6,13
     */
    @ApiModelProperty(value = "税率：单位（%）0,3,6,13")
    private Double taxrate;
    /**
     * 打票员编码
     */
    @ApiModelProperty(value = "打票员编码")
    private String dprybm;
    /**
     * 打票人员姓名
     */
    @ApiModelProperty(value = "打票人员姓名")
    private String dpryxm;
    /**
     * 打票时间
     */
    @ApiModelProperty(value = "打票时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date dprq;
    /**
     * 打票状态
     */
    @ApiModelProperty(value = "打票状态")
    private String dptype;
    /**
     * 转预存金额
     */
    @ApiModelProperty(value = "转预存金额")
    private BigDecimal zyc;
    /**
     * 发票类型
     */
    @ApiModelProperty(value = "发票类型")
    private String fplx;
    /**
     * 所属城镇
     */
    @ApiModelProperty(value = "所属城镇")
    private String ssregion;
    /**
     * 超定量（防止变更后报表变化）
     */
    @ApiModelProperty(value = "超定量（防止变更后报表变化）")
    private Long cdl;
    /**
     * 欠费ID:用于部分收费时拆分欠费，yy_qfmx.id
     */
    @ApiModelProperty(value = "欠费ID:用于部分收费时拆分欠费，yy_qfmx.id")
    private String qfid;
    /**
     * 欠费流水号，流水号相同欠费是一次抄表产生的同一笔欠费
     */
    @ApiModelProperty(value = "欠费流水号，流水号相同欠费是一次抄表产生的同一笔欠费")
    private String qflsbh;
    /**
     * 抄表卡ID，对应yh_cbkxx.id
     */
    @ApiModelProperty(value = "抄表卡ID，对应yh_cbkxx.id")
    private String cbkid;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号")
    private String cbkh;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    private String sscbpq;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private String sscbb;
    /**
     * 用水月份
     */
    @ApiModelProperty(value = "用水月份")
    private String ysyf;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    private String cwrq;
    /**
     * 上次读数
     */
    @ApiModelProperty(value = "上次读数")
    private BigDecimal scds;
    /**
     * 本次读数
     */
    @ApiModelProperty(value = "本次读数")
    private BigDecimal bcds;
    /**
     * 加减量
     */
    @ApiModelProperty(value = "加减量")
    private BigDecimal jjl;
    /**
     * 水量
     */
    @ApiModelProperty(value = "水量")
    private BigDecimal sl;
    /**
     * 水价编码
     */
    @ApiModelProperty(value = "水价编码")
    private String sjbm;
    /**
     * 水价
     */
    @ApiModelProperty(value = "水价")
    private BigDecimal sj;
    /**
     * 水费
     */
    @ApiModelProperty(value = "水费")
    private BigDecimal sf;
    /**
     * 污水费单价
     */
    @ApiModelProperty(value = "污水费单价")
    private BigDecimal wsfdj;
    /**
     * 污水费
     */
    @ApiModelProperty(value = "污水费")
    private BigDecimal wsf;
    /**
     * 垃圾费单价
     */
    @ApiModelProperty(value = "垃圾费单价")
    private BigDecimal ljfdj;
    /**
     * 垃圾费
     */
    @ApiModelProperty(value = "垃圾费")
    private BigDecimal ljf;
    /**
     * 水价编码2（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码2（一表多价时存储）")
    private String sjbm1;
    /**
     * 水价2（一表多价时存储）
     */
    @ApiModelProperty(value = "水价2（一表多价时存储）")
    private BigDecimal sj1;
    /**
     * 水量2（一表多价时存储）
     */
    @ApiModelProperty(value = "水量2（一表多价时存储）")
    private BigDecimal sl1;
    /**
     * 水费2（一表多价时存储）
     */
    @ApiModelProperty(value = "水费2（一表多价时存储）")
    private BigDecimal sf1;
    /**
     * 污水费单价2
     */
    @ApiModelProperty(value = "污水费单价2")
    private BigDecimal wsfdj1;
    /**
     * 污水费2
     */
    @ApiModelProperty(value = "污水费2")
    private BigDecimal wsf1;
    /**
     * 垃圾费单价2
     */
    @ApiModelProperty(value = "垃圾费单价2")
    private BigDecimal ljfdj1;
    /**
     * 垃圾费2
     */
    @ApiModelProperty(value = "垃圾费2")
    private BigDecimal ljf1;
    /**
     * 水价编码3（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码3（一表多价时存储）")
    private String sjbm2;
    /**
     * 水价3（一表多价时存储）
     */
    @ApiModelProperty(value = "水价3（一表多价时存储）")
    private BigDecimal sj2;
    /**
     * 水量3（一表多价时存储）
     */
    @ApiModelProperty(value = "水量3（一表多价时存储）")
    private BigDecimal sl2;
    /**
     * 水费3（一表多价时存储）
     */
    @ApiModelProperty(value = "水费3（一表多价时存储）")
    private BigDecimal sf2;
    /**
     * 污水费单价3
     */
    @ApiModelProperty(value = "污水费单价3")
    private BigDecimal wsfdj2;
    /**
     * 污水费3
     */
    @ApiModelProperty(value = "污水费3")
    private BigDecimal wsf2;
    /**
     * 垃圾费单价3
     */
    @ApiModelProperty(value = "垃圾费单价3")
    private BigDecimal ljfdj2;
    /**
     * 垃圾费3
     */
    @ApiModelProperty(value = "垃圾费3")
    private BigDecimal ljf2;
    /**
     * 水价编码4（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码4（一表多价时存储）")
    private String sjbm3;
    /**
     * 水价4（一表多价时存储）
     */
    @ApiModelProperty(value = "水价4（一表多价时存储）")
    private BigDecimal sj3;
    /**
     * 水量4（一表多价时存储）
     */
    @ApiModelProperty(value = "水量4（一表多价时存储）")
    private BigDecimal sl3;
    /**
     * 水费4（一表多价时存储）
     */
    @ApiModelProperty(value = "水费4（一表多价时存储）")
    private BigDecimal sf3;
    /**
     * 污水费单价4
     */
    @ApiModelProperty(value = "污水费单价4")
    private BigDecimal wsfdj3;
    /**
     * 污水费4
     */
    @ApiModelProperty(value = "污水费4")
    private BigDecimal wsf3;
    /**
     * 垃圾费单价4
     */
    @ApiModelProperty(value = "垃圾费单价4")
    private BigDecimal ljfdj3;
    /**
     * 垃圾费4
     */
    @ApiModelProperty(value = "垃圾费4")
    private BigDecimal ljf3;
    /**
     * 抄表人员编码
     */
    @ApiModelProperty(value = "抄表人员编码")
    private String cbrybm;
    /**
     * 抄表人员姓名
     */
    @ApiModelProperty(value = "抄表人员姓名")
    private String cbryxm;
    /**
     * 抄表日期
     */
    @ApiModelProperty(value = "抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cbrq;
    /**
     * 录入人员编码
     */
    @ApiModelProperty(value = "录入人员编码")
    private String lrrybm;
    /**
     * 录入人员姓名
     */
    @ApiModelProperty(value = "录入人员姓名")
    private String lrryxm;
    /**
     * 录入日期
     */
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date lrrq;
    /**
     * 计算日期
     */
    @ApiModelProperty(value = "计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date jsrq;
    /**
     * 应收水量（sl+sl1+sl2+sl3）
     */
    @ApiModelProperty(value = "应收水量（sl+sl1+sl2+sl3）")
    private BigDecimal yssl;
    /**
     * 应收水费（sf+sf1+sf2+sf3）
     */
    @ApiModelProperty(value = "应收水费（sf+sf1+sf2+sf3）")
    private BigDecimal yssf;
    /**
     * 应收污水费（wsf+wsf1+wsf2+wsf3）
     */
    @ApiModelProperty(value = "应收污水费（wsf+wsf1+wsf2+wsf3）")
    private BigDecimal yswsf;
    /**
     * 应收垃圾费
     */
    @ApiModelProperty(value = "应收垃圾费")
    private BigDecimal ysljf;
    /**
     * 应收其它费
     */
    @ApiModelProperty(value = "应收其它费")
    private BigDecimal ysqt;
    /**
     * 应收金额=应收水费+应收污水费+应收垃圾费+应收其他费（yssf+yswsf+ysLJF+ysqt）
     */
    @ApiModelProperty(value = "应收金额=应收水费+应收污水费+应收垃圾费+应收其他费（yssf+yswsf+ysLJF+ysqt）")
    private BigDecimal ysje;
    /**
     * 阶梯1水量(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯1水量(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt1sl;
    /**
     * 阶梯1水价(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯1水价(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt1sj;
    /**
     * 阶梯1水费(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯1水费(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt1sf;
    /**
     * 阶梯2水量(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯2水量(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt2sl;
    /**
     * 阶梯2水价(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯2水价(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt2sj;
    /**
     * 阶梯2水费(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯2水费(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt2sf;
    /**
     * 阶梯3水量(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯3水量(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt3sl;
    /**
     * 阶梯3水价(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯3水价(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt3sj;
    /**
     * 阶梯3水费(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯3水费(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt3sf;
    /**
     * 阶梯4水量(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯4水量(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt4sl;
    /**
     * 阶梯4水价(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯4水价(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt4sj;
    /**
     * 阶梯4水费(阶梯只能是第一种水价有，即SJBM)
     */
    @ApiModelProperty(value = "阶梯4水费(阶梯只能是第一种水价有，即SJBM)")
    private BigDecimal jt4sf;
    /**
     * 滞纳金天数
     */
    @ApiModelProperty(value = "滞纳金天数")
    private BigDecimal znjts;
    /**
     * 滞纳金费率
     */
    @ApiModelProperty(value = "滞纳金费率")
    private BigDecimal znjfl;
    /**
     * 滞纳金
     */
    @ApiModelProperty(value = "滞纳金")
    private BigDecimal znj;
    /**
     * 滞纳金计算日期
     */
    @ApiModelProperty(value = "滞纳金计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date znjjsrq;
    /**
     * 实收滞纳金
     */
    @ApiModelProperty(value = "实收滞纳金")
    private BigDecimal ssznj;
    /**
     * 实收总金额:本次实际收取的金额，
     */
    @ApiModelProperty(value = "实收总金额:本次实际收取的金额，")
    private BigDecimal sszje;
    /**
     * 上次余额
     */
    @ApiModelProperty(value = "上次余额")
    private BigDecimal scye;
    /**
     * 本次预存
     */
    @ApiModelProperty(value = "本次预存")
    private BigDecimal bcyc;
    /**
     * 本次扣减=实收水费+实收污水费+实收滞纳金+垃圾费+其它费
     */
    @ApiModelProperty(value = "本次扣减=实收水费+实收污水费+实收滞纳金+垃圾费+其它费")
    private BigDecimal bckj;
    /**
     * 本次余额=上次余额+实收总金额或者本次预存-本次扣减
     */
    @ApiModelProperty(value = "本次余额=上次余额+实收总金额或者本次预存-本次扣减")
    private BigDecimal bcye;
    /**
     * 收费标志,1已收
     */
    @ApiModelProperty(value = "收费标志,1已收")
    private String sfbz;
    /**
     * 收费日期
     */
    @ApiModelProperty(value = "收费日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date sfrq;
    /**
     * 收费流水编号
     */
    @ApiModelProperty(value = "收费流水编号")
    private String sflsbh;
    /**
     * 发票组
     */
    @ApiModelProperty(value = "发票组")
    private String fpz;
    /**
     * 发票号
     */
    @ApiModelProperty(value = "发票号")
    private String fph;
    /**
     * 发票组1
     */
    @ApiModelProperty(value = "发票组1")
    private String fpz1;
    /**
     * 污水发票号
     */
    @ApiModelProperty(value = "污水发票号")
    private String fph1;
    /**
     * 发票组2
     */
    @ApiModelProperty(value = "发票组2")
    private String fpz2;
    /**
     * 其它发票号
     */
    @ApiModelProperty(value = "其它发票号")
    private String fph2;
    /**
     * 收费类型：bm_sflx
     */
    @ApiModelProperty(value = "收费类型：bm_sflx")
    private SflxEnum sflx;
    /**
     * 收费人员编码
     */
    @ApiModelProperty(value = "收费人员编码")
    private String sfrybm;
    /**
     * 收费人员姓名
     */
    @ApiModelProperty(value = "收费人员姓名")
    private String sfryxm;
    /**
     * 发票打印次数
     */
    @ApiModelProperty(value = "发票打印次数")
    private BigDecimal dycs;
    /**
     * 付费方式：bm_fffs
     */
    @ApiModelProperty(value = "付费方式：bm_fffs")
    private String fffs;
    /**
     * 收费实际日期：下账日期，针对第三方代收费获取服务器时间today
     */
    @ApiModelProperty(value = "收费实际日期：下账日期，针对第三方代收费获取服务器时间today")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date sfsjrq;
    /**
     * （发票）冲红标志：0未冲红，1已冲红，2红票
     */
    @ApiModelProperty(value = "（发票）冲红标志：0未冲红，1已冲红，2红票")
    private String chbz;
    /**
     * （发票）冲红ID，红票ID号
     */
    @ApiModelProperty(value = "（发票）冲红ID，红票ID号")
    private String chid;
    /**
     * 冲红时间
     */
    @ApiModelProperty(value = "冲红时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date chsj;
    /**
     * 冲红人员编码
     */
    @ApiModelProperty(value = "冲红人员编码")
    private String chrybm;
    /**
     * 冲红人员姓名
     */
    @ApiModelProperty(value = "冲红人员姓名")
    private String chryxm;
    /**
     * 抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯；用于判断计价类型，处理显示水价）
     */
    @ApiModelProperty(value = "抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯；用于判断计价类型，处理显示水价）")
    private String cbjsbz;
    /**
     * 抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯；用于查询显示）
     */
    @ApiModelProperty(value = "抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯；用于查询显示）")
    private String cbjsfs;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 用户姓名（历史开票信息）
     */
    @ApiModelProperty(value = "用户姓名（历史开票信息）")
    private String fpName;
    /**
     * 用户地址（历史开票信息）
     */
    @ApiModelProperty(value = "用户地址（历史开票信息）")
    private String fpDz;
    /**
     * 纳税人识别号（历史开票信息）
     */
    @ApiModelProperty(value = "纳税人识别号（历史开票信息）")
    private String fpNsrsbh;
    /**
     * 开户银行（历史开票信息）
     */
    @ApiModelProperty(value = "开户银行（历史开票信息）")
    private String fpBankname;
    /**
     * 开户行账号（历史开票信息）
     */
    @ApiModelProperty(value = "开户行账号（历史开票信息）")
    private String fpBankcode;
    /**
     * 开票电话（历史开票信息）
     */
    @ApiModelProperty(value = "开票电话（历史开票信息）")
    private String fpLxdh;
    /**
     * 抄表类型bm_cblx.bm
     */
    @ApiModelProperty(value = "抄表类型bm_cblx.bm")
    private String cblx;
    /**
     * 抄表方式:bm_cbfs
     */
    @ApiModelProperty(value = "抄表方式:bm_cbfs")
    private String cbfs;
    /**
     * 旧表止读
     */
    @ApiModelProperty(value = "旧表止读")
    private BigDecimal jbzd;
    /**
     * 新表起度
     */
    @ApiModelProperty(value = "新表起度")
    private BigDecimal xbqd;
    /**
     * 抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）
     */
    @ApiModelProperty(value = "抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）")
    private String cbly;
    /**
     * 抄表次数
     */
    @ApiModelProperty(value = "抄表次数")
    private BigDecimal cbcs;

}
