package com.tofly.feesapi.sfgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 智能表抄收结算明细
 * </p>
 *
 * @author decai
 * @since 2024-04-10
 */
@Getter
@Setter
@TableName("ZNB_CSJS_LOG")
@ApiModel(value = "ZnbCsjsLog对象", description = "智能表抄收结算明细")
public class ZnbCsjsLog implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键ID，newid()")
    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty("抄表明细ID，对应znb_cb_log.id")
    @TableField("qflsbh")
    private String cbLogId;

    @ApiModelProperty("抄表卡ID，对应yh_cbkxx.id")
    private String cbkid;

    @ApiModelProperty("用户编号")
    private String yhbh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("所属抄表片区")
    private String sscbpq;

    @ApiModelProperty("所属抄表本")
    private String sscbb;

    @ApiModelProperty("用水月份")
    private String ysyf;

    @ApiModelProperty("财务日期")
    private String cwrq;

    @ApiModelProperty("上次读数")
    private BigDecimal scds;

    @ApiModelProperty("本次读数")
    private BigDecimal bcds;

    @ApiModelProperty("加减量")
    private BigDecimal jjl;

    @ApiModelProperty("水量")
    private BigDecimal sl;

    @ApiModelProperty("水价编码")
    private String sjbm;

    @ApiModelProperty("水价")
    private BigDecimal sj;

    @ApiModelProperty("水费")
    private BigDecimal sf;

    @ApiModelProperty("污水费单价")
    private BigDecimal wsfdj;

    @ApiModelProperty("污水费")
    private BigDecimal wsf;

    @ApiModelProperty("水价编码2（一表多价时存储）")
    private String sjbm1;

    @ApiModelProperty("水价2（一表多价时存储）")
    private BigDecimal sj1;

    @ApiModelProperty("水量2（一表多价时存储）")
    private BigDecimal sl1;

    @ApiModelProperty("水费2（一表多价时存储）")
    private BigDecimal sf1;

    @ApiModelProperty("污水费单价2")
    private BigDecimal wsfdj1;

    @ApiModelProperty("污水费2")
    private BigDecimal wsf1;

    @ApiModelProperty("水价编码3（一表多价时存储）")
    private String sjbm2;

    @ApiModelProperty("水价3（一表多价时存储）")
    private BigDecimal sj2;

    @ApiModelProperty("水量3（一表多价时存储）")
    private BigDecimal sl2;

    @ApiModelProperty("水费3（一表多价时存储）")
    private BigDecimal sf2;

    @ApiModelProperty("污水费单价3")
    private BigDecimal wsfdj2;

    @ApiModelProperty("污水费3")
    private BigDecimal wsf2;

    @ApiModelProperty("水价编码4（一表多价时存储）")
    private String sjbm3;

    @ApiModelProperty("水价4（一表多价时存储）")
    private BigDecimal sj3;

    @ApiModelProperty("水量4（一表多价时存储）")
    private BigDecimal sl3;

    @ApiModelProperty("水费4（一表多价时存储）")
    private BigDecimal sf3;

    @ApiModelProperty("污水费单价4")
    private BigDecimal wsfdj3;

    @ApiModelProperty("污水费4")
    private BigDecimal wsf3;

    @ApiModelProperty("抄表人员编码")
    private String cbrybm;

    @ApiModelProperty("抄表人员姓名")
    private String cbryxm;

    @ApiModelProperty("抄表日期")
    private Date cbrq;

    @ApiModelProperty("录入人员编码")
    private String lrrybm;

    @ApiModelProperty("录入人员姓名")
    private String lrryxm;

    @ApiModelProperty("录入日期")
    private Date lrrq;

    @ApiModelProperty("计算日期")
    private Date jsrq;

    @ApiModelProperty("应收水量（sl+sl1+sl2+sl3）")
    private BigDecimal yssl;

    @ApiModelProperty("应收水费（sf+sf1+sf2+sf3）")
    private BigDecimal yssf;

    @ApiModelProperty("应收污水费（wsf+wsf1+wsf2+wsf3）")
    private BigDecimal yswsf;

    @ApiModelProperty("应收垃圾费")
    private BigDecimal ysljf;

    @ApiModelProperty("应收其它费")
    private BigDecimal ysqt;

    @ApiModelProperty("应收金额=应收水费+应收污水费+应收垃圾费+应收其他费（yssf+yswsf+ysLJF+ysqt）")
    private BigDecimal ysje;

    @ApiModelProperty("阶梯1水量")
    private BigDecimal jt1sl;

    @ApiModelProperty("阶梯1水价")
    private BigDecimal jt1sj;

    @ApiModelProperty("阶梯1水费")
    private BigDecimal jt1sf;

    @ApiModelProperty("阶梯2水量")
    private BigDecimal jt2sl;

    @ApiModelProperty("阶梯2水价")
    private BigDecimal jt2sj;

    @ApiModelProperty("阶梯2水费")
    private BigDecimal jt2sf;

    @ApiModelProperty("阶梯3水量")
    private BigDecimal jt3sl;

    @ApiModelProperty("阶梯3水价")
    private BigDecimal jt3sj;

    @ApiModelProperty("阶梯3水费")
    private BigDecimal jt3sf;

    @ApiModelProperty("阶梯4水量")
    private BigDecimal jt4sl;

    @ApiModelProperty("阶梯4水价")
    private BigDecimal jt4sj;

    @ApiModelProperty("阶梯4水费")
    private BigDecimal jt4sf;

    @ApiModelProperty("滞纳金天数")
    private BigDecimal znjts;

    @ApiModelProperty("滞纳金费率")
    private BigDecimal znjfl;

    @ApiModelProperty("滞纳金")
    private BigDecimal znj;

    @ApiModelProperty("滞纳金计算日期")
    private Date znjjsrq;

    @ApiModelProperty("抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯；用于判断计价类型，处理显示水价）")
    private String cbjsbz;

    @ApiModelProperty("抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯；用于查询显示）")
    private String cbjsfs;

    @ApiModelProperty("备注")
    private String bz;

    @ApiModelProperty("抄表类型bm_cblx.bm")
    private String cblx;

    @ApiModelProperty("抄表方式:bm_cbfs")
    private String cbfs;

    @ApiModelProperty("旧表止读")
    private BigDecimal jbzd;

    @ApiModelProperty("新表起度")
    private BigDecimal xbqd;

    @ApiModelProperty("抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）")
    private String cbly;

    @ApiModelProperty("抄表次数")
    private Integer cbcs;

    @ApiModelProperty("费用类型编码：bm_fylx")
    private String fylx;

    @ApiModelProperty("冲红标志：0未冲红，1已冲红，2红票")
    private String chbz;

    @ApiModelProperty("冲红ID，红票ID号")
    private String chid;

    @ApiModelProperty("冲红时间")
    private Date chsj;

    @ApiModelProperty("冲红人员编码")
    private String chrybm;

    @ApiModelProperty("冲红人员姓名")
    private String chryxm;

    @ApiModelProperty("冲红类型  0 应收冲红，1 收费冲红")
    private String chlx;

    @ApiModelProperty("收费标志,0未收 1已收 4不收费")
    private String sfbz;

    @ApiModelProperty("收费日期")
    private Date sfrq;

    @ApiModelProperty("用户姓名")
    private String yhxm;

    @ApiModelProperty("收费流水编号")
    private String sflsbh;

    @ApiModelProperty("年度累计量(计算前）")
    private BigDecimal jtzqljlJsq;

    @ApiModelProperty("年度累计量")
    private BigDecimal jtzqljl;

    @ApiModelProperty("阶梯标准（多人口阶梯）编码，bm_jtrk")
    private String jtrk;

    @ApiModelProperty("水价2.阶梯1水量")
    private BigDecimal sj1Jt1sl;

    @ApiModelProperty("水价2.阶梯1水价")
    private BigDecimal sj1Jt1sj;

    @ApiModelProperty("水价2.阶梯1水费")
    private BigDecimal sj1Jt1sf;

    @ApiModelProperty("水价2.阶梯2水量")
    private BigDecimal sj1Jt2sl;

    @ApiModelProperty("水价2.阶梯2水价")
    private BigDecimal sj1Jt2sj;

    @ApiModelProperty("水价2.阶梯2水费")
    private BigDecimal sj1Jt2sf;

    @ApiModelProperty("水价2.阶梯3水量")
    private BigDecimal sj1Jt3sl;

    @ApiModelProperty("水价2.阶梯3水价")
    private BigDecimal sj1Jt3sj;

    @ApiModelProperty("水价2.阶梯3水费")
    private BigDecimal sj1Jt3sf;

    @ApiModelProperty("水价2.阶梯4水量")
    private BigDecimal sj1Jt4sl;

    @ApiModelProperty("水价2.阶梯4水费")
    private BigDecimal sj1Jt4sf;

    @ApiModelProperty("水价2.阶梯4水价")
    private BigDecimal sj1Jt4sj;

    @ApiModelProperty("水价3.阶梯1水量")
    private BigDecimal sj2Jt1sl;

    @ApiModelProperty("水价3.阶梯1水价")
    private BigDecimal sj2Jt1sj;

    @ApiModelProperty("水价3.阶梯1水费")
    private BigDecimal sj2Jt1sf;

    @ApiModelProperty("水价3.阶梯2水量")
    private BigDecimal sj2Jt2sl;

    @ApiModelProperty("水价3.阶梯2水价")
    private BigDecimal sj2Jt2sj;

    @ApiModelProperty("水价3.阶梯2水费")
    private BigDecimal sj2Jt2sf;

    @ApiModelProperty("水价3.阶梯3水量")
    private BigDecimal sj2Jt3sl;

    @ApiModelProperty("水价3.阶梯3水价")
    private BigDecimal sj2Jt3sj;

    @ApiModelProperty("水价3.阶梯3水费")
    private BigDecimal sj2Jt3sf;

    @ApiModelProperty("水价3.阶梯4水量")
    private BigDecimal sj2Jt4sl;

    @ApiModelProperty("水价3.阶梯4水费")
    private BigDecimal sj2Jt4sf;

    @ApiModelProperty("水价3.阶梯4水价")
    private BigDecimal sj2Jt4sj;

    @ApiModelProperty("所属营业所")
    private String ssyys;

    @ApiModelProperty("费用类型名称")
    private String fylxmc;

    @ApiModelProperty("是否补差（0：否；1：是）")
    private String sfbc;

    @ApiModelProperty("开票标志（0未开票 ,1已开票）")
    private String kpbz;

    @ApiModelProperty("开票日期")
    private Date kprq;

    @ApiModelProperty("审核人员")
    private String shry;

    @ApiModelProperty("垃圾费单价")
    private BigDecimal ljfdj;

    @ApiModelProperty("垃圾费")
    private BigDecimal ljf;

    @ApiModelProperty("垃圾费单价1")
    private BigDecimal ljfdj1;

    @ApiModelProperty("垃圾费1")
    private BigDecimal ljf1;

    @ApiModelProperty("垃圾费单价2")
    private BigDecimal ljfdj2;

    @ApiModelProperty("垃圾费2")
    private BigDecimal ljf2;

    @ApiModelProperty("垃圾费单价3")
    private BigDecimal ljfdj3;

    @ApiModelProperty("垃圾费3")
    private BigDecimal ljf3;

    @ApiModelProperty("实收滞纳金")
    private BigDecimal ssznj;

    @ApiModelProperty("实收总金额:本次实际收取的金额，")
    private BigDecimal sszje;

    @ApiModelProperty("上次余额")
    private BigDecimal scye;

    @ApiModelProperty("本次预存")
    private BigDecimal bcyc;

    @ApiModelProperty("本次扣减=实收水费+实收污水费+实收滞纳金+垃圾费+其它费")
    private BigDecimal bckj;

    @ApiModelProperty("本次余额=上次余额+实收总金额或者本次预存-本次扣减")
    private BigDecimal bcye;

    @ApiModelProperty("收费类型：bm_sflx")
    private String sflx;

    @ApiModelProperty("收费人员编码")
    private String sfrybm;

    @ApiModelProperty("收费人员姓名")
    private String sfryxm;

    @ApiModelProperty("付费方式：bm_fffs")
    private String fffs = "07";

    public static final String ID = "ID";

    public static final String QFLSBH = "QFLSBH";

    public static final String CBKID = "CBKID";

    public static final String YHBH = "YHBH";

    public static final String CBKH = "CBKH";

    public static final String SSGS = "SSGS";

    public static final String SSCBPQ = "SSCBPQ";

    public static final String SSCBB = "SSCBB";

    public static final String YSYF = "YSYF";

    public static final String CWRQ = "CWRQ";

    public static final String SCDS = "SCDS";

    public static final String BCDS = "BCDS";

    public static final String JJL = "JJL";

    public static final String SL = "SL";

    public static final String SJBM = "SJBM";

    public static final String SJ = "SJ";

    public static final String SF = "SF";

    public static final String WSFDJ = "WSFDJ";

    public static final String WSF = "WSF";

    public static final String SJBM1 = "SJBM1";

    public static final String SJ1 = "SJ1";

    public static final String SL1 = "SL1";

    public static final String SF1 = "SF1";

    public static final String WSFDJ1 = "WSFDJ1";

    public static final String WSF1 = "WSF1";

    public static final String SJBM2 = "SJBM2";

    public static final String SJ2 = "SJ2";

    public static final String SL2 = "SL2";

    public static final String SF2 = "SF2";

    public static final String WSFDJ2 = "WSFDJ2";

    public static final String WSF2 = "WSF2";

    public static final String SJBM3 = "SJBM3";

    public static final String SJ3 = "SJ3";

    public static final String SL3 = "SL3";

    public static final String SF3 = "SF3";

    public static final String WSFDJ3 = "WSFDJ3";

    public static final String WSF3 = "WSF3";

    public static final String CBRYBM = "CBRYBM";

    public static final String CBRYXM = "CBRYXM";

    public static final String CBRQ = "CBRQ";

    public static final String LRRYBM = "LRRYBM";

    public static final String LRRYXM = "LRRYXM";

    public static final String LRRQ = "LRRQ";

    public static final String JSRQ = "JSRQ";

    public static final String YSSL = "YSSL";

    public static final String YSSF = "YSSF";

    public static final String YSWSF = "YSWSF";

    public static final String YSLJF = "YSLJF";

    public static final String YSQT = "YSQT";

    public static final String YSJE = "YSJE";

    public static final String JT1SL = "JT1SL";

    public static final String JT1SJ = "JT1SJ";

    public static final String JT1SF = "JT1SF";

    public static final String JT2SL = "JT2SL";

    public static final String JT2SJ = "JT2SJ";

    public static final String JT2SF = "JT2SF";

    public static final String JT3SL = "JT3SL";

    public static final String JT3SJ = "JT3SJ";

    public static final String JT3SF = "JT3SF";

    public static final String JT4SL = "JT4SL";

    public static final String JT4SJ = "JT4SJ";

    public static final String JT4SF = "JT4SF";

    public static final String ZNJTS = "ZNJTS";

    public static final String ZNJFL = "ZNJFL";

    public static final String ZNJ = "ZNJ";

    public static final String ZNJJSRQ = "ZNJJSRQ";

    public static final String CBJSBZ = "CBJSBZ";

    public static final String CBJSFS = "CBJSFS";

    public static final String BZ = "BZ";

    public static final String CBLX = "CBLX";

    public static final String CBFS = "CBFS";

    public static final String JBZD = "JBZD";

    public static final String XBQD = "XBQD";

    public static final String CBLY = "CBLY";

    public static final String CBCS = "CBCS";

    public static final String FYLX = "FYLX";

    public static final String CHBZ = "CHBZ";

    public static final String CHID = "CHID";

    public static final String CHSJ = "CHSJ";

    public static final String CHRYBM = "CHRYBM";

    public static final String CHRYXM = "CHRYXM";

    public static final String CHLX = "CHLX";

    public static final String SFBZ = "SFBZ";

    public static final String SFRQ = "SFRQ";

    public static final String YHXM = "YHXM";

    public static final String SFLSBH = "SFLSBH";

    public static final String JTZQLJL_JSQ = "JTZQLJL_JSQ";

    public static final String JTZQLJL = "JTZQLJL";

    public static final String JTRK = "JTRK";

    public static final String SJ1_JT1SL = "SJ1_JT1SL";

    public static final String SJ1_JT1SJ = "SJ1_JT1SJ";

    public static final String SJ1_JT1SF = "SJ1_JT1SF";

    public static final String SJ1_JT2SL = "SJ1_JT2SL";

    public static final String SJ1_JT2SJ = "SJ1_JT2SJ";

    public static final String SJ1_JT2SF = "SJ1_JT2SF";

    public static final String SJ1_JT3SL = "SJ1_JT3SL";

    public static final String SJ1_JT3SJ = "SJ1_JT3SJ";

    public static final String SJ1_JT3SF = "SJ1_JT3SF";

    public static final String SJ1_JT4SL = "SJ1_JT4SL";

    public static final String SJ1_JT4SF = "SJ1_JT4SF";

    public static final String SJ1_JT4SJ = "SJ1_JT4SJ";

    public static final String SJ2_JT1SL = "SJ2_JT1SL";

    public static final String SJ2_JT1SJ = "SJ2_JT1SJ";

    public static final String SJ2_JT1SF = "SJ2_JT1SF";

    public static final String SJ2_JT2SL = "SJ2_JT2SL";

    public static final String SJ2_JT2SJ = "SJ2_JT2SJ";

    public static final String SJ2_JT2SF = "SJ2_JT2SF";

    public static final String SJ2_JT3SL = "SJ2_JT3SL";

    public static final String SJ2_JT3SJ = "SJ2_JT3SJ";

    public static final String SJ2_JT3SF = "SJ2_JT3SF";

    public static final String SJ2_JT4SL = "SJ2_JT4SL";

    public static final String SJ2_JT4SF = "SJ2_JT4SF";

    public static final String SJ2_JT4SJ = "SJ2_JT4SJ";

    public static final String SSYYS = "SSYYS";

    public static final String FYLXMC = "FYLXMC";

    public static final String SFBC = "SFBC";

    public static final String KPBZ = "KPBZ";

    public static final String KPRQ = "KPRQ";

    public static final String SHRY = "SHRY";

    public static final String LJFDJ = "LJFDJ";

    public static final String LJF = "LJF";

    public static final String LJFDJ1 = "LJFDJ1";

    public static final String LJF1 = "LJF1";

    public static final String LJFDJ2 = "LJFDJ2";

    public static final String LJF2 = "LJF2";

    public static final String LJFDJ3 = "LJFDJ3";

    public static final String LJF3 = "LJF3";

    public static final String SSZNJ = "SSZNJ";

    public static final String SSZJE = "SSZJE";

    public static final String SCYE = "SCYE";

    public static final String BCYC = "BCYC";

    public static final String BCKJ = "BCKJ";

    public static final String BCYE = "BCYE";

    public static final String SFLX = "SFLX";

    public static final String SFRYBM = "SFRYBM";

    public static final String SFRYXM = "SFRYXM";

    public static final String FFFS = "FFFS";
}
