package com.tofly.feesapi.sfgl.entity.dto;

import com.tofly.feesapi.sfgl.entity.vo.SfJsJg;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;


@Data
@ApiModel("水费补差DTO")
public class SfBc {

    @ApiModelProperty(value = "补差欠费ID", required = true, position = 3)
    private String id;

    @ApiModelProperty(value = "费用类型编码", required = true, position = 4)
    private String fylx;

    @ApiModelProperty(value = "补差水量", position = 5)
    private BigDecimal yssl = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差水费", position = 6)
    private BigDecimal yssf = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差污水费", position = 7)
    private BigDecimal yswsf = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差垃圾费", position = 8)
    private BigDecimal ysljf = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差滞纳金", position = 9)
    private BigDecimal znj = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差金额", position = 10)
    private BigDecimal ysje = BigDecimal.ZERO;

    @ApiModelProperty(value = "补差备注", position = 11, required = true)
    private String bz;

    @ApiModelProperty(value = "上次读数", position = 14)
    private BigDecimal scds;

    @ApiModelProperty(value = "本次读数", position = 15)
    private BigDecimal bcds;


    @ApiModelProperty(value = "水价计算结果", position = 23)
    private SfJsJg sfJsJg;

}