package com.tofly.feesapi.sfgl.entity.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * @author lihaoli
 * @date 2024/6/7
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("水费测算DTO")
public class Sfcs {
    @ApiModelProperty(value = "抄表卡ID", required = true, example = "625520431")
    private String cbkid;
    @ApiModelProperty(value = "用户编号", required = true, example = "625520431")
    private String yhbh;
    @ApiModelProperty(value = "原始金额")
    private BigDecimal yje = BigDecimal.ZERO;
    @ApiModelProperty(value = "原始水量")
    private BigDecimal ysl = BigDecimal.ZERO;
    @ApiModelProperty(value = "原始水费")
    private BigDecimal ysf = BigDecimal.ZERO;
    @ApiModelProperty(value = "原始污水费")
    private BigDecimal ywsf = BigDecimal.ZERO;
    @ApiModelProperty(value = "原始垃圾费")
    private BigDecimal yljf = BigDecimal.ZERO;
    @ApiModelProperty(value = "一表多价标志")
    private String ybdjbz = "0";
    @ApiModelProperty(value = "是否收取污水费标志")
    private String wsfbz = "0";
    @ApiModelProperty(value = "是否收取垃圾费标志")
    private String ljfbz = "0";
    @ApiModelProperty(value = "阶梯标准")
    private String jtrk;
    @ApiModelProperty(value = "阶梯累积量")
    private BigDecimal jtzqljl;
    @ApiModelProperty(value = "水价编码")
    private String sjbm;
    @ApiModelProperty(value = "水量")
    private BigDecimal sl;
    @ApiModelProperty(value = "水价编码1")
    private String sjbm1;
    @ApiModelProperty(value = "水量1")
    private BigDecimal sl1;
    @ApiModelProperty(value = "水价编码2")
    private String sjbm2;
    @ApiModelProperty(value = "水量2")
    private BigDecimal sl2;
    @ApiModelProperty(value = "费用类型编码")
    private String fylx;
    @ApiModelProperty(value = "费用月份")
    private String ysyf;
}
