package com.tofly.feesapi.sfgl.entity.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.format.DateTimeFormat;
import com.alibaba.excel.annotation.format.NumberFormat;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.tofly.feesapi.common.MoneySerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;


@Data
@ApiModel("欠费明细列表VO")
@ColumnWidth(15)
public class YyQfmxSelect {

    @ExcelIgnore
    @ApiModelProperty(value = "欠费ID:用于部分收费时拆分欠费，newid()")
    private String id;

    @ExcelIgnore
    @ApiModelProperty(value = "欠费流水号，流水号相同欠费是一次抄表产生的同一笔欠费")
    private String qflsbh;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表卡ID，对应yh_cbkxx.id")
    private String cbkid;

    @ExcelIgnore
    @ApiModelProperty(value = "水费4（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sf3;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费单价4")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsfdj3;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费4")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsf3;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费单价4")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljfdj3;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费4")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljf3;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表人员编码")
    private String cbrybm;

    @ExcelProperty(value = {"应收明细月报表", "抄表人员"}, order = 13)
    @ApiModelProperty(value = "抄表人员姓名")
    private String cbryxm;

    @ExcelProperty(value = {"应收明细月报表", "抄表日期"}, order = 12)
    @ColumnWidth(30)
    @DateTimeFormat("yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date cbrq;

    @ExcelIgnore
    @ApiModelProperty(value = "录入人员编码")
    private String lrrybm;

    @ExcelIgnore
    @ApiModelProperty(value = "录入人员姓名")
    private String lrryxm;

    @ExcelIgnore
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date lrrq;

    @ExcelIgnore
    @ApiModelProperty(value = "计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date jsrq;

    @ExcelProperty(value = {"应收明细月报表", "应收水量"}, order = 7)
    @ApiModelProperty(value = "应收水量（sl+sl1+sl2+sl3）")
    private BigDecimal yssl;

    @ExcelProperty(value = {"应收明细月报表", "应收水费"}, order = 8)
    @NumberFormat("0.00#")
    @ApiModelProperty(value = "应收水费（sf+sf1+sf2+sf3）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal yssf;

    @ExcelProperty(value = {"应收明细月报表", "应收污水费"}, order = 9)
    @NumberFormat("0.00#")
    @ApiModelProperty(value = "应收污水费（wsf+wsf1+wsf2+wsf3）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal yswsf;

    @ExcelProperty(value = {"应收明细月报表", "应收垃圾费"}, order = 10)
    @NumberFormat("0.00#")
    @ApiModelProperty(value = "应收垃圾费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ysljf;

    @ExcelIgnore
    @ApiModelProperty(value = "应收其它费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ysqt;

    @ExcelProperty(value = {"应收明细月报表", "应收金额"}, order = 11)
    @NumberFormat("0.00#")
    @ApiModelProperty(value = "应收金额=应收水费+应收污水费+应收垃圾费+应收其他费（yssf+yswsf+ysLJF+ysqt）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ysje;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯1水量")
    private BigDecimal jt1sl;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯1水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt1sj;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯1水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt1sf;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯2水量")
    private BigDecimal jt2sl;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯2水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt2sj;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯2水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt2sf;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯3水量")
    private BigDecimal jt3sl;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯3水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt3sj;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯3水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt3sf;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯4水量")
    private BigDecimal jt4sl;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯4水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt4sj;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯4水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal jt4sf;

    @ExcelIgnore
    @ApiModelProperty(value = "滞纳金天数")
    private BigDecimal znjts;

    @ExcelIgnore
    @ApiModelProperty(value = "滞纳金费率")
    private BigDecimal znjfl;

    @ExcelIgnore
    @ApiModelProperty(value = "滞纳金")
    private BigDecimal znj;

    @ExcelIgnore
    @ApiModelProperty(value = "滞纳金计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date znjjsrq;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯，4超定额，5两高一剩；用于判断计价类型，处理显示水价）")
    private String cbjsbz;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯，超定额，两高一剩；用于查询显示）")
    private String cbjsfs;

    @ExcelIgnore
    @ApiModelProperty(value = "备注")
    private String bz;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表类型bm_cblx.bm")
    private BigDecimal cblx;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表方式:bm_cbfs")
    private String cbfs;

    @ExcelIgnore
    @ApiModelProperty(value = "旧表止读")
    private BigDecimal jbzd;

    @ExcelIgnore
    @ApiModelProperty(value = "新表起度")
    private BigDecimal xbqd;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）")
    private String cbly;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表次数")
    private BigDecimal cbcs;

    @ExcelIgnore
    @ApiModelProperty(value = "费用类型编码：bm_fylx")
    private String fylx;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红标志：0未冲红，1已冲红，2红票")
    private String chbz;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红ID，红票ID号")
    private String chid;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date chsj;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红人员编码")
    private String chrybm;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红人员姓名")
    private String chryxm;

    @ExcelIgnore
    @ApiModelProperty(value = "冲红类型  0 应收冲红，1 收费冲红")
    private String chlx;

    @ExcelIgnore
    @ApiModelProperty(value = "收费标志,0未收 1已收 4不收费")
    private String sfbz;

    @ExcelIgnore
    @ApiModelProperty(value = "收费日期")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date sfrq;

    @ExcelProperty(value = {"应收明细月报表", "用户姓名"}, order = 2)
    @ColumnWidth(30)
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;

    @ExcelProperty(value = {"应收明细月报表", "用户地址"}, order = 3)
    @ColumnWidth(30)
    @ApiModelProperty(value = "用户地址")
    private String yhdz;

    @ExcelProperty(value = {"应收明细月报表", "联系电话"}, order = 4)
    @ApiModelProperty(value = "联系电话")
    private String lxdh;

    @ExcelIgnore
    @ApiModelProperty(value = "收费流水编号")
    private String sflsbh;

    @ExcelIgnore
    @ApiModelProperty(value = "年度累计量(计算前）")
    private BigDecimal jtzqljlJsq;

    @ExcelIgnore
    @ApiModelProperty(value = "年度累计量")
    private BigDecimal jtzqljl;

    @ExcelIgnore
    @ApiModelProperty(value = "阶梯标准（多人口阶梯）编码，bm_jtrk")
    private BigDecimal rks;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯1水量")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt1sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯1水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt1sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯1水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt1sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯2水量")
    private BigDecimal sj1Jt2sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯2水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt2sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯2水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt2sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯3水量")
    private BigDecimal sj1Jt3sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯3水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt3sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯3水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt3sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯4水量")
    private BigDecimal sj1Jt4sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯4水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt4sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2.阶梯4水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1Jt4sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯1水量")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt1sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯1水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt1sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯1水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt1sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯2水量")
    private BigDecimal sj2Jt2sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯2水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt2sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯2水费")
    private BigDecimal sj2Jt2sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯3水量")
    private BigDecimal sj2Jt3sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯3水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt3sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯3水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt3sf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯4水量")
    private BigDecimal sj2Jt4sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯4水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2Jt4sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3.阶梯4水费")
    private BigDecimal sj2Jt4sf;

    @ExcelIgnore
    @ApiModelProperty(value = "费用类型名称")
    private String fylxmc;

    @ExcelIgnore
    @ApiModelProperty(value = "是否补差（0：否；1：是）")
    private String sfbc;

    @ExcelIgnore
    @ApiModelProperty(value = "开票标志（0未开票 ,1已开票）")
    private String kpbz;

    @ExcelIgnore
    @ApiModelProperty(value = "开票日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date kprq;

    @ExcelIgnore
    @ApiModelProperty(value = "审核人员")
    private String shry;


    @ExcelIgnore
    @ApiModelProperty(value = "零税率 （0：不免税，1：免税）")
    private String taxrate;

    @ExcelIgnore
    @ApiModelProperty(value = "锁定标志：0 未锁定，1 已锁定")
    private String lockbz;

    @ExcelIgnore
    @ApiModelProperty(value = "超定量（防止变更后报表变化）")
    private Long cdl;

    @ExcelIgnore
    @ApiModelProperty(value = "预开票")
    private String eiSgkpId;

    @ExcelIgnore
    @ApiModelProperty(value = "所属区域")
    private String ssregion;

    @ExcelProperty(value = {"应收明细月报表", "用户编号"}, order = 1)
    @ApiModelProperty(value = "用户编号")
    private String yhbh;

    @ExcelIgnore
    @ApiModelProperty(value = "抄表卡号")
    private BigDecimal cbkh;

    @ExcelIgnore
    @ApiModelProperty(value = "所属公司")
    private BigDecimal ssgs;

    @ExcelIgnore
    @ApiModelProperty(value = "所属抄表片区")
    private BigDecimal sscbpq;

    @ExcelIgnore
    @ApiModelProperty(value = "所属抄表本")
    private BigDecimal sscbb;

    @ExcelIgnore
    @ApiModelProperty(value = "用水月份")
    private BigDecimal ysyf;

    @ExcelIgnore
    @ApiModelProperty(value = "财务日期")
    private BigDecimal cwrq;

    @ExcelProperty(value = {"应收明细月报表", "上次读数"}, order = 5)
    @ApiModelProperty(value = "上次读数")
    private BigDecimal scds;

    @ExcelProperty(value = {"应收明细月报表", "本次读数"}, order = 6)
    @ApiModelProperty(value = "本次读数")
    private BigDecimal bcds;

    @ExcelIgnore
    @ApiModelProperty(value = "加减量")
    private BigDecimal jjl;

    @ExcelIgnore
    @ApiModelProperty(value = "水量")
    private BigDecimal sl;

    @ExcelIgnore
    @ApiModelProperty(value = "水价编码")
    private String sjbm;

    @ExcelIgnore
    @ApiModelProperty(value = "水价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj;

    @ExcelIgnore
    @ApiModelProperty(value = "水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sf;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费单价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsfdj;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsf;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费单价")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljfdj;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljf;

    @ExcelIgnore
    @ApiModelProperty(value = "水价编码2（一表多价时存储）")
    private String sjbm1;

    @ExcelIgnore
    @ApiModelProperty(value = "水价2（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj1;

    @ExcelIgnore
    @ApiModelProperty(value = "水量2（一表多价时存储）")
    private BigDecimal sl1;

    @ExcelIgnore
    @ApiModelProperty(value = "水费2（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sf1;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费单价2")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsfdj1;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费2")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsf1;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费单价2")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljfdj1;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费2")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljf1;

    @ExcelIgnore
    @ApiModelProperty(value = "水价编码3（一表多价时存储）")
    private String sjbm2;

    @ExcelIgnore
    @ApiModelProperty(value = "水价3（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj2;

    @ExcelIgnore
    @ApiModelProperty(value = "水量3（一表多价时存储）")
    private BigDecimal sl2;

    @ExcelIgnore
    @ApiModelProperty(value = "水费3（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sf2;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费单价3")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsfdj2;

    @ExcelIgnore
    @ApiModelProperty(value = "污水费3")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsf2;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费单价3")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljfdj2;

    @ExcelIgnore
    @ApiModelProperty(value = "垃圾费3")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljf2;

    @ExcelIgnore
    @ApiModelProperty(value = "水价编码4（一表多价时存储）")
    private String sjbm3;

    @ExcelIgnore
    @ApiModelProperty(value = "水价4（一表多价时存储）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sj3;

    @ExcelIgnore
    @ApiModelProperty(value = "水量4（一表多价时存储）")
    private BigDecimal sl3;

}
