package com.tofly.feesapi.sfgl.entity.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.tofly.feesapi.common.MoneySerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.List;

@ApiModel(value = "日收费统计VO", description = "日收费统计")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class YySspjxxDailyStat {

    @ApiModelProperty(value = "水费收入", position = 1)
    private List<SrxmStat> sfsr;

    @ApiModelProperty(value = "附加及代收费", position = 2)
    private List<SrxmStat> fjjdsf;

    @ApiModelProperty(value = "总计", position = 3)
    private SrxmStat zj;

    @Data
    @NoArgsConstructor
    @AllArgsConstructor
    @ApiModel(value = "收入项目统计VO", description = "日收费统计")
    public static class SrxmStat {

        @ApiModelProperty(value = "收入项目", position = 2)
        private String srxm;

        @ApiModelProperty(value = "付费方式统计", position = 3)
        private List<FffsStat> fffsStats;


    }

    @ApiModel(value = "付费方式统计VO", description = "日收费统计")
    @NoArgsConstructor
    @AllArgsConstructor
    @Data
    public static class FffsStat {

        @ApiModelProperty(value = "付费方式名称", position = 1)
        private String fffsmc;

        @ApiModelProperty(value = "水量", position = 1)
        private BigDecimal sl;

        @ApiModelProperty(value = "金额", position = 2)
        @JsonSerialize(using = MoneySerializer.class)
        private BigDecimal je;


    }
}
