package com.tofly.feesapi.sfgl.entity.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.tofly.feesapi.common.MoneySerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@ApiModel(value = "按日汇总报表VO", description = "按日汇总报表")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class YySspjxxDailyStat2 {

    @ApiModelProperty(value = "收费日期")
    private String sfrq;

    @ApiModelProperty(value = "笔数")
    private Integer bs;

    @ApiModelProperty(value = "应收水量")
    private BigDecimal yssl;

    @ApiModelProperty(value = "应收水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal yssf;

    @ApiModelProperty(value = "应收污水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal yswsf;

    @ApiModelProperty(value = "应收垃圾费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ysljf;

    @ApiModelProperty(value = "本次扣减(冲预交水费)")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal bckj;

    @ApiModelProperty(value = "转预存金额")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal zyc;

    @ApiModelProperty(value = "本次预存(预交水费)")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal bcyc;

    @ApiModelProperty(value = "实收总金额（合计）")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sszje;



}
