package com.tofly.feesapi.sfgl.entity.vo;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.tofly.feesapi.common.MoneySerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@ApiModel(value = "水费水量汇总统计VO", description = "欠费明细统计")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class YyStat {

    @ApiModelProperty(value = "水量")
    private BigDecimal sl;

    @ApiModelProperty(value = "水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal sf;

    @ApiModelProperty(value = "污水费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal wsf;

    @ApiModelProperty(value = "垃圾费")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal ljf;

    @ApiModelProperty(value = "合计")
    @JsonSerialize(using = MoneySerializer.class)
    private BigDecimal hj;



}
