package com.tofly.feesapi.sfgl.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.sfgl.entity.YyQfmx;
import com.tofly.feesapi.sfgl.entity.dto.YyQfmxFilter;
import com.tofly.feesapi.sfgl.entity.dto.YyQfmxStatFilter;
import com.tofly.feesapi.sfgl.entity.dto.YySjStat;
import com.tofly.feesapi.sfgl.entity.vo.YyQfmxSelect;
import com.tofly.feesapi.sfgl.entity.vo.YyStat;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

public interface YyQfmxMapper extends BaseMapper<YyQfmx> {

    //获取用户是否存在欠费
    int selectExistQf(String yhbh);

    @Select({"{call PROC_SLSFJS(#{cbkid},#{code,mode=OUT,jdbcType=INTEGER},#{message,mode=OUT,jdbcType=VARCHAR})}"})
    @Options(statementType = StatementType.CALLABLE)
    Map<Integer, String> sf(String cbkid);

    PageDto<YyQfmxSelect> getPage(PageDto pageDto,
                                  @Param("filter") YyQfmxFilter filter,
                                  @Param("sfbz") String sfbz,
                                  @Param("chbz") String chbz);

    List<YyQfmxSelect> getList(@Param("filter") YyQfmxFilter filter,
                               @Param("sfbz") String sfbz,
                               @Param("chbz") String chbz);

    /**
     * 用水性质统计（非补差）
     *
     * @param filter
     * @param tag
     * @return
     */
    List<YySjStat> sjStat(@Param("filter") YyQfmxStatFilter filter, @Param("tag") String tag);

    /**
     * 补差统计
     *
     * @param filter
     * @return
     */
    BigDecimal bcStat(@Param("filter") YyQfmxStatFilter filter);

    YyStat stat(@Param("filter") YyQfmxStatFilter filter,
                @Param("sfbz") String sfbz);
}
