package com.tofly.feesapi.sfgl.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.sfgl.entity.YySspjxx;
import com.tofly.feesapi.sfgl.entity.dto.*;
import com.tofly.feesapi.sfgl.entity.vo.*;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 收费明细
 */
public interface YySspjxxMapper extends BaseMapper<YySspjxx> {

    List<YyFjFffsStat> fjFffsStat(@Param("filter") YySspjxxDailyStatFilter filter);

    List<YySjFffsStat> sjSffsStat(@Param("filter") YySspjxxDailyStatFilter filter, @Param("tag") String tag);

    PageDto<YySspjxxSelect> getPage(PageDto pageDto,
                                    @Param("filter") YySspjxxFilter filter,
                                    @Param("sffl") String sffl,
                                    @Param("chbz") String chbz);

    /**
     * 今日统计
     *
     * @param sfrybm
     * @return
     */
    List<JrtjSelect> jrtj(@Param("sfrybm") String sfrybm);

    /**
     * 上笔金额
     *
     * @param yhbh
     * @return
     */
    BigDecimal sbje(@Param("yhbh") String yhbh);

    /**
     * 实收总金额
     *
     * @param sflsbh 收费流水编号
     * @return
     */
    BigDecimal sszje(@Param("sflsbh") String sflsbh);

    /**
     * 票据冲红
     *
     * @param params yhbh   用户编号
     *               sflsbh 收费流水编号
     *               sszje  实收金额
     *               chrybm 冲红人员编码
     *               chryxm 冲红人员姓名
     *               chsj   冲红时间
     *               result 是否成功
     *               <p>
     *               ***0（失败）;1（成功）
     *               --***2（收费金额不匹配）;
     *               --***3（不是最新缴费记录）;
     *               --***4（预付费余额已发生变化或剩余预付费不够退费）;
     *               --***5（收费转存的预付费不能单独退费）
     *               --***9（没有收费记录）
     *               --***-6生成电子发票（红票错误）
     */
    @Select({"{call PROC_SF_CH(#{yhbh,jdbcType=VARCHAR},#{sflsbh},#{sszje},#{chrybm,jdbcType=VARCHAR},#{chryxm,jdbcType=VARCHAR},#{chsj},#{result,mode=OUT,jdbcType=INTEGER})}"})
    @Options(statementType = StatementType.CALLABLE)
    void pjCh(Map<String, Object> params);

    List<YySspjxxSelect> getList(@Param("filter") YySspjxxFilter filter,
                                 @Param("sffl") String sffl,
                                 @Param("chbz") String chbz);

    List<YySspjxxDailyStat2> dailyStat2(@Param("filter") YySspjxxStatFilter filter);

    /**
     * 综合收费报表
     *
     * @param filter
     * @return
     */
    List<YySspjxxZhSfStat> zhSfStat(@Param("filter") YySspjxxStatFilter filter);

    /**
     * 水价收费统计
     *
     * @param filter
     * @param tag
     * @return
     */
    List<YySjStat> sjStat(@Param("filter") YySspjxxStatFilter filter,
                          @Param("tag") String tag);

    /**
     * 其它收费统计
     *
     * @param filter
     * @return
     */
    BigDecimal qtStat(@Param("filter") YySspjxxStatFilter filter,
                      @Param("flag") String flag);

    /**
     * 用户缴费信息统计
     *
     * @param filter
     * @return
     */
    YyStat stat(@Param("filter") YySspjxxStatFilter filter);


    PageDto<YffYeSeachSelect> yffyeseach(PageDto pageDto,
                                         @Param("filter") YffYeSeachFilter filter);

    List<YffYeSeachSelect> yffyeseachList( @Param("filter") YffYeSeachFilter filter);

    @Select("SELECT count(*) FROM YY_SSPJXX_CZLS WHERE SFLX  IN (#{val})")
    int sspjSFLX(@Param("val") List<String> val);
    @Select("SELECT count(*)  FROM YY_SSPJXX_CZLS WHERE FFFS  IN (#{val})")
    int sspjFFFS(@Param("val") List<String> val);
    @Select("SELECT count(*)  FROM YY_SSPJXX_CZLS WHERE JFQD IN (#{val})")
    int sspjJFQD(@Param("val") List<String> val);
}
