package com.tofly.feesapi.sfgl.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.sfgl.entity.YyQfmx;
import com.tofly.feesapi.sfgl.entity.dto.*;
import com.tofly.feesapi.sfgl.entity.vo.SfJsJg;
import com.tofly.feesapi.sfgl.entity.vo.YyQfmxMonthlyStat;
import com.tofly.feesapi.sfgl.entity.vo.YyQfmxSelect;
import com.tofly.feesapi.sfgl.entity.vo.YyStat;

import java.math.BigDecimal;
import java.util.List;

/**
 * 应收明细：欠费明细
 */
public interface YyQfmxService extends IService<YyQfmx> {

    /**
     * 全部抄表录入算费生成应收明细
     */
    void sf();

    PageResult<YyQfmxSelect> getPage(PageDto pageDto, YyQfmxFilter filter, String sfbz, String chbz);

    /**
     * 按抄表本（册）算费生成应收明细
     */
    boolean cbbSf(CbbSf cbbSf, CzyUserDetails czyUserDetails);

    /**
     * 按用户算费生成应收明细
     */
    boolean yhSf(YhSf yhSf, CzyUserDetails czyUserDetails);

    /**
     * 水费补差
     *
     * @param sfBc
     * @param czyUserDetails
     * @return
     */
    boolean sfBc(SfBc sfBc, CzyUserDetails czyUserDetails);

    /**
     * 水费测算
     *
     * @param sfJs
     * @param czyUserDetails
     * @return
     */
    SfJsJg sfJs(SfJs sfJs, CzyUserDetails czyUserDetails);

    SfJsJg sfCs(Sfcs sfcs, CzyUserDetails czyUserDetails);

    /**
     * 应收汇总月报表
     *
     * @param filter
     * @return
     */
    List<YyQfmxMonthlyStat> monthlyStat(YyQfmxStatFilter filter);

    /**
     * @param filter
     * @return
     */
    List<YyQfmxSelect> getList(YyQfmxFilter filter, String sfbz, String chbz);

    /**
     * 撤销算费
     *
     * @param id
     * @param czyUserDetails
     * @return
     */
    boolean cxSf(String id, CzyUserDetails czyUserDetails);

    /**
     * 欠费统计
     *
     * @param filter
     * @return
     */
    YyStat stat(YyQfmxStatFilter filter, String sfbz);

    SfJsJg sfJs(YhCbkxx cbkxx, BigDecimal sjsl, CzyUserDetails czyUserDetails);

    SfJsJg jtSfjs(Jtsfjs jtsfjs, CzyUserDetails czyUserDetails);

    String pjyl(pjYl pjyl, CzyUserDetails czyUserDetails);

    int Tasksf(List<YyCblr> cblrs);
}
