package com.tofly.feesapi.sfgl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.common.NumberHelper;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.bmgl.entity.BmFffs;
import com.tofly.feesapi.bmgl.entity.BmSj;
import com.tofly.feesapi.bmgl.service.BmSjService;
import com.tofly.feesapi.bmgl.service.IBmFffsService;
import com.tofly.feesapi.cbgl.entity.ZnbZlLog;
import com.tofly.feesapi.cbgl.service.IZnbZlLogService;
import com.tofly.feesapi.common.constant.PjztEnum;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.entity.dto.Order;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.enums.PjlxEnum;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.sfgl.entity.YyQfmx;
import com.tofly.feesapi.sfgl.entity.YySspjxx;
import com.tofly.feesapi.sfgl.entity.dto.*;
import com.tofly.feesapi.sfgl.entity.vo.*;
import com.tofly.feesapi.sfgl.mapper.YySspjxxMapper;
import com.tofly.feesapi.sfgl.service.YyQfmxService;
import com.tofly.feesapi.sfgl.service.YySspjxxService;
import com.tofly.feesapi.udb.smpn.entity.User;
import com.tofly.feesapi.udb.smpn.service.IUserService;
import com.tofly.feesapi.xtgl.service.ISysGdcsbService;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.entity.YyZjzh;
import com.tofly.feesapi.yhgl.entity.dto.YyZjzhUpdate;
import com.tofly.feesapi.yhgl.service.IYyZjzhService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.stream.Collectors;

import static com.tofly.feesapi.common.constant.SflxEnum.*;

/**
 * 收费明细
 */
@Service("yySspjxxService")
public class YySspjxxServiceImpl extends ServiceImpl<YySspjxxMapper, YySspjxx> implements YySspjxxService {


    @Autowired
    private BmSjService sjService;
    @Autowired
    private IBmFffsService bmFffsService;
    @Autowired
    private YyQfmxService qfmxService;
    @Autowired
    private IYyZjzhService zjzhService;
    @Autowired
    private ISysGdcsbService gdcsbService;
    @Autowired
    private YhKhjbxxService khjbxxService;
    @Autowired
    private YhCbkxxService yhCbkxxService;
    @Autowired
    private IZnbZlLogService iZnbZlLogService;
    @Autowired
    private IUserService userService;

    @Override
    public YySspjxxDailyStat dailyStat(YySspjxxDailyStatFilter filter) {
        Map<String, String> fffsMap = getFffsMap();
        List<YySspjxxDailyStat.SrxmStat> sfsr = getSfsr(filter, fffsMap);
        List<YySspjxxDailyStat.SrxmStat> fjjdsf = getFjjdsf(filter, fffsMap);

        int sfsfSize = sfsr.size();
        int fjjdsfSize = fjjdsf.size();
        List<YySspjxxDailyStat.SrxmStat> srxmStat2 = new ArrayList<>();
        if (sfsfSize > 0) {
            srxmStat2.add(sfsr.get(sfsfSize - 1));
        }
        if (fjjdsfSize > 0) {
            srxmStat2.add(fjjdsf.get(fjjdsfSize - 1));
        }

        YySspjxxDailyStat.SrxmStat zj = getZj(fffsMap, srxmStat2);

        return new YySspjxxDailyStat(sfsr, fjjdsf, zj);
    }

    @Override
    public PageResult<YySspjxxSelect> getPage(PageDto pageDto, YySspjxxFilter filter, String sffl, String chbz) {
        List<Order> orders = pageDto.getOrders();
        if (orders.isEmpty()) {
            orders.add(new Order("sfrq", false));
        }
        PageDto<YySspjxxSelect> page = this.baseMapper.getPage(pageDto, filter, sffl, chbz);
        Map<String, String> sjMap = getSjMap();
        page.getRecords().forEach(e -> setYslx(e, sjMap));
        return page.toVo();
    }

    @Override
    @Transactional
    public List<String> save(YySspjxxInsert insert, CzyUserDetails czyUserDetails) throws Exception {
        List<String> qfids = insert.getQfids();
        String fffs = insert.getFffs();
        if (StringUtils.isBlank(fffs)) throw new FeesException("付费方式为空", FeesErrorCode.BUSINESS_ERROR);
        if (!"1".equals(fffs)) throw new FeesException("付费方式暂不支持", FeesErrorCode.BUSINESS_ERROR);
        String yhbh = insert.getYhbh();
        BigDecimal sszje = insert.getSszje();
        String sflsbh = getSflsbh();
        List<String> printpjList = new ArrayList<>();
        if (qfids == null || qfids.isEmpty()) {
            YyZjzhUpdate zjzhUpdate = new YyZjzhUpdate();
            zjzhUpdate.setYhbh(yhbh);
            zjzhUpdate.setJe(sszje);
            zjzhService.xgyck(zjzhUpdate, czyUserDetails, true, 1, fffs, sflsbh);
            printpjList.add(yffpj(sflsbh, 预付费收取.getValue().toString(), ""));
            return printpjList;
        }
        List<YyQfmx> yyQfmxes = qfmxService.listByIds(qfids);
        if (yyQfmxes.isEmpty()) throw new FeesException("欠费明细不存在", FeesErrorCode.BUSINESS_ERROR);
        for (YyQfmx e : yyQfmxes) {
            if ("1".equals(e.getSfbz()))
                throw new FeesException(String.format("已收费:%s", e.getId()), FeesErrorCode.BUSINESS_ERROR);
            if ("1".equals(e.getChbz()))
                throw new FeesException(String.format("已冲红:%s", e.getId()), FeesErrorCode.BUSINESS_ERROR);
        }
        yyQfmxes = yyQfmxes.stream()
                .sorted(Comparator.comparing(YyQfmx::getCbrq).thenComparing(YyQfmx::getCbkid))
                .collect(Collectors.toList());

        BigDecimal yhye = BigDecimal.ZERO;
        YyZjzh zjzh = zjzhService.getById(yhbh);//用户资金账号
        if (zjzh != null) {
            BigDecimal syje = zjzh.getSyje();
            yhye = syje == null ? BigDecimal.ZERO : syje;
        }
        YyQfmx firstQfmx = yyQfmxes.get(0);
        BigDecimal ysje = firstQfmx.getYsje();
        BigDecimal znj = firstQfmx.getZnj();
        ysje = ysje == null ? BigDecimal.ZERO : ysje;
        znj = znj == null ? BigDecimal.ZERO : znj;
        if (yhye.compareTo(ysje.add(znj)) > 0) {
            throw new FeesException("剩余预付费大于等于最早一笔欠费", FeesErrorCode.BUSINESS_ERROR);
        }
        BigDecimal yszje = yyQfmxes.stream().map(e -> e.getYsje())
                .filter(e -> e != null)
                .reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
        yszje = yszje.subtract(yhye);//减去余额
        if (sszje.compareTo(yszje) < 0) {
            throw new FeesException("缴费金额低于欠费金额", FeesErrorCode.BUSINESS_ERROR);
        }
        //BigDecimal bckj = yhye;//本次扣减
        //BigDecimal bcye = BigDecimal.ZERO;//本次余额
        BigDecimal bcyfje = sszje.subtract(yszje);//本次预付金额

        Date now = new Date();
        List<YySspjxx> list = new ArrayList<>();
        int sfxh = 1;
        for (YyQfmx qfmx : yyQfmxes) {
            BigDecimal bckj1 = BigDecimal.ZERO;
            BigDecimal ysje1 = qfmx.getYsje();
            BigDecimal znj1 = qfmx.getZnj();
            BigDecimal sszje1 = null;
            //BigDecimal bcjz = null;
            if (sfxh == 1) {
                bckj1 = yhye;
                sszje1 = ysje1.add(znj1).subtract(yhye);
            } else {
                sszje1 = ysje1.add(znj1);
            }
            YySspjxx sspjxx = new YySspjxx();
            BeanUtils.copyProperties(qfmx, sspjxx);
            sspjxx.setQfid(qfmx.getId());
            sspjxx.setSfxh(sfxh);//收费序号
            if (bckj1.compareTo(BigDecimal.ZERO) > 0) {
                sspjxx.setBcye(BigDecimal.ZERO);
                sspjxx.setScye(yhye);
                sspjxx.setZyc(bckj1.negate());
                sspjxx.setBckj(bckj1);
                sspjxx.setSflx(预付费收取);
            } else {
                sspjxx.setSflx(欠费收取);
            }
            sspjxx.setSszje(sszje1);
            list.add(sspjxx);
            sfxh++;
        }

        boolean islast = false;
        int i = 0;
        for (YySspjxx sspjxx : list) {
            sspjxx.setFffs(fffs);
            sspjxx.setSflsbh(sflsbh);
            sspjxx.setSfrq(now);
            sspjxx.setChbz(PjztEnum.正常.getValue());
            sspjxx.setSfbz("1");
            if (czyUserDetails != null) {
                sspjxx.setSfrybm(String.valueOf(czyUserDetails.getId()));
                sspjxx.setSfryxm(czyUserDetails.getRealName());
            }
            this.save(sspjxx);
            if (list.size() - 1 == i) {
                islast = true;
            }
            printpjList.add(sspj(sspjxx.getId(), islast));
            if (sspjxx.getQfid() != null) {
                qfmxService.lambdaUpdate()
                        .set(YyQfmx::getSfrq, now)
                        .set(YyQfmx::getSfbz, "1")
                        .set(YyQfmx::getSflsbh, sflsbh)
                        .eq(YyQfmx::getId, sspjxx.getQfid())
                        .update();
            }
            i++;
        }

        if (bcyfje.compareTo(BigDecimal.ZERO) > 0) {//取整结转
            YyZjzhUpdate zjzhUpdate = new YyZjzhUpdate();
            zjzhUpdate.setYhbh(yhbh);
            zjzhUpdate.setJe(bcyfje);
            zjzhService.xgyck(zjzhUpdate, czyUserDetails, true, sfxh, fffs, sflsbh);
        }

        return printpjList;
    }

    public String printPj(String ssid) {
        try {
            YySspjxx yySspjxx = this.getById(ssid);
            if (yySspjxx == null)
                throw new FeesException("实收记录不存在", FeesErrorCode.BUSINESS_ERROR);
            if (yySspjxx.getSflx().equals(预付费收取) || yySspjxx.getSflx().equals(余额转存)) {
                return yffpj(yySspjxx.getSflsbh(), yySspjxx.getSflx().getValue().toString(), ssid);
            } else {
                return sspj(ssid, false);
            }
        } catch (Exception e) {
            throw new FeesException(e.getMessage(), FeesErrorCode.BUSINESS_ERROR);
        }
    }

    /**
     * 实收票据
     *
     * @return
     */
    private String sspj(String ssid, boolean islast) throws Exception {
        YySspjxx sspjxx = this.getById(ssid);
        if (sspjxx == null)
            throw new FeesException("实收记录不存在", FeesErrorCode.BUSINESS_ERROR);
        YhKhjbxx yhKhjbxx = khjbxxService.getById(sspjxx.getYhbh());
        if (yhKhjbxx == null)
            throw new FeesException("客户信息不存在", FeesErrorCode.BUSINESS_ERROR);

        String ssmxsql = String.format("with sssf as\n" +
                " (select 1 xh,\n" +
                "         '阶梯1' as mc,\n" +
                "         sjbm,\n" +
                "         b.name sjmc,\n" +
                "         jt1sj sj,\n" +
                "         jt1sl sl,\n" +
                "         jt1sf sf\n" +
                "    from yy_sspjxx a\n" +
                "    left join bm_sj b\n" +
                "      on a.sjbm = b.code\n" +
                "   where id = '%s'\n" +
                "     and sflx <> 3\n" +
                "     and b.jtbz = 1\n" +
                "  union\n" +
                "  select 2 xh, '阶梯2', sjbm, b.name sjmc, jt2sj, jt2sl, jt2sf\n" +
                "    from yy_sspjxx a\n" +
                "    left join bm_sj b\n" +
                "      on a.sjbm = b.code\n" +
                "   where id = '%s'\n" +
                "     and sflx <> 3\n" +
                "     and b.jtbz = 1\n" +
                "  union\n" +
                "  select 3 xh, '阶梯3', sjbm, b.name sjmc, jt3sj, jt3sl, jt3sf\n" +
                "    from yy_sspjxx a\n" +
                "    left join bm_sj b\n" +
                "      on a.sjbm = b.code\n" +
                "   where id = '%s'\n" +
                "     and sflx <> 3\n" +
                "     and b.jtbz = 1\n" +
                "  union\n" +
                "  select 4 xh, '非居', a.sjbm, b.name sjmc, a.sj, a.sl, a.sf\n" +
                "    from yy_sspjxx a\n" +
                "    left join bm_sj b\n" +
                "      on a.sjbm = b.code\n" +
                "   where id = '%s'\n" +
                "     and sflx <> 3\n" +
                "     and nvl(b.jtbz, 0) = 0)\n" +
                "select a.*\n" +
                "  from sssf a\n" +
                "  left join bm_sj b\n" +
                "    on a.sjbm = b.code\n" +
                " where nvl(a.sf, 0) > 0\n", ssid, ssid, ssid, ssid);

        String qtfysql = String.format("select 5, '污水费' mc, wsfdj dj, yswsf sf, yssl sl\n" +
                "  from yy_sspjxx\n" +
                " where id = '%s'\n" +
                "   and nvl(yswsf, 0) > 0\n" +
                "union\n" +
                "select 6, '垃圾费', ljfdj dj, ysljf, yssl sl\n" +
                "  from yy_sspjxx\n" +
                " where id = '%s'\n" +
                "   and nvl(ysljf, 0) > 0\n" +
                "union\n" +
                "select 7, '违约金', 0, znj, 0 sl\n" +
                "  from yy_sspjxx\n" +
                " where id = '%s'\n" +
                "   and nvl(znj, 0) > 0\n", ssid, ssid, ssid);
        List<HashMap<String, Object>> sflist = DbHelper.getDbHelper().getList(ssmxsql);
        StringBuilder str = new StringBuilder();
        sflist.forEach(e -> {
            str.append("<tr>");
            str.append(String.format("<td>%s</td>", e.get("mc")));
            str.append(String.format("<td>%s</td>", e.get("sf")));
            str.append(String.format("<td>%s</td>", e.get("sj")));
            str.append(String.format("<td>%s</td>", e.get("sl")));
            str.append(String.format("<td>%s</td>", "\\"));
            str.append(String.format("<td>%s</td>", ""));
            str.append("</tr>");
        });
        List<HashMap<String, Object>> qtlist = DbHelper.getDbHelper().getList(qtfysql);
        qtlist.forEach(e -> {
            str.append("<tr>");
            str.append(String.format("<td>%s</td>", e.get("mc")));
            str.append(String.format("<td>%s</td>", e.get("sf")));
            str.append(String.format("<td>%s</td>", e.get("dj")));
            str.append(String.format("<td>%s</td>", e.get("sl")));
            str.append(String.format("<td>%s</td>", "\\"));
            str.append(String.format("<td>%s</td>", ""));
            str.append("</tr>");
        });
        BigDecimal ycje = BigDecimal.ZERO;
        if (islast) {
            String ycjesql = String.format("select sum(NVL(sszje,0)) from yy_sspjxx " +
                            "where sflsbh='%s' and sflx=3  group by sflsbh"
                    , sspjxx.getSflsbh());
            String ycjestr = DbHelper.getDbHelper().getValue(ycjesql);
            if (StringUtils.isNotEmpty(ycjestr)) {
                ycje = BigDecimal.valueOf(Long.parseLong(ycjestr));
            }
        }
        if (sspjxx.getFylx().equals("9")) {
            ycje = sspjxx.getBcyc();
        }
        String htmlstr = DbHelper.getDbHelper().getValue(String.format("select printtemplate from print_template where id=%s", PjlxEnum.实收票据信息.getValue()));
        htmlstr = htmlstr.replace("{{title}}", "水务");
        htmlstr = htmlstr.replace("{{yhbh}}", sspjxx.getYhbh());
        htmlstr = htmlstr.replace("{{yhxm}}", sspjxx.getYhxm());
        htmlstr = htmlstr.replace("{{cwyf}}", sspjxx.getCwrq());
        htmlstr = htmlstr.replace("{{sfrq}}", sspjxx.getSfrq().toString());
        htmlstr = htmlstr.replace("{{lxdh}}", yhKhjbxx.getLxdh());
        htmlstr = htmlstr.replace("{{addr}}", yhKhjbxx.getYhdz());
        htmlstr = htmlstr.replace("{{scds}}", sspjxx.getScds().toString());
        htmlstr = htmlstr.replace("{{bcds}}", sspjxx.getBcds().toString());
        htmlstr = htmlstr.replace("{{sl}}", sspjxx.getSl().toString());

        htmlstr = htmlstr.replace("{{content}}", str.toString());
        htmlstr = htmlstr.replace("{{ysje}}", sspjxx.getYsje().add(sspjxx.getZnj()).toString());
        htmlstr = htmlstr.replace("{{ysjedx}}", NumberHelper.CmycurD(sspjxx.getYsje().add(sspjxx.getZnj())));
        htmlstr = htmlstr.replace("{{scjy}}", sspjxx.getScye().toString());
        htmlstr = htmlstr.replace("{{bcjy}}", ycje.toString());
        htmlstr = htmlstr.replace("{{sszje}}", sspjxx.getSszje().add(ycje).toString());
        htmlstr = htmlstr.replace("{{sfry}}", sspjxx.getSfryxm());
        htmlstr = htmlstr.replace("{{cbry}}", sspjxx.getCbryxm());
        User user = userService.get(Long.valueOf(sspjxx.getCbrybm()));
        //String cbrydh = DbHelper.getDbHelper().getValue(String.format("select olxdh from  sys_operators where ocode = (select cby from bm_cbb where cbbbm='%s')", sspjxx.getSscbb()));
        String cbrydh = "暂无";
        if (user != null && StringUtils.isNotEmpty(user.getPhone())) {
            cbrydh = user.getPhone();
        }
        htmlstr = htmlstr.replace("{{cbrydh}}", cbrydh);
        return htmlstr;
    }

    /**
     * 预付费票据
     *
     * @return
     */
    private String yffpj(String sflsbh, String sflx, String ssid) throws Exception {
        YySspjxx yySspjxx = null;
        if (StringUtils.isNotEmpty(ssid)) {
            yySspjxx = this.getById(ssid);
        } else {
            yySspjxx = this.getOne(
                    new QueryWrapper<YySspjxx>().lambda()
                            .eq(YySspjxx::getSflsbh, sflsbh)
                            .eq(YySspjxx::getSflx, sflx)
            );
        }
        if (yySspjxx == null)
            throw new FeesException("实收记录不存在", FeesErrorCode.BUSINESS_ERROR);
        YhKhjbxx yhKhjbxx = khjbxxService.getById(yySspjxx.getYhbh());
        if (yhKhjbxx == null)
            throw new FeesException("客户信息不存在", FeesErrorCode.BUSINESS_ERROR);

        User user = userService.get(Long.valueOf(yySspjxx.getCbrybm()));
        //String cbrydh = DbHelper.getDbHelper().getValue(String.format("select olxdh from  sys_operators where ocode = (select cby from bm_cbb where cbbbm='%s')", sspjxx.getSscbb()));
        String cbrydh = "暂无";
        if (user != null && StringUtils.isNotEmpty(user.getPhone())) {
            cbrydh = user.getPhone();
        }
        String htmlstr = DbHelper.getDbHelper().getValue(String.format("select printtemplate from print_template where id=%s", PjlxEnum.预付费票据信息.getValue()));
        htmlstr = htmlstr.replace("{{title}}", "预付费收据");
        htmlstr = htmlstr.replace("{{tip}}", "如有疑问请拨打");
        htmlstr = htmlstr.replace("{{tip1}}", String.format("片区管理员电话：%s", cbrydh));
        htmlstr = htmlstr.replace("{{yhbh}}", yySspjxx.getYhbh());
        htmlstr = htmlstr.replace("{{yhxm}}", yySspjxx.getYhxm());
        htmlstr = htmlstr.replace("{{cwyf}}", yySspjxx.getCwrq());
        htmlstr = htmlstr.replace("{{sfrq}}", yySspjxx.getCwrq());
        htmlstr = htmlstr.replace("{{year}}", LocalDateTime.parse(yySspjxx.getSfrq().toString()).format(DateTimeFormatter.ofPattern("yyyy")));
        htmlstr = htmlstr.replace("{{month}}", LocalDateTime.parse(yySspjxx.getSfrq().toString()).format(DateTimeFormatter.ofPattern("MM")));
        htmlstr = htmlstr.replace("{{day}}", LocalDateTime.parse(yySspjxx.getSfrq().toString()).format(DateTimeFormatter.ofPattern("dd")));
        htmlstr = htmlstr.replace("{{lsbh}}", (yySspjxx.getDycs().compareTo(BigDecimal.ZERO) > 1 ? "【补】" : "") + sflsbh);


        htmlstr = htmlstr.replace("{{lxdh}}", yhKhjbxx.getLxdh());
        htmlstr = htmlstr.replace("{{addr}}", yhKhjbxx.getYhdz());

        htmlstr = htmlstr.replace("{{scjy}}", yySspjxx.getScye().toString());
        htmlstr = htmlstr.replace("{{bcyc}}", yySspjxx.getBcyc().toString());
        htmlstr = htmlstr.replace("{{bcycdx}}", NumberHelper.CmycurD(yySspjxx.getBcyc()));

        htmlstr = htmlstr.replace("{{bckj}}", yySspjxx.getBckj().toString());
        htmlstr = htmlstr.replace("{{sszje}}", yySspjxx.getSszje().toString() + "元");
        htmlstr = htmlstr.replace("{{bcye}}", yySspjxx.getBcye().toString());

        htmlstr = htmlstr.replace("{{sfry}}", yySspjxx.getSfryxm());
        htmlstr = htmlstr.replace("{{sfdw}}", "水务");
        htmlstr = htmlstr.replace("{{tip2}}", "请扫“二维码”关注微信公众号");
        return htmlstr;
    }

    private YySspjxx createYffsq(YhKhjbxx yhxx, String ysyf, BigDecimal scye, BigDecimal bcye, BigDecimal yc, int sfxh, String fffs) {
        YySspjxx zsspjxx = new YySspjxx();
        String cwrq = gdcsbService.selectCwrq();
        BeanUtils.copyProperties(yhxx, zsspjxx, "fffs");

        zsspjxx.setSfxh(sfxh);//收费序号
        zsspjxx.setSflx(预付费收取);
        zsspjxx.setYsyf(ysyf);
        zsspjxx.setBz("YFF");
        zsspjxx.setScye(scye);
        zsspjxx.setBcye(bcye);
        zsspjxx.setBcyc(yc);
        zsspjxx.setCwrq(cwrq);
        zsspjxx.setSszje(yc);
        zsspjxx.setSfbc("0");
        zsspjxx.setSfbz("1");
        zsspjxx.setFffs(fffs);
        return zsspjxx;
    }

    private YySspjxx createYezc(YhKhjbxx yhxx, String ysyf, BigDecimal scye, BigDecimal bcye, BigDecimal yc, int sfxh, String fffs) {
        YySspjxx zsspjxx = new YySspjxx();
        String cwrq = gdcsbService.selectCwrq();
        BeanUtils.copyProperties(yhxx, zsspjxx, "fffs");

        zsspjxx.setSfxh(sfxh);//收费序号
        zsspjxx.setSflx(余额转存);
        zsspjxx.setYsyf(ysyf);
        zsspjxx.setBz("YEZC");
        zsspjxx.setScye(scye);
        zsspjxx.setBcye(bcye);
        zsspjxx.setBckj(BigDecimal.ZERO);
        zsspjxx.setZyc(yc);
        zsspjxx.setCwrq(cwrq);
        zsspjxx.setSszje(BigDecimal.ZERO);
        zsspjxx.setSfbc("1");
        zsspjxx.setSfbz("1");
        zsspjxx.setFffs(fffs);
        return zsspjxx;
    }

    @Override
    public List<JrtjSelect> jrtj(String sfrybm) {
        return this.baseMapper.jrtj(sfrybm);
    }

    @Override
    public BigDecimal sbje(String yhbh) {
        return this.baseMapper.sbje(yhbh);
    }

    @Override
    public void addYffsq(String yhbh, BigDecimal scye, BigDecimal bcye, BigDecimal sszje, Date sfrq, String bz, CzyUserDetails czyUserDetails, int sfxh, String fffs, String sflsbh) {
        String ysyf = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMM"));
        YhKhjbxx yhxx = khjbxxService.getById(yhbh);
        YySspjxx sspjxx = createYffsq(yhxx, ysyf, scye, bcye, sszje, sfxh, fffs);
        if (StringUtils.isEmpty(sflsbh))
            sflsbh = getSflsbh();
        sspjxx.setSflsbh(sflsbh);
        sspjxx.setQflsbh(sflsbh);
        sspjxx.setQfid(sflsbh);
        sspjxx.setSfrq(sfrq);
        sspjxx.setBz(bz);
        YhCbkxx yhcbkxx = yhCbkxxService.getOne(new QueryWrapper<YhCbkxx>().lambda()
                .eq(YhCbkxx::getYhbh, yhbh)
                .eq(YhCbkxx::getCbkh, "1")
        );
        sspjxx.setCbkid(yhcbkxx.getCbkid());
        sspjxx.setCbkh(yhcbkxx.getCbkh());
        if (yhcbkxx.getSblb().equals("2") || yhcbkxx.getSblb().equals("3")) {
            ZnbZlLog znbZlLog = new ZnbZlLog();
            znbZlLog.setYhbh(sspjxx.getYhbh());
            znbZlLog.setPch(yhxx.getJdpcxlh());
            znbZlLog.setSsgs(yhxx.getSsgs());
            znbZlLog.setCbkh(yhcbkxx.getCbkh());
            znbZlLog.setCbkid(yhcbkxx.getCbkid());
            znbZlLog.setSccj(yhcbkxx.getSbsccj());

            znbZlLog.setCzry(String.valueOf(czyUserDetails.getId()));
            znbZlLog.setCzsj(LocalDateTime.now());
            znbZlLog.setClLock("0");
            znbZlLog.setClCljg("0");
            znbZlLog.setZltype("2");
            iZnbZlLogService.save(znbZlLog);
        }
        if (czyUserDetails != null) {
            sspjxx.setSfrybm(String.valueOf(czyUserDetails.getId()));
            sspjxx.setSfryxm(czyUserDetails.getRealName());
        }
        this.save(sspjxx);
    }

    @Override
    public void addZyc(String yhbh, BigDecimal scye, BigDecimal bcye, BigDecimal zyc, Date sfrq, String bz, CzyUserDetails czyUserDetails, int sfxh, String fffs, String sflsbh) {
        String ysyf = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMM"));
        YhKhjbxx yhxx = khjbxxService.getById(yhbh);
        YySspjxx sspjxx = createYezc(yhxx, ysyf, scye, bcye, zyc, sfxh, fffs);
        if (StringUtils.isEmpty(sflsbh))
            sflsbh = getSflsbh();
        sspjxx.setSflsbh(sflsbh);
        sspjxx.setQflsbh(sflsbh);
        sspjxx.setQfid(sflsbh);
        sspjxx.setSfrq(sfrq);
        sspjxx.setBz(bz);
        YhCbkxx yhcbkxx = yhCbkxxService.getOne(new QueryWrapper<YhCbkxx>().lambda()
                .eq(YhCbkxx::getYhbh, yhbh)
                .eq(YhCbkxx::getCbxh, "1")
        );
        sspjxx.setCbkid(yhcbkxx.getCbkid());
        sspjxx.setCbkh(yhcbkxx.getCbkh());
        if (yhcbkxx.getSblb().equals("2") || yhcbkxx.getSblb().equals("3")) {
            ZnbZlLog znbZlLog = new ZnbZlLog();
            znbZlLog.setYhbh(yhxx.getYhbh());
            znbZlLog.setPch(yhxx.getJdpcxlh());
            znbZlLog.setSsgs(yhxx.getSsgs());
            znbZlLog.setCbkh(yhcbkxx.getCbkh());
            znbZlLog.setCbkid(yhcbkxx.getCbkid());
            znbZlLog.setSccj(yhcbkxx.getSbsccj());

            znbZlLog.setCzry(String.valueOf(czyUserDetails.getId()));
            znbZlLog.setCzsj(LocalDateTime.now());
            znbZlLog.setClLock("0");
            znbZlLog.setClCljg("0");
            znbZlLog.setZltype("2");
            iZnbZlLogService.save(znbZlLog);
        }
        if (czyUserDetails != null) {
            sspjxx.setSfrybm(String.valueOf(czyUserDetails.getId()));
            sspjxx.setSfryxm(czyUserDetails.getRealName());
        }
        this.save(sspjxx);
    }

    @Override
    public Integer pjCh(PjCh pjch, CzyUserDetails czyUserDetails) {
        String sflsbh = pjch.getSflsbh();
        if (StringUtils.isBlank(sflsbh)) throw new FeesException("收费流水编号为空", FeesErrorCode.BUSINESS_ERROR);
        BigDecimal sszje = this.baseMapper.sszje(sflsbh);
        if (sszje == null) throw new FeesException("收费流水编号不存在", FeesErrorCode.BUSINESS_ERROR);
        String yhbh = pjch.getYhbh();
        String chrybm = null;
        String chryxm = null;
        if (czyUserDetails != null) {
            chrybm = String.valueOf(czyUserDetails.getId());
            chryxm = czyUserDetails.getRealName();
        }
        Date chsj = new Date();
        Map<String, Object> result = new HashMap<>();
        result.put("yhbh", yhbh);
        result.put("sflsbh", sflsbh);
        result.put("sszje", sszje);
        result.put("chrybm", chrybm);
        result.put("chryxm", chryxm);
        result.put("chsj", chsj);
        this.baseMapper.pjCh(result);
        return (Integer) result.get("result");
    }

    @Override
    public List<YySspjxxSelect> getList(YySspjxxFilter filter, String sffl, String chbz) {
        List<YySspjxxSelect> list = this.baseMapper.getList(filter, sffl, chbz);
        Map<String, String> sjMap = getSjMap();
        list.forEach(e -> setYslx(e, sjMap));
        return list;
    }

    @Override
    public List<YySspjxxDailyStat2> dailyStat2(YySspjxxStatFilter filter) {
        List<YySspjxxDailyStat2> list = this.baseMapper.dailyStat2(filter);
        if (!list.isEmpty()) {
            Integer bs = list.stream().map(e -> e.getBs()).filter(e -> e != null).reduce(0, (x, y) -> x + y);
            BigDecimal yssl = list.stream().map(e -> e.getYssl()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yssf = list.stream().map(e -> e.getYssf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yswsf = list.stream().map(e -> e.getYswsf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yslfj = list.stream().map(e -> e.getYsljf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal bckj = list.stream().map(e -> e.getBckj()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal zyc = list.stream().map(e -> e.getZyc()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal bcyc = list.stream().map(e -> e.getBcyc()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal sszje = list.stream().map(e -> e.getSszje()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            list.add(new YySspjxxDailyStat2("合计", bs, yssl, yssf, yswsf, yslfj, bckj, zyc, bcyc, sszje));
        }
        return list;
    }

    @Override
    public List<YySspjxxZhSfStat> zhSfStat(YySspjxxStatFilter filter) {
        List<YySspjxxZhSfStat> list = this.baseMapper.zhSfStat(filter);
        if (!list.isEmpty()) {
            Integer pjs = list.stream().map(e -> e.getPjs()).filter(e -> e != null).reduce(0, (x, y) -> x + y);
            BigDecimal yssl = list.stream().map(e -> e.getYssl()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yssf = list.stream().map(e -> e.getYssf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yswsf = list.stream().map(e -> e.getYswsf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal yslfj = list.stream().map(e -> e.getYsljf()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal bckj = list.stream().map(e -> e.getBckj()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal bcyc = list.stream().map(e -> e.getBcyc()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal zyc = list.stream().map(e -> e.getZyc()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal sszje = list.stream().map(e -> e.getSszje()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal zsl = list.stream().map(e -> e.getZsl()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal ssznj = list.stream().map(e -> e.getSsznj()).filter(e -> e != null).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            list.add(new YySspjxxZhSfStat("合计", pjs, yssl, yssf, yswsf, yslfj, bckj, bcyc, zyc, ssznj, zsl, sszje));
        }
        return list;
    }

    @Override
    public List<YySspjxxMonthlyStat> monthlyStat(YySspjxxStatFilter filter) {
        List<YySjStat> list0 = this.baseMapper.sjStat(filter, "");
        List<YySjStat> list1 = this.baseMapper.sjStat(filter, "1");
        List<YySjStat> list2 = this.baseMapper.sjStat(filter, "2");
        List<YySjStat> list3 = this.baseMapper.sjStat(filter, "3");
        BigDecimal yff = this.baseMapper.qtStat(filter, "yff");//预交水费
        BigDecimal yckj = this.baseMapper.qtStat(filter, "yckj");//预存扣款金额
        BigDecimal bc = this.baseMapper.qtStat(filter, "sfbc");//水费补差
        List<YySjStat> list = new ArrayList<>();
        list.addAll(list0);
        list.addAll(list1);
        list.addAll(list2);
        list.addAll(list3);

        Map<String, List<YySjStat>> sjmxMap = list.stream()
                .filter(e -> StringUtils.isNotBlank(e.getSjbm()))
                .collect(Collectors.groupingBy(YySjStat::getSjbm));
        Map<String, String> sjMap = getSjMap();
        List<YySspjxxMonthlyStat> results = new ArrayList<>();
        sjMap.forEach((sjbm, sjmc) -> {
            List<YySjStat> sjmxs = sjmxMap.getOrDefault(sjbm, new ArrayList<>());
            BigDecimal sl = sjmxs.stream().map(e -> e.getSl()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal sf = sjmxs.stream().map(e -> e.getSf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal wsf = sjmxs.stream().map(e -> e.getWsf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal ljf = sjmxs.stream().map(e -> e.getLjf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal znj = sjmxs.stream().map(e -> e.getZnj()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            results.add(new YySspjxxMonthlyStat(sjmc, sl, sf, wsf, ljf, znj, sf.add(wsf).add(ljf).add(znj)));
        });
        if (!results.isEmpty()) {
            BigDecimal sl = results.stream().map(e -> e.getSl()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal sf = results.stream().map(e -> e.getSf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal wsf = results.stream().map(e -> e.getWsf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal ljf = results.stream().map(e -> e.getLjf()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal hj = results.stream().map(e -> e.getHj()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            BigDecimal znj = results.stream().map(e -> e.getZnj()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
            results.add(new YySspjxxMonthlyStat("小计", sl, sf, wsf, ljf, znj, hj));
        }
        results.add(new YySspjxxMonthlyStat("充值(旧)", null, null, null, null, null, BigDecimal.ZERO));
        results.add(new YySspjxxMonthlyStat("工本费", null, null, null, null, null, BigDecimal.ZERO));
        results.add(new YySspjxxMonthlyStat("预交水费", null, null, null, null, null, yff == null ? BigDecimal.ZERO : yff));
        results.add(new YySspjxxMonthlyStat("预存扣款金额", null, null, null, null, null, yckj == null ? BigDecimal.ZERO : yckj.negate()));
        results.add(new YySspjxxMonthlyStat("水费补差", null, null, null, null, null, bc == null ? BigDecimal.ZERO : bc));
        BigDecimal hj = results.stream().map(e -> e.getHj()).filter(Objects::nonNull).reduce(BigDecimal.ZERO, (x, y) -> x.add(y));
        results.add(new YySspjxxMonthlyStat("合计", null, null, null, null, null, hj));
        return results;
    }

    @Override
    public YyStat stat(YySspjxxStatFilter filter) {
        return this.baseMapper.stat(filter);
    }

    private YySspjxxSelect setYslx(YySspjxxSelect e, Map<String, String> sjMap) {
        if (e == null) return null;
        e.setYsxz(e.getSjbm() == null ? "预付费" : sjMap.get(e.getSjbm()));
        return e;
    }

    private String getSflsbh() {
        String prefix = LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyyMMddHHmmss"));
        return String.format("S%s%05d", prefix, (int) ((Math.random() * 9 + 1) * 10000));
    }

    private YySspjxxDailyStat.SrxmStat getZj(Map<String, String> fffsMap, List<YySspjxxDailyStat.SrxmStat> srxmStats) {
        Map<String, BigDecimal> zjSlMap = new LinkedHashMap<>();
        Map<String, BigDecimal> zjJeMap = new LinkedHashMap<>();
        srxmStats.forEach(e -> {
            e.getFffsStats().forEach(f -> {
                BigDecimal sumSl = zjSlMap.getOrDefault(f.getFffsmc(), BigDecimal.ZERO);
                zjSlMap.put(f.getFffsmc(), sumSl.add(f.getSl()));
                BigDecimal sumJe = zjJeMap.getOrDefault(f.getFffsmc(), BigDecimal.ZERO);
                zjJeMap.put(f.getFffsmc(), sumJe.add(f.getJe()));
            });
        });

        List<YySspjxxDailyStat.FffsStat> zjFffsStats = new ArrayList<>();
        fffsMap.forEach((fffs, fffsmc) -> {
            BigDecimal sl = zjSlMap.getOrDefault(fffsmc, BigDecimal.ZERO);
            BigDecimal je = zjJeMap.getOrDefault(fffsmc, BigDecimal.ZERO);
            zjFffsStats.add(new YySspjxxDailyStat.FffsStat(fffsmc, sl, je));
        });

        BigDecimal slTotal = zjFffsStats.stream().map(e -> e.getSl()).reduce(BigDecimal.ZERO, (item, total) -> total.add(item));
        BigDecimal jeTotal = zjFffsStats.stream().map(e -> e.getJe()).reduce(BigDecimal.ZERO, (item, total) -> total.add(item));
        zjFffsStats.add(new YySspjxxDailyStat.FffsStat("合计", slTotal, jeTotal));

        return new YySspjxxDailyStat.SrxmStat("总计", zjFffsStats);
    }

    private List<YySspjxxDailyStat.SrxmStat> getSfsr(YySspjxxDailyStatFilter filter, Map<String, String> fffsMap) {
        List<YySjFffsStat> list0 = this.baseMapper.sjSffsStat(filter, "");
        List<YySjFffsStat> list1 = this.baseMapper.sjSffsStat(filter, "1");
        List<YySjFffsStat> list2 = this.baseMapper.sjSffsStat(filter, "2");
        List<YySjFffsStat> list3 = this.baseMapper.sjSffsStat(filter, "3");
        List<YySjFffsStat> list = new ArrayList<>();
        list.addAll(list0);
        list.addAll(list1);
        list.addAll(list2);
        list.addAll(list3);
        Map<String, List<YySjFffsStat>> sjStatMap = list.stream()
                .filter(e -> e.getSjbm() != null)
                .collect(Collectors.groupingBy(YySjFffsStat::getSjbm, Collectors.toList()));
        Map<String, String> sjMap = getSjMap();

        List<YySspjxxDailyStat.SrxmStat> sfsr = new ArrayList<>();
        sjMap.forEach((sjbm, sjmc) -> {
            List<YySjFffsStat> fffsStats = sjStatMap.getOrDefault(sjbm, new ArrayList<>());
            Map<String, YySjFffsStat> sjFffsStatMap = fffsStats.stream()
                    .filter(e -> e.getFffs() != null)
                    .collect(Collectors.toMap(YySjFffsStat::getFffs,
                            e -> e,
                            (v1, v2) -> new YySjFffsStat(sjbm, v1.getFffs(), add(v1.getSl(), v2.getSl()), add(v1.getSf(), v2.getSf()))
                    ));
            List<YySspjxxDailyStat.FffsStat> fffsStats1 = new ArrayList<>();
            fffsMap.forEach((fffs, fffsmc) -> {
                YySjFffsStat sjFffsStat = sjFffsStatMap.getOrDefault(fffs, new YySjFffsStat(null, fffs, new BigDecimal(0), new BigDecimal(0)));
                fffsStats1.add(new YySspjxxDailyStat.FffsStat(fffsmc, sjFffsStat.getSl(), sjFffsStat.getSf()));
            });
            sfsr.add(new YySspjxxDailyStat.SrxmStat(sjmc, fffsStats1));
        });
        addHjXj(fffsMap, sfsr);
        return sfsr;
    }

    private BigDecimal add(BigDecimal v1, BigDecimal v2) {
        if (v1 == null || v2 == null) return null;
        return v1.add(v2);
    }

    /***
     * 添加合计和小计
     * @param fffsMap
     * @param srxmStats
     */
    private void addHjXj(Map<String, String> fffsMap, List<YySspjxxDailyStat.SrxmStat> srxmStats) {


        Map<String, BigDecimal> xjSlMap = new LinkedHashMap<>();
        Map<String, BigDecimal> xjJeMap = new LinkedHashMap<>();
        srxmStats.forEach(e -> {
            e.getFffsStats().forEach(f -> {
                BigDecimal sumSl = xjSlMap.getOrDefault(f.getFffsmc(), BigDecimal.ZERO);
                xjSlMap.put(f.getFffsmc(), sumSl.add(f.getSl()));
                BigDecimal sumJe = xjJeMap.getOrDefault(f.getFffsmc(), BigDecimal.ZERO);
                xjJeMap.put(f.getFffsmc(), sumJe.add(f.getJe()));
            });
        });

        List<YySspjxxDailyStat.FffsStat> xjFffsStats = new ArrayList<>();
        fffsMap.forEach((fffs, fffsmc) -> {
            BigDecimal sl = xjSlMap.getOrDefault(fffsmc, BigDecimal.ZERO);
            BigDecimal je = xjJeMap.getOrDefault(fffsmc, BigDecimal.ZERO);
            xjFffsStats.add(new YySspjxxDailyStat.FffsStat(fffsmc, sl, je));
        });

        srxmStats.add(new YySspjxxDailyStat.SrxmStat("小计", xjFffsStats));

        srxmStats.forEach(srxmStat -> {
            List<YySspjxxDailyStat.FffsStat> fffsStats = srxmStat.getFffsStats();
            BigDecimal slTotal = fffsStats.stream().map(e -> e.getSl()).reduce(BigDecimal.ZERO, (item, total) -> total.add(item));
            BigDecimal jeTotal = fffsStats.stream().map(e -> e.getJe()).reduce(BigDecimal.ZERO, (item, total) -> total.add(item));
            fffsStats.add(new YySspjxxDailyStat.FffsStat("合计", slTotal, jeTotal));
        });
    }

    private List<YySspjxxDailyStat.SrxmStat> getFjjdsf(YySspjxxDailyStatFilter filter, Map<String, String> fffsMap) {
        List<YyFjFffsStat> list2 = this.baseMapper.fjFffsStat(filter);
        List<YySspjxxDailyStat.SrxmStat> fjjdsf = new ArrayList<>();//附加及代收费
        fjjdsf.add(getSrxmStat(list2, fffsMap, "yswsf", "预交污水费"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "ysljf", "垃圾费"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "wyj", "违约金"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "cz", "充值(旧)"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "gbf", "工本费"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "yjsf", "预交水费"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "cyjsf", "冲预交水费(-)"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "yftf", "预付退费(-)"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "sfbc1", "水费补差(+)"));
        fjjdsf.add(getSrxmStat(list2, fffsMap, "sfbc2", "水费补差(-)"));
        addHjXj(fffsMap, fjjdsf);
        if (fjjdsf.size() > 0) {
            Iterator<YySspjxxDailyStat.SrxmStat> iterator = fjjdsf.iterator();
            while (iterator.hasNext()) {
                YySspjxxDailyStat.SrxmStat e = iterator.next();
                BigDecimal sl = e.getFffsStats().stream()
                        .filter(item -> item.getFffsmc().equals("合计"))
                        .findFirst()
                        .map(item -> item.getSl())
                        .orElse(BigDecimal.ZERO);
                BigDecimal je = e.getFffsStats().stream()
                        .filter(item -> item.getFffsmc().equals("合计"))
                        .findFirst()
                        .map(item -> item.getJe())
                        .orElse(BigDecimal.ZERO);
                if (sl == BigDecimal.ZERO && je == BigDecimal.ZERO) {
                    iterator.remove();
                }
            }
        }
        return fjjdsf;
    }

    private YySspjxxDailyStat.SrxmStat getSrxmStat(List<YyFjFffsStat> list2, Map<String, String> fffsMap, String propertyName, String srxm) {
        Map<String, Double> fffsSfMap = list2.stream()
                .filter(e -> e.getFffs() != null)
                .collect(Collectors.groupingBy(YyFjFffsStat::getFffs, Collectors.summingDouble((s) -> getValue(s, propertyName).doubleValue())));
        List<YySspjxxDailyStat.FffsStat> fffsStats = new ArrayList<>();
        fffsMap.forEach((fffs, fffsmc) -> {
            double sf = fffsSfMap.getOrDefault(fffs, 0D);
            fffsStats.add(new YySspjxxDailyStat.FffsStat(fffsmc, BigDecimal.ZERO, new BigDecimal(sf)));
        });
        return new YySspjxxDailyStat.SrxmStat(srxm, fffsStats);
    }

    public PageResult<YffYeSeachSelect> yffyeseach(PageDto pageDto, YffYeSeachFilter filter) {
        PageDto<YffYeSeachSelect> yffYeSeachSelectPageDto = this.baseMapper.yffyeseach(pageDto, filter);
        return yffYeSeachSelectPageDto.toVo();
    }

    public List<YffYeSeachSelect> yffyeseachList(YffYeSeachFilter filter) {
        List<YffYeSeachSelect> list = this.baseMapper.yffyeseachList(filter);
        return list;
    }

    private BigDecimal getValue(YyFjFffsStat stat, String propertyName) {
        Field field = null;
        try {
            field = stat.getClass().getDeclaredField(propertyName);
            field.setAccessible(true);
            return (BigDecimal) field.get(stat);
        } catch (NoSuchFieldException e) {
            return BigDecimal.ZERO;
        } catch (IllegalAccessException e) {
            return BigDecimal.ZERO;
        }
    }

    private Map<String, String> getSjMap() {
        List<BmSj> list = sjService.lambdaQuery().orderByAsc(BmSj::getCzsj).list();
        return list.stream().collect(Collectors.toMap(BmSj::getCode, BmSj::getName, (u1, u2) -> u1, LinkedHashMap::new));
    }

    private Map<String, String> getFffsMap() {
        return bmFffsService.list(Wrappers.lambdaQuery(BmFffs.class).eq(BmFffs::getIsdisabled, "1"))
                .stream().collect(Collectors.toMap(BmFffs::getCode, BmFffs::getName, (u1, u2) -> u1, LinkedHashMap::new));
    }
}
