package com.tofly.feesapi.sfgl.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.sfgl.entity.ZnbCsjsLog;
import com.tofly.feesapi.sfgl.entity.dto.ZnbCsjsFilter;
import com.tofly.feesapi.sfgl.entity.dto.ZnbCsjsListFilter;
import com.tofly.feesapi.sfgl.entity.vo.SfJsJg;
import com.tofly.feesapi.sfgl.entity.vo.ZnbCsjsSelect;
import com.tofly.feesapi.sfgl.mapper.ZnbCsjsLogMapper;
import com.tofly.feesapi.sfgl.service.IZnbCsjsLogService;
import com.tofly.feesapi.sfgl.service.YyQfmxService;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.service.IYyZjzhService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * <p>
 * 智能表抄收结算明细 服务实现类
 * </p>
 *
 * @author decai
 * @since 2024-04-10
 */
@Service
public class ZnbCsjsLogServiceImpl extends ServiceImpl<ZnbCsjsLogMapper, ZnbCsjsLog> implements IZnbCsjsLogService {

    @Autowired
    private YhKhjbxxService khjbxxService;

    @Autowired
    private IYyZjzhService zjzhService;

    @Autowired
    private YyQfmxService qfmxService;

    @Override
    public ZnbCsjsLog csjs(YhCbkxx cbkxx, YhKhjbxx khjbxx, String cwrq, BigDecimal scds, BigDecimal bcds, String cbLogId) {
        if (scds == null || bcds == null || scds.compareTo(BigDecimal.ZERO) < 0 || bcds.compareTo(BigDecimal.ZERO) < 0)
            return null;
        BigDecimal sjsl = bcds.subtract(scds);
        if (sjsl.compareTo(BigDecimal.ZERO) < 0) return null;
        if (this.getByCbLogId(cbLogId) != null) return null;
        ZnbCsjsLog znbCsjsLog = new ZnbCsjsLog();
        SfJsJg sfJsJg = qfmxService.sfJs(cbkxx, sjsl, null);
        BeanUtils.copyProperties(sfJsJg, znbCsjsLog);
        BeanUtils.copyProperties(khjbxx, znbCsjsLog, "bz", "fffs");
        BeanUtils.copyProperties(cbkxx, znbCsjsLog, "bz");
        znbCsjsLog.setCbLogId(cbLogId);
        znbCsjsLog.setCwrq(cwrq);
        String ysyf = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMMdd"));
        znbCsjsLog.setYsyf(ysyf);
        znbCsjsLog.setScds(scds);
        znbCsjsLog.setBcds(bcds);
        this.save(znbCsjsLog);
        return znbCsjsLog;
    }

    public ZnbCsjsLog getByCbLogId(String cbLogId) {
        return this.getOne(Wrappers.lambdaQuery(ZnbCsjsLog.class).eq(ZnbCsjsLog::getCbLogId, cbLogId));
    }

    @Override
    public PageResult<ZnbCsjsSelect> getPage(PageDto pageDto, ZnbCsjsFilter filter) {
        PageDto<ZnbCsjsSelect> page = this.baseMapper.getPage(pageDto, filter);
        PageResult<ZnbCsjsSelect> pageResult = page.toVo();
        return pageResult;
    }

    @Override
    public List<ZnbCsjsLog> getYhysmxList(ZnbCsjsListFilter filter) {
        List<ZnbCsjsLog> list = this.baseMapper.getYhysmxList(filter);
        return list;
    }
}
