package com.tofly.feesapi.udb.smpn.entity;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 公司信息表
 * </p>
 *
 * @author decai
 * @since 2024-02-27
 */
@Getter
@Setter
@TableName("TF_SMPN_COMPANY_X")
@ApiModel(value = "Company对象", description = "公司信息表")
public class Company implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId
    @ApiModelProperty("公司ID")
    private Long id;

    @ApiModelProperty("公司名称")
    private String companyName;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("修改时间")
    private Date updateTime;

    @ApiModelProperty("是否启用禁用 1启用 0禁用")
    private String statusFlag;

    @ApiModelProperty("父级ID")
    private Long parentId;

    @ApiModelProperty("创建人")
    private Long createUser;

    @ApiModelProperty("编码")
    private String coding;

    @ApiModelProperty("地址")
    private String address;

    @ApiModelProperty("电话")
    private String phone;

    @ApiModelProperty("简称")
    private String abbreviation;

    @ApiModelProperty("编码")
    private String code;

    public static final String ID = "ID";

    public static final String COMPANY_NAME = "COMPANY_NAME";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String STATUS_FLAG = "STATUS_FLAG";

    public static final String PARENT_ID = "PARENT_ID";

    public static final String CREATE_USER = "CREATE_USER";

    public static final String CODING = "CODING";

    public static final String ADDRESS = "ADDRESS";

    public static final String PHONE = "PHONE";

    public static final String ABBREVIATION = "ABBREVIATION";

    public static final String CODE = "CODE";
}
