package com.tofly.feesapi.udb.smpn.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 用户表
 * </p>
 *
 * @author decai
 * @since 2024-02-23
 */
@Getter
@Setter
@TableName("TF_SMPN_USER_X")
@ApiModel(value = "User对象", description = "用户表")
public class User implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户ID，主键")
    private Long id;

    @ApiModelProperty("用户名")
    private String username;

    @ApiModelProperty("密码")
    private String password;

    @ApiModelProperty("随机数")
    private String salt;

    @ApiModelProperty("电话")
    private String phone;

    @ApiModelProperty("头像")
    private String avatar;

    @ApiModelProperty("部门ID")
    private Long departmentId;

    @ApiModelProperty("创建时间")
    private Date createTime;

    @ApiModelProperty("修改时间")
    private Date updateTime;

    @ApiModelProperty("是否锁定，1正常，0锁定")
    private String lockFlag;

    @ApiModelProperty("是否启用禁用，1启用，0禁用")
    private String statusFlag;

    @ApiModelProperty("扩展功能，微信openid")
    private String wxOpenid;

    @ApiModelProperty("扩展功能，QQ openid")
    private String qqOpenid;

    @ApiModelProperty("用户email")
    private String email;

    @ApiModelProperty("用户姓名")
    private String realName;

    @ApiModelProperty("最后一次登录时间")
    private Date loginTime;

    @ApiModelProperty("最后一次访问IP")
    private String lastIp;

    @ApiModelProperty("密码错误次数")
    private Short pwderrtimes;

    @ApiModelProperty("工号")
    private String worknumber;

    @ApiModelProperty("找回密码关键字")
    private String findpwdkey;

    @ApiModelProperty("别名")
    private String aliasname;

    @ApiModelProperty("生日")
    private Date birthday;

    @ApiModelProperty("属于（学院/部门）")
    private String belong;

    @ApiModelProperty("创建人")
    private Long createUser;

    @ApiModelProperty("用户级别  用于超级管理员与其他用户区分等  。0 超级管理员1普通管理员")
    private String userLevel;

    @ApiModelProperty("电子签名")
    private String esignature;

    @ApiModelProperty("创建类型，0自建、1申请创建")
    private String createType;

    @ApiModelProperty("首次登陆状态,1 首次登录,0 非首次登录")
    private String firstlog;

    @ApiModelProperty("申请人")
    private String applyer;

    @ApiModelProperty("申请时间")
    private Date applytime;

    @ApiModelProperty("申请说明")
    private String applystate;

    @ApiModelProperty("审核人")
    private String auditor;

    @ApiModelProperty("用户账号详情")
    private String accountstate;

    @ApiModelProperty("审核时间")
    private Date audittime;

    @ApiModelProperty("审核说明")
    private String auditstate;

    @ApiModelProperty("审核状态,1 未审核,2 同意, 0 不同意")
    private String auditstatus;

    @ApiModelProperty("备注")
    private String note;

    @ApiModelProperty("是否启用禁用，1启用，0禁用")
    private String enableFlag;

    @ApiModelProperty("原始密码")
    private String originalPassword;

    @ApiModelProperty("岗位")
    private String job;

    @ApiModelProperty("总公司ID")
    private Long parentCompanyId;

    @ApiModelProperty("分公司Id")
    private Long companyId;

    @ApiModelProperty("当前APP版本号")
    private String nowVersion;

    @ApiModelProperty("上次APP更新时间")
    private Date lastAppUpdateTime;

    public static final String ID = "ID";

    public static final String USERNAME = "USERNAME";

    public static final String PASSWORD = "PASSWORD";

    public static final String SALT = "SALT";

    public static final String PHONE = "PHONE";

    public static final String AVATAR = "AVATAR";

    public static final String DEPARTMENT_ID = "DEPARTMENT_ID";

    public static final String CREATE_TIME = "CREATE_TIME";

    public static final String UPDATE_TIME = "UPDATE_TIME";

    public static final String LOCK_FLAG = "LOCK_FLAG";

    public static final String STATUS_FLAG = "STATUS_FLAG";

    public static final String WX_OPENID = "WX_OPENID";

    public static final String QQ_OPENID = "QQ_OPENID";

    public static final String EMAIL = "EMAIL";

    public static final String REAL_NAME = "REAL_NAME";

    public static final String LOGIN_TIME = "LOGIN_TIME";

    public static final String LAST_IP = "LAST_IP";

    public static final String PWDERRTIMES = "PWDERRTIMES";

    public static final String WORKNUMBER = "WORKNUMBER";

    public static final String FINDPWDKEY = "FINDPWDKEY";

    public static final String ALIASNAME = "ALIASNAME";

    public static final String BIRTHDAY = "BIRTHDAY";

    public static final String BELONG = "BELONG";

    public static final String CREATE_USER = "CREATE_USER";

    public static final String USER_LEVEL = "USER_LEVEL";

    public static final String ESIGNATURE = "ESIGNATURE";

    public static final String CREATE_TYPE = "CREATE_TYPE";

    public static final String FIRSTLOG = "FIRSTLOG";

    public static final String APPLYER = "APPLYER";

    public static final String APPLYTIME = "APPLYTIME";

    public static final String APPLYSTATE = "APPLYSTATE";

    public static final String AUDITOR = "AUDITOR";

    public static final String ACCOUNTSTATE = "ACCOUNTSTATE";

    public static final String AUDITTIME = "AUDITTIME";

    public static final String AUDITSTATE = "AUDITSTATE";

    public static final String AUDITSTATUS = "AUDITSTATUS";

    public static final String NOTE = "NOTE";

    public static final String ENABLE_FLAG = "ENABLE_FLAG";

    public static final String ORIGINAL_PASSWORD = "ORIGINAL_PASSWORD";

    public static final String JOB = "JOB";

    public static final String PARENT_COMPANY_ID = "PARENT_COMPANY_ID";

    public static final String COMPANY_ID = "COMPANY_ID";

    public static final String NOW_VERSION = "NOW_VERSION";

    public static final String LAST_APP_UPDATE_TIME = "LAST_APP_UPDATE_TIME";
}
