package com.tofly.feesapi.udb.smpn.service.impl;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.tofly.feesapi.udb.smpn.entity.User;
import com.tofly.feesapi.udb.smpn.mapper.UserMapper;
import com.tofly.feesapi.udb.smpn.service.IUserService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 用户表 服务实现类
 * </p>
 *
 * @author decai
 * @since 2024-02-23
 */
@Service
@DS("udb")
public class UserServiceImpl extends ServiceImpl<UserMapper, User> implements IUserService {

    @Override
    public User getByUsername(String username) {
        List<User> list = this.lambdaQuery().eq(User::getUsername, username).list();
        if (list.isEmpty()) return null;
        return list.get(0);
    }

    @Override
    public User get(Long id) {
        return this.baseMapper.get(id);
    }
}
