package com.tofly.feesapi.wxgl.wechatbasicmgt.entity;/*
 * Author: wangjian
 * 生成entity
 */


import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 微信推送服务通知
 *
 * @author sxb
 * @date Mon Jun 05 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_FWTZ")
@KeySequence("WX_FWTZ")
@ApiModel
public class WxFwtz extends Model<WxFwtz> {
    private static final long serialVersionUID = 1L;

    /**
     * ID
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "ID")
    private Integer id;
    /**
     * 时间
     */
    @ApiModelProperty(value = "时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date editDate;
    /**
     * 编辑账号
     */
    @ApiModelProperty(value = "编辑账号")
    private String editCode;
    /**
     * 编辑人员
     */
    @ApiModelProperty(value = "编辑人员")
    private String editName;
    /**
     * 标题
     */
    @ApiModelProperty(value = "标题")
    private String title;
    /**
     * 发送状态，0未发送，1已发送
     */
    @ApiModelProperty(value = "发送状态，0未发送，1已发送")
    private String state;
    /**
     * 区域
     */
    @ApiModelProperty(value = "区域")
    private String area;
    /**
     * 原因
     */
    @ApiModelProperty(value = "原因")
    private String reason;
    /**
     * 通知时间
     */
    @ApiModelProperty(value = "通知时间")
    @TableField("tzsj")
    private String noticeTime;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 审核标志：0未审核，1 审核
     */
    @ApiModelProperty(value = "审核标志：0未审核，1 审核")
    @TableField("shbz")
    private String auditFlag;
    /**
     * 审核结果:0 未处理，1 同意，2 不同意
     */
    @ApiModelProperty(value = "审核结果:0 未处理，1 同意，2 不同意")
    @TableField("shjg")
    private String auditResult;
    /**
     * 审核人员编码
     */
    @ApiModelProperty(value = "审核人员编码")
    @TableField("shfybm")
    private String auditCode;
    /**
     * 审核人员
     */
    @ApiModelProperty(value = "审核人员")
    @TableField("shfyxm")
    private String auditName;
    /**
     * 审核日期
     */
    @ApiModelProperty(value = "审核日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField("shrq")
    private Date auditDate;
    /**
     * 审核原因
     */
    @ApiModelProperty(value = "审核原因")
    @TableField("shreason")
    private String auditRemark;
    /**
     * 打印次数
     */
    @ApiModelProperty(value = "打印次数")
    @TableField("dycs")
    private BigDecimal printTimes;

}
