/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.wxgl.wechatbasicmgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 微信模板消息
 *
 * @author admin
 * @date Tue Jul 04 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_MESSAGE", resultMap = "wxMessageMap")
@KeySequence("WX_MESSAGE")
@ApiModel
public class WxMessage extends Model<WxMessage> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 模板类型
     */
    @ApiModelProperty(value = "模板类型")
    private String msgType;
    /**
     * openid
     */
    @ApiModelProperty(value = "openid")
    private String openid;
    /**
     * first内容
     */
    @ApiModelProperty(value = "first内容")
    private String first;
    /**
     * 第一项内容
     */
    @ApiModelProperty(value = "第一项内容")
    private String keyword1;
    /**
     * 第二项内容
     */
    @ApiModelProperty(value = "第二项内容")
    private String keyword2;
    /**
     * 第三项内容
     */
    @ApiModelProperty(value = "第三项内容")
    private String keyword3;
    /**
     * 第四项内容
     */
    @ApiModelProperty(value = "第四项内容")
    private String keyword4;
    /**
     * 第五项内容
     */
    @ApiModelProperty(value = "第五项内容")
    private String keyword5;
    /**
     * 第六项内容
     */
    @ApiModelProperty(value = "第六项内容")
    private String keyword6;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 添加日期
     */
    @ApiModelProperty(value = "添加日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addDate;
    /**
     * 添加人员
     */
    @ApiModelProperty(value = "添加人员")
    private String addOcode;
    /**
     * 发送状态
     */
    @ApiModelProperty(value = "发送状态")
    private String sendState;
    /**
     * 处理人员
     */
    @ApiModelProperty(value = "处理人员")
    private String handleOcode;
    /**
     * 处理日期
     */
    @ApiModelProperty(value = "处理日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date handleDate;
    /**
     * 处理备注
     */
    @ApiModelProperty(value = "处理备注")
    private String handleRemark;
    /**
     * 是否锁定
     */
    @ApiModelProperty(value = "是否锁定")
    private String isLock;

}
