package com.tofly.feesapi.wxgl.wechatbasicmgt.entity;/*
 * Author: wangjian
 * 生成entity
 */


import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 微信解绑
 *
 * @author sxb
 * @date Mon Jun 05 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_USER")
@KeySequence("WX_USER")
@ApiModel
public class WxUser extends Model<WxUser> {
    private static final long serialVersionUID = 1L;

    /**
     * 用户号
     */
    @TableId(value = "yhbh", type = IdType.INPUT)
    @ApiModelProperty(value = "用户号")
    private String customerNo;
    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    private String name;
    /**
     * 地址
     */
    @ApiModelProperty(value = "地址")
    private String address;
    /**
     * 电话
     */
    @ApiModelProperty(value = "电话")
    private String phone;
    /**
     * 微信绑定标志
     */
    @ApiModelProperty(value = "微信绑定标志")
    @TableField("wxbdbz")
    private String bindFlag;
    /**
     * 微信id
     */
    @ApiModelProperty(value = "微信id")
    private String openid;
    /**
     * 微信绑定时间
     */
    @ApiModelProperty(value = "微信绑定时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField("wxbdsj")
    private Date bindDate;
    /**
     * 微信备注
     */
    @ApiModelProperty(value = "微信备注")
    @TableField("wxbz")
    private String bindRemark;
    /**
     * 绑定微信名
     */
    @ApiModelProperty(value = "绑定微信名")
    @TableField("wxbdname")
    private String bindWxname;
    /**
     * 绑定微信性别
     */
    @ApiModelProperty(value = "绑定微信性别")
    @TableField("wxbdsex")
    private String bindSex;
    /**
     * 微信解绑时间
     */
    @ApiModelProperty(value = "微信解绑时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField("wxjbsj")
    private Date unbindDate;
    /**
     * 微信解绑姓名
     */
    @ApiModelProperty(value = "微信解绑姓名")
    @TableField("wxjbname")
    private String unbindName;
    /**
     * 微信解绑备注
     */
    @ApiModelProperty(value = "微信解绑备注")
    @TableField("wxjbbz")
    private String unbindRemark;

}
