/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.wxgl.wechatbasicmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 业务须知
 *
 * @author admin
 * @date Wed Jul 05 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_YWXZ", resultMap = "wxBusinessMap")
@KeySequence("WX_YWXZ")
@ApiModel
public class WxYwxz extends Model<WxYwxz> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 类型wx_business_code.id
     */
    @ApiModelProperty(value = "类型wx_business_code.id")
    private BigDecimal type;
    /**
     * 标题
     */
    @ApiModelProperty(value = "标题")
    private String title;
    /**
     * 操作日期
     */
    @ApiModelProperty(value = "操作日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    @TableField("czry")
    private String cocode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    @TableField("czryxm")
    private String coname;
    /**
     * 内容
     */
    @ApiModelProperty(value = "内容")
    private String context;
    /**
     * 是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "是否启用：0不启用，1启用")
    private String isdisabled;

    @TableField(exist = false) //数据排除字段
    @ApiModelProperty(value = "类型名称")
    private String typeName;

}
