/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 微信-更名过户申请
 *
 * @author sxb
 * @date Thu Jul 06 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_GHSQ", resultMap = "wxGhsqMap")
@KeySequence("WX_GHSQ")
@ApiModel
public class WxGhsq extends Model<WxGhsq> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")
    private String id;
    /**
     * 编号
     */
    @ApiModelProperty(value = "编号")
    private String bh;
    /**
     * 类型1，更名，2过户
     */
    @ApiModelProperty(value = "类型1，更名，2过户")
    private String type;
    /**
     * 微信openid
     */
    @ApiModelProperty(value = "微信openid")
    private String registerOpenid;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String registerYhbh;
    /**
     * 登记名称
     */
    @ApiModelProperty(value = "登记名称")
    private String registerName;
    /**
     * 申请地址
     */
    @ApiModelProperty(value = "申请地址")
    private String registerAddress;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String registerPhone;
    /**
     * 证件号码
     */
    @ApiModelProperty(value = "证件号码")
    private String registerCertNo;
    /**
     * new登记名称
     */
    @ApiModelProperty(value = "new登记名称")
    private String registerNewname;
    /**
     * new申请地址
     */
    @ApiModelProperty(value = "new申请地址")
    private String registerNewaddress;
    /**
     * new联系电话
     */
    @ApiModelProperty(value = "new联系电话")
    private String registerNewphone;
    /**
     * new证件号码
     */
    @ApiModelProperty(value = "new证件号码")
    private String registerNewcertNo;
    /**
     * 具体内容
     */
    @ApiModelProperty(value = "具体内容")
    private String registerContext;
    /**
     * 登记日期
     */
    @ApiModelProperty(value = "登记日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date registerDate;
    /**
     * 处理人员
     */
    @ApiModelProperty(value = "处理人员")
    private String handleName;
    /**
     * 处理日期
     */
    @ApiModelProperty(value = "处理日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date handleDate;
    /**
     * 处理结果
     */
    @ApiModelProperty(value = "处理结果")
    private String handleResult;
    /**
     * 状态:0未处理,1处理中,2已作废
     */
    @ApiModelProperty(value = "状态:0未处理,1处理中,2已作废")
    private String state;

}
