/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.wxgl.wechatofficalacctmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 公示公告
 *
 * @author sxb
 * @date Mon Jun 05 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "WX_GSDT", resultMap = "wxGsdtMap")
@KeySequence("WX_GSDT")
@ApiModel
public class WxGsdt extends Model<WxGsdt> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")
    private Integer id;
    /**
     * 编辑日期
     */
    @ApiModelProperty(value = "编辑日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date editDate;
    /**
     * 编辑人员代码
     */
    @ApiModelProperty(value = "编辑人员代码")
    private String editCode;
    /**
     * 编辑人员姓名
     */
    @ApiModelProperty(value = "编辑人员姓名")
    private String editName;
    /**
     * 标题
     */
    @ApiModelProperty(value = "标题")
    private String title;
    /**
     * 状态
     */
    @ApiModelProperty(value = "状态")
    private String state;
    /**
     * 类型
     */
    @ApiModelProperty(value = "类型")
    private String dtType;


    @TableField(exist = false) //数据排除字段
    @ApiModelProperty(value = "类型名称")
    private String dtTypeName;
    /**
     * 内容
     */
    @ApiModelProperty(value = "内容")
    private String context;

}
