package com.tofly.feesapi.xtgl.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 系统归档参数表
 * </p>
 *
 * @author decai
 * @since 2024-02-01
 */
@Getter
@Setter
@TableName("SYS_GDCSB")
@ApiModel(value = "SysGdcsb对象", description = "系统归档参数表")
public class SysGdcsb implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("所属公司编码")
    private String ssgs;

    @ApiModelProperty("财务日期")
    private String cwrq;

    @ApiModelProperty("账务日期（月末结转使用）")
    private String zwrq;

    @ApiModelProperty("归档日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gdrq;

    @ApiModelProperty("归档标志（1已归档，0未归档）")
    private String gdbz;

    public static final String SSGS = "SSGS";

    public static final String CWRQ = "CWRQ";

    public static final String ZWRQ = "ZWRQ";

    public static final String GDRQ = "GDRQ";

    public static final String GDBZ = "GDBZ";
}
