package com.tofly.feesapi.xtgl.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.tofly.feesapi.xtgl.entity.SysGdcsb;
import com.tofly.feesapi.xtgl.mapper.SysGdcsbMapper;
import com.tofly.feesapi.xtgl.service.ISysGdcsbService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.format.DateTimeFormatter;

/**
 * <p>
 * 系统归档参数表 服务实现类
 * </p>
 *
 * @author decai
 * @since 2024-02-01
 */
@Service
public class SysGdcsbServiceImpl extends ServiceImpl<SysGdcsbMapper, SysGdcsb> implements ISysGdcsbService {

    @Override
    public String selectCwrq() {
        SysGdcsb gdcs = getGdcs();
        return gdcs.getCwrq();
    }

    private SysGdcsb getGdcs() {
        return this.getOne(Wrappers.lambdaQuery(SysGdcsb.class)
                .eq(SysGdcsb::getGdbz, "0"));
    }

    @Override
    public boolean scgdcs() {
        SysGdcsb gdcs = getGdcs();
        String cwrq = LocalDate.now().format(DateTimeFormatter.ofPattern("yyyyMM"));
        if (cwrq.equals(gdcs.getCwrq())) return false;
        SysGdcsb gdscNew = new SysGdcsb();
        BeanUtils.copyProperties(gdcs, gdscNew);
        gdscNew.setCwrq(cwrq);
        this.save(gdscNew);
        this.lambdaUpdate()
                .set(SysGdcsb::getGdbz, "1")
                .eq(SysGdcsb::getCwrq, gdcs.getCwrq())
                .eq(SysGdcsb::getSsgs, gdcs.getSsgs()).update();
        return true;
    }
}
