/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.yhgl.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.Excel.ExcleFileUtil;
import com.tofly.feesapi.common.constant.YhztEnum;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.common.dbhelper.PageSortHelper;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.sfgl.mapper.YyQfmxMapper;
import com.tofly.feesapi.udb.smpn.entity.Company;
import com.tofly.feesapi.udb.smpn.service.ICompanyService;
import com.tofly.feesapi.yhgl.entity.YhBtLog;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.entity.Yhkhjbxx2;
import com.tofly.feesapi.yhgl.entity.vo.YhBtLogSelect;
import com.tofly.feesapi.yhgl.mapper.YhBtLogMapper;
import com.tofly.feesapi.yhgl.mapper.YhKhjbxxMapper;
import com.tofly.feesapi.yhgl.service.YhBtLogService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import io.netty.util.internal.StringUtil;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 用户报停记录
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("api/yhgl/yhbtlog")
@Api(tags = "用户管理-用户报停记录接口")
public class YhBtLogController {
    private final YhBtLogService yhBtLogService;
    private final YhBtLogMapper yhBtLogMapper;
    private final YhKhjbxxService yhKhjbxxService;
    private final YhKhjbxxMapper yhKhjbxxMapper;
    private final YhCbkxxService yhCbkxxService;
    private final YyCblrService yyCblrService;
    private final YyQfmxMapper yyQfmxMapper;
    private final ICompanyService companyService;

    /**
     * 分页查询
     *
     * @param page 分页对象
     * @param
     * @return
     */
    @GetMapping("/page")
    @ApiOperation(value = "page分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "ssgs", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "ksrq", value = "开始时间", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束时间", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(编号、姓名、电话、地址)", dataType = "String")
    })
    public ResultRespone getDaBtLogPage(Page page, String searchText, String ssgs, String sscbpq, String sscbb, String ksrq, String jsrq) {
        PageSortHelper.setPageSort(YhBtLog.class, page);
        // 执行分页查询
        IPage<YhBtLogSelect> yhdaPage = yhBtLogMapper.selectDaCustomerBtPage(page, ssgs, sscbpq, sscbb, ksrq, jsrq, searchText);
        // 遍历查询结果进行赋值
        List<YhBtLogSelect> yhbtList = yhdaPage.getRecords();
        for (YhBtLogSelect yhbt : yhbtList) {
            if (yhbt.getHfysbz() != null && yhbt.getHfysbz().equals("0")) {
                yhbt.setHfysbz("未恢复");
            } else {
                yhbt.setHfysbz("已恢复");
            }
            if (yhbt.getSsgs() != null) {
                Company company = companyService.get(Long.valueOf(yhbt.getSsgs()));
                if (company != null) {
                    yhbt.setSsgsname(company.getCompanyName());
                }
            }
        }
        return ResultRespone.success(yhdaPage);
    }


    /**
     * 通过id查询用户报停记录
     *
     * @param bh id
     * @return ResultRespone
     */
    @GetMapping("/{bh}")
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "bh", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("bh") String bh) {
        return ResultRespone.success(yhBtLogService.getById(bh));
    }

    @ApiOperation(value = "新增用户报停记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yzqf", value = "是否验证欠费（1：需验证；0：不验证）", required = false, dataType = "String")
    })
    @PostMapping
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public ResultRespone save(@RequestBody YhBtLog daBtLog, @RequestParam(required = false) String yzqf) {
        if (StringUtils.isNotBlank(daBtLog.getYhbh())) {
            if (yzqf.equals("1")) {
                //判断用户是否存在欠费
                int count = yyQfmxMapper.selectExistQf(daBtLog.getYhbh());
                if (count > 0) {
                    return ResultRespone.failed(false, "操作失败,用户存在欠费:" + count + "笔");
                }
            }
            // int bh= yhBtLogMapper.selectMaxId()+1;
            daBtLog.setBh(GuidGenerator.getGuid().substring(0, 8));
            if (yhBtLogService.save(daBtLog)) {
                //同步用户档案状态
                YhKhjbxx yhKhjbxx = new YhKhjbxx();
                yhKhjbxx.setYhbh(daBtLog.getYhbh());//用户编号
                yhKhjbxx.setYhzt(YhztEnum.报停用户);
                //抄表卡信息
                YhCbkxx yhCbkxx = new YhCbkxx();
                yhCbkxx.setCbkid(daBtLog.getCbkid());
                yhCbkxx.setYhbh(daBtLog.getYhbh());
                yhCbkxx.setJfzt("2");//1正常2停用
                //抄表计划添加
                YyCblr yyCblr = new YyCblr();
                yyCblr.setCbkid(daBtLog.getCbkid());
                yyCblr.setJfzt("2");
                yyCblr.setYhbh(daBtLog.getYhbh());

                if (yhKhjbxxService.updateById(yhKhjbxx) && yhCbkxxService.updateById(yhCbkxx) && yyCblrService.updateById(yyCblr)) {
                    return ResultRespone.success(true, "操作成功");
                } else {
                    return ResultRespone.failed(false, "操作失败");
                }
            } else {
                return ResultRespone.failed(false, "操作失败");
            }
        } else {
            return ResultRespone.failed(false, "操作失败,用户编号不存在");
        }
    }


    /**
     * 修改用户报停记录
     *
     * @param yhBtLog 用户报停记录
     * @return ResultRespone
     */
    @ApiOperation(value = "修改用户报停记录")
    @PutMapping
    public ResultRespone updateById(@RequestBody YhBtLog yhBtLog) {
        return ResultRespone.success(yhBtLogService.updateById(yhBtLog));
    }

    /**
     * 通过id删除用户报停记录
     *
     * @param bh id
     * @return ResultRespone
     */
    @ApiOperation(value = "通过ID删除用户报停记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "bh", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{bh}")
    public ResultRespone removeById(@PathVariable String bh) {
        return ResultRespone.success(yhBtLogService.removeById(bh));
    }

    /**
     * 通过id批量删除用户报停记录
     *
     * @param ids id
     * @return ResultRespone
     */
    @ApiOperation(value = "通过ID批量删除用户报停记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yhBtLogService.removeByIds(Arrays.asList(ids.split(","))));
    }

    /**
     * export  Excel 数据导出
     */
    @GetMapping("/export")
    @ApiOperation(value = "export导出")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ssgs", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "ksrq", value = "开始时间", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束时间", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(编号、姓名、电话、地址)", dataType = "String")
    })
    public void export(HttpServletResponse response, String ssgs, String sscbpq, String sscbb, String ksrq, String jsrq, String searchText) throws IOException {
        // 遍历查询结果进行赋值
        List<YhBtLogSelect> list = yhBtLogMapper.selectDaCustomerBtPage(ssgs, sscbpq, sscbb, ksrq, jsrq, searchText);
        for (YhBtLogSelect yhbt : list) {
            if (yhbt.getSsgs() != null) {
                Company company = companyService.get(Long.valueOf(yhbt.getSsgs()));
                if (company != null) {
                    yhbt.setSsgsname(company.getCompanyName());
                }
            }
        }
        //导出excle
        ExcleFileUtil.exportExcel(response, list, YhBtLogSelect.class, "用户报停记录.xlsx");
    }
}
