/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.yhgl.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.yhgl.entity.YhFfgx;
import com.tofly.feesapi.yhgl.service.YhFfgxService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 付费关系
 *
 * @author admin
 * @date Wed Feb 28 00:00:00 CST 2024
 */
@RestController
@AllArgsConstructor
@RequestMapping("api/yhgl/yhffgx")
@Api(tags="付费关系接口")
public class YhFfgxController {

    private final  YhFfgxService yhFfgxService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param yhFfgx 付费关系
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getYhFfgxPage(Page page, @ModelAttribute YhFfgx yhFfgx) {
      return ResultRespone.success(yhFfgxService.page(page, Wrappers.query(yhFfgx)));
    }


    /**
     * 通过id查询付费关系
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(yhFfgxService.getById(id));
    }

    /**
     * 新增付费关系
     * @param yhFfgx 付费关系
     * @return ResultRespone
     */
    @ApiOperation(value = "新增付费关系")
    @PostMapping
    public ResultRespone save(@RequestBody YhFfgx yhFfgx) {
      return ResultRespone.success(yhFfgxService.save(yhFfgx));
    }

    /**
     * 修改付费关系
     * @param yhFfgx 付费关系
     * @return ResultRespone
     */
    @ApiOperation(value = "修改付费关系")
    @PutMapping
    public ResultRespone updateById(@RequestBody YhFfgx yhFfgx) {
      return ResultRespone.success(yhFfgxService.updateById(yhFfgx));
    }

    /**
     * 通过id删除付费关系
     * @param id id
     * @return ResultRespone
     */
    @ApiOperation(value = "通过ID删除付费关系")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(yhFfgxService.removeById(id));
    }

    /**
     * 通过id批量删除付费关系
     * @param ids id
     * @return ResultRespone
     */
    @ApiOperation(value = "通过ID批量删除付费关系")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yhFfgxService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
