package com.tofly.feesapi.yhgl.controller;

import cn.hutool.core.date.DateTime;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.util.ListUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.bjgl.entity.YhCbkxx;
import com.tofly.feesapi.bjgl.entity.YhCbkxxLog;
import com.tofly.feesapi.bjgl.entity.vo.YhCbkxxSelect;
import com.tofly.feesapi.bjgl.service.YhCbkxxLogService;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.IZnbZlLogService;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.Excel.ExcleFileUtil;
import com.tofly.feesapi.common.constant.*;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.*;
import com.tofly.feesapi.yhgl.entity.dto.*;
import com.tofly.feesapi.yhgl.entity.vo.YhkhjbxxSelect;
import com.tofly.feesapi.yhgl.entity.vo.YhkhjbxxSelect2;
import com.tofly.feesapi.yhgl.entity.vo.YyZjzhView;
import com.tofly.feesapi.yhgl.mapper.YhKhjbxxMapper;
import com.tofly.feesapi.yhgl.service.IYyZjzhService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxLogService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import com.tofly.feesapi.znbgl.entity.dto.ZnbYhdaFilter;
import com.tofly.feesapi.znbgl.entity.vo.ZnbYhdaSelect;
import com.tofly.feesapi.znbgl.service.ZnbDaLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.beans.BeanUtils;
import org.springframework.http.MediaType;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import static com.tofly.feesapi.common.util.copyPropertiesUtils.copyProperties;

@RestController
@AllArgsConstructor
@RequestMapping("api/yhgl/yhkhjbxx")
@Api(tags = "用户管理-用户档案")
public class YhKhjbxxController {

    private final YhKhjbxxService yhKhjbxxService;
    private final YhKhjbxxMapper yhKhjbxxMapper;

    private final YhCbkxxService yhCbkxxService;

    private final YyCblrService yyCblrService;

    private final YhCbkxxLogService yhCbkxxLogService;
    private final YhKhjbxxLogService yhKhjbxxLogService;

    private final IYyZjzhService zjzhService;
    private final ZnbDaLogService znbDaLogService;

    private final IZnbZlLogService iZnbZlLogService;

//    @ApiOperationSupport(order = 1)
//    @GetMapping("/yhbh")
//    @ApiOperation(value = "获取用户编号")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "cbbbm", value = "抄表本(册)编码", required = true)
//    })
//    public ResultRespone<String> getYhbh(@RequestParam String cbbbm) {
//        return ResultRespone.success(yhKhjbxxService.getYhbh(cbbbm));
//    }

    /**
     * 新增用户档案
     */
//    @ApiOperationSupport(order = 2)
//    @ApiOperation(value = "新增")
//    @PostMapping
//    public ResultRespone<Boolean> save(@RequestBody YhKhjbxxInsert insert,
//                                       @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
//        return ResultRespone.success(yhKhjbxxService.save(insert, czyUserDetails));
//    }
    @ApiOperationSupport(order = 3)
    @ApiOperation(value = "批量建档-下载Excel模板")
    @GetMapping("/template")
    public void getTemplate(HttpServletResponse response) throws IOException {
        ExcleFileUtil.exportExcel(response, data(), YhkhjbxxTpl.class, "用户批量建档模板.xlsx");
    }

    private List<YhkhjbxxTpl> data() {
        List<YhkhjbxxTpl> list = ListUtils.newArrayList();
        for (int i = 0; i < 5; i++) {
            YhkhjbxxTpl data = new YhkhjbxxTpl();
            data.setXh(String.valueOf(i));
            data.setYhbh("20231" + i); // 用户编号 setDate(new Date());
            data.setYhxm("李四" + i); // 用户姓名 setDoubleData(0.56);
            data.setYhdz("用户地址" + i); //用户地址
            data.setLxdh("1860821173" + i); //联系电话
            data.setZjhm("51050418880223336" + i); //证件号码
            data.setSqrq(LocalDate.now()); //申请日期
            data.setSbbh("20230677" + i); //水表编号
            data.setSbkj("20"); //水表口径
            data.setCcrq(LocalDate.now()); //水表出厂日期
            data.setSbqs("0");
            list.add(data);
        }
        return list;
    }

    /**
     * 批量建档
     */
    @ApiOperationSupport(order = 4)
    @ApiOperation(value = "批量建档")
    @PostMapping(value = "/import", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    public ResultRespone<Boolean> importExcel(@RequestParam("file") MultipartFile file,
                                              @ModelAttribute YhkhjbxxImport importDto,
                                              @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) throws IOException {
        List<YhkhjbxxTpl> userList = EasyExcel.read(file.getInputStream()).head(YhkhjbxxTpl.class).sheet().doReadSync();
        if (userList != null && !userList.isEmpty()) {
            LocalDateTime now = LocalDateTime.now();
            List<YhKhjbxxInsert> inserts = userList.stream()
                    .map(e -> getYhKhjbxxInsert(importDto, now, e))
                    .collect(Collectors.toList());
            yhKhjbxxService.batchSave(inserts, czyUserDetails);
            return ResultRespone.success(true, "操作成功");
        } else {
            return ResultRespone.failed(false, "操作失败，导入用户资料为空");
        }
    }

    /**
     * Excle上传文件
     */
    @ApiOperation(value = "Excel2上传文件,批量建档")
    @PostMapping("/import2")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ssgs", value = "所属公司", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sblb", value = "水表类别", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sbsccj", value = "水表厂家", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sbxh", value = "水表型号", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sjbm", value = "水价", required = true, dataType = "String"),
            @ApiImplicitParam(name = "wsfbz", value = "是否污水费", required = true, dataType = "String"),
            @ApiImplicitParam(name = "ljfbz", value = "是否垃圾费", required = true, dataType = "String"),
            @ApiImplicitParam(name = "ljffs", value = "垃圾费收取方式", required = true, dataType = "String"),
            @ApiImplicitParam(name = "ljfje", value = "垃圾费金额", required = true, dataType = "String"),
            @ApiImplicitParam(name = "czrybm", value = "创建人员编码", required = true, dataType = "String"),
            @ApiImplicitParam(name = "czrymc", value = "操作人员名称", required = true, dataType = "String"),
            @ApiImplicitParam(name = "jfzt", value = "表计状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "yhzt", value = "用户状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "tsbz", value = "通水状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "tsrq", value = "通水日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "cbpl", value = "抄表频率", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sblc", value = "水表量程", required = true, dataType = "String"),
            @ApiImplicitParam(name = "bjwz", value = "水表位置", required = true, dataType = "String"),
    })
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public ResultRespone importExcel(
            @RequestParam("file") MultipartFile file, String ssgs, String sscbpq, String sscbb, String sblb, String sbsccj, String sbxh, String sjbm, String wsfbz, String ljfbz, String czrybm, String czrymc, String jfzt, String yhzt, String tsbz,
            @RequestParam String tsrq, String cbpl, String sblc, String bjwz, String ljffs, String ljfje,
            @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        //传入参数校验
        ResultRespone<Object> rest = checkImportExcel(ssgs, sscbpq, sscbb, sblb, sbsccj, sbxh, sjbm, wsfbz, ljfbz, czrybm, czrymc);
        if (StringUtils.isNotBlank(file.toString())) {
            if (rest.getCode() != -1) {
                try {
                    List<YhkhjbxxExcel> userList = EasyExcel.read(file.getInputStream()).head(YhkhjbxxExcel.class).sheet().doReadSync();
                    for (YhkhjbxxExcel user : userList) {
                        //数据校验
                        if (StringUtils.isEmpty(user.getYhbh())) {
                            return ResultRespone.failed(false, "用户编号不能为空");
                        }
                        if (StringUtils.isEmpty(user.getYhxm())) {
                            return ResultRespone.failed(false, "用户名不能为空");
                        }
                        if (StringUtils.isEmpty(user.getYhdz())) {
                            return ResultRespone.failed(false, "用户地址不能为空");
                        }
                        if (StringUtils.isEmpty(user.getLxdh())) {
                            return ResultRespone.failed(false, "用户电话不能为空");
                        }
                        if (StringUtils.isEmpty(user.getZjhm())) {
                            return ResultRespone.failed(false, "证件号码不能为空");
                        }
                        if (StringUtils.isEmpty(user.getSbbh())) {
                            return ResultRespone.failed(false, "表号不能为空");
                        }
                        if (StringUtils.isEmpty(user.getSbkj())) {
                            return ResultRespone.failed(false, "口径不能为空");
                        }
                        if (StringUtils.isEmpty(user.getSbqs())) {
                            return ResultRespone.failed(false, "表起度不能为空");
                        }
                        if (StringUtils.isEmpty(user.getSqrq())) {
                            return ResultRespone.failed(false, "申请日期不能为空");
                        }
                        if (StringUtils.isEmpty(user.getSbccrq())) {
                            return ResultRespone.failed(false, "水表出厂日期不能为空");
                        }
                        SimpleDateFormat dFormat = new SimpleDateFormat("yyyy-MM-dd");
                        Date currentDate = new Date();
                        //将合法数据插入数据库
                        if (rest.getCode() != -1) {
                            //查询用户是否存在
                            int count = yhKhjbxxMapper.selectExistYhbh(user.getYhbh());
                            if (count > 0) {
                                rest.setCode(-1);
                                rest.setMessage("添加用户编号已存在" + user.getYhbh());
                            } else {

                                //用户档案添加
                                String strplbh = GuidGenerator.getGuid();//批次编号
                                YhKhjbxx daCustomer = new YhKhjbxx();
                                daCustomer.setJdpcxlh(strplbh);
                                daCustomer.setSsgs(ssgs);
                                daCustomer.setSscbpq(sscbpq);
                                daCustomer.setSscbb(sscbb);
                                daCustomer.setYhbh(user.getYhbh());//用户编号
                                daCustomer.setYkhbh(user.getYhbh());
                                daCustomer.setYhxm(user.getYhxm());//用户名称
                                daCustomer.setYhdz(user.getYhdz());//用户地址
                                daCustomer.setLxdh(user.getLxdh());//用户电话
                                daCustomer.setZjhm(user.getZjhm());//证件号码
                                if (yhzt.equals("1") || yhzt.equals("正式用户")) {
                                    daCustomer.setYhzt(YhztEnum.正式用户);//用户状态
                                }
                                if (yhzt.equals("0") || yhzt.equals("申请用户")) {
                                    daCustomer.setYhzt(YhztEnum.申请用户);//用户状态
                                }
                                if (yhzt.equals("2") || yhzt.equals("报停用户")) {
                                    daCustomer.setYhzt(YhztEnum.报停用户);//用户状态
                                }
                                if (yhzt.equals("3") || yhzt.equals("销户用户")) {
                                    daCustomer.setYhzt(YhztEnum.销户用户);//用户状态
                                }
                                if (yhzt.equals("4") || yhzt.equals("作废用户")) {
                                    daCustomer.setYhzt(YhztEnum.作废用户);//用户状态
                                }

                                daCustomer.setTsbz(tsbz);//通水状态
                                daCustomer.setFffs("1");//付费方式
                                if (StringUtils.isNotBlank(tsrq)) {
                                    daCustomer.setTsrq(dFormat.parse(tsrq)); // 通水时间
                                }
                                if (StringUtils.isNotBlank(user.getSqrq())) {
                                    daCustomer.setSqrq(dFormat.parse(user.getSqrq())); //申请日期
                                }
                                daCustomer.setCzsj(new DateTime());//创建时间
                                daCustomer.setJdrq(new DateTime());
                                daCustomer.setCzrybm(czrybm); //创建人员编码
                                daCustomer.setCzryxm(czrymc); //创建人员名称
                                daCustomer.setJdrybm(czrybm); //操作人员
                                daCustomer.setJdryxm(czrymc); //操作人员名称
                                daCustomer.setCzsj(currentDate);//操作时间
                                daCustomer.setZjlb("1");//证件类型
                                yhKhjbxxService.save(daCustomer);
                                //水表档案添加
                                YhCbkxx daMeter = new YhCbkxx();
                                daMeter.setGxh(strplbh);//批次号
                                daMeter.setCbkh("1");
                                daMeter.setCbkid(user.getYhbh() + "1");
                                daMeter.setYhbh(user.getYhbh());//用户编号
                                daMeter.setCzrybm(czrybm); //创建人员编码
                                daMeter.setCzryxm(czrymc); //创建人员名称
                                daMeter.setCzsj(new Date());//操作时间

                                daMeter.setLjffs(ljffs); //垃圾费收取方式
                                daMeter.setLjfje(new BigDecimal(ljfje));
                                if (jfzt.equals("1") || jfzt.equals("正常")) {
                                    daMeter.setJfzt("1");//计费状态
                                } else {
                                    daMeter.setJfzt("2");//计费状态
                                }

                                daMeter.setSbsccj(sbsccj);//水表厂家
                                if (StringUtils.isNotBlank(user.getSbccrq())) {
                                    daMeter.setSbccrq(dFormat.parse(user.getSbccrq()));
                                }
                                daMeter.setSblb(sblb); //水表类别
                                daMeter.setSbbh(user.getSbbh());//水表编号
                                daMeter.setSbkj(user.getSbkj());//水表口径
                                daMeter.setSjbm(sjbm);//水价
                                daMeter.setSbxh(sbxh);//水表型号
                                daMeter.setCbpl(cbpl);//抄表频率
                                daMeter.setSblc(sblc);//水表量程
                                daMeter.setBjwz(bjwz); //表具位置

                                daMeter.setSbqs(Integer.parseInt(user.getSbqs()));//起度
                                daMeter.setWsfbz(wsfbz);//污水费
                                daMeter.setLjfbz(ljfbz);//垃圾费
                                yhCbkxxService.save(daMeter);

                                DaCustomerAndMeter daCustomerAndMeter = new DaCustomerAndMeter();
                                daCustomerAndMeter.setYhKhjbxx(daCustomer);
                                daCustomerAndMeter.setYhCbkxx(daMeter);
                                addDaCustomerAndMeterLog(daCustomerAndMeter, "save");

                                //抄表计划添加
                                if (sblb.equals("0") || sblb.equals("2") || sblb.equals("3") || sblb.equals("4")) {
                                    YyCblr bwMeterReadPlan = new YyCblr();
                                    bwMeterReadPlan.setYhbh(String.valueOf(user.getYhbh()));//用户编号
                                    bwMeterReadPlan.setCbkh("1");//抄表卡号
                                    bwMeterReadPlan.setCbkid(user.getYhbh() + "1");//抄表卡ID
                                    Map<String, Object> mapcwrq = yhKhjbxxMapper.selectCwrq();//获取财务日期
                                    String strcwrq = mapcwrq.get("cwrq").toString();//202305
                                    bwMeterReadPlan.setCwrq(strcwrq);//财务日期
                                    bwMeterReadPlan.setJsbz(JsbzEnum.未算费);//计算标志
                                    bwMeterReadPlan.setJfzt("1");//正常状态
                                    bwMeterReadPlan.setCbbz(CbbzEnum.未抄表);//未抄表状态
                                    bwMeterReadPlan.setShbz(ShbzEnum.未审核);//未审核标志
                                    bwMeterReadPlan.setSsgs(ssgs);//公司
                                    bwMeterReadPlan.setSscbpq(sscbpq);//片区
                                    bwMeterReadPlan.setSscbb(sscbb);//抄表本

                                    yyCblrService.save(bwMeterReadPlan);
                                    //添加智能表档案日志
                                    if (sblb.equals("2") || sblb.equals("3")) {
                                        znbDaLogService.addznbDaLog(daCustomer, daMeter, "0", czyUserDetails);
                                    }
                                }
                            }
                        }
                    }
                    rest.setCode(1);
                    rest.setMessage("导入成功:" + userList.size() + "条");
                } catch (IOException e) {
                    e.printStackTrace();
                    rest.setCode(-1);
                    rest.setMessage("导入失败:" + e.getMessage());
                } catch (ParseException e) {
                    throw new RuntimeException(e);
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
            }
        }
        return ResultRespone.success(rest.getCode(), rest.getMessage());
    }


    public ResultRespone<Object> checkImportExcel(String ssgs, String sscbpq, String sscbb, String sblb, String sbsccj, String sbxh, String sjbm, String wsfbz, String ljfbz, String czrybm, String czrymc) {
        ResultRespone<Object> rest = new ResultRespone<>();
        rest.setCode(1);
        rest.setMessage("操作成功");

        if (StringUtils.isEmpty(ssgs)) {
            return createErrorResponse(rest, -1, "所属公司不能为空");
        }
        if (StringUtils.isEmpty(sscbpq)) {
            return createErrorResponse(rest, -1, "所属片区参数不能为空");
        }
        if (StringUtils.isEmpty(sscbb)) {
            return createErrorResponse(rest, -1, "所属抄表本参数不能为空");
        }
        if (StringUtils.isEmpty(sblb)) {
            return createErrorResponse(rest, -1, "水表类别参数不能为空");
        }
        if (StringUtils.isEmpty(sbsccj)) {
            return createErrorResponse(rest, -1, "水表厂家参数不能为空");
        }
        if (StringUtils.isEmpty(sbxh)) {
            return createErrorResponse(rest, -1, "水表型号参数不能为空");
        }
        if (StringUtils.isEmpty(sjbm)) {
            return createErrorResponse(rest, -1, "水价参数不能为空");
        }
        if (StringUtils.isEmpty(wsfbz)) {
            return createErrorResponse(rest, -1, "是否污水费参数不能为空");
        }
        if (StringUtils.isEmpty(ljfbz)) {
            return createErrorResponse(rest, -1, "是否垃圾费参数不能为空");
        }
        if (StringUtils.isEmpty(czrybm)) {
            return createErrorResponse(rest, -1, "创建人员编码参数不能为空");
        }
        if (StringUtils.isEmpty(czrymc)) {
            return createErrorResponse(rest, -1, "创建人员名称参数不能为空");
        }

        return rest;
    }

    private ResultRespone<Object> createErrorResponse(ResultRespone<Object> rest, int code, String message) {
        rest.setCode(code);
        rest.setMessage(message);
        return rest;
    }


    private YhKhjbxxInsert getYhKhjbxxInsert(YhkhjbxxImport importDto, LocalDateTime now, YhkhjbxxTpl e) {
        YhKhjbxxInsert insert = new YhKhjbxxInsert();
        BeanUtils.copyProperties(importDto, insert);
        BeanUtils.copyProperties(e, insert);

        YhKhjbxxInsert.YhCbkxxInsert yhCbkxx = insert.getYhCbkxx();
        BeanUtils.copyProperties(importDto.getYhCbkxx(), yhCbkxx);
        BeanUtils.copyProperties(e, yhCbkxx);
        if (insert.getCzsj() == null) {
            insert.setCzsj(new Date());
        }
        return insert;
    }


    /**
     * 分页查询
     */
    @ApiOperationSupport(order = 5)
    @GetMapping("/page")
    @ApiOperation(value = "查询用户档案（分页）", tags = {"营业厅收费"})
    public ResultRespone<PageResult<YhkhjbxxSelect>> getPage(@ModelAttribute PageDto pageDto, @ModelAttribute YhkhjbxxFilter filter) {
        return ResultRespone.success(yhKhjbxxService.getPage(pageDto, filter));
    }

    /**
     * 分页查询2
     */
    @ApiOperationSupport(order = 5)
    @GetMapping("/page2")
    @ApiOperation(value = "查询用户档案2（分页）")
    public ResultRespone<PageResult<YhkhjbxxSelect2>> getPage2(@ModelAttribute PageDto pageDto, @ModelAttribute YhkhjbxxFilter filter) {

        PageResult<YhkhjbxxSelect2> yhdaPage = yhKhjbxxService.getPage2(pageDto, filter);
        // 遍历查询结果进行赋值
        List<YhkhjbxxSelect2> yhdaList = yhdaPage.getRecords();

        // 对 obj 进行一些操作    yhdaList.set(i, obj); // 将 obj 的新值重新赋给 yhdaList}
        for (YhkhjbxxSelect2 yhda : yhdaList) {
            //用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
            //customerStateSearch(yhda);
            int cbsl = yhKhjbxxMapper.selectExistCbkxx(yhda.getYhbh());
            if (cbsl > 0) {
                //用户是否存在水表档案
                List<Map<String, Object>> list = yhKhjbxxMapper.selectCbkh(yhda.getYhbh());
                //循环遍历，重新赋值
                StringBuilder strcbkh = new StringBuilder();
                StringBuilder strid = new StringBuilder();
                for (Map<String, Object> map : list) {
                    strcbkh.append(map.get("cbkh")).append(",");
                    strid.append(map.get("cbkid")).append(",");
                }

                yhda.setCbkhList(strcbkh.substring(0, strcbkh.length() - 1));
                yhda.setCbkid(strid.substring(0, strid.length() - 1));
                yhda.setSbsl(cbsl);//水表数量

                //查询用户是否存在多只表
            }
//              if(yhsl>0)
//              {
            //Map<String, Object>list_yhda = yhKhjbxxMapper.s(yhda.getYhbh());
//
//                      yhda.setSsgsbm(list_yhda.get("SSGS").toString());
//                      yhda.setSscbpqmc(list_yhda.get("SSCBPQ").toString());
//                      yhda.setSscbbbm(list_yhda.get("SSCBB").toString());
//                  }

        }
        return ResultRespone.success(yhdaPage);
        // return ResultRespone.success(yhKhjbxxService.getPage2(pageDto, filter));
    }

    @GetMapping("/page3")
    @ApiOperation(value = "page分页查询-用户档案")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
//            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
//            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", dataType = "String"),
            @ApiImplicitParam(name = "ssgs", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "sblb", value = "水表类别", dataType = "String"),
            @ApiImplicitParam(name = "sjbm", value = "用水性质", dataType = "String"),
            @ApiImplicitParam(name = "yhzt", value = "用户状态", dataType = "String"),
            @ApiImplicitParam(name = "cbry", value = "抄表人员", dataType = "String"),
            @ApiImplicitParam(name = "ljfbz", value = "是否垃圾费", dataType = "String"),
            @ApiImplicitParam(name = "ksrq", value = "开始建档日期", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束建档日期", dataType = "String"),
    })
    public ResultRespone getDaCustomerPage(Page page, String searchText, String ssgs, String sscbpq, String sscbb, String sblb, String sjbm, String cbry, String yhzt, String ljfbz, String ksrq, String jsrq) {
        //自定义查询用户档案
        //用户编号、用户姓名、用户地址、联系电话
        //片区、抄表本、水表型号、用水性质、用户状态、是否垃圾费、建档日期、抄表人员
        IPage<YhkhjbxxSelect2> yhdaPage = yhKhjbxxMapper.selectDaCustomerPage(page, searchText, ssgs, sscbpq, sscbb, sblb, sjbm, cbry, yhzt, ljfbz, ksrq, jsrq);
        // 遍历查询结果进行赋值
        List<YhkhjbxxSelect2> yhdaList = yhdaPage.getRecords();


        // 对 obj 进行一些操作    yhdaList.set(i, obj); // 将 obj 的新值重新赋给 yhdaList}
        for (YhkhjbxxSelect2 yhda : yhdaList) {

            int cbsl = yhKhjbxxMapper.selectExistCbkxx(yhda.getYhbh());
            if (cbsl > 0) {
                //用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
                customerStateSearch(yhda);
                List<Map<String, Object>> list = yhKhjbxxMapper.selectCbkh(yhda.getYhbh());
                //循环遍历，重新赋值
                StringBuilder strcbkh = new StringBuilder();
                StringBuilder strid = new StringBuilder();
                for (Map<String, Object> map : list) {
                    strcbkh.append(map.get("cbkh")).append(",");
                    strid.append(map.get("cbkid")).append(",");
                }
                yhda.setCbkhList(strcbkh.substring(0, strcbkh.length() - 1));
                yhda.setCbkid(strid.substring(0, strid.length() - 1));
                yhda.setSbsl(cbsl);//水表数量
                //查询用户是否存在多只表
            }
        }
        return ResultRespone.success(yhdaPage);
    }

    @GetMapping("/export3")
    @ApiOperation(value = "export导出-用户档案")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", dataType = "String"),
            @ApiImplicitParam(name = "ssgs", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "sscbpq", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "sscbb", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "sblb", value = "水表型号", dataType = "String"),
            @ApiImplicitParam(name = "sjbm", value = "用水性质", dataType = "String"),
            @ApiImplicitParam(name = "yhzt", value = "用户状态", dataType = "String"),
            @ApiImplicitParam(name = "ljfbz", value = "是否垃圾费", dataType = "String"),
            @ApiImplicitParam(name = "ksrq", value = "开始建档日期", dataType = "String"),
            @ApiImplicitParam(name = "jsrq", value = "结束建档日期", dataType = "String"),
            @ApiImplicitParam(name = "cbry", value = "抄表人员", dataType = "String")
    })
    public void export(HttpServletResponse response, String searchText, String ssgs, String sscbpq, String sscbb, String sblb, String sjbm, String cbry, String yhzt, String ljfbz, String ksrq, String jsrq) throws IOException {
        List<YhkhjbxxSelect2> yhdaList = yhKhjbxxMapper.selectDaCustomerPage(searchText, ssgs, sscbpq, sscbb, sblb, sjbm, cbry, yhzt, ljfbz, ksrq, jsrq);
        // 遍历查询结果进行赋值
        // 对 obj 进行一些操作    yhdaList.set(i, obj); // 将 obj 的新值重新赋给 yhdaList}
        for (YhkhjbxxSelect2 yhda : yhdaList) {
            //用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
            customerStateSearch(yhda);
        }
        ExcleFileUtil.exportExcel(response, yhdaList, YhkhjbxxSelect2.class, "用户档案.xlsx");
    }

    private void customerStateSearch(YhkhjbxxSelect2 yhda) {
        if (yhda.getYhzt().equals("0")) {
            yhda.setYhzt(YhztEnum.申请用户);
        }
        if (yhda.getYhzt().equals("1")) {
            yhda.setYhzt(YhztEnum.正式用户);
        }
        if (yhda.getYhzt().equals("2")) {
            yhda.setYhzt(YhztEnum.报停用户);
        }
        if (yhda.getYhzt().equals("3")) {
            yhda.setYhzt(YhztEnum.销户用户);
        }
        if (yhda.getYhzt().equals("4")) {
            yhda.setYhzt(YhztEnum.作废用户);
        }
    }


    /**
     * 通过id查询用户档案
     */
    @ApiOperationSupport(order = 6)
    @GetMapping("/{yhbh}")
    @ApiOperation(value = "查看用户档案", tags = {"水费补差", "营业厅收费", "综合查询"})
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String")
    })
    public ResultRespone<Yhkhjbxx2> getById(@PathVariable("yhbh") String yhbh) {
        return ResultRespone.success(yhKhjbxxMapper.selectYhDa(yhbh));
    }

    @ApiOperation(value = "查看账户余额信息", tags = {"余额转存", "综合查询"})
    @GetMapping("/{yhbh}/zjzh")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String")
    })
    public ResultRespone<YyZjzhView> getZjzh(@PathVariable("yhbh") String yhbh) {
        return ResultRespone.success(zjzhService.get(yhbh));
    }


    @ApiOperation(value = "(新增、修改)用户、水表基本信息")
    @PostMapping("/saveDaCustomerAndMeter")
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    @ApiImplicitParams({
            @ApiImplicitParam(name = "operationType", value = "save、saveUpate", required = true, dataType = "String")
    })
    public ResultRespone saveYhda(@RequestBody DaCustomerAndMeter daCustomerAndMeter,
                                  @RequestParam String operationType,
                                  @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails
    ) throws Exception {

        //参数校验
        ResultRespone<Object> rest = new ResultRespone<>();
        //  ResultRespone<Object> rest = checkYhjbxx_cbkxx(operationType, daCustomerAndMeter);
        if (StringUtils.isEmpty(operationType)) {
            return ResultRespone.failed(false, "操作类型不能为空");
        }
        if (!operationType.equals("save") && !operationType.equals("saveUpdate")) {
            return ResultRespone.failed(false, "操作类型参数不等于save或saveUpdate");
        }

        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSsgs())) {
            return ResultRespone.failed(false, "所属公司不能为空");
        }

        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbpq())) {
            return ResultRespone.failed(false, "片区不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbb())) {

            return ResultRespone.failed(false, "抄表本不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhxm().toString())) {
            return ResultRespone.failed(false, "用户姓名不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhdz().toString())) {
            return ResultRespone.failed(false, "用户地址不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbbh().toString())) {
            return ResultRespone.failed(false, "水表编号不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSblb().toString())) {
            return ResultRespone.failed(false, "水表类别不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbsccj().toString())) {
            return ResultRespone.failed(false, "水表厂家不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbxh())) {
            return ResultRespone.failed(false, "水表型号不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbkj())) {
            return ResultRespone.failed(false, "水表口径不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getCzrybm())) {
            return ResultRespone.failed(false, "操作人员编码不能为空");
        }
        if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getCzryxm())) {
            return ResultRespone.failed(false, "操作人员姓名不能为空");
        }


        //用户档案基础信息添加
        YhKhjbxx yhKhjbxx = daCustomerAndMeter.getYhKhjbxx();
        //水表档案基础信息添加
        YhCbkxx yhCbkxx = daCustomerAndMeter.getYhCbkxx();
        String inputDate = "1999-01-01 00:00:00";
        SimpleDateFormat inputFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = inputFormat.parse(inputDate);
        if (yhKhjbxx.getTsbz().equals("0") || StringUtils.isEmpty(yhKhjbxx.getTsbz())) {
            yhKhjbxx.setTsrq(date);
            yhKhjbxx.setTsbz("0");
        }
        if (yhKhjbxx.getHtqd().equals("0") || StringUtils.isEmpty(yhKhjbxx.getHtqd())) {
            yhKhjbxx.setHtqdrq(date);
            yhKhjbxx.setHtqd("0");
        }
        if (StringUtils.isEmpty(yhKhjbxx.getZjlb())) {
            yhKhjbxx.setZjlb("1");
            yhKhjbxx.setZjhm("0");
        }
        if (StringUtils.isEmpty(yhKhjbxx.getFffs())) {
            yhKhjbxx.setFffs("1");
        }
        //抄表计划添加
        YyCblr yyCblr = new YyCblr();

        String yhzt = daCustomerAndMeter.getYhKhjbxx().getYhzt().toString();
        String jfzt = daCustomerAndMeter.getYhCbkxx().getJfzt();
        if (yhzt == "1" || yhzt == "正式用户") {
            yhKhjbxx.setYhzt(YhztEnum.正式用户);//正式用户状态
            yhCbkxx.setJfzt(JfztEnum.正常.toString());//计费状态（1正常，2停用）
            yyCblr.setJfzt(JfztEnum.正常.getValue().toString());//正常状态
        }

        if (yhzt == "2" || yhzt == "报停用户") {
            yhKhjbxx.setYhzt(YhztEnum.报停用户);//正式用户状态
        }
        if (yhzt == "3" || yhzt == "销户用户") {
            yhKhjbxx.setYhzt(YhztEnum.销户用户);//正式用户状态
        }
        if (yhzt == "4" || yhzt == "作废用户") {
            yhKhjbxx.setYhzt(YhztEnum.作废用户);//正式用户状态
        }
        if (Arrays.asList("1", "正常").contains(jfzt)) {
            yhCbkxx.setJfzt("1");//计费状态（1正常，2停用）
            yyCblr.setJfzt("1");//正常状态（1正常，2停用）
        } else {
            yhCbkxx.setJfzt("2");//计费状态（1正常，2停用）
            yyCblr.setJfzt("2");//正常状态（1正常，2停用）
        }

        if (operationType.equals("save")) {
            //获取用户编号
            int maxyhbh = yhKhjbxxMapper.selectMaxYhbh() + 1;
            //用户档案
            yhKhjbxx.setYhbh(String.valueOf(maxyhbh)); //用户编号
            yhKhjbxx.setYkhbh(String.valueOf(maxyhbh));//旧用户编号
            yhKhjbxx.setJdrybm(daCustomerAndMeter.getYhKhjbxx().getCzrybm());
            yhKhjbxx.setJdryxm(daCustomerAndMeter.getYhKhjbxx().getCzryxm());

            yhKhjbxx.setJdrq(new Date());//建档日期
            yhKhjbxx.setCzsj(new Date());//操作时间
            //水表档案
            yhCbkxx.setYhbh(String.valueOf(maxyhbh));//用户编号
            yhCbkxx.setCbkh("1");//抄表卡号
            String strcbkh = String.valueOf(maxyhbh) + 1;
            yhCbkxx.setCbkid(strcbkh);//抄表卡ID
            yhCbkxx.setFmzt(FmztEnum.开阀);
            yhCbkxx.setCzryxm(daCustomerAndMeter.getYhCbkxx().getCzryxm());
            yhCbkxx.setCzrybm(daCustomerAndMeter.getYhCbkxx().getCzrybm());
            yhCbkxx.setCzsj(new Date());//操作时间
            //抄表计划
            yyCblr.setYhbh(String.valueOf(maxyhbh));//用户编号
            yyCblr.setCbkh("1");//抄表卡号
            yyCblr.setCbkid(strcbkh);//抄表卡ID

            Map<String, Object> mapcwrq = yhKhjbxxMapper.selectCwrq();//获取财务日期
            String strcwrq = mapcwrq.get("cwrq").toString();//202305
            yyCblr.setCwrq(strcwrq);//财务日期
            yyCblr.setJsbz(JsbzEnum.未算费);//计算标志

            yyCblr.setCbbz(CbbzEnum.未抄表);//未抄表状态
            yyCblr.setShbz(ShbzEnum.未审核);//未审核标志
            yyCblr.setSsgs(daCustomerAndMeter.getYhKhjbxx().getSsgs());//公司
            yyCblr.setSscbpq(daCustomerAndMeter.getYhKhjbxx().getSscbpq());//片区
            yyCblr.setSscbb(daCustomerAndMeter.getYhKhjbxx().getSscbb());//抄表本

            yyCblr.setScds(BigDecimal.valueOf(yhCbkxx.getSbqs()));
            yyCblr.setBcds(BigDecimal.valueOf(yhCbkxx.getSbqs()));

            //用户档案添加执行成功
            if (yhKhjbxxService.save(yhKhjbxx)) {
                //用户水表档案执行功
                if (yhCbkxxService.save(yhCbkxx)) {
                    //执行抄表计划（0普表、1IC卡表、2远传表、3NB表、4流量计）
                    if (daCustomerAndMeter.getYhCbkxx().getSblb().equals("0") || daCustomerAndMeter.getYhCbkxx().getSblb().equals("2") || daCustomerAndMeter.getYhCbkxx().getSblb().equals("3") || daCustomerAndMeter.getYhCbkxx().getSblb().equals("4")) {
                        if (yyCblrService.save(yyCblr)) {
                            if (daCustomerAndMeter.getYhCbkxx().getSblb().equals("2") || daCustomerAndMeter.getYhCbkxx().getSblb().equals("3")) {
                                //执行智能表档案添加
                                if (znbDaLogService.addznbDaLog(yhKhjbxx, yhCbkxx, "0", czyUserDetails)) {
                                    rest.setCode(1);
                                    rest.setMessage("新增用户档案成功");
                                } else {
                                    rest.setCode(-1);
                                    rest.setMessage("新增智能表档案日志信息失败");
                                }
                            } else {
                                rest.setCode(1);
                                rest.setMessage("新增用户档案成功");
                            }
                        } else {
                            rest.setCode(-1);
                            rest.setMessage("新增用户抄表计划失败");
                        }
                    } else {
                        rest.setCode(1);
                        rest.setMessage("新增用户档案成功");
                    }
                } else {
                    rest.setCode(-1);
                    rest.setMessage("新增水表档案失败");
                }
            } else {
                rest.setCode(-1);
                rest.setMessage("新增用户档案失败");
            }

        } else {
            yhKhjbxx.setYhbh(daCustomerAndMeter.getYhKhjbxx().getYhbh());//用户编号
            yhKhjbxx.setYhzt(daCustomerAndMeter.getYhKhjbxx().getYhzt());//用户状态
            yhCbkxx.setIckid(daCustomerAndMeter.getYhCbkxx().getIckid());//iCKID
            yhCbkxx.setYhbh(daCustomerAndMeter.getYhCbkxx().getYhbh());
            yyCblr.setCbkid(daCustomerAndMeter.getYhCbkxx().getCbkid());
            //用户档案修改执行成功
            if (yhKhjbxxService.updateById(yhKhjbxx)) {
                //用户水表档案执行功
                QueryWrapper<YhCbkxx> queryWrapper = new QueryWrapper<>();
                queryWrapper.eq("cbkid", daCustomerAndMeter.getYhCbkxx().getCbkid());
                YhCbkxx oldyhCbkxx = yhCbkxxService.getOne(queryWrapper);
                if (!oldyhCbkxx.getSblb().equals(yhCbkxx.getSblb())) {
                    return ResultRespone.failed("修改水表档案失败，不能修改水表类型！");
                }
                if (yhCbkxxService.update(yhCbkxx, queryWrapper)) {
                    if (yyCblrService.updateById(yyCblr)) {
                        //用户水表档案执行功
                        if (daCustomerAndMeter.getYhCbkxx().getSblb().equals("2") || daCustomerAndMeter.getYhCbkxx().getSblb().equals("3")) {
                            if (znbDaLogService.addznbDaLog(yhKhjbxx, yhCbkxx, "1", czyUserDetails)) {
                                rest.setCode(1);
                                rest.setMessage("操作成功");
                            }
                        }
                        rest.setCode(1);
                        rest.setMessage("操作成功");
                    }
                }
            }
        }

        rest = addDaCustomerAndMeterLog(daCustomerAndMeter, operationType);//操作日志添加
        return rest;

    }

    private ResultRespone<Object> checkYhjbxx_cbkxx(@RequestParam String operationType, DaCustomerAndMeter daCustomerAndMeter) {
        ResultRespone<Object> rest = new ResultRespone<>();
        rest.setCode(1);
        if (StringUtils.isEmpty(operationType)) {
            rest.setCode(-1);
            rest.setMessage("操作类型不能为空");
        }
        if (!operationType.equals("save") && !operationType.equals("saveUpdate")) {
            rest.setCode(-1);
            rest.setMessage("操作类型参数不等于save或saveUpdate");
        }
        if (operationType.equals("save")) {
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSsgs())) {
                rest.setCode(-1);
                rest.setMessage("所属公司不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbpq())) {
                rest.setCode(-1);
                rest.setMessage("片区不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbb())) {
                rest.setCode(-1);
                rest.setMessage("抄表本不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhxm().toString())) {
                rest.setCode(-1);
                rest.setMessage("用户姓名不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhdz().toString())) {
                rest.setCode(-1);
                rest.setMessage("用户地址不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbbh().toString())) {
                rest.setCode(-1);
                rest.setMessage("水表编号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSblb().toString())) {
                rest.setCode(-1);
                rest.setMessage("水表类别不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbsccj().toString())) {
                rest.setCode(-1);
                rest.setMessage("水表厂家不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbsccj())) {
                rest.setCode(-1);
                rest.setMessage("水表型号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbxh())) {
                rest.setCode(-1);
                rest.setMessage("水表口径不能为空");
            }

        }

        return rest;
    }


    /**
     * 用户档案水表档案日志添加
     */
    public ResultRespone<Object> addDaCustomerAndMeterLog(DaCustomerAndMeter daCustomerAndMeter, String operationType) throws Exception {
        ResultRespone<Object> rest = new ResultRespone<>();

        //操作日志记录添加
        // 将源对象的属性值赋值给目标对象的属性值
        //档案操作日志记录
        YhKhjbxxLog daCustomerLog = new YhKhjbxxLog();
        copyProperties(daCustomerAndMeter.getYhKhjbxx(), daCustomerLog);
        daCustomerLog.setLogCzsj(new Date());//操作时间
        daCustomerLog.setCzsj(new Date());//操作时间
        daCustomerLog.setLogCzlx(operationType);//操作类型
        daCustomerLog.setLogCllx(operationType);
        daCustomerLog.setLogCzryxm(daCustomerAndMeter.getYhKhjbxx().getCzryxm());//操作人员
        daCustomerLog.setLogCzrybm(daCustomerAndMeter.getYhKhjbxx().getCzrybm());//操作人员编码
        daCustomerLog.setCzryxm(daCustomerAndMeter.getYhKhjbxx().getCzryxm());
        daCustomerLog.setCzrybm(daCustomerAndMeter.getYhKhjbxx().getCzrybm());//操作人员编码
        daCustomerLog.setLogId(GuidGenerator.getGuid());//id
        //水表档案操作日志记录
        YhCbkxxLog daMeterLog = new YhCbkxxLog();
        copyProperties(daCustomerAndMeter.getYhCbkxx(), daMeterLog);
        daMeterLog.setLogId(GuidGenerator.getGuid());//id
        daMeterLog.setLogCzlx(operationType);
        daMeterLog.setLogCllx(operationType);

        daMeterLog.setLogLsh("");//流水编号
        daMeterLog.setLogCzsj(new Date());//操作时间
        daMeterLog.setLogCzryxm(daCustomerAndMeter.getYhCbkxx().getCzryxm());//操作人员
        daMeterLog.setLogCzrybm(daCustomerAndMeter.getYhCbkxx().getCzrybm());//操作人员编码
        daMeterLog.setBz("");//备注

        if (operationType.equals("save")) {
            daMeterLog.setLogCzlx("添加");
            daMeterLog.setLogCllx("添加后");//修改后
        } else {
            daMeterLog.setLogCzlx("修改");
            daMeterLog.setLogCllx("修改后");//修改后
        }
        if (yhKhjbxxLogService.save(daCustomerLog) && yhCbkxxLogService.save(daMeterLog)) {
            rest.setCode(1);
            rest.setMessage("操作成功");
        } else {
            rest.setCode(-1);
            rest.setMessage("操作失败--日志添加失败");
        }
        return rest;
    }

    public ResultRespone<Object> checkDaCustomerAndMeter(DaCustomerAndMeter daCustomerAndMeter, String operationType) {
        ResultRespone<Object> rest = new ResultRespone<>();
        if (operationType.equals("save") && !operationType.equals("saveUpdate")) {
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSsgs())) {
                rest.setCode(-1);
                rest.setMessage("所属公司不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbpq().toString())) {
                rest.setCode(-1);
                rest.setMessage("片区不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getSscbb().toString())) {
                rest.setCode(-1);
                rest.setMessage("抄表本不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhxm())) {
                rest.setCode(-1);
                rest.setMessage("用户姓名不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhKhjbxx().getYhdz())) {
                rest.setCode(-1);
                rest.setMessage("用户地址不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbbh())) {
                rest.setCode(-1);
                rest.setMessage("水表编号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSblb())) {
                rest.setCode(-1);
                rest.setMessage("水表类别不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbsccj())) {
                rest.setCode(-1);
                rest.setMessage("水表厂家不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbsccj())) {
                rest.setCode(-1);
                rest.setMessage("水表型号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getYhCbkxx().getSbxh())) {
                rest.setCode(-1);
                rest.setMessage("水表口径不能为空");
            }
        }
        return rest;
    }


    /**
     * 修改用户档案
     */
    @ApiOperationSupport(order = 7)
    @ApiOperation(value = "修改")
    @PutMapping
    public ResultRespone<Boolean> update(@RequestBody YhKhjbxxUpdate update,
                                         @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.update(update, czyUserDetails));
    }

    /**
     * 删除用户档案
     */
    @ApiOperationSupport(order = 9)
    @ApiOperation(value = "删除")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "用户编号", required = true, dataType = "String")
    })
    @DeleteMapping("/{yhbh}")
    public ResultRespone<Boolean> delById(@PathVariable String yhbh,
                                          @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.delById(yhbh, czyUserDetails));
    }

    /**
     * 批量删除用户档案
     */
    @ApiOperationSupport(order = 10)
    @ApiOperation(value = "批量删除")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbhs", value = "用户编号，多个以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/delByIds")
    public ResultRespone<Boolean> delByIds(@RequestParam("yhbhs") String yhbhs,
                                           @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.delByIds(Arrays.asList(yhbhs.split(",")), czyUserDetails));
    }

    @ApiOperationSupport(order = 15)
    @GetMapping("/export")
    @ApiOperation(value = "导出用户档案")
    public void export(HttpServletResponse response, @ModelAttribute YhkhjbxxFilter filter) throws IOException {
        List<YhkhjbxxSelect> list = yhKhjbxxService.getList(filter);
        ExcleFileUtil.exportExcel(response, list, YhkhjbxxSelect.class, "用户档案.xlsx");
    }

    /**
     * 查询水表档案
     *
     * @param yhbh id
     * @return ResultRespone
     */
    @ApiOperationSupport(order = 17)
    @GetMapping("/{yhbh}/yhcbkxx")
    @ApiOperation(value = "查询水表档案")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "yhbh", required = true, dataType = "String")
    })
    public ResultRespone<List<YhCbkxxSelect>> getCbkxxById(@PathVariable("yhbh") String yhbh) {
        return ResultRespone.success(yhKhjbxxService.getCbkxxById(yhbh));
    }

    /**
     * 作废用户档案
     */
    @ApiOperationSupport(order = 20)
    @ApiOperation(value = "作废")
    @PutMapping("/{yhbh}/disable")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "yhbh", required = true, dataType = "String")
    })
    public ResultRespone<Boolean> disable(@PathVariable("yhbh") String yhbh,
                                          @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.disable(yhbh, czyUserDetails));
    }

    /**
     * 恢复作废用户档案
     */
    @ApiOperationSupport(order = 21)
    @ApiOperation(value = "恢复作废")
    @PutMapping("/{yhbh}/enable")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "yhbh", value = "yhbh", required = true, dataType = "String")
    })
    public ResultRespone<Boolean> enable(@PathVariable("yhbh") String yhbh,
                                         @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.enable(yhbh, czyUserDetails));
    }

    @ApiOperationSupport(order = 26)
    @ApiOperation(value = "批量配置(撤销)抄表本(册)")
    @PutMapping("/sscbb")
    public ResultRespone<Boolean> update(@RequestBody YhKhjbxxSscbbUpdate update,
                                         @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
        return ResultRespone.success(yhKhjbxxService.updateSscbb(update, czyUserDetails));
    }

    @ApiOperationSupport(order = 27)
    @ApiOperation(value = "智能表档案分页查询")
    @GetMapping("/znbda")
    public ResultRespone<PageResult<ZnbYhdaSelect>> getZnbDaPage(PageDto pageDto, @ModelAttribute ZnbYhdaFilter query) {
        PageResult<ZnbYhdaSelect> pageResult = yhKhjbxxService.getZnbDaPage(pageDto, query);
        return ResultRespone.success(pageResult);
    }
}
