/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.yhgl.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.yhgl.entity.YhKhjbxxLog;
import com.tofly.feesapi.yhgl.service.YhKhjbxxLogService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 用户档案日志记录表
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("api/yhgl/yhkhjbxxlog")
@Api(tags="用户管理-用户档案日志记录表接口")
public class YhKhjbxxLogController {

    private final  YhKhjbxxLogService yhKhjbxxLogService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param yhKhjbxxLog 用户档案日志记录表
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getYhKhjbxxLogPage(Page page, @ModelAttribute YhKhjbxxLog yhKhjbxxLog) {
      return ResultRespone.success(yhKhjbxxLogService.page(page, Wrappers.query(yhKhjbxxLog)));
    }


    /**
     * 通过id查询用户档案日志记录表
     * @param logId id
     * @return ResultRespone
     */
    @GetMapping("/{logId}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "logId", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("logId" ) String logId) {
      return ResultRespone.success(yhKhjbxxLogService.getById(logId));
    }

    /**
     * 新增用户档案日志记录表
     * @param yhKhjbxxLog 用户档案日志记录表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增用户档案日志记录表" )
    @ApiOperation(value = "新增用户档案日志记录表")
    @PostMapping
    public ResultRespone save(@RequestBody YhKhjbxxLog yhKhjbxxLog) {
      return ResultRespone.success(yhKhjbxxLogService.save(yhKhjbxxLog));
    }

    /**
     * 修改用户档案日志记录表
     * @param yhKhjbxxLog 用户档案日志记录表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改用户档案日志记录表" )
    @ApiOperation(value = "修改用户档案日志记录表")
    @PutMapping
    public ResultRespone updateById(@RequestBody YhKhjbxxLog yhKhjbxxLog) {
      return ResultRespone.success(yhKhjbxxLogService.updateById(yhKhjbxxLog));
    }

    /**
     * 通过id删除用户档案日志记录表
     * @param logId id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除用户档案日志记录表" )
    @ApiOperation(value = "通过ID删除用户档案日志记录表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "logId", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{logId}" )
    public ResultRespone removeById(@PathVariable String logId) {
      return ResultRespone.success(yhKhjbxxLogService.removeById(logId));
    }

    /**
     * 通过id批量删除用户档案日志记录表
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除用户档案日志记录表" )
    @ApiOperation(value = "通过ID批量删除用户档案日志记录表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(yhKhjbxxLogService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
