package com.tofly.feesapi.yhgl.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.dto.YyZjzhUpdate;
import com.tofly.feesapi.yhgl.service.IYyZjzhService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.security.core.annotation.AuthenticationPrincipal;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import springfox.documentation.annotations.ApiIgnore;

/**
 * <p>
 * 用户资金账号 前端控制器
 * </p>
 *
 * @author decai
 * @since 2024-03-11
 */
@AllArgsConstructor
@RestController
@RequestMapping("/api/yhgl/yyZjzh")
@Api(tags = "用户资金账号")
public class YyZjzhController {

    private final IYyZjzhService zjzhService;

    @ApiOperation(value = "余额转存", tags = "余额转存")
    @PutMapping
    public ResultRespone<Boolean> update(@RequestBody YyZjzhUpdate update,
                                             @ApiIgnore @AuthenticationPrincipal CzyUserDetails czyUserDetails) {
      return ResultRespone.success(zjzhService.xgyck(update, czyUserDetails));
    }

}
