/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.feesapi.yhgl.controller_easy;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.feesapi.common.dbhelper.DbHelper;
import com.tofly.feesapi.common.util.DateUtils;
import com.tofly.feesapi.common.util.SqlConvertor;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.text.MessageFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.Map;

/**
 * 总分表关系
 *
 * @author admin
 * @date Tue Jul 04 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/userprofilemgt/dacustomerffgx")
@Api(tags = "用户管理-付费关系接口(easy)")
public class BwMeterFfgxEasyController {

    /**
     * 新增总分表关系
     *
     * @param data 请求参数
     * @return
     */
    @ToFlyAppLog(title = "新增付费关系(批量)")
    @ApiOperation(value = "新增付费关系(批量)")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "yhbhZb", value = "用户编号-主户", required = true, dataType = "String"),
//            @ApiImplicitParam(name = "yhbhFbList", value = "用户编号-分户（逗号分割列表）", required = true, dataType = "String"),
//            @ApiImplicitParam(name = "czrybm", value = "操作人员编码", required = true, dataType = "String"),
//            @ApiImplicitParam(name = "czryxm", value = "操作人员姓名", required = true, dataType = "String"),
//            @ApiImplicitParam(name = "czsj", value = "操作时间", required = true, dataType = "String(date-time)")
//    })
    @PostMapping("/saveBatch")
    public ResultRespone saveBatch(@RequestBody Map<String, Object> data) throws Exception {
        //region 参数解析
        String customerNoZb = "";
        String customerNoFbList = "";
        String operatorCode = "";
        String operatorName = "";
        String operatorDatetime = "";
        try {
            customerNoZb = data.get("yhbhZb").toString();
            customerNoFbList = data.get("yhbhFbList").toString();
            if (data.get("czrybm") != null) operatorCode = data.get("czrybm").toString();
            if (data.get("czryxm") != null) operatorName = data.get("czryxm").toString();
            if (data.get("czsj") != null) {
                operatorDatetime = data.get("czsj").toString();
            } else {
                operatorDatetime = DateUtils.formatDate_pattern(new Date(), "yyyy-MM-dd HH:mm:ss");
            }
        } catch (Exception e) {
            e.printStackTrace();
            return ResultRespone.failed(e.getMessage());
        }
        //endregion

        //region 业务处理
        //验证
        if (StringUtils.isBlank(customerNoZb)) {
            return ResultRespone.failed("主户用户编号不能为空！");
        }
        if (StringUtils.isBlank(customerNoFbList)) {
            return ResultRespone.failed("分户用户编号数量不能为0！");
        }
        if (Arrays.asList(customerNoFbList.split(",")).contains(customerNoZb)) {
            return ResultRespone.failed("用户编号错误：选择的分户用户中包含了主户用户！");
        }
        //处理
        DbHelper db = DbHelper.getDbHelper();
        String strSql = MessageFormat.format("delete from yh_ffgx where yhbh_fb in(''{0}'')", customerNoFbList.replace(",", "','"));
        db.addTransactionSql(strSql);
        strSql = "insert into yh_ffgx select sys_guid(),yhbh_zb,yhbh_fb,cbkid_id_zb,cbkid_id_fb,'{2}','{3}',{4} from (\n" +
                "  select '1' k, yhbh as yhbh_zb,null as cbkid_id_zb from yh_khjbxx where yhbh='{0}'\n" +
                ") zb inner join (\n" +
                "  select '1' k, yhbh as yhbh_fb,null as cbkid_id_fb from yh_khjbxx where yhbh in('{1}')\n" +
                ") fb on(zb.k=fb.k)";
        strSql = MessageFormat.format(strSql.replace("'", "''"), customerNoZb, customerNoFbList.replace(",", "','"), operatorCode, operatorName, SqlConvertor.toDate(operatorDatetime));
        db.addTransactionSql(strSql);

        boolean result = db.executeTransaction();
        if (!result) {
            return ResultRespone.failed("数据处理失败！");
        }
        //endregion

        //region 成功返回
        return ResultRespone.success(result);
        //endregion
    }
}
