package com.tofly.feesapi.yhgl.entity;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.YhztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.apache.ibatis.type.JdbcType;
import org.springframework.format.annotation.DateTimeFormat;

/**
 * <p>
 * 用户基本信息
 * </p>
 *
 * @author decai
 * @since 2024-01-12
 */
@Getter
@Setter
@TableName("YH_KHJBXX")
@ApiModel(value = "YhKhjbxx对象", description = "用户基本信息")
public class YhKhjbxx implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户编号")
    @TableId(type = IdType.INPUT)
    private String yhbh;

    @ApiModelProperty("原用户号")
    private String ykhbh;

    @ApiModelProperty("所属公司")
    //@TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String ssgs;

    @ApiModelProperty("所属抄表片区")
    //@TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String sscbpq;

    @ApiModelProperty("所属抄表本")
    //@TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String sscbb;

    @ApiModelProperty("申请日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date sqrq;

    @ApiModelProperty("用户姓名")
    private String yhxm;

    @ApiModelProperty("用户地址")
    private String yhdz;

    @ApiModelProperty("联系电话")
    private String lxdh;

    @ApiModelProperty("用户数")
    private Long rks;

    @ApiModelProperty("性别（1男，2女，3未知）[sys_child_code,pcid='9']")
    private String xb;

    @ApiModelProperty("手机")
    private String sj;

    @ApiModelProperty("住宅电话")
    private String zzdh;

    @ApiModelProperty("工作单位")
    private String gzdw;

    @ApiModelProperty("办公电话")
    private String bgdh;

    @ApiModelProperty("电子邮箱")
    private String dzyx;

    @ApiModelProperty("证件类别(sys_child_code,pcid='10')")
    private String zjlb;

    @ApiModelProperty("证件号码")
    private String zjhm;

    @ApiModelProperty("与户主关系")
    private String hzgx;

    @ApiModelProperty("用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）")
    private YhztEnum yhzt;


    @ApiModelProperty("重视级别")
    private String zsjb;

    @ApiModelProperty("建档日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date jdrq;

    @ApiModelProperty("通水标志（0：未开通，1：已开通）")
    private String tsbz;

    @ApiModelProperty("通水日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date tsrq;

    @ApiModelProperty("合同签订")
    private String htqd;

    @ApiModelProperty("合同签订日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date htqdrq;

    @ApiModelProperty("合同编号")
    private String htbh;

    @ApiModelProperty("备注")
    private String bz;

    @ApiModelProperty("报装_工程编号")
    private String bzGcbh;

    @ApiModelProperty("报装_批次序列号")
    private String bzPcxlh;

    @ApiModelProperty("操作人员编码")
    private String czrybm;

    @ApiModelProperty("操作人员姓名")
    private String czryxm;

    @ApiModelProperty("操作时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date czsj;

    @ApiModelProperty("身份证图片")
    private String psfz;

    @ApiModelProperty("合同图片")
    private String pht;

    @ApiModelProperty("工商执照图片")
    private String pgszz;

    @ApiModelProperty("房产证图片")
    private String pfcz;

    @ApiModelProperty("营业执照图片")
    private String pyyzz;

    @ApiModelProperty("有效证件图片")
    private String pyxzj;

    @ApiModelProperty("信用等级（sys_child_code,pcid='20'）")
    private String xydj;

    @ApiModelProperty("是否特困户（1是，0否）")
    private String tkhbz;

    @ApiModelProperty("职位")
    private String zw;

    @ApiModelProperty("建档人员编码")
    private String jdrybm;

    @ApiModelProperty("建档人员姓名")
    private String jdryxm;

    @ApiModelProperty("建档批次序列号")
    private String jdpcxlh;

    @ApiModelProperty("发票类型;0普票，1 专票，2 手册，3 未知")
    private String fplx;

    @ApiModelProperty("是否取整")
    private String sfqz;

    @ApiModelProperty("抄表人员姓名")
    private String cbryxm;

    private Short xh;

    @ApiModelProperty("所属行政规划")
    private String ssregion;

    @ApiModelProperty("修改人员")
    private String xgrybm;

    @ApiModelProperty("发票开具姓名")
    private String fpName;

    @ApiModelProperty("发票开具纳税人识别号")
    private String fpNsrsbh;

    @ApiModelProperty("发票开具地址")
    private String fpDz;

    @ApiModelProperty("发票开具联系电话")
    private String fpLxdh;

    @ApiModelProperty("发票开具开户行")
    private String fpBankname;

    @ApiModelProperty("发票开具银行账号")
    private String fpBankcode;

    @ApiModelProperty("发票开具备注")
    private String fpBz;

    private String fpKind;

    @ApiModelProperty("收费方式")
    private String fffs;

    @ApiModelProperty("年度累计量")
    private BigDecimal jtzqljl;

    @ApiModelProperty("客户类型（弱势群体，残疾，正常，低保，企业，服务）")
    private String khlb;

    @ApiModelProperty("拼音简码")
    private String pyjm;

    @ApiModelProperty("月累积量")
    private BigDecimal yljl;

    @ApiModelProperty("水表数量")
    private Integer sbsl;

    public static final String YHBH = "YHBH";

    public static final String YKHBH = "YKHBH";

    public static final String SSGS = "SSGS";

    public static final String SSCBPQ = "SSCBPQ";

    public static final String SSCBB = "SSCBB";

    public static final String SQRQ = "SQRQ";

    public static final String YHXM = "YHXM";

    public static final String YHDZ = "YHDZ";

    public static final String LXDH = "LXDH";

    public static final String RKS = "RKS";

    public static final String XB = "XB";

    public static final String SJ = "SJ";

    public static final String ZZDH = "ZZDH";

    public static final String GZDW = "GZDW";

    public static final String BGDH = "BGDH";

    public static final String DZYX = "DZYX";

    public static final String ZJLB = "ZJLB";

    public static final String ZJHM = "ZJHM";

    public static final String HZGX = "HZGX";

    public static final String YHZT = "YHZT";

    public static final String ZSJB = "ZSJB";

    public static final String JDRQ = "JDRQ";

    public static final String TSBZ = "TSBZ";

    public static final String TSRQ = "TSRQ";

    public static final String HTQD = "HTQD";

    public static final String HTQDRQ = "HTQDRQ";

    public static final String HTBH = "HTBH";

    public static final String BZ = "BZ";

    public static final String BZ_GCBH = "BZ_GCBH";

    public static final String BZ_PCXLH = "BZ_PCXLH";

    public static final String CZRYBM = "CZRYBM";

    public static final String CZRYXM = "CZRYXM";

    public static final String CZSJ = "CZSJ";

    public static final String PSFZ = "PSFZ";

    public static final String PHT = "PHT";

    public static final String PGSZZ = "PGSZZ";

    public static final String PFCZ = "PFCZ";

    public static final String PYYZZ = "PYYZZ";

    public static final String PYXZJ = "PYXZJ";

    public static final String XYDJ = "XYDJ";

    public static final String TKHBZ = "TKHBZ";

    public static final String ZW = "ZW";

    public static final String JDRYBM = "JDRYBM";

    public static final String JDRYXM = "JDRYXM";

    public static final String JDPCXLH = "JDPCXLH";

    public static final String FPLX = "FPLX";

    public static final String SFQZ = "SFQZ";

    public static final String CBRYXM = "CBRYXM";

    public static final String XH = "XH";

    public static final String SSREGION = "SSREGION";

    public static final String XGRYBM = "XGRYBM";

    public static final String FP_NAME = "FP_NAME";

    public static final String FP_NSRSBH = "FP_NSRSBH";

    public static final String FP_DZ = "FP_DZ";

    public static final String FP_LXDH = "FP_LXDH";

    public static final String FP_BANKNAME = "FP_BANKNAME";

    public static final String FP_BANKCODE = "FP_BANKCODE";

    public static final String FP_BZ = "FP_BZ";

    public static final String FP_KIND = "FP_KIND";

    public static final String FFFS = "FFFS";

    public static final String JTZQLJL = "JTZQLJL";

    public static final String KHLB = "KHLB";

    public static final String PYJM = "PYJM";

    public static final String YLJL = "YLJL";

    public static final String SBSL = "SBSL";
}
