/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.yhgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.tofly.feesapi.common.constant.YhztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 用户档案日志记录表
 *
 * @author sxb
 * @date Tue Aug 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "YH_KHJBXX_LOG", resultMap = "yhKhjbxxLogMap")
@KeySequence("YH_KHJBXX_LOG")
@ApiModel
public class YhKhjbxxLog extends Model<YhKhjbxxLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 日志ID
     */
    @TableId(value = "LOG_ID", type = IdType.INPUT)
    @ApiModelProperty(value = "日志ID")
    private String logId;
    /**
     * 日志流水编号
     */
    @ApiModelProperty(value = "日志流水编号")
    private String logLsh;
    /**
     * 日志操作人员编码
     */
    @ApiModelProperty(value = "日志操作人员编码")
    private String logCzrybm;
    /**
     * 日志操作人员姓名
     */
    @ApiModelProperty(value = "日志操作人员姓名")
    private String logCzryxm;
    /**
     * 日志操作时间
     */
    @ApiModelProperty(value = "日志操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date logCzsj;
    /**
     * 操作类型：增加、修改、删除、作废
     */
    @ApiModelProperty(value = "操作类型：增加、修改、删除、作废")
    private String logCzlx;
    /**
     * 处理类型：增加后、修改前、修改后、删除前、作废前、作废后
     */
    @ApiModelProperty(value = "处理类型：增加后、修改前、修改后、删除前、作废前、作废后")
    private String logCllx;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String logBz;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 原用户号
     */
    @ApiModelProperty(value = "原用户号")
    private String ykhbh;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    private String sscbpq;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private String sscbb;
    /**
     * 申请日期
     */
    @ApiModelProperty(value = "申请日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDate sqrq;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 用户数
     */
    @ApiModelProperty(value = "用户数")
    private Long rks;
    /**
     * 性别（1男，2女，3未知）[sys_child_code,pcid='9']
     */
    @ApiModelProperty(value = "性别（1男，2女，3未知）[sys_child_code,pcid='9']")
    private String xb;
    /**
     * 手机
     */
    @ApiModelProperty(value = "手机")
    private String sj;
    /**
     * 住宅电话
     */
    @ApiModelProperty(value = "住宅电话")
    private String zzdh;
    /**
     * 工作单位
     */
    @ApiModelProperty(value = "工作单位")
    private String gzdw;
    /**
     * 办公电话
     */
    @ApiModelProperty(value = "办公电话")
    private String bgdh;
    /**
     * 电子邮箱
     */
    @ApiModelProperty(value = "电子邮箱")
    private String dzyx;
    /**
     * 证件类别(sys_child_code,pcid='10')
     */
    @ApiModelProperty(value = "证件类别(sys_child_code,pcid='10')")
    private String zjlb;
    /**
     * 证件号码
     */
    @ApiModelProperty(value = "证件号码")
    private String zjhm;
    /**
     * 与户主关系
     */
    @ApiModelProperty(value = "与户主关系")
    private String hzgx;
    /**
     * 用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
     */
    @ApiModelProperty(value = "用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）")
    private YhztEnum yhzt;
    /**
     * 重视级别
     */
    @ApiModelProperty(value = "重视级别")
    private String zsjb;
    /**
     * 建档日期
     */
    @ApiModelProperty(value = "建档日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDate jdrq;
    /**
     * 通水标志（0：未开通，1：已开通）
     */
    @ApiModelProperty(value = "通水标志（0：未开通，1：已开通）")
    private String tsbz;
    /**
     * 通水日期
     */
    @ApiModelProperty(value = "通水日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDate tsrq;
    /**
     * 合同签订
     */
    @ApiModelProperty(value = "合同签订")
    private String htqd;
    /**
     * 合同签订日期
     */
    @ApiModelProperty(value = "合同签订日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date htqdrq;
    /**
     * 合同编号
     */
    @ApiModelProperty(value = "合同编号")
    private String htbh;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 报装_工程编号
     */
    @ApiModelProperty(value = "报装_工程编号")
    private String bzGcbh;
    /**
     * 报装_批次序列号
     */
    @ApiModelProperty(value = "报装_批次序列号")
    private String bzPcxlh;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String czrybm;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String czryxm;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czsj;
    /**
     * 身份证图片
     */
    @ApiModelProperty(value = "身份证图片")
    private String psfz;
    /**
     * 合同图片
     */
    @ApiModelProperty(value = "合同图片")
    private String pht;
    /**
     * 工商执照图片
     */
    @ApiModelProperty(value = "工商执照图片")
    private String pgszz;
    /**
     * 房产证图片
     */
    @ApiModelProperty(value = "房产证图片")
    private String pfcz;
    /**
     * 营业执照图片
     */
    @ApiModelProperty(value = "营业执照图片")
    private String pyyzz;
    /**
     * 有效证件图片
     */
    @ApiModelProperty(value = "有效证件图片")
    private String pyxzj;
    /**
     * 信用等级（sys_child_code,pcid='20'）
     */
    @ApiModelProperty(value = "信用等级（sys_child_code,pcid='20'）")
    private String xydj;
    /**
     * 是否特困户（1是，0否）
     */
    @ApiModelProperty(value = "是否特困户（1是，0否）")
    private String tkhbz;
    /**
     * 职位
     */
    @ApiModelProperty(value = "职位")
    private String zw;
    /**
     * 建档人员编码
     */
    @ApiModelProperty(value = "建档人员编码")
    private String jdrybm;
    /**
     * 建档人员姓名
     */
    @ApiModelProperty(value = "建档人员姓名")
    private String jdryxm;
    /**
     * 建档批次序列号
     */
    @ApiModelProperty(value = "建档批次序列号")
    private String jdpcxlh;
    /**
     * 发票类型;0普票，1 专票，2 手册，3 未知
     */
    @ApiModelProperty(value = "发票类型;0普票，1 专票，2 手册，3 未知")
    private String fplx;
    /**
     * 是否取整
     */
    @ApiModelProperty(value = "是否取整")
    private String sfqz;
    /**
     * 抄表人员姓名
     */
    @ApiModelProperty(value = "抄表人员姓名")
    private String cbryxm;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private BigDecimal xh;
    /**
     * 所属行政规划
     */
    @ApiModelProperty(value = "所属行政规划")
    private String ssregion;
    /**
     * 修改人员
     */
    @ApiModelProperty(value = "修改人员")
    private String xgrybm;
    /**
     * 发票开具姓名
     */
    @ApiModelProperty(value = "发票开具姓名")
    private String fpName;
    /**
     * 发票开具纳税人识别号
     */
    @ApiModelProperty(value = "发票开具纳税人识别号")
    private String fpNsrsbh;
    /**
     * 发票开具地址
     */
    @ApiModelProperty(value = "发票开具地址")
    private String fpDz;
    /**
     * 发票开具联系电话
     */
    @ApiModelProperty(value = "发票开具联系电话")
    private String fpLxdh;
    /**
     * 发票开具开户行
     */
    @ApiModelProperty(value = "发票开具开户行")
    private String fpBankname;
    /**
     * 发票开具银行账号
     */
    @ApiModelProperty(value = "发票开具银行账号")
    private String fpBankcode;
    /**
     * 发票开具备注
     */
    @ApiModelProperty(value = "发票开具备注")
    private String fpBz;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String fpKind;
    /**
     * 收费方式
     */
    @ApiModelProperty(value = "收费方式")
    private String fffs;
    /**
     * 年度累计量
     */
    @ApiModelProperty(value = "年度累计量")
    private BigDecimal jtzqljl;
    /**
     * 客户类别
     */
    @ApiModelProperty(value = "客户类别")
    private String khlb;
    /**
     * 拼音简码
     */
    @ApiModelProperty(value = "拼音简码")
    private String pyjm;
    /**
     * 月累积量
     */
    @ApiModelProperty(value = "月累积量")
    private BigDecimal yljl;
    /**
     * 水表数量
     */
    @ApiModelProperty(value = "水表数量")
    private BigDecimal sbsl;

}
