package com.tofly.feesapi.yhgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.YhztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.ibatis.type.JdbcType;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

@Data
@TableName("YH_KHJBXX")
@ApiModel(value = "YhKhjbxx对象", description = "用户基本信息")
public class Yhkhjbxx2 implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户编号")
    @TableId(type = IdType.INPUT)
    private String yhbh;

    @ApiModelProperty("原用户号")
    private String ykhbh;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("所属抄表片区编码")
    private String sscbpq;

    @ApiModelProperty("所属抄表片区")
    private String sscbpqmc;

    @ApiModelProperty("所属抄表本编码")
    private String sscbb;

    @ApiModelProperty("所属抄表本")
    private String sscbbmc;

    @ApiModelProperty("申请日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date sqrq;

    @ApiModelProperty("用户姓名")
    private String yhxm;

    @ApiModelProperty("用户地址")
    private String yhdz;

    @ApiModelProperty("联系电话")
    private String lxdh;

    @ApiModelProperty("用户数")
    private Long rks;

    @ApiModelProperty("性别（1男，2女，3未知）[sys_child_code,pcid='9']")
    private String xb;

    @ApiModelProperty("手机")
    private String sj;

    @ApiModelProperty("住宅电话")
    private String zzdh;

    @ApiModelProperty("工作单位")
    private String gzdw;

    @ApiModelProperty("办公电话")
    private String bgdh;

    @ApiModelProperty("电子邮箱")
    private String dzyx;

    @ApiModelProperty("证件类别(sys_child_code,pcid='10')")
    private String zjlb;

    @ApiModelProperty("证件号码")
    private String zjhm;

    @ApiModelProperty("与户主关系")
    private String hzgx;

    @ApiModelProperty("用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）")
    private YhztEnum yhzt;


    @ApiModelProperty("重视级别")
    private String zsjb;

    @ApiModelProperty("建档日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date jdrq;

    @ApiModelProperty("通水标志（0：未开通，1：已开通）")
    private String tsbz;

    @ApiModelProperty("通水日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date tsrq;

    @ApiModelProperty("合同签订")
    private String htqd;

    @ApiModelProperty("合同签订日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date htqdrq;

    @ApiModelProperty("合同编号")
    private String htbh;

    @ApiModelProperty("备注")
    private String bz;

    @ApiModelProperty("报装_工程编号")
    private String bzGcbh;

    @ApiModelProperty("报装_批次序列号")
    private String bzPcxlh;

    @ApiModelProperty("操作人员编码")
    private String czrybm;

    @ApiModelProperty("操作人员姓名")
    private String czryxm;

    @ApiModelProperty("操作时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date czsj;

    @ApiModelProperty("身份证图片")
    private String psfz;

    @ApiModelProperty("合同图片")
    private String pht;

    @ApiModelProperty("工商执照图片")
    private String pgszz;

    @ApiModelProperty("房产证图片")
    private String pfcz;

    @ApiModelProperty("营业执照图片")
    private String pyyzz;

    @ApiModelProperty("有效证件图片")
    private String pyxzj;

    @ApiModelProperty("信用等级（sys_child_code,pcid='20'）")
    private String xydj;

    @ApiModelProperty("是否特困户（1是，0否）")
    private String tkhbz;

    @ApiModelProperty("职位")
    private String zw;

    @ApiModelProperty("建档人员编码")
    private String jdrybm;

    @ApiModelProperty("建档人员姓名")
    private String jdryxm;

    @ApiModelProperty("建档批次序列号")
    private String jdpcxlh;

    @ApiModelProperty("发票类型;0普票，1 专票，2 手册，3 未知")
    private String fplx;

    @ApiModelProperty("是否取整")
    private String sfqz;

    @ApiModelProperty("抄表人员姓名")
    private String cbryxm;

    private Short xh;

    @ApiModelProperty("所属行政规划")
    private String ssregion;

    @ApiModelProperty("修改人员")
    private String xgrybm;

    @ApiModelProperty("发票开具姓名")
    private String fpName;

    @ApiModelProperty("发票开具纳税人识别号")
    private String fpNsrsbh;

    @ApiModelProperty("发票开具地址")
    private String fpDz;

    @ApiModelProperty("发票开具联系电话")
    private String fpLxdh;

    @ApiModelProperty("发票开具开户行")
    private String fpBankname;

    @ApiModelProperty("发票开具银行账号")
    private String fpBankcode;

    @ApiModelProperty("发票开具备注")
    private String fpBz;

    private String fpKind;

    @ApiModelProperty("收费方式")
    private String fffs;

    @ApiModelProperty("年度累计量")
    private Short jtzqljl;

    @ApiModelProperty("客户类型（弱势群体，残疾，正常，低保，企业，服务）")
    private String khlb;

    @ApiModelProperty("拼音简码")
    private String pyjm;

    @ApiModelProperty("月累积量")
    private Short yljl;

    @ApiModelProperty("水表数量")
    private Short sbsl;
}
