package com.tofly.feesapi.yhgl.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * <p>
 * 用户资金账号
 * </p>
 *
 * @author decai
 * @since 2024-03-11
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("YY_ZJZH")
@KeySequence("YY_ZJZH")
@ApiModel(value = "YyZjzh对象", description = "用户资金账号")
public class YyZjzh extends Model<YyZjzh> {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用户编号")
    @TableId(value = "YHBH")
    private String yhbh;

    @ApiModelProperty("预付金额")
    private BigDecimal yfje = BigDecimal.ZERO;

    @ApiModelProperty("扣减金额")
    private BigDecimal kjje = BigDecimal.ZERO;

    @ApiModelProperty("剩余金额")
    private BigDecimal syje = BigDecimal.ZERO;

    @ApiModelProperty("智能表剩余金额")
    private BigDecimal nbsyje = BigDecimal.ZERO;

    public static final String YHBH = "YHBH";

    public static final String YFJE = "YFJE";

    public static final String KJJE = "KJJE";

    public static final String SYJE = "SYJE";

    public static final String NBSYJE = "NBSYJE";
}
