package com.tofly.feesapi.yhgl.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.feesapi.common.constant.YhztEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.time.LocalDateTime;


/**
 * 用户档案
 */
@Data
@ApiModel("用户档案更新DTO")
public class YhKhjbxxUpdate {

    @ApiModelProperty(value = "用户编号", required = true, position = 1, example = "61006501")
    private String yhbh;

//    @ApiModelProperty("原用户号")
//    private String ykhbh;

    @ApiModelProperty(value = "所属公司编码", required = true, position = 2, example = "1")
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区编码", position = 3, example = "1")
    private String sscbpq;

    @ApiModelProperty(value = "所属抄表本编码", required = true, position = 4, example = "1")
    private String sscbb;

    @ApiModelProperty(value = "申请日期(yyyy-MM-dd)", position = 5, example = "2024-02-02")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate sqrq;

    @ApiModelProperty(value = "建档日期(yyyy-MM-dd)", position = 5, example = "2024-02-02")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private LocalDate jdrq;

    @ApiModelProperty(value = "用户姓名", required = true, position = 6, example = "张三")
    private String yhxm;

    @ApiModelProperty(value = "用户地址", required = true, position = 7, example = "xx小区x栋")
    private String yhdz;

    @ApiModelProperty(value = "联系电话", position = 8, example = "13925426572")
    private String lxdh;

    @ApiModelProperty(value = "性别编码", position = 9, example = "1")
    private String xb;

    @ApiModelProperty(value = "证件类别编码", position = 10, example = "1")
    private String zjlb;

    @ApiModelProperty(value = "证件号码", position = 11, example = "520606201405082758")
    private String zjhm;

    @ApiModelProperty(value = "用户状态", position = 12, example = "申请用户")
    private YhztEnum yhzt = YhztEnum.正式用户;

    @ApiModelProperty(value = "是否特困户（1是，0否）", position = 13, example = "1")
    private String tkhbz = "0";

    @ApiModelProperty(value = "发票类型 0普票1专票", position = 14, example = "0")
    private String fplx = "0";

    @ApiModelProperty(value = "是否取整（1是，0否）", position = 15, example = "0")
    private String sfqz = "0";

    @ApiModelProperty(value = "发票开具纳税人识别号", position = 16, example = "25452557558")
    private String fpNsrsbh;

    @ApiModelProperty(value = "发票开具地址", position = 17, example = "xx市xx区xxx街道xx号")
    private String fpDz;

    @ApiModelProperty(value = "备注", position = 30, example = "备注")
    private String bz;

    @ApiModelProperty(value = "操作人员编码", position = 31, example = "223")
    private String czrybm;

    @ApiModelProperty(value = "操作人员姓名", position = 31, example = "李四")
    private String czryxm;

    @ApiModelProperty(value = "操作时间(yyyy-MM-dd HH:mm:ss)", position = 32, example = "2024-02-06 13:37:13")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime czsj;

}
