package com.tofly.feesapi.yhgl.entity.dto;

import com.tofly.feesapi.common.constant.YhztEnum;
import com.tofly.feesapi.common.entity.dto.SortDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;

@Data
@ApiModel("用户档案查询参数DTO")
public class YhkhjbxxFilter extends SortDto {

    @ApiModelProperty("关键字(用户编号、用户姓名、用户地址、联系电话)")
    private String searchText;

    @ApiModelProperty(value = "所属公司编码")
    private String ssgs;

    @ApiModelProperty(value = "所属抄表片区编码")
    private String sscbpq;

    @ApiModelProperty("所属抄表本(册)编码")
    private String sscbb;

    @ApiModelProperty("水表类别编码")
    private String sblb;

    @ApiModelProperty("用水类型编码")
    private String yslx;

    @ApiModelProperty("用户状态")
    private YhztEnum yhzt;

    @ApiModelProperty("垃圾费标志（1是，0否）")
    private String ljfbz;

    @ApiModelProperty("建档开始日期(yyyy-MM-dd)")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate jdrqStart;

    @ApiModelProperty("建档截止日期(yyyy-MM-dd)")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate jdrqEnd;

    @ApiModelProperty("抄表人员")
    private String cby;

    @ApiModelProperty(value = "用户姓名")
    private String yhxm;

    @ApiModelProperty("用户编号")
    private String yhbh;

    @ApiModelProperty(value = "用户地址")
    private String yhdz;

    @ApiModelProperty(value = "联系电话")
    private String lxdh;

    @ApiModelProperty("是否分配抄表本(册),已分配:true,未分配:false")
    private Boolean sffpcbb;
}
