package com.tofly.feesapi.yhgl.entity.vo;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author lihaoli
 * @date 2024/6/20
 */
@Data
@ApiModel("用户报停日志Vo")
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class YhBtLogSelect {
    /**
     * 编号
     */
    @ColumnWidth(30)
    @ExcelProperty("编号")
    @ExcelIgnore
    @TableId(value = "BH", type = IdType.INPUT)
    @ApiModelProperty(value = "编号")
    private String bh;
    /**
     * 所属公司编码
     */
    @ColumnWidth(30)
    @ExcelProperty("所属公司编码")
    @ExcelIgnore
    @ApiModelProperty(value = "所属公司编码")
    private String ssgs;

    /**
     * 所属公司
     */
    @ColumnWidth(30)
    @ExcelProperty("所属公司")
    @ExcelIgnore
    @ApiModelProperty(value = "所属公司")
    private String ssgsname;
    /**
     * 所属抄表片区编码
     */
    @ColumnWidth(30)
    @ExcelProperty("所属抄表片区编码")
    @ExcelIgnore
    @ApiModelProperty(value = "所属抄表片区编码")
    private String sscbpq;

    /**
     * 所属抄表片区
     */
    @ColumnWidth(30)
    @ExcelProperty("所属抄表片区")
    @ExcelIgnore
    @ApiModelProperty(value = "所属抄表片区")
    private String sscbpqname;
    /**
     * 所属表册编码
     */
    @ColumnWidth(30)
    @ExcelProperty("所属表册编码")
    @ApiModelProperty(value = "所属表册编码")
    private String sscbb;

    /**
     * 所属抄表本
     */
    @ColumnWidth(30)
    @ExcelProperty("所属表册")
    @ApiModelProperty(value = "所属表册")
    private String sscbbname;

    /**
     * 用户编号
     */
    @ColumnWidth(30)
    @ExcelProperty("用户编号")
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 报停人员姓名
     */
    @ColumnWidth(30)
    @ExcelProperty("用户姓名")
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ColumnWidth(30)
    @ExcelProperty("用户地址")
    @ApiModelProperty(value = "用户地址")
    private String yhdz;

    /**
     * 报停申请人员
     */
    @ColumnWidth(30)
    @ExcelProperty("申请人员")
    @ApiModelProperty(value = "申请人员")
    private String btsqr;
    /**
     * 报停电话
     */
    @ColumnWidth(30)
    @ExcelProperty("申请电话")
    @ApiModelProperty(value = "申请电话")
    private String btdh;
    /**
     * 备注说明
     */
    @ColumnWidth(30)
    @ExcelProperty("备注")
    @ApiModelProperty(value = "备注")
    private String bz;
    /**
     * 操作时间
     */
    @ColumnWidth(30)
    @ExcelProperty("操作时间")
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czrq;
    /**
     * 操作人员姓名
     */
    @ColumnWidth(30)
    @ExcelProperty("操作人员姓名")
    @ApiModelProperty(value = "操作人员姓名")
    private String czryxm;
    /**
     * 操作人员编码
     */
    @ColumnWidth(30)
    @ExcelProperty("操作人员编码")
    @ExcelIgnore
    @ApiModelProperty(value = "操作人员编码")
    private String czrybm;
    /**
     * 报停时间
     */
    @ColumnWidth(30)
    @ExcelProperty("报停时间")
    @ApiModelProperty(value = "报停时间")
    @ExcelIgnore
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date btsj;


    /**
     * 恢复用水标志（默认为0,1是已恢复）
     */
    @ColumnWidth(30)
    @ExcelProperty("恢复用水标志")
    @ExcelIgnore
    @ApiModelProperty(value = "恢复用水标志（默认为0,1是已恢复）")
    private String hfysbz;
    /**
     * 恢复报停时间
     */
    @ColumnWidth(30)
    @ExcelProperty("恢复报停时间")
    @ExcelIgnore
    @ApiModelProperty(value = "恢复报停时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date hfbtsj;

}
