package com.tofly.feesapi.yhgl.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.bjgl.entity.vo.YhCbkxxSelect;
import com.tofly.feesapi.bjgl.service.YhCbkxxService;
import com.tofly.feesapi.bmgl.entity.BmCbb;
import com.tofly.feesapi.bmgl.entity.BmCbpq;
import com.tofly.feesapi.bmgl.service.BmCbbService;
import com.tofly.feesapi.bmgl.service.BmCbpqService;
import com.tofly.feesapi.cbgl.entity.YyCblr;
import com.tofly.feesapi.cbgl.service.IZnbCbLogService;
import com.tofly.feesapi.cbgl.service.YyCblrService;
import com.tofly.feesapi.common.constant.YhztEnum;
import com.tofly.feesapi.common.entity.dto.PageDto;
import com.tofly.feesapi.common.entity.vo.PageResult;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.common.util.GuidGenerator;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.yhgl.entity.YhKhjbxx;
import com.tofly.feesapi.yhgl.entity.YhKhjbxxLog;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxInsert;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxSscbbUpdate;
import com.tofly.feesapi.yhgl.entity.dto.YhKhjbxxUpdate;
import com.tofly.feesapi.yhgl.entity.dto.YhkhjbxxFilter;
import com.tofly.feesapi.yhgl.entity.vo.YhKhjbxxView;
import com.tofly.feesapi.yhgl.entity.vo.YhkhjbxxSelect;
import com.tofly.feesapi.yhgl.entity.vo.YhkhjbxxSelect2;
import com.tofly.feesapi.yhgl.mapper.YhKhjbxxMapper;
import com.tofly.feesapi.yhgl.service.YhKhjbxxLogService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import com.tofly.feesapi.znbgl.entity.dto.ZnbYhdaFilter;
import com.tofly.feesapi.znbgl.entity.vo.ZnbYhdaSelect;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.temporal.TemporalAdjusters;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 用户档案
 */
@Service("yhKhjbxxService")
public class YhKhjbxxServiceImpl extends ServiceImpl<YhKhjbxxMapper, YhKhjbxx> implements YhKhjbxxService {
    @Autowired
    private YhCbkxxService yhCbkxxService;

    @Autowired
    private YhKhjbxxLogService yhKhjbxxLogService;

    @Autowired
    private BmCbpqService cbpqService;
    @Autowired
    private BmCbbService cbbService;

    @Autowired
    private IZnbCbLogService znbCbLogService;
    @Autowired
    private YyCblrService yyCblrService;

    @Override
    public PageResult<YhkhjbxxSelect> getPage(PageDto pageDto, YhkhjbxxFilter filter) {
        PageDto<YhkhjbxxSelect> page = this.baseMapper.getPage(pageDto, filter);
        return page.toVo();
    }

    @Override
    public PageResult<ZnbYhdaSelect> getZnbDaPage(PageDto pageDto, ZnbYhdaFilter query) {
        PageDto<ZnbYhdaSelect> page = this.baseMapper.getZnbDaPage(pageDto, query);
        return page.toVo();
    }

    @Override
    public List<YhkhjbxxSelect> getList(YhkhjbxxFilter filter) {
        List<YhkhjbxxSelect> list = this.baseMapper.getList(filter);
        return list;
    }

    @Override
    public String getYhbh(String cbbbm) {
        YhKhjbxx entity = this.lambdaQuery().select(YhKhjbxx::getYhbh)
                .eq(YhKhjbxx::getSscbb, cbbbm)
                .last("AND rownum = 1 ORDER BY yhbh DESC")
                .one();
        String yhbh = "";
        String format = "%05d%03d";
        if (entity != null) {
            String yhbh1 = entity.getYhbh();
            int curr = Integer.valueOf(yhbh1.substring(5));
            yhbh = String.format(format, Integer.valueOf(cbbbm), curr + 1);
        } else {
            yhbh = String.format(format, Integer.valueOf(cbbbm), 1);
        }
        return yhbh;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean save(YhKhjbxxInsert insert, CzyUserDetails czyUserDetails) {
        YhKhjbxx yhKhjbxx = new YhKhjbxx();
        BeanUtils.copyProperties(insert, yhKhjbxx);
        String sscbpq = insert.getSscbpq();
        if (StringUtils.isEmpty(yhKhjbxx.getSscbpq())) {
            throw new FeesException("片区不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        String yhbh = this.getYhbh(sscbpq);
        yhKhjbxx.setYhbh(yhbh);
        check(yhKhjbxx, true);
        this.save(yhKhjbxx);//添加用户档案

        yhCbkxxService.save(czyUserDetails, insert, yhbh);//添加水表档案
        saveLog(yhKhjbxx, null, czyUserDetails, "添加");//添加用户档案操作历史
        return true;
    }

    @Override
    public boolean update(YhKhjbxxUpdate update, CzyUserDetails czyUserDetails) {
        String yhbh = update.getYhbh();
        if (StringUtils.isBlank(yhbh)) throw new FeesException("用户编号不能为空", FeesErrorCode.BUSINESS_ERROR);
        YhKhjbxx oldYhKhjbxx = this.getById(yhbh);
        if (oldYhKhjbxx == null) throw new FeesException("用户不存在", FeesErrorCode.BUSINESS_ERROR);
        YhKhjbxx yhKhjbxx = new YhKhjbxx();
        BeanUtils.copyProperties(oldYhKhjbxx, yhKhjbxx);
        BeanUtils.copyProperties(update, yhKhjbxx);
        check(yhKhjbxx, false);
        this.updateById(yhKhjbxx);//更新用户档案
        saveLog(yhKhjbxx, oldYhKhjbxx, czyUserDetails, "修改");//添加用户档案操作历史
        return true;
    }

    @Override
    public YhKhjbxxView getViewById(String yhbh) {
        YhKhjbxxView view = new YhKhjbxxView();
        YhKhjbxx yhKhjbxx = this.getById(yhbh);
        if (yhKhjbxx == null) throw new FeesException("用户不存在", FeesErrorCode.BUSINESS_ERROR);
        BeanUtils.copyProperties(yhKhjbxx, view);
        return view;
    }

    @Override
    public void batchSave(List<YhKhjbxxInsert> userList, CzyUserDetails czyUserDetails) {
        userList.forEach(insert -> this.save(insert, czyUserDetails));
    }

    @Override
    public List<YhCbkxxSelect> getCbkxxById(String yhbh) {
        return yhCbkxxService.getList(yhbh);
    }

    @Override
    public boolean disable(String yhbh, CzyUserDetails czyUserDetails) {
        YhKhjbxx oldYhKhjbxx = getById(yhbh);
        if (oldYhKhjbxx == null) throw new FeesException("用户不存在", FeesErrorCode.BUSINESS_ERROR);
        YhKhjbxx yhKhjbxx = new YhKhjbxx();
        BeanUtils.copyProperties(oldYhKhjbxx, yhKhjbxx);
        yhKhjbxx.setYhzt(YhztEnum.作废用户);
        this.updateById(yhKhjbxx);
        saveLog(yhKhjbxx, oldYhKhjbxx, czyUserDetails, "作废");
        return true;
    }

    @Override
    public boolean enable(String yhbh, CzyUserDetails czyUserDetails) {
        YhKhjbxx yhKhjbxx = getById(yhbh);
        if (yhKhjbxx == null) throw new FeesException("用户不存在", FeesErrorCode.BUSINESS_ERROR);
        yhKhjbxx.setYhzt(YhztEnum.正式用户);
        this.updateById(yhKhjbxx);
        return true;
    }

    @Override
    public boolean delById(String yhbh, CzyUserDetails czyUserDetails) {
        YhKhjbxx yhKhjbxx = this.getById(yhbh);
        if (yhKhjbxx == null) throw new FeesException("用户不存在", FeesErrorCode.BUSINESS_ERROR);
        saveLog(null, yhKhjbxx, czyUserDetails, "删除");
        this.removeById(yhbh);
        return true;
    }

    @Override
    public boolean delByIds(List<String> yhbhs, CzyUserDetails czyUserDetails) {
        yhbhs.forEach(yhbh -> delById(yhbh, czyUserDetails));
        return true;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public boolean updateSscbb(YhKhjbxxSscbbUpdate update, CzyUserDetails czyUserDetails) {
        List<String> yhbhs = update.getYhbhs();
        if (update.getType().equals("1") || update.getType().equals("3")) {
            if (yhbhs == null || yhbhs.size() == 0) {
                throw new FeesException("请选择用户", FeesErrorCode.BUSINESS_ERROR);
            } else {
                yhbhs.forEach(yhbh -> {
                    YhKhjbxx yhKhjbxx = this.getById(yhbh);
                    if (yhKhjbxx == null)
                        throw new FeesException("[" + yhbh + "]用户不存在", FeesErrorCode.BUSINESS_ERROR);
                });
            }
        }

        String sscbpq = update.getSscbpq();
        String cbpqstr = null;
        String sscbb = update.getSscbb();
        if (update.getType().equals("2") || update.getType().equals("3") || update.getType().equals("4")) {
            if (sscbpq != null) {
                BmCbpq cbpq = cbpqService.getById(sscbpq);
                if (cbpq == null)
                    throw new FeesException("抄表片区不存在", FeesErrorCode.BUSINESS_ERROR);
            }
        }
        if (update.getType().equals("1") || update.getType().equals("2") || update.getType().equals("4")) {
            if (StringUtils.isEmpty(sscbb)) {
                throw new FeesException("请选择抄表本(册)", FeesErrorCode.BUSINESS_ERROR);
            }
            if (sscbb != null) {
                BmCbb cbb = cbbService.getById(sscbb);
                if (cbb == null)
                    throw new FeesException("抄表本(册)不存在", FeesErrorCode.BUSINESS_ERROR);
                if (update.getType().equals("1") || update.getType().equals("2"))
                    cbpqstr = cbb.getSscbpq();
            }
        }
        switch (update.getType()) {
            case "1"://选择分配
                this.lambdaUpdate()
                        .in(YhKhjbxx::getYhbh, yhbhs)
                        .set(YhKhjbxx::getSscbpq, cbpqstr)
                        .set(YhKhjbxx::getSscbb, sscbb)
                        .update();
                yyCblrService.lambdaUpdate()
                        .in(YyCblr::getYhbh, yhbhs)
                        .set(YyCblr::getSscbpq, cbpqstr)
                        .set(YyCblr::getSscbb, sscbb)
                        .update();
                break;
            case "2"://全部分配
                this.lambdaUpdate()
                        .isNull(YhKhjbxx::getSscbb)
                        .eq(StringUtils.isNotEmpty(sscbpq), YhKhjbxx::getSscbpq, sscbpq)
                        .set(YhKhjbxx::getSscbpq, cbpqstr)
                        .set(YhKhjbxx::getSscbb, sscbb)
                        .update();
                yyCblrService.lambdaUpdate()
                        .isNull(YyCblr::getSscbb)
                        .eq(StringUtils.isNotEmpty(sscbpq), YyCblr::getSscbpq, sscbpq)
                        .set(YyCblr::getSscbpq, cbpqstr)
                        .set(YyCblr::getSscbb, sscbb)
                        .update();
                break;
            case "3"://选择撤销
                this.lambdaUpdate()
                        .in(YhKhjbxx::getYhbh, yhbhs)
                        .set(YhKhjbxx::getSscbpq, sscbpq)
                        .set(YhKhjbxx::getSscbb, null)
                        .update();
                yyCblrService.lambdaUpdate()
                        .in(YyCblr::getYhbh, yhbhs)
                        .set(YyCblr::getSscbpq, sscbpq)
                        .set(YyCblr::getSscbb, null)
                        .update();
                break;
            case "4"://全部撤销
                this.lambdaUpdate()
                        .in(YhKhjbxx::getSscbb, sscbb)
                        .set(YhKhjbxx::getSscbpq, sscbpq)
                        .set(YhKhjbxx::getSscbb, null)
                        .update();
                yyCblrService.lambdaUpdate()
                        .in(YyCblr::getSscbb, sscbb)
                        .set(YyCblr::getSscbpq, sscbpq)
                        .set(YyCblr::getSscbb, null)
                        .update();
                break;
        }
        return true;
    }

    @Override
    public PageResult<YhkhjbxxSelect2> getPage2(PageDto pageDto, YhkhjbxxFilter filter) {
        PageDto<YhkhjbxxSelect2> page = this.baseMapper.getPage2(pageDto, filter);
        return page.toVo();
    }

    @Override
    public List<YhKhjbxx> getListByYhbh(List<String> yhbhs) {
        if (yhbhs == null || yhbhs.isEmpty()) return new ArrayList<>();
        return this.list(Wrappers.lambdaQuery(YhKhjbxx.class).in(YhKhjbxx::getYhbh, yhbhs));
    }

    @Override
    public void updateDjyLjl(String yhbh) {
        if (yhbh == null) return;
        LocalDate now = LocalDate.now();
        LocalDate firstDayOfMonth = now.with(TemporalAdjusters.firstDayOfMonth());
        LocalDateTime startTime = LocalDateTime.of(firstDayOfMonth, LocalTime.MIN);
        LocalDateTime endTime = LocalDateTime.of(now, LocalTime.now());
        BigDecimal ljl = znbCbLogService.getLjl(yhbh, startTime, endTime);
        this.lambdaUpdate().set(YhKhjbxx::getYljl, ljl).eq(YhKhjbxx::getYhbh, yhbh).update();

    }

    @Override
    public void updateDjnLjl(String yhbh) {
        if (yhbh == null) return;
        LocalDate now = LocalDate.now();
        LocalDate firstDayOfYear = now.with(TemporalAdjusters.firstDayOfYear());
        LocalDateTime startTime = LocalDateTime.of(firstDayOfYear, LocalTime.MIN);
        LocalDateTime endTime = LocalDateTime.of(now, LocalTime.now());
        BigDecimal ljl = znbCbLogService.getLjl(yhbh, startTime, endTime);
        this.lambdaUpdate().set(YhKhjbxx::getJtzqljl, ljl).eq(YhKhjbxx::getYhbh, yhbh).update();
    }

    private void check(YhKhjbxx yhKhjbxx, boolean insert) {
        String yhbh = yhKhjbxx.getYhbh();
        if (insert) {
            int count = this.baseMapper.selectExistYhbh(yhbh);
            if (count > 0) throw new FeesException("用户编号已存在", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(yhKhjbxx.getSsgs())) {
            throw new FeesException("公司不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(yhKhjbxx.getSscbpq())) {
            throw new FeesException("片区不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(yhKhjbxx.getSscbb())) {
            throw new FeesException("抄表本(册)不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(yhKhjbxx.getYhxm())) {
            throw new FeesException("用户姓名不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
        if (StringUtils.isEmpty(yhKhjbxx.getYhdz())) {
            throw new FeesException("用户地址不能为空", FeesErrorCode.BUSINESS_ERROR);
        }
    }

    /**
     * 用户档案操作日志记录
     *
     * @param yhKhjbxx
     * @param oldYhKhjbxx
     * @param czyUserDetails
     * @param logCzlx
     */
    private void saveLog(YhKhjbxx yhKhjbxx, YhKhjbxx oldYhKhjbxx, CzyUserDetails czyUserDetails, String logCzlx) {
        String logCzrybm = null;
        String logCzryxm = null;
        if (czyUserDetails != null) {
            logCzrybm = String.valueOf(czyUserDetails.getId());
        }
        //档案操作日志记录
        Date logCzsj = new Date();
        DateFormat dateFormat = new SimpleDateFormat("yyyyMMddHHmmss");
        String logLsh = dateFormat.format(logCzsj);
        if (oldYhKhjbxx != null) {
            YhKhjbxxLog before = new YhKhjbxxLog();
            BeanUtils.copyProperties(oldYhKhjbxx, before);
            before.setCzsj(logCzsj);//操作时间
            before.setLogLsh(logLsh);//流水号
            before.setLogCzryxm(logCzryxm);//操作人员
            before.setLogCzrybm(logCzrybm);//操作人员编码
            before.setLogCzsj(logCzsj);
            before.setLogId(GuidGenerator.getGuid());//id
            before.setLogCzlx(logCzlx);
            before.setLogCllx(String.format("%s前", logCzlx));
            yhKhjbxxLogService.save(before);
        }
        if (yhKhjbxx != null) {
            YhKhjbxxLog after = new YhKhjbxxLog();
            BeanUtils.copyProperties(yhKhjbxx, after);
            after.setCzsj(logCzsj);//操作时间
            after.setLogLsh(logLsh);//流水号
            after.setLogCzryxm(logCzryxm);//操作人员
            after.setLogCzrybm(logCzrybm);//操作人员编码
            after.setLogCzsj(logCzsj);
            after.setLogId(GuidGenerator.getGuid());
            after.setLogCzlx(logCzlx);
            after.setLogCllx(String.format("%s后", logCzlx));
            yhKhjbxxLogService.save(after);
        }


    }
}
