package com.tofly.feesapi.yhgl.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.feesapi.common.exception.FeesErrorCode;
import com.tofly.feesapi.common.exception.FeesException;
import com.tofly.feesapi.security.model.CzyUserDetails;
import com.tofly.feesapi.sfgl.service.YySspjxxService;
import com.tofly.feesapi.yhgl.entity.YyZjzh;
import com.tofly.feesapi.yhgl.entity.dto.YyZjzhUpdate;
import com.tofly.feesapi.yhgl.entity.vo.YyZjzhView;
import com.tofly.feesapi.yhgl.mapper.YyZjzhMapper;
import com.tofly.feesapi.yhgl.service.IYyZjzhService;
import com.tofly.feesapi.yhgl.service.YhKhjbxxService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 用户资金账号 服务实现类
 * </p>
 *
 * @author decai
 * @since 2024-03-11
 */
@Service
public class YyZjzhServiceImpl extends ServiceImpl<YyZjzhMapper, YyZjzh> implements IYyZjzhService {

    @Autowired
    private YhKhjbxxService yhKhjbxxService;

    @Autowired
    private YySspjxxService yySspjxxService;

    @Override
    @Transactional
    public boolean xgyck(YyZjzhUpdate update, CzyUserDetails czyUserDetails) {
        return xgyck(update, czyUserDetails, false, 1, "2","");
    }

    @Override
    @Transactional
    public boolean xgyck(YyZjzhUpdate update, CzyUserDetails czyUserDetails, boolean ssbz, int sfxh, String fffs,String sflsbh) {
        String yhbh = update.getYhbh();
        String bz = update.getBz();
        BigDecimal je = update.getJe();
        if (je == null || je.compareTo(BigDecimal.ZERO) == 0) {
            throw new FeesException("金额无效", FeesErrorCode.BUSINESS_ERROR);
        }
        YyZjzh zjzh = createOrGetZjzh(yhbh, je);
        BigDecimal syje = zjzh.getSyje();//剩余金额
        BigDecimal scje = syje.subtract(je);
        BigDecimal bcje = syje;
        if (bcje.compareTo(BigDecimal.ZERO) < 0)
            throw new FeesException("余额不足", FeesErrorCode.BUSINESS_ERROR);
        if (ssbz) {
            yySspjxxService.addYffsq(yhbh, scje, bcje, je, new Date(), bz, czyUserDetails, sfxh, fffs,sflsbh);
        } else {
            yySspjxxService.addZyc(yhbh, scje, bcje, je, new Date(), bz, czyUserDetails, sfxh, fffs,sflsbh);//转存流水账
        }
        return this.saveOrUpdate(zjzh);
    }

    private YyZjzh createOrGetZjzh(String yhbh, BigDecimal je) {
        YyZjzh zjzh = this.getById(yhbh);
        BigDecimal kjje;
        BigDecimal yfje;
        BigDecimal syje;
        if (zjzh == null) {
            zjzh = new YyZjzh();
            kjje = BigDecimal.ZERO;
            yfje = BigDecimal.ZERO;
            syje = BigDecimal.ZERO;
            zjzh.setYhbh(yhbh);
        } else {
            kjje = zjzh.getKjje();
            yfje = zjzh.getYfje();
            syje = zjzh.getSyje();
            kjje = kjje == null ? BigDecimal.ZERO : kjje;
            yfje = yfje == null ? BigDecimal.ZERO : yfje;
            syje = syje == null ? BigDecimal.ZERO : syje;
        }
        if (je.compareTo(BigDecimal.ZERO) < 0) {
            kjje = kjje.add(je.abs());
            syje = syje.subtract(je.abs());
        } else {
            yfje = yfje.add(je);
            syje = syje.add(je);
        }

        zjzh.setKjje(kjje);
        zjzh.setYfje(yfje);
        zjzh.setSyje(syje);
        return zjzh;
    }

    @Override
    public YyZjzh addOrUpdate(String yhbh, BigDecimal bcyfje) {
        YyZjzh zjzh = this.createOrGetZjzh(yhbh, bcyfje);
        this.saveOrUpdate(zjzh);
        return zjzh;
    }

    @Override
    public YyZjzhView get(String yhbh) {
        return this.baseMapper.get(yhbh);
    }

    @Override
    public void updateNbSyje(String yhbh, BigDecimal nbsyje) {
        YyZjzh zjzh = this.getById(yhbh);
        if (zjzh == null) {
            zjzh = new YyZjzh();
            zjzh.setSyje(BigDecimal.ZERO);
            zjzh.setYhbh(yhbh);
        }
        zjzh.setNbsyje(nbsyje);
        this.saveOrUpdate(zjzh);

    }
}
