package com.tofly.feesapi.znbgl.entity;

import com.baomidou.mybatisplus.annotation.*;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.apache.ibatis.type.JdbcType;

/**
 * <p>
 * 智能表档案明细
 * </p>
 *
 * @author decai
 * @since 2024-04-23
 */
@Getter
@Setter
@TableName("ZNB_DA_LOG")
@ApiModel(value = "ZnbDaLog对象", description = "智能表档案明细")
public class ZnbDaLog implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键id")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty("用户编号")
    @TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String yhbh;

    @ApiModelProperty("抄表卡号")
    private String cbkh;

    @ApiModelProperty("抄表卡ID")
    @TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String cbkid;

    @ApiModelProperty("表具编号")
    private String bjbh;

    @ApiModelProperty("生产厂家")
    private String sccj;

    @ApiModelProperty("所属公司")
    private String ssgs;

    @ApiModelProperty("所属抄表片区")
    @TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String sscbpq;

    @ApiModelProperty("所属抄表本")
    @TableField(updateStrategy = FieldStrategy.IGNORED, jdbcType = JdbcType.VARCHAR)
    private String sscbb;

    @ApiModelProperty("批次号")
    private String pch;

    @ApiModelProperty("操作人员")
    private String czry;

    @ApiModelProperty("操作时间")
    private Date czsj;

    @ApiModelProperty("锁定标志（0：未锁定；1：已锁定）")
    private String clLock;

    @ApiModelProperty("处理结果（0：未处理；1：成功处理；其它见bm_cljg）")
    private String clCljg;

    @ApiModelProperty("处理人员")
    private String clClry;

    @ApiModelProperty("处理时间")
    private Date clClsj;

    @ApiModelProperty("返回代码")
    private String clRecode;

    @ApiModelProperty("返回消息")
    private String clRemessage;

    @ApiModelProperty("建档类型（0：建档；1：变更；2：换表）")
    private String jdlx;

    @ApiModelProperty("用户姓名")
    private String yhxm;

    @ApiModelProperty("用户地址")
    private String yhdz;

    @ApiModelProperty("联系电话")
    private String lxdh;

    @ApiModelProperty("建档日期")
    private Date jdrq;

    @ApiModelProperty("用户类型（居民、非居民、合表、特种、低保），变更时需做相应处理。")
    private String yhlx;

    @ApiModelProperty("表具位置（户内、户外）")
    private String bjwz;

    @ApiModelProperty("表具检定日期")
    private Date bjjdrq;

    @ApiModelProperty("表具口径")
    private String bjkj;

    @ApiModelProperty("抄表频率（0：每月抄；1：单月抄；2：双月抄；3：按日抄）")
    private String cbpl;

    @ApiModelProperty("旧表编号")
    private String jbbh;

    @ApiModelProperty("旧表止数")
    private BigDecimal jbzs;

    @ApiModelProperty("新表起数")
    private BigDecimal xbqs;

    @ApiModelProperty("用户余额")
    private BigDecimal yhye;

    @ApiModelProperty("价格编码")
    private String jgbm;

    @ApiModelProperty("价格编码1")
    private String jgbm1;

    @ApiModelProperty("价格编码2")
    private String jgbm2;

    @ApiModelProperty("IC卡id")
    private String ickid;

    @ApiModelProperty("写卡次数")
    private Short xkcs;

    @ApiModelProperty("补卡次数")
    private Short bkcs;

    @ApiModelProperty("交易流水号")
    private String jylsh;

    public static final String ID = "ID";

    public static final String YHBH = "YHBH";

    public static final String CBKH = "CBKH";

    public static final String CBKID = "CBKID";

    public static final String BJBH = "BJBH";

    public static final String SCCJ = "SCCJ";

    public static final String SSGS = "SSGS";

    public static final String PCH = "PCH";

    public static final String CZRY = "CZRY";

    public static final String CZSJ = "CZSJ";

    public static final String CL_LOCK = "CL_LOCK";

    public static final String CL_CLJG = "CL_CLJG";

    public static final String CL_CLRY = "CL_CLRY";

    public static final String CL_CLSJ = "CL_CLSJ";

    public static final String CL_RECODE = "CL_RECODE";

    public static final String CL_REMESSAGE = "CL_REMESSAGE";

    public static final String SSCBPQ = "SSCBPQ";

    public static final String SSCBB = "SSCBB";

    public static final String JDLX = "JDLX";

    public static final String YHXM = "YHXM";

    public static final String YHDZ = "YHDZ";

    public static final String LXDH = "LXDH";

    public static final String JDRQ = "JDRQ";

    public static final String YHLX = "YHLX";

    public static final String BJWZ = "BJWZ";

    public static final String BJJDRQ = "BJJDRQ";

    public static final String BJKJ = "BJKJ";

    public static final String CBPL = "CBPL";

    public static final String JBBH = "JBBH";

    public static final String JBZS = "JBZS";

    public static final String XBQS = "XBQS";

    public static final String YHYE = "YHYE";

    public static final String JGBM = "JGBM";

    public static final String JGBM1 = "JGBM1";

    public static final String JGBM2 = "JGBM2";

    public static final String ICKID = "ICKID";

    public static final String XKCS = "XKCS";

    public static final String BKCS = "BKCS";

    public static final String JYLSH = "JYLSH";
}
