/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.feesapi.znbgl.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 智能表用户档案
 *
 * @author sxb
 * @date Tue Apr 23 00:00:00 CST 2024
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "ZNB_YHDA", resultMap = "znbYhdaMap")
@KeySequence("ZNB_YHDA")
@ApiModel
public class ZnbYhda extends Model<ZnbYhda> {
    private static final long serialVersionUID = 1L;

    /**
     * 表具位置
     */
    @ApiModelProperty(value = "表具位置")
    private String bjwz;
    /**
     * 表具口径
     */
    @ApiModelProperty(value = "表具口径")
    private String bjkj;
    /**
     * 表具量程
     */
    @ApiModelProperty(value = "表具量程")
    private String bjlc;
    /**
     * 抄表频率（0：每月抄；1：单月抄；2：双月抄；3：按日抄）
     */
    @ApiModelProperty(value = "抄表频率（0：每月抄；1：单月抄；2：双月抄；3：按日抄）")
    private String cbpl;
    /**
     * 表具起度
     */
    @ApiModelProperty(value = "表具起度")
    private BigDecimal bjqd;
    /**
     * 表具止度
     */
    @ApiModelProperty(value = "表具止度")
    private BigDecimal bjzd;
    /**
     * 表具编号
     */
    @ApiModelProperty(value = "表具编号")
    private String bjbh;
    /**
     * 建档日期
     */
    @ApiModelProperty(value = "建档日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date jdrq;
    /**
     * 建档批次号
     */
    @ApiModelProperty(value = "建档批次号")
    private String jdpch;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String czry;
    /**
     * 操作日期
     */
    @ApiModelProperty(value = "操作日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date czrq;
    /**
     * 用户状态
     */
    @ApiModelProperty(value = "用户状态")
    private String yhzt;
    /**
     * 阀门状态0关阀1开阀
     */
    @ApiModelProperty(value = "阀门状态0关阀1开阀")
    private String fmzt;
    /**
     * 表具状态0异常1正常
     */
    @ApiModelProperty(value = "表具状态0异常1正常")
    private String bjzt;
    /**
     * 具体状态异常信息
     */
    @ApiModelProperty(value = "具体状态异常信息")
    private String bjmsg;
    /**
     * 表具余额
     */
    @ApiModelProperty(value = "表具余额")
    private BigDecimal bjye;
    /**
     * 档案同步标志0未同步,1同步
     */
    @ApiModelProperty(value = "档案同步标志0未同步,1同步")
    private String tbbz;
    /**
     * 建档类型（0：建档；1：变更；2：换表）
     */
    @ApiModelProperty(value = "建档类型（0：建档；1：变更；2：换表）")
    private String jdlx;
    /**
     * 用户编号
     */
    @TableId(value = "YHBH", type = IdType.INPUT)
    @ApiModelProperty(value = "用户编号")
    private String yhbh;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String yhxm;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String yhdz;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String lxdh;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String ssgs;
    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区")
    private String sspq;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private String sscbb;
    /**
     * 用户类型
     */
    @ApiModelProperty(value = "用户类型")
    private String yhlx;
    /**
     * 价格编码
     */
    @ApiModelProperty(value = "价格编码")
    private String jgbm;
    /**
     * 表具厂家
     */
    @ApiModelProperty(value = "表具厂家")
    private String bjcj;
    /**
     * 表具型号
     */
    @ApiModelProperty(value = "表具型号")
    private String bjxh;
    /**
     * 表具类别
     */
    @ApiModelProperty(value = "表具类别")
    private String bjlb;

}
