package com.tofly.feesapi.znbgl.entity.vo;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.tofly.feesapi.common.constant.FmztEnum;
import com.tofly.feesapi.common.constant.TbbzEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @author lihaoli
 * @date 2024/4/24
 */
@Data
@ApiModel(value = "智能表档案列表", description = "用户表计信息")
public class ZnbYhdaSelect {

    @ApiModelProperty(value = "用户编号", position = 1)
    private String yhbh;

    @ApiModelProperty(value = "用户姓名", position = 2)
    private String yhxm;

    @ApiModelProperty(value = "用户地址", position = 2, example = "13-1-8（29号）")
    private String yhdz;

    @ApiModelProperty(value = "水价编码", hidden = true)
    @JsonIgnore
    private String sjbm;

    @ApiModelProperty(value = "水价名称", position = 3, example = "居民用水")
    private String sjmc;

    @ApiModelProperty(value = "水价", position = 4, example = "2.6")
    private String sj;

    @ApiModelProperty(value = "水价编码1", hidden = true)
    @JsonIgnore
    private String sjbm1;

    @ApiModelProperty(value = "水价名称1", position = 5, example = "居民用水")
    private String sjmc1;

    @ApiModelProperty(value = "水价1", position = 6, example = "2.6")
    private String sj1;

    @ApiModelProperty(value = "水量比例1", position = 7, example = "0.5")
    private BigDecimal slbl1;

    @ApiModelProperty(value = "水价编码2", hidden = true)
    @JsonIgnore
    private String sjbm2;

    @ApiModelProperty(value = "水价名称2", position = 8, example = "居民用水")
    private String sjmc2;

    @ApiModelProperty(value = "水价2", position = 9, example = "2.6")
    private String sj2;

    @ApiModelProperty(value = "水量比例2", position = 10, example = "0.5")
    private BigDecimal slbl2;

    @ApiModelProperty(value = "水价编码3", hidden = true)
    @JsonIgnore
    private String sjbm3;

    @ApiModelProperty(value = "水价名称3", position = 11, example = "居民用水")
    private String sjmc3;

    @ApiModelProperty(value = "水价3", position = 12, example = "2.6")
    private String sj3;

    @ApiModelProperty(value = "水量比例3", position = 13, example = "0.5")
    private BigDecimal slbl3;

    @ApiModelProperty(value = "所属抄表册名称", position = 14)
    private String sscbbmc;

    @ApiModelProperty(value = "所属抄表片区名称", position = 15)
    private String sscbpqmc;

    @ApiModelProperty(value = "联系电话", position = 16)
    private String lxdh;

    @ApiModelProperty(value = "水表编号", position = 17)
    private String sbbh;

    @ApiModelProperty(value = "水表类别", position = 18)
    private String sblbmc;

    @ApiModelProperty(value = "阀门状态(0关阀 1处理中 2开阀)", position = 19)
    private FmztEnum fmzt;
    @ApiModelProperty(value = "表具厂家", position = 20)
    private String bjcjmc;
    @ApiModelProperty(value = "表具余额", position = 21)
    private BigDecimal bjye;
    @ApiModelProperty(value = "档案同步标志0未同步,1同步", position = 22)
    private TbbzEnum tbbz;
}
