package com.tofly.fees;

import org.apache.ibatis.builder.SqlSourceBuilder;
import org.apache.ibatis.session.Configuration;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.actuate.autoconfigure.security.servlet.ManagementWebSecurityAutoConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.security.servlet.SecurityAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.context.annotation.Bean;

@EnableDiscoveryClient
@SpringBootApplication(exclude = {ManagementWebSecurityAutoConfiguration.class, SecurityAutoConfiguration.class})
public class FeesApplication {
    public static void main(String[] args) {
        SpringApplication.run(FeesApplication.class,args);
    }

    @Bean
    public SqlSourceBuilder sqlSourceBuilder(){
        Configuration configuration = new Configuration();
        return new SqlSourceBuilder(configuration);
    }
}
