package com.tofly.fees.codemgt.controller_easy;


import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.common.core.entity.ResultRespone;

import com.tofly.fees.codemgt.entity.BmBglx;

import com.tofly.fees.common.BaseController;
import com.tofly.fees.common.dbhelper.DbHelper;
import com.tofly.fees.common.enums.SysEnum;
import com.tofly.fees.common.model.PageLink;
import com.tofly.fees.common.util.DateUtils;

import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import java.math.BigDecimal;
import static com.tofly.fees.common.ControllerConstants.*;


@RestController
@AllArgsConstructor
@RequestMapping("api/codemgt/BmBglx")
@Api(tags = "编码_变更类型")

public class BmBglxEasyController extends BaseController {
    /**
     * 分页查询
     *
     * @param page 分页对象
     * @return
     */
    @GetMapping("/pageInfo")
    @ApiOperation(value = "[Easy]分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "code", value = "code", required = false, dataType = "long",defaultValue = ""),
            @ApiImplicitParam(name = "name", value = "name", required = false, dataType = "String",defaultValue = ""),
            @ApiImplicitParam(name = "btype", value = "btype", required = false, dataType = "String",defaultValue = ""),
            @ApiImplicitParam(name = "btable", value = "btable", required = false, dataType = "String",defaultValue = ""),
            @ApiImplicitParam(name = "bkey", value = "bkey", required = false, dataType = "String",defaultValue = ""),
            @ApiImplicitParam(name = "orderNo", value = "orderNo", required = false, dataType = "long",defaultValue = "")

    })
    public ResultRespone getBmBglxPage(@ApiParam(value = PAGE_SIZE_DESCRIPTION, required = true)
                                              @RequestParam(value = PAGE_SIZE_PARA_NAME) int pageSize,
                                         @ApiParam(value = PAGE_NUMBER_DESCRIPTION, required = true)
                                             @RequestParam(value = PAGE_NUMBER_PARA_NAME) int page,
                                         @ApiParam(value = SORT_PROPERTY_DESCRIPTION)
                                             @RequestParam(required = false) String sortProperty,
                                         @ApiParam(value = SORT_ORDER_DESCRIPTION, allowableValues = SORT_ORDER_ALLOWABLE_VALUES)
                                             @RequestParam(required = false) String sortOrder,
                                         @ModelAttribute BmBglx bmBglx
                                         ) throws Exception {

        DbHelper db = DbHelper.getDbHelper();
        PageLink pg = createPageLink(pageSize, page);
        String strSql = String.format("select * from TF_YWYS_BM_BGLX t where 1=1");

        if(bmBglx.getCode()!=null){
            strSql+=String.format(" and CODE='%s'",bmBglx.getCode());
        }

        if(!StringUtils.isBlank(bmBglx.getName())){
            strSql+=String.format(" and NAME like '%%%s'",bmBglx.getName());
        }

        if(!StringUtils.isBlank(bmBglx.getBtype())){
            strSql+=String.format(" and BTYPE like '%%%s'",bmBglx.getBtype());
        }

        if(!StringUtils.isBlank(bmBglx.getBtable())){
            strSql+=String.format(" and BTABLE like '%%%s'",bmBglx.getBtable());
        }

        if(!StringUtils.isBlank(bmBglx.getBkey())){
            strSql+=String.format(" and BKEY like '%%%s'",bmBglx.getBkey());
        }


        if(bmBglx.getOrderNo()!=null){
            strSql+=String.format(" and ORDER_NO='%s'",bmBglx.getOrderNo());
        }

        Object obj = db.getPage(pg, strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
    }

    /**
     * 根据CODE获取对象
     *
     * @param CODE 主键
     * @return
     */
    @GetMapping("/getBmBglxById")
    @ApiOperation(value = "[Easy]根据code获取对象")
    public ResultRespone getBmBglxById(@ApiParam(value = "获取一条记录", required = true)
                                         @RequestParam(value = "code") long code) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        String strSql = String.format("select * from TF_YWYS_BM_BGLX t where CODE='%s'", code);

        Object obj = db.getList(strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
    }



    /**
     * 新增编码_变更类型
     *
     * @return
     */
    @PostMapping("/saveBmBglx")
    @ApiOperation(value = "[Easy]新增编码_变更类型")
    public ResultRespone addBmBglx(@RequestBody BmBglx bmBglx) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        sb.append("insert into TF_YWYS_BM_BGLX (CODE,NAME,BTYPE,BTABLE,BKEY,ISDISABLED,ORDER_NO)");
        sb.append("values(");
        if (bmBglx.getCode() != null)
            sb.append("'" + bmBglx.getCode() + "'");
        else
            sb.append("''");
        sb.append(",'" + bmBglx.getName() + "'");
        sb.append(",'" + bmBglx.getBtype() + "'");
        sb.append(",'" + bmBglx.getBtable() + "'");
        sb.append(",'" + bmBglx.getBkey() + "'");
        sb.append(",'" + bmBglx.getIsdisabled() + "'");
        if (bmBglx.getOrderNo() != null)
            sb.append(",'" + bmBglx.getOrderNo() + "'");
        else
            sb.append(",''");
        sb.append(")");
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

    /**
     * 修改编码_变更类型
     *
     * @return
     */
    @PutMapping("/updateBmBglxByID")
    @ApiOperation(value = "[Easy]修改编码_变更类型")
    public ResultRespone updateBmBglxByID(@RequestBody BmBglx bmBglx) throws Exception {

        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        StringBuffer strConditionSQL = new StringBuffer();
        sb.append("update TF_YWYS_BM_BGLX set ");
        if (bmBglx.getCode() != null) {
            strConditionSQL.append(",CODE='" + bmBglx.getCode() + "'");
        }
        if (!StringUtils.isBlank(bmBglx.getName())) {
            strConditionSQL.append(",NAME='" + bmBglx.getName() + "'");
        }
        if (!StringUtils.isBlank(bmBglx.getBtype())) {
            strConditionSQL.append(",BTYPE='" + bmBglx.getBtype() + "'");
        }
        if (!StringUtils.isBlank(bmBglx.getBtable())) {
            strConditionSQL.append(",BTABLE='" + bmBglx.getBtable() + "'");
        }
        if (!StringUtils.isBlank(bmBglx.getBkey())) {
            strConditionSQL.append(",BKEY='" + bmBglx.getBkey() + "'");
        }
        if (!StringUtils.isBlank(bmBglx.getIsdisabled())) {
            strConditionSQL.append(",ISDISABLED='" + bmBglx.getIsdisabled() + "'");
        }
        if (bmBglx.getOrderNo() != null) {
            strConditionSQL.append(",ORDER_NO='" + bmBglx.getOrderNo() + "'");
        }
        if (bmBglx.getCode() != null) {
            strConditionSQL.append(" where CODE='" + bmBglx.getCode() + "'");
        }
        if (!StringUtils.isBlank(strConditionSQL)) {
            sb.append(strConditionSQL.substring(1).toString());
        }
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

    /**
     * 修改编码_变更类型
     *
     * @return
     */
    @PutMapping("/updateAllBmBglxById")
    @ApiOperation(value = "[Easy]修改编码_变更类型")
    public ResultRespone updateAllBmBglxById(@RequestBody BmBglx bmBglx) throws Exception {

        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        StringBuffer strConditionSQL = new StringBuffer();
        sb.append("update TF_YWYS_BM_BGLX set ");
        strConditionSQL.append(",CODE='" + bmBglx.getCode() + "'");
        strConditionSQL.append(",NAME='" + bmBglx.getName() + "'");
        strConditionSQL.append(",BTYPE='" + bmBglx.getBtype() + "'");
        strConditionSQL.append(",BTABLE='" + bmBglx.getBtable() + "'");
        strConditionSQL.append(",BKEY='" + bmBglx.getBkey() + "'");
        strConditionSQL.append(",ISDISABLED='" + bmBglx.getIsdisabled() + "'");
        strConditionSQL.append(",ORDER_NO='" + bmBglx.getOrderNo() + "'");
        strConditionSQL.append(" where CODE='" + bmBglx.getCode() + "'");
        if (!StringUtils.isBlank(strConditionSQL)) {
            sb.append(strConditionSQL.substring(1).toString());
        }
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

    /**
     * 删除编码_变更类型
     *
     * @return
     */
    @DeleteMapping("/esay/{CODE}}")
    @ApiOperation(value = "[Easy]删除编码_变更类型")
    public ResultRespone deleteById(@PathVariable("CODE") long code) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        String strSql = "delete from TF_YWYS_BM_BGLX where CODE='" + code + "'";
        int row = db.executeCmd(strSql);
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

}
