package com.tofly.fees.codemgt.controller_easy;


import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.fees.codemgt.entity.BmMrBook;
import com.tofly.fees.common.BaseController;
import com.tofly.fees.common.dbhelper.DbHelper;
import com.tofly.fees.common.enums.SysEnum;
import com.tofly.fees.common.model.PageLink;
import com.tofly.fees.common.util.DateUtils;
import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;

import static com.tofly.fees.common.ControllerConstants.*;
import static com.tofly.fees.common.ControllerConstants.PAGE_NUMBER_PARA_NAME;


@RestController
@AllArgsConstructor
@RequestMapping("/bmmrbook")
@Api(tags = "编码管理-抄表本接口")

public class BmMrBookEasyController extends BaseController {
    /**
     * 分页查询
     *
     * @param page 分页对象
     * @return
     */
    @GetMapping("/pageInfo")
    @ApiOperation(value = "[Easy]分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "code", value = "code", required = false, dataType = "int", defaultValue = ""),
            @ApiImplicitParam(name = "cdate", value = "cdate", required = false, dataType = "date", defaultValue = ""),
            @ApiImplicitParam(name = "mdate", value = "mdate", required = false, dataType = "date", defaultValue = ""),
            @ApiImplicitParam(name = "name", value = "name", required = false, dataType = "String", defaultValue = ""),
            @ApiImplicitParam(name = "remark", value = "remark", required = false, dataType = "String", defaultValue = "")

    })
    public ResultRespone getBmMrBookPage(@ApiParam(value = PAGE_SIZE_DESCRIPTION, required = true)
                                         @RequestParam(value = PAGE_SIZE_PARA_NAME) int pageSize,
                                         @ApiParam(value = PAGE_NUMBER_DESCRIPTION, required = true)
                                         @RequestParam(value = PAGE_NUMBER_PARA_NAME) int page,
                                         @ApiParam(value = SORT_PROPERTY_DESCRIPTION)
                                         @RequestParam(required = false) String sortProperty,
                                         @ApiParam(value = SORT_ORDER_DESCRIPTION, allowableValues = SORT_ORDER_ALLOWABLE_VALUES)
                                         @RequestParam(required = false) String sortOrder,
                                         @ModelAttribute BmMrBook bmMrBook
    ) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        PageLink pg = createPageLink(pageSize, page);
        String strSql = String.format("select * from tf_ywys_bm_mr_book t where 1=1");

        if (bmMrBook.getCode() != null) {
            strSql += String.format(" and code='%s'", bmMrBook.getCode());
        }
        if (!StringUtils.isBlank(bmMrBook.getName())) {
            strSql += String.format(" and name like '%s%%'", bmMrBook.getName());
        }
        if (!StringUtils.isBlank(bmMrBook.getRemark())) {
            strSql += String.format(" and remark like '%s%%'", bmMrBook.getCode());
        }

        System.out.println(strSql);
        Object obj = db.getPage(pg, strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
    }

    /**
     * 分页查询
     *
     * @param code 分页对象
     * @return
     */
    @GetMapping("/getBmMrBookById")
    @ApiOperation(value = "[Easy]根据code获取对象")
    public ResultRespone getBmMrBookById(@ApiParam(value = "获取一条记录", required = true)
                                         @RequestParam(value = "code") int code) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        String strSql = String.format("select * from tf_ywys_bm_mr_book t where code='%s'", code);
        System.out.println(strSql);
        Object obj = db.getList(strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
    }


    /**
     * 新增
     *
     * @return
     */
    @PostMapping("/saveBmMrBook")
    @ApiOperation(value = "[Easy]新增表本(小区)编码")
    public ResultRespone addBmMrBook(@RequestBody BmMrBook bmMrBook) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        sb.append("insert into tf_ywys_bm_mr_book (code,name,address,mr_ocode,company_branch,mr_area,remark,cdate,mdate,ocode,sx_flag,xy_mr_ocode)");
        sb.append("values('" + bmMrBook.getCode() + "'");
        sb.append(",'" + bmMrBook.getName() + "'");
        sb.append(",'" + bmMrBook.getAddress() + "'");
        sb.append(",'" + bmMrBook.getMrOcode() + "'");
        sb.append(",'" + bmMrBook.getCompanyBranch() + "'");
        sb.append(",'" + bmMrBook.getMrArea() + "'");
        sb.append(",'" + bmMrBook.getRemark() + "'");
        if (bmMrBook.getCdate() != null)
            sb.append(",'to_date('" + DateUtils.formatDate(bmMrBook.getCdate(), "yyyy-MM-dd hh:mm:ss") + "'");
        else
            sb.append(",''");

        if (bmMrBook.getMdate() != null)
            sb.append(",'to_date('" + DateUtils.formatDate(bmMrBook.getMdate(), "yyyy-MM-dd hh:mm:ss") + "'");
        else
            sb.append(",''");
        sb.append(",'" + bmMrBook.getOcode() + "'");
        sb.append(",'" + bmMrBook.getSxFlag() + "'");
        sb.append(",'" + bmMrBook.getXyMrOcode() + "')");
        System.out.println(sb.toString());
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

    /**
     * 修改表本(小区)编码
     *
     * @return
     */
    @PutMapping("/updateBmMrBookByID")
    @ApiOperation(value = "[Easy]修改表本(小区)编码过滤空参数")
    public ResultRespone updateBmMrBookByID(@RequestBody BmMrBook bmMrBook) throws Exception {

        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        StringBuffer strConditionSQL = new StringBuffer();
        sb.append("update  tf_ywys_bm_mr_book set   ");
        boolean isAppend = false;
        if (!StringUtils.isBlank(bmMrBook.getName())) {
            strConditionSQL.append(",name='" + bmMrBook.getName() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getAddress())) {
            strConditionSQL.append(",address='" + bmMrBook.getAddress() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getMrOcode())) {
            strConditionSQL.append(",mr_ocode='" + bmMrBook.getMrOcode() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getCompanyBranch())) {
            strConditionSQL.append(",company_branch='" + bmMrBook.getCompanyBranch() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getMrArea())) {
            strConditionSQL.append(",mr_area='" + bmMrBook.getMrArea() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getRemark())) {
            strConditionSQL.append(",remark='" + bmMrBook.getRemark() + "'");
        }
        if (bmMrBook.getCdate() != null && !StringUtils.isBlank(bmMrBook.getCdate().toString())) {
            strConditionSQL.append(",cdate='to_date('" + bmMrBook.getCdate() + "','yyyy-MM-dd HH24:mi:ss')'");
        }
        if (bmMrBook.getMdate() != null && !StringUtils.isBlank(bmMrBook.getMdate().toString())) {
            strConditionSQL.append(",mdate='to_date('" + bmMrBook.getMdate() + "','yyyy-MM-dd HH24:mi:ss')'");
        }
        if (!StringUtils.isBlank(bmMrBook.getOcode())) {
            strConditionSQL.append(",ocode='" + bmMrBook.getOcode() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getSxFlag())) {
            strConditionSQL.append(",sx_flag='" + bmMrBook.getSxFlag() + "'");
        }
        if (!StringUtils.isBlank(bmMrBook.getXyMrOcode())) {
            strConditionSQL.append(",xy_mr_ocode='" + bmMrBook.getXyMrOcode() + "'");
        }
        if (bmMrBook.getCode() != null) {
            strConditionSQL.append(" where code='" + bmMrBook.getCode() + "'");
        }
        if (!StringUtils.isBlank(strConditionSQL)) {
            sb.append(strConditionSQL.substring(1).toString());
        }
        System.out.println(sb.toString());
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }


    /**
     * 修改表本(小区)编码
     *
     * @return
     */
    @PutMapping("/updateAllBmMrBookById")
    @ApiOperation(value = "[Easy]修改表本(小区)编码可为空")
    public ResultRespone updateAllBmMrBookById(@RequestBody BmMrBook bmMrBook) throws Exception {

        DbHelper db = DbHelper.getDbHelper();
        StringBuffer sb = new StringBuffer();
        StringBuffer strConditionSQL = new StringBuffer();
        sb.append("update  tf_ywys_bm_mr_book set   ");
        boolean isAppend = false;
        strConditionSQL.append(",name='" + bmMrBook.getName() + "'");
        strConditionSQL.append(",address='" + bmMrBook.getAddress() + "'");
        strConditionSQL.append(",mr_ocode='" + bmMrBook.getMrOcode() + "'");
        strConditionSQL.append(",company_branch='" + bmMrBook.getCompanyBranch() + "'");
        strConditionSQL.append(",mr_area='" + bmMrBook.getMrArea() + "'");
        strConditionSQL.append(",remark='" + bmMrBook.getRemark() + "'");
        if (bmMrBook.getCdate() != null) {
            strConditionSQL.append(",cdate='to_date('" + bmMrBook.getCdate() + "','yyyy-MM-dd HH24:mi:ss')'");
        } else {
            strConditionSQL.append(",cdate=''");
        }

        if (bmMrBook.getMdate() != null) {
            strConditionSQL.append(",mdate='to_date('" + bmMrBook.getMdate() + "','yyyy-MM-dd HH24:mi:ss')'");
        } else {
            strConditionSQL.append(",mdate=''");
        }
        strConditionSQL.append(",ocode='" + bmMrBook.getOcode() + "'");
        strConditionSQL.append(",sx_flag='" + bmMrBook.getSxFlag() + "'");
        strConditionSQL.append(",xy_mr_ocode='" + bmMrBook.getXyMrOcode() + "'");
        strConditionSQL.append(" where code='" + bmMrBook.getCode() + "'");
        if (!StringUtils.isBlank(strConditionSQL)) {
            sb.append(strConditionSQL.substring(1).toString());
        }
        System.out.println(sb.toString());
        int row = db.executeCmd(sb.toString());
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

    /**
     * 删除(小区)编码
     *
     * @return
     */
    @DeleteMapping("/esay/{code}}")
    @ApiOperation(value = "[Easy]删除表本(小区)编码")
    public ResultRespone deleteById(@PathVariable("code") BigDecimal code) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        String strSql = "delete from tf_ywys_bm_mr_book where code='" + code + "'";
        int row = db.executeCmd(strSql);
        boolean isFlag = false;
        if (row > 0) {
            isFlag = true;
        }
        return ResultRespone.success(isFlag);
    }

}
