/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.codemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 收费点
 *
 * @author sxb
 * @date Thu May 18 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_BM_CHARGE_CHANNEL", resultMap = "bmChargeChannelMap")
@KeySequence("TF_YWYS_BM_CHARGE_CHANNEL")
@ApiModel
public class BmChargeChannel extends Model<BmChargeChannel> {
    private static final long serialVersionUID = 1L;

    /**
     * 营业点编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)  //
    @ApiModelProperty(value = "营业点编码")
    private Integer code;
    /**
     * 营业点名称
     */
    @ApiModelProperty(value = "营业点名称")
    private String name;
    /**
     * 营业时间
     */
    @ApiModelProperty(value = "营业时间")
    private String yysj;
    /**
     * 负责人
     */
    @ApiModelProperty(value = "负责人")
    private String head;
    /**
     * 电话
     */
    @ApiModelProperty(value = "电话")
    private String telephone;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String companyBranch;
    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 修改日期
     */
    @ApiModelProperty(value = "修改日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mdate;
    /**
     * 修改人员
     */
    @ApiModelProperty(value = "修改人员")
    private String ocode;

    @ApiModelProperty(value = "操作人员名称")
    private String oname;

    @ApiModelProperty(value = "是否外部单位（0：否；1：是）")
    private String isextunit;


}
