/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.codemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 水表生产厂家
 *
 * @author sxb
 * @date Thu May 18 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_YWYS_BM_METER_FACTORY",resultMap = "bmMeterFactoryMap")
@KeySequence("TF_YWYS_BM_METER_FACTORY")
@ApiModel
public class BmMeterFactory extends Model<BmMeterFactory> {
    private static final long serialVersionUID = 1L;

        /**
     * 厂家编码
     */
        @TableId(value = "CODE",type= IdType.INPUT)
            @ApiModelProperty(value = "厂家编码")
                private Integer code;
                /**
     * 厂家名称
     */
            @ApiModelProperty(value = "厂家名称")
                private String name;
                /**
     * 水表类别
     */
           // @ApiModelProperty(value = "水表类别")
             //   private String meterType;
                /**
     * 厂家地址
     */
            @ApiModelProperty(value = "厂家地址")
                private String address;
                /**
     * 厂家备注
     */
            @ApiModelProperty(value = "厂家备注")
                private String remark;
                /**
     * 操作时间
     */
            @ApiModelProperty(value = "操作时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date cdate;
                /**
     * 是否启用：0不启用，1启用
     */
            @ApiModelProperty(value = "是否启用：0不启用，1启用")
                private String isdisabled;
                /**
     * 操作人员
     */
            @ApiModelProperty(value = "操作人员")
                private String ocode;
    @ApiModelProperty(value = "操作人员名称")
    private String oname;
}
