/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.codemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 水表型号
 *
 * @author sxb
 * @date Thu May 18 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_BM_METER_MODEL", resultMap = "bmMeterModelMap")
@KeySequence("TF_YWYS_BM_METER_MODEL")
@ApiModel
public class BmMeterModel extends Model<BmMeterModel> {
    private static final long serialVersionUID = 1L;

    /**
     * 型号编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "型号编码")
    private Integer code;
    /**
     * 水表厂家编码bm_METER_FACTORY.CODE
     */
    @ApiModelProperty(value = "水表厂家编码bm_METER_FACTORY.CODE")
    private String meterFactory;
    /**
     * 型号名称
     */
    @ApiModelProperty(value = "型号名称")
    private String name;
    /**
     * 水表大小
     */
    @ApiModelProperty(value = "水表大小")
    private String meterSize;
    /**
     * 检测参数TEST_parameter
     */
    @ApiModelProperty(value = "检测参数TEST_parameter")
    private String testPara;
    /**
     * 采样点
     */
    @ApiModelProperty(value = "采样点")
    private String samplePoint;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String ocode;
    @ApiModelProperty(value = "操作人员名称")
    private String oname;
    /**
     * 是否启用：0不启用，1启用
     */
    @ApiModelProperty(value = "是否启用：0不启用，1启用")
    private String isdisabled;

}
