/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.codemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 表本(小区)编码
 *
 * @author admin
 * @date Fri Jun 30 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_BM_MR_BOOK", resultMap = "bmMrBookMap")
@KeySequence("TF_YWYS_BM_MR_BOOK")
@ApiModel
public class BmMrBook extends Model<BmMrBook> {
    private static final long serialVersionUID = 1L;

    /**
     * 表本编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "表本编码")
    private BigDecimal code;
    /**
     * 表本名称
     */
    @ApiModelProperty(value = "表本名称")
    private String name;
    /**
     * 表本地址描述
     */
    @ApiModelProperty(value = "表本地址描述")
    private String address;
    /**
     * 所属抄表员
     */
    @ApiModelProperty(value = "所属抄表员")
    private String mrOcode;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String companyBranch;
    /**
     * 所属片区
     */
    @ApiModelProperty(value = "所属片区")
    private String mrArea;
    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    private String remark;
    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 修改日期
     */
    @ApiModelProperty(value = "修改日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mdate;
    /**
     * 操作人员
     */
    @ApiModelProperty(value = "操作人员")
    private String ocode;
    /**
     * 抄表员生效标志(0=当月生效，1=下月生效)
     */
    @ApiModelProperty(value = "抄表员生效标志(0=当月生效，1=下月生效)")
    private String sxFlag;
    /**
     * 下月抄表员的编码(仅当SX_FLAG='1'时有效，月末结转时更新)
     */
    @ApiModelProperty(value = "下月抄表员的编码(仅当SX_FLAG='1'时有效，月末结转时更新)")
    private String xyMrOcode;
}
