/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.codemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 子集编码表
 *
 * @author admin
 * @date Thu Jun 08 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_SYS_CHILD_CODE", resultMap = "sysChildCodeMap")
@KeySequence("TF_YWYS_SYS_CHILD_CODE")
@ApiModel
public class SysChildCode extends Model<SysChildCode> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键编号
     */
    @TableId(value = "CCID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键编号")
    private Long ccid;
    /**
     * 编码
     */
    @ApiModelProperty(value = "编码")
    private String code;
    /**
     * 名称
     */
    @ApiModelProperty(value = "名称")
    private String name;
    /**
     * 注释
     */
    @ApiModelProperty(value = "注释")
    private String content;
    /**
     * 是否禁用(0=禁用,1=启用)
     */
    @ApiModelProperty(value = "是否禁用(0=禁用,1=启用)")
    private String isdisabled;
    /**
     * 父级编号
     */
    @ApiModelProperty(value = "父级编号")
    private Long pcid;
    /**
     * 父级名称
     */
    @ApiModelProperty(value = "父级名称")
    private String pcname;

}
