/*
 * Author: wangjian
 * 生成mapper
 */
package com.tofly.fees.codemgt.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.fees.codemgt.entity.BmMrArea;
import com.tofly.fees.userprofilemgt.entity.DaCustomerSelect;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;

import java.util.List;

/**
 * 抄表片区
 *
 * @author admin
 * @date Fri Jun 30 00:00:00 CST 2023
 */
public interface BmMrAreaMapper extends BaseMapper<BmMrArea> {
    /**
     * 自定义分页列表数据
     *
     * @param page 分页对象
     * @param searchText    模糊查询(编码、名称、备注)
     * @param companyBranch 公司编码值
     * @return 分页列表数据
     */
    Page<BmMrArea> getPageList(@Param("page") Page<BmMrArea> page, String searchText, String companyBranch);

    /**
     * 判断片区编码是否已被使用
     *
     * @param mrCode 片区编码
     * @return 大于0表示被使用，等于0未使用
     */
    Integer checkMrCodeIsUse(BigDecimal mrCode);
}
