/*
 * Author: wangjian
 * 生成mapper
 */
package com.tofly.fees.codemgt.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.fees.codemgt.entity.BmMrBook;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表本(小区)编码
 *
 * @author admin
 * @date Fri Jun 30 00:00:00 CST 2023
 */
public interface BmMrBookMapper extends BaseMapper<BmMrBook> {

    /**
     * 查询分页数据
     *
     * @param page          分页对象
     * @param companyBranch 公司编码值
     * @param mrArea        片区编码
     * @param searchText    模糊查询(编码、名称、备注)
     * @return 分页列表数据
     */
    @MapKey("code")
    IPage<Map<String, Object>> getPageList(Page page, String companyBranch, String mrArea, String searchText);

    /**
     * 判断抄表本编码是否已被使用
     *
     * @param bookCode 抄表本编码
     * @return 大于0表示被使用，等于0未使用
     */
    Integer checkBookCodeIsUse(BigDecimal bookCode);
}
