package com.tofly.fees.codemgt.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.fees.codemgt.entity.BmMrArea;
import com.tofly.fees.financialmgt.entity.BmUwTypeEntity;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.BeanUtils;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

public class BmMrAreaAddForm {
    private static final long serialVersionUID = 1L;

    /**
     * 抄表片区编码
     */
    @TableId(value = "CODE", type = IdType.INPUT)
    @ApiModelProperty(value = "抄表片区编码")
    private BigDecimal code;
    /**
     * 抄表片区名称
     */
    @ApiModelProperty(value = "抄表片区名称")
    private String name;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private Long companyBranch;

    @ApiModelProperty("所属公司名称")
    private String companyName;

    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cdate;
    /**
     * 修改时间
     */
    @ApiModelProperty(value = "修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mdate;
    /**
     * 修改人员编码
     */
    @ApiModelProperty(value = "修改人员编码")
    private String ocode;


    public BmMrArea toEntity(){
        BmMrArea entity = new BmMrArea();
        BeanUtils.copyProperties(this, entity);
        return entity;
    }
}
