package com.tofly.fees.common;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.fees.common.BaseController;

import com.tofly.fees.common.mapper.CommonMapper;
import com.tofly.fees.common.model.CollectionData;
import com.tofly.fees.common.util.ToolsUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.ObjectUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.poi.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.sql.ResultSet;
import java.util.*;

@RestController
@AllArgsConstructor
@RequestMapping("/EsayController")
@Api(tags = "EsayController")
public class EsayCommController extends BaseController {

    private CommonMapper commonMapper;

    @ToFlyAppLog(title = "公用码表查询")
    @ApiOperation(value = "公用码表查询")
    @GetMapping("/getCode")
    public ResultRespone getCode(@ApiParam(value = "表名", required = true)
                                 @RequestParam String tableName,
                                 @ApiParam(value = "key值", required = true)
                                 @RequestParam String key,
                                 @ApiParam(value = "value值", required = true)
                                 @RequestParam String value,
                                 @ApiParam(value = "排序关键字")
                                 @RequestParam String orderField,
                                 @ApiParam(value = "排序[ asc ,desc]",allowableValues ="asc,desc")
                                 @RequestParam String orderWay,
                                 @ApiParam(value = "查询对象")
                                 @RequestParam Object strWhere
                                 ) throws Exception {

        String sql = String.format("select %s as \""+key+"\",%s as \""+value+"\" from %s where 1=1", key, value, tableName);
        String str = ObjectUtils.toString(strWhere, "");

        if(!StringUtils.isBlank(str)){
            JSONObject jsonObj=JSONObject.parseObject(str);
            for (Map.Entry<String, Object> entry : jsonObj.entrySet()) {
                System.out.println(entry.getKey());
                System.out.println(entry.getValue());
                sql+=String.format(" and %s = '%s' ",entry.getKey(),entry.getValue());
            }
        }

        if (!StringUtils.isBlank(orderField)) {
            sql += String.format("order by %s %s", orderField, orderWay);
        }
        //System.out.println(sql);
        List<HashMap<String,Object>> rs = commonMapper.query(sql);
        CollectionData data=new CollectionData(rs,rs.size());
        return ResultRespone.success(data);
    }

}
