package com.tofly.fees.common.Ftp;

import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
@Component
public class FtpService {
    private static final String FTP_SERVER = "192.168.2.233";
    private static final int FTP_PORT = 21;
    private static final String FTP_USERNAME = "ftpuser";
    private static final String FTP_PASSWORD = "ftpuser";
    public void uploadFile(MultipartFile file, String remoteFilePath) throws IOException {
        FTPClient ftpClient = new FTPClient();
        String localFilePath = "/opt/ftp/fptpath/" + file.getOriginalFilename();
        try {
            ftpClient.connect(FTP_SERVER, FTP_PORT);
            ftpClient.login(FTP_USERNAME, FTP_PASSWORD);
            ftpClient.enterLocalPassiveMode();
            ftpClient.setFileType(FTP.BINARY_FILE_TYPE);
            File convertedFile = convertMultiPartToFile(file);
            FileInputStream inputStream = new FileInputStream(convertedFile);
            ftpClient.storeFile(remoteFilePath, inputStream);
          //  ftpClient.storeFile(remoteFilePath, new FileInputStream(localFilePath));
            inputStream.close();
            convertedFile.delete();
        } finally {
            if (ftpClient.isConnected()) {
                ftpClient.logout();
                ftpClient.disconnect();
            }
        }
    }
    public File downloadFile(String remoteFilePath, String localFilePath) throws IOException {
        FTPClient ftpClient = new FTPClient();
        try {
            ftpClient.connect(FTP_SERVER, FTP_PORT);
            ftpClient.login(FTP_USERNAME, FTP_PASSWORD);
            ftpClient.enterLocalPassiveMode();
            ftpClient.setFileType(FTP.BINARY_FILE_TYPE);
            File downloadedFile = new File(localFilePath);
            FileOutputStream outputStream = new FileOutputStream(downloadedFile);
            ftpClient.retrieveFile(remoteFilePath, outputStream);
            outputStream.close();
            return downloadedFile;
        } finally {
            if (ftpClient.isConnected()) {
                ftpClient.logout();
                ftpClient.disconnect();
            }
        }
    }
    private File convertMultiPartToFile(MultipartFile file) throws IOException {
        File convertedFile = new File(file.getOriginalFilename());
        FileOutputStream fileOutputStream = new FileOutputStream(convertedFile);
        fileOutputStream.write(file.getBytes());
        fileOutputStream.close();
        return convertedFile;
    }
}