package com.tofly.fees.common.annotate.repeatableHttpServletRequest;

import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.servlet.Filter;

/**
 * @description:
 * @Title: FilterRegistrationConfiguration
 * @Package com.tofly.fees.common.annotate
 * @Date 2023-06-27 13:36
 */
@Configuration
public class FilterRegistrationConfiguration {
    @Bean
    public FilterRegistrationBean someFilterRegistration() {
        FilterRegistrationBean registration = new FilterRegistrationBean();
        registration.setFilter(repeatableFilter());
        registration.addUrlPatterns("/*");
        registration.setName("repeatableFilter");
        registration.setOrder(1);
        return registration;
    }

    @Bean
    public Filter repeatableFilter() {
        return new RepeatableFilter();
    }
}
