package com.tofly.fees.common.enums;

import com.baomidou.mybatisplus.annotation.EnumValue;

/**
 * 数据表的主键ID枚举
 * @author shudong
 */
public enum TableIdEnum {

    /**
     * 主键ID为guid值
     */
    GUID,
    /**
     * 最大ID，生成insert语句时取【最大的数字id+1】
     */
    MaxID,
    /**
     * 数据库的自增标识列，生成insert语句时不处理
     */
    AutoIncrement,
    /**
     * 其他自定义字符，非guid、自增、MaxID方式，当做普通字段存值
     */
    Other
}
