package com.tofly.fees.common.util;

import java.text.NumberFormat;

/**
 * 数字转换处理类
 *
 * @author shudong
 */
public class NumberUtils {

    private final static NumberFormat numberFormat = NumberFormat.getInstance();

    /**
     * Object类型转字符串
     *
     * @param obj 对象
     * @return 字符串
     */
    public static String toString(Object obj) {
        return numberFormat.format(obj);
    }

    /**
     * double数字转字符串（如4.0，转换后为”4“，而不是”4.0“）
     *
     * @param dNum 数字
     * @return 字符串
     */
    public static String toString(double dNum) {
        return numberFormat.format(dNum);
    }

    /**
     * long数字转字符串
     *
     * @param dNum 数字
     * @return 字符串
     */
    public static String toString(long dNum) {
        return numberFormat.format(dNum);
    } 
}
