package com.tofly.fees.common.util;

import com.tofly.fees.common.mapper.CommonMapper;

/**
 * 系统配置公用处理类
 *
 * @author shudong
 */
public class SysConfigUtils {

    private static CommonMapper commonMapper=SpringContextHolder.getBean("commonMapper");

    /**
     * 通过配置ID查询配置值
     *
     * @param strPZid 配置ID
     * @return 配置值
     */
    public static String getConfigValue(String strPZid) {
        return commonMapper.getConfigValueByPZID(strPZid);
    }

    /**
     * 通过公司编码查询当前的财务日期值
     *
     * @param companyBranch 公司编码
     * @return 财务日期
     */
    public static String getBillYearMonth(String companyBranch) {
        return commonMapper.getBillMonthByCompanyBranch(companyBranch);
    }
}
