/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.feesmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 实收明细：实收明细
 *
 * @author xb
 * @date Wed Jun 07 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_SF_CHARGE", resultMap = "sfChargeMap")
@KeySequence("TF_YWYS_SF_CHARGE")
@ApiModel
public class SfCharge extends Model<SfCharge> {
    private static final long serialVersionUID = 1L;


    /**
     * $column.comments
     */
    @TableId(value = "CHARGE_TYPE", type = IdType.INPUT)
    @ApiModelProperty(value = "$column.comments")
    private String chargeType;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String chargeOcode;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String chargeOname;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private BigDecimal printTimes;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String realPayMode;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date realChargeDate;
    /**
     * 冲红标志：0未冲红，1已冲红，2红票
     */
    @ApiModelProperty(value = "冲红标志：0未冲红，1已冲红，2红票")
    private String cancelFlag;
    /**
     * 冲红ID，红票ID号
     */
    @ApiModelProperty(value = "冲红ID，红票ID号")
    private String cancelId;
    /**
     * 冲红时间
     */
    @ApiModelProperty(value = "冲红时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date cancelDate;
    /**
     * 冲红人员编码
     */
    @ApiModelProperty(value = "冲红人员编码")
    private String cancelOcode;
    /**
     * 冲红人员姓名
     */
    @ApiModelProperty(value = "冲红人员姓名")
    private String cancelOname;
    /**
     * 抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯，4超定额，5两高一剩；用于判断计价类型，处理显示水价）
     */
    @ApiModelProperty(value = "抄表计算标志（0正常单价，1一表多价，2阶梯,3 一表多价含阶梯，4超定额，5两高一剩；用于判断计价类型，处理显示水价）")
    private String mrCalFlag;
    /**
     * 抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯，超定额，两高一剩；用于查询显示）
     */
    @ApiModelProperty(value = "抄表计算方式（正常单价计费，一表多价计费，阶梯计费, 一表多价含阶梯，超定额，两高一剩；用于查询显示）")
    private String mrCalMode;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceName;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceAddress;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceNsrsbh;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceBankName;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceBankAccount;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoicePhone;
    /**
     * 抄表类型bm_mr_type.code
     */
    @ApiModelProperty(value = "抄表类型bm_mr_type.code")
    private BigDecimal mrType;
    /**
     * 抄表方式:bm_mr_mode
     */
    @ApiModelProperty(value = "抄表方式:bm_mr_mode")
    private String mrMode;
    /**
     * 旧表止读
     */
    @ApiModelProperty(value = "旧表止读")
    private BigDecimal oldMeterEreading;
    /**
     * 新表起度
     */
    @ApiModelProperty(value = "新表起度")
    private BigDecimal newMeterBreading;
    /**
     * 抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）
     */
    @ApiModelProperty(value = "抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄）")
    private String mrDataSource;
    /**
     * 抄表次数
     */
    @ApiModelProperty(value = "抄表次数")
    private BigDecimal mrTimes;
    /**
     * 费用类型编码：bm_fee_type
     */
    @ApiModelProperty(value = "费用类型编码：bm_fee_type")
    private String feeType;
    /**
     * 缴费渠道
     */
    @ApiModelProperty(value = "缴费渠道")
    private String chargeChannel;
    /**
     * 年度累计量(计算前）
     */
    @ApiModelProperty(value = "年度累计量(计算前）")
    private BigDecimal yearCumQuantityB;
    /**
     * 年度累计量
     */
    @ApiModelProperty(value = "年度累计量")
    private BigDecimal yearCumQuantityA;
    /**
     * 多人口
     */
    @ApiModelProperty(value = "多人口")
    private BigDecimal population;
    /**
     * 水价2.阶梯1水量
     */
    @ApiModelProperty(value = "水价2.阶梯1水量")
    private BigDecimal price1Tiered1Quantity;
    /**
     * 水价2.阶梯1水价
     */
    @ApiModelProperty(value = "水价2.阶梯1水价")
    private Double price1Tiered1Price;
    /**
     * 水价2.阶梯1水费
     */
    @ApiModelProperty(value = "水价2.阶梯1水费")
    private Double price1Tiered1Amount;
    /**
     * 水价2.阶梯2水量
     */
    @ApiModelProperty(value = "水价2.阶梯2水量")
    private BigDecimal price1Tiered2Quantity;
    /**
     * 水价2.阶梯2水价
     */
    @ApiModelProperty(value = "水价2.阶梯2水价")
    private Double price1Tiered2Price;
    /**
     * 水价2.阶梯2水费
     */
    @ApiModelProperty(value = "水价2.阶梯2水费")
    private Double price1Tiered2Amount;
    /**
     * 水价2.阶梯3水量
     */
    @ApiModelProperty(value = "水价2.阶梯3水量")
    private BigDecimal price1Tiered3Quantity;
    /**
     * 水价2.阶梯3水价
     */
    @ApiModelProperty(value = "水价2.阶梯3水价")
    private Double price1Tiered3Price;
    /**
     * 水价2.阶梯3水费
     */
    @ApiModelProperty(value = "水价2.阶梯3水费")
    private Double price1Tiered3Amount;
    /**
     * 水价2.阶梯4水量
     */
    @ApiModelProperty(value = "水价2.阶梯4水量")
    private BigDecimal price1Tiered4Quantity;
    /**
     * 水价2.阶梯4水价
     */
    @ApiModelProperty(value = "水价2.阶梯4水价")
    private Double price1Tiered4Price;
    /**
     * 水价2.阶梯4水费
     */
    @ApiModelProperty(value = "水价2.阶梯4水费")
    private Double price1Tiered4Amount;
    /**
     * 水价3.阶梯1水量
     */
    @ApiModelProperty(value = "水价3.阶梯1水量")
    private BigDecimal price2Tiered1Quantity;
    /**
     * 水价3.阶梯1水价
     */
    @ApiModelProperty(value = "水价3.阶梯1水价")
    private Double price2Tiered1Price;
    /**
     * 水价3.阶梯1水费
     */
    @ApiModelProperty(value = "水价3.阶梯1水费")
    private Double price2Tiered1Amount;
    /**
     * 水价3.阶梯2水量
     */
    @ApiModelProperty(value = "水价3.阶梯2水量")
    private BigDecimal price2Tiered2Quantity;
    /**
     * 水价3.阶梯2水价
     */
    @ApiModelProperty(value = "水价3.阶梯2水价")
    private Double price2Tiered2Price;
    /**
     * 水价3.阶梯2水费
     */
    @ApiModelProperty(value = "水价3.阶梯2水费")
    private Double price2Tiered2Amount;
    /**
     * 水价3.阶梯3水量
     */
    @ApiModelProperty(value = "水价3.阶梯3水量")
    private BigDecimal price2Tiered3Quantity;
    /**
     * 水价3.阶梯3水价
     */
    @ApiModelProperty(value = "水价3.阶梯3水价")
    private Double price2Tiered3Price;
    /**
     * 水价3.阶梯3水费
     */
    @ApiModelProperty(value = "水价3.阶梯3水费")
    private Double price2Tiered3Amount;
    /**
     * 水价3.阶梯4水量
     */
    @ApiModelProperty(value = "水价3.阶梯4水量")
    private BigDecimal price2Tiered4Quantity;
    /**
     * 水价3.阶梯4水价
     */
    @ApiModelProperty(value = "水价3.阶梯4水价")
    private Double price2Tiered4Price;
    /**
     * 水价3.阶梯4水费
     */
    @ApiModelProperty(value = "水价3.阶梯4水费")
    private Double price2Tiered4Amount;
    /**
     * 客户姓名
     */
    @ApiModelProperty(value = "客户姓名")
    private String customerName;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private BigDecimal chargeOrderNo;
    /**
     * 费用类型名称
     */
    @ApiModelProperty(value = "费用类型名称")
    private String feeTypeName;
    /**
     * 是否补差（0：否；1：是）
     */
    @ApiModelProperty(value = "是否补差（0：否；1：是）")
    private String isBc;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String bankSerialNo;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String chargePch;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String printOcode;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String printOname;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date printDate;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String printState;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double changeBalance;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceType;
    /**
     * 税率：单位（%）0,3,6,13
     */
    @ApiModelProperty(value = "税率：单位（%）0,3,6,13")
    private Double taxRate;
    /**
     * 超定量（防止变更后报表变化）
     */
    @ApiModelProperty(value = "超定量（防止变更后报表变化）")
    private Long overQuantity;
    /**
     * 实收ID:用于部分收费时拆分实收，newid()
     */
    @ApiModelProperty(value = "实收ID:用于部分收费时拆分实收，newid()")
    private String id;
    /**
     * 应收id
     */
    @ApiModelProperty(value = "应收id")
    private String recId;
    /**
     * 应收流水号，流水号相同欠费是一次抄表产生的同一笔欠费
     */
    @ApiModelProperty(value = "应收流水号，流水号相同欠费是一次抄表产生的同一笔欠费")
    private String feeSerialNo;
    /**
     * 抄表卡ID，对应TF_YWYS_DA_METER.meter_card_id
     */
    @ApiModelProperty(value = "抄表卡ID，对应TF_YWYS_DA_METER.meter_card_id")
    private BigDecimal meterCardId;
    /**
     * 客户编号
     */
    @ApiModelProperty(value = "客户编号")
    private String customerNo;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号")
    private BigDecimal meterCardNo;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    private String companyBranch;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    private BigDecimal mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private BigDecimal mrBook;
    /**
     * 用水月份
     */
    @ApiModelProperty(value = "用水月份")
    private BigDecimal yearMonth;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    private BigDecimal billYearMonth;
    /**
     * 上次读数
     */
    @ApiModelProperty(value = "上次读数")
    private BigDecimal lastReading;
    /**
     * 本次读数
     */
    @ApiModelProperty(value = "本次读数")
    private BigDecimal thisReading;
    /**
     * 加减量
     */
    @ApiModelProperty(value = "加减量")
    private BigDecimal jjl;
    /**
     * 水量
     */
    @ApiModelProperty(value = "水量")
    private BigDecimal quantity;
    /**
     * 水价编码
     */
    @ApiModelProperty(value = "水价编码")
    private String priceCode;
    /**
     * 水价
     */
    @ApiModelProperty(value = "水价")
    private BigDecimal price;
    /**
     * 水费
     */
    @ApiModelProperty(value = "水费")
    private BigDecimal amount;
    /**
     * 污水费单价
     */
    @ApiModelProperty(value = "污水费单价")
    private BigDecimal sewageFeePrice;
    /**
     * 污水费
     */
    @ApiModelProperty(value = "污水费")
    private BigDecimal sewageFee;
    /**
     * 垃圾费单价
     */
    @ApiModelProperty(value = "垃圾费单价")
    private BigDecimal garbageFeePrice;
    /**
     * 垃圾费
     */
    @ApiModelProperty(value = "垃圾费")
    private BigDecimal garbageFee;
    /**
     * 水价编码2（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码2（一表多价时存储）")
    private String priceCode1;
    /**
     * 水价2（一表多价时存储）
     */
    @ApiModelProperty(value = "水价2（一表多价时存储）")
    private BigDecimal price1;
    /**
     * 水量2（一表多价时存储）
     */
    @ApiModelProperty(value = "水量2（一表多价时存储）")
    private BigDecimal quantity1;
    /**
     * 水费2（一表多价时存储）
     */
    @ApiModelProperty(value = "水费2（一表多价时存储）")
    private BigDecimal amount1;
    /**
     * 污水费单价2
     */
    @ApiModelProperty(value = "污水费单价2")
    private BigDecimal sewageFeePrice1;
    /**
     * 污水费2
     */
    @ApiModelProperty(value = "污水费2")
    private BigDecimal sewageFee1;
    /**
     * 垃圾费单价2
     */
    @ApiModelProperty(value = "垃圾费单价2")
    private BigDecimal garbageFeePrice1;
    /**
     * 垃圾费2
     */
    @ApiModelProperty(value = "垃圾费2")
    private BigDecimal garbageFee1;
    /**
     * 水价编码3（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码3（一表多价时存储）")
    private String priceCode2;
    /**
     * 水价3（一表多价时存储）
     */
    @ApiModelProperty(value = "水价3（一表多价时存储）")
    private BigDecimal price2;
    /**
     * 水量3（一表多价时存储）
     */
    @ApiModelProperty(value = "水量3（一表多价时存储）")
    private BigDecimal quantity2;
    /**
     * 水费3（一表多价时存储）
     */
    @ApiModelProperty(value = "水费3（一表多价时存储）")
    private BigDecimal amount2;
    /**
     * 污水费单价3
     */
    @ApiModelProperty(value = "污水费单价3")
    private BigDecimal sewageFeePrice2;
    /**
     * 污水费3
     */
    @ApiModelProperty(value = "污水费3")
    private BigDecimal sewageFee2;
    /**
     * 垃圾费单价3
     */
    @ApiModelProperty(value = "垃圾费单价3")
    private BigDecimal garbageFeePrice2;
    /**
     * 垃圾费3
     */
    @ApiModelProperty(value = "垃圾费3")
    private BigDecimal garbageFee2;
    /**
     * 水价编码4（一表多价时存储）
     */
    @ApiModelProperty(value = "水价编码4（一表多价时存储）")
    private String priceCode3;
    /**
     * 水价4（一表多价时存储）
     */
    @ApiModelProperty(value = "水价4（一表多价时存储）")
    private BigDecimal price3;
    /**
     * 水量4（一表多价时存储）
     */
    @ApiModelProperty(value = "水量4（一表多价时存储）")
    private BigDecimal quantity3;
    /**
     * 水费4（一表多价时存储）
     */
    @ApiModelProperty(value = "水费4（一表多价时存储）")
    private BigDecimal amount3;
    /**
     * 污水费单价4
     */
    @ApiModelProperty(value = "污水费单价4")
    private BigDecimal sewageFeePrice3;
    /**
     * 污水费4
     */
    @ApiModelProperty(value = "污水费4")
    private BigDecimal sewageFee3;
    /**
     * 垃圾费单价4
     */
    @ApiModelProperty(value = "垃圾费单价4")
    private BigDecimal garbageFeePrice3;
    /**
     * 垃圾费4
     */
    @ApiModelProperty(value = "垃圾费4")
    private BigDecimal garbageFee3;
    /**
     * 抄表人员编码
     */
    @ApiModelProperty(value = "抄表人员编码")
    private String mrOcode;
    /**
     * 抄表人员姓名
     */
    @ApiModelProperty(value = "抄表人员姓名")
    private String mrOname;
    /**
     * 抄表日期
     */
    @ApiModelProperty(value = "抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mrDate;
    /**
     * 录入人员编码
     */
    @ApiModelProperty(value = "录入人员编码")
    private String inputOcode;
    /**
     * 录入人员姓名
     */
    @ApiModelProperty(value = "录入人员姓名")
    private String inputOname;
    /**
     * 录入日期
     */
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date inputDate;
    /**
     * 计算日期
     */
    @ApiModelProperty(value = "计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date calDate;
    /**
     * 应收水量（sl+sl1+sl2+sl3）
     */
    @ApiModelProperty(value = "应收水量（sl+sl1+sl2+sl3）")
    private BigDecimal recQuantity;
    /**
     * 应收水费（sf+sf1+sf2+sf3）
     */
    @ApiModelProperty(value = "应收水费（sf+sf1+sf2+sf3）")
    private BigDecimal recFeeAmount;
    /**
     * 应收污水费（wsf+wsf1+wsf2+wsf3）
     */
    @ApiModelProperty(value = "应收污水费（wsf+wsf1+wsf2+wsf3）")
    private BigDecimal recSewageFee;
    /**
     * 应收垃圾费
     */
    @ApiModelProperty(value = "应收垃圾费")
    private BigDecimal recGarbageFee;
    /**
     * 应收其它费
     */
    @ApiModelProperty(value = "应收其它费")
    private BigDecimal recOther;
    /**
     * 应收金额=应收水费+应收污水费+应收垃圾费+应收其他费
     */
    @ApiModelProperty(value = "应收金额=应收水费+应收污水费+应收垃圾费+应收其他费")
    private BigDecimal recAmount;
    /**
     * 阶梯1水量
     */
    @ApiModelProperty(value = "阶梯1水量")
    private BigDecimal priceTiered1Quantity;
    /**
     * 阶梯1水价
     */
    @ApiModelProperty(value = "阶梯1水价")
    private Double priceTiered1Price;
    /**
     * 阶梯1水费
     */
    @ApiModelProperty(value = "阶梯1水费")
    private Double priceTiered1Amount;
    /**
     * 阶梯2水量
     */
    @ApiModelProperty(value = "阶梯2水量")
    private BigDecimal priceTiered2Quantity;
    /**
     * 阶梯2水价
     */
    @ApiModelProperty(value = "阶梯2水价")
    private Double priceTiered2Price;
    /**
     * 阶梯2水费
     */
    @ApiModelProperty(value = "阶梯2水费")
    private Double priceTiered2Amount;
    /**
     * 阶梯3水量
     */
    @ApiModelProperty(value = "阶梯3水量")
    private BigDecimal priceTiered3Quantity;
    /**
     * 阶梯3水价
     */
    @ApiModelProperty(value = "阶梯3水价")
    private Double priceTiered3Price;
    /**
     * 阶梯3水费
     */
    @ApiModelProperty(value = "阶梯3水费")
    private Double priceTiered3Amount;
    /**
     * 阶梯4水量
     */
    @ApiModelProperty(value = "阶梯4水量")
    private BigDecimal priceTiered4Quantity;
    /**
     * 阶梯4水价
     */
    @ApiModelProperty(value = "阶梯4水价")
    private Double priceTiered4Price;
    /**
     * 阶梯4水费
     */
    @ApiModelProperty(value = "阶梯4水费")
    private Double priceTiered4Amount;
    /**
     * 违约金天数
     */
    @ApiModelProperty(value = "违约金天数")
    private BigDecimal penaltyDays;
    /**
     * 违约金费率
     */
    @ApiModelProperty(value = "违约金费率")
    private BigDecimal penaltyRate;
    /**
     * 违约金
     */
    @ApiModelProperty(value = "违约金")
    private BigDecimal penalty;
    /**
     * 违约金计算日期
     */
    @ApiModelProperty(value = "违约金计算日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date penaltyCalDate;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double payPenalty;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double payTotalAmount;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double lastBalance;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double thisPrestore;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double thisDeduct;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Double thisBalance;
    /**
     * 收费标志,0未收 1已收 4不收费
     */
    @ApiModelProperty(value = "收费标志,0未收 1已收 4不收费")
    private String chargeFlag;
    /**
     * 收费日期
     */
    @ApiModelProperty(value = "收费日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date chargeDate;
    /**
     * 收费流水编号
     */
    @ApiModelProperty(value = "收费流水编号")
    private String chargeSerialNo;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceGroup;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoiceNo;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoice1Group;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoice1No;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoice2Group;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String invoice2No;

    @TableField(exist = false) //不映射此字段数据库
    @ApiModelProperty(value = "用户地址")
    private String customerAddress;
}
