/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.feesmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 客户资金账号
 *
 * @author xb
 * @date Wed Jun 07 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_SF_CUS_ACC", resultMap = "sfCusAccMap")
@KeySequence("TF_YWYS_SF_CUS_ACC")
@ApiModel
public class SfCusAcc extends Model<SfCusAcc> {
    private static final long serialVersionUID = 1L;

    /**
     * NB剩余金额
     */
    @ApiModelProperty(value = "NB剩余金额")
    private Double nbBalanceAmount;
    /**
     * 用户编号
     */
    @TableId(value = "CUSTOMER_NO", type = IdType.INPUT)
    @ApiModelProperty(value = "用户编号")
    private String customerNo;
    /**
     * 预付金额
     */
    @ApiModelProperty(value = "预付金额")
    private Double prestoreAmount;
    /**
     * 扣减金额
     */
    @ApiModelProperty(value = "扣减金额")
    private Double deductAmount;
    /**
     * 剩余金额
     */
    @ApiModelProperty(value = "剩余金额")
    private Double balanceAmount;

}
