package com.tofly.fees.financialmgt.controller_easy;

import cn.hutool.db.meta.JdbcType;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.fees.common.BaseController;
import com.tofly.fees.common.annotate.requestPostSingle.RequestPostSingleParam;
import com.tofly.fees.common.dbhelper.DbHelper;
import com.tofly.fees.common.enums.SysEnum;
import com.tofly.fees.common.model.CollectionData;
import com.tofly.fees.common.model.PageLink;
import com.tofly.fees.common.model.ProcParamModel;
import com.tofly.fees.common.util.DateUtils;
import com.tofly.fees.common.util.XmlUtils;
import com.tofly.fees.financialmgt.entity.SfRec;
import com.tofly.fees.financialmgt.service.SfRecService;
import com.tofly.fees.userprofilemgt.entity.DaCustomer;
import com.tofly.fees.userprofilemgt.service.DaCustomerService;
import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import lombok.Data;
import org.apache.ibatis.io.Resources;
import org.apache.ibatis.mapping.ParameterMode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.repository.query.Param;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.*;

import java.io.InputStream;
import java.sql.JDBCType;
import java.sql.ParameterMetaData;
import java.util.*;
import java.util.stream.Collectors;

import static com.tofly.fees.common.ControllerConstants.*;
import static com.tofly.fees.common.ControllerConstants.Mapper_Redis_Prix;

/**
 * @description:
 * @Title: SfRecEasyController
 * @Package com.tofly.fees.financialmgt.controller_esay
 * @Author 芝士汉堡
 * @Date 2023-07-05 10:37
 */

@RestController
@AllArgsConstructor
@RequestMapping("/api/financialmgt/sfrec")
@Api(tags = "核算管理-欠费明细(含欠费变更)接口")
public class SfRecEasyController extends BaseController {


    @Autowired
    private final SfRecService sfRecService;
    @Autowired
    private final DaCustomerService daCustomerService;

    /**
     * 分页查询
     *
     * @param 分页对象
     * @return
     */
    @GetMapping("/getListByCustomerNo")
    @ApiOperation(value = "[Easy]查询欠费不分页")
    public ResultRespone getRecPage(@ApiParam(value = "用户编号")
                                    @RequestParam(value = "customerNo", defaultValue = "") String customerNo
    ) throws Exception {


        DbHelper db = DbHelper.getDbHelper();
        // List<HashMap<String, Object>> lst = new ArrayList<>();
//        //参数
//        Map<String, Object> params = new HashMap<>();
//        params.put("V_YHBH", customerNo);
//        params.put("V_ISFFGX", "0");
//        params.put("V_CUR", lst);
//        params.put("V_SFCG", "0");
//
//        //这里要注意参数前面的map固定写法不然读取不了数据
//        Map mp = db.procurdeCmd("{call PROC_CX_QFMX(" +
//                "#{V_YHBH,mode=IN,jdbcType=VARCHAR}," +
//                "#{V_ISFFGX,mode=IN,jdbcType=VARCHAR}," +
//                "#{V_CUR,mode=OUT,jdbcType=CURSOR}," +
//                "#{V_SFCG,mode=OUT,jdbcType=VARCHAR}" +
//                ")}", params, SysEnum.MyBatis.getName());


        //        //这里要注意参数前面的map固定写法不然读取不了数据
//        Map mp = db.procurdeCmd("{call PROC_CX_QFMX }", params, SysEnum.MyBatis.getName());

//        //存储过程返回的参数
//        // ArrayList<Object> arr = (ArrayList<Object>) mp.get("V_CUR");
//        if (mp.get("V_SFCG").equals("0")) {
//            return ResultRespone.success(mp.get("V_CUR"));
//            //return ResultRespone.success(new CollectionData(arr, arr.size()));
//        } else {
//            return ResultRespone.success(new CollectionData(null, 0));
//        }

        List<ProcParamModel> list = new ArrayList<>();
        list.add(new ProcParamModel("V_YHBH", ParameterMode.IN, JDBCType.VARCHAR, customerNo));
        list.add(new ProcParamModel("V_ISFFGX", ParameterMode.IN, JDBCType.VARCHAR, "0"));
        list.add(new ProcParamModel("V_CUR", ParameterMode.OUT, JDBCType.REF_CURSOR, null));
        list.add(new ProcParamModel("V_SFCG", ParameterMode.OUT, JDBCType.VARCHAR, "0"));
        Map map = db.executeProcedure("PROC_CX_QFMX", list);

        //存储过程返回的参数
        if (map != null && map.get("V_SFCG").equals("0")) {
            return ResultRespone.success(map.get("V_CUR"));
        } else {
            return ResultRespone.success(new CollectionData(null, 0));
        }
    }

    @PostMapping("/doCalcFeeByRecId")
    @ApiOperation(value = "欠费明细变更费用算费")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "recId", value = "欠费Id", dataType = "String")
    })
    public ResultRespone doCalcFeeByRecId(@RequestPostSingleParam("recId") String recId) throws Exception {
        if (StringUtils.isBlank(recId)) {
            return ResultRespone.failed("请选择一条欠费信息.");
        }
        SfRec model = sfRecService.getById(recId);


        DaCustomer daCustomerModel = daCustomerService.getById(model.getCustomerNo());
        test t=new test();
        DbHelper db = DbHelper.getDbHelper();
        /*
        List<ProcParamModel> list = new ArrayList<>();
        list.add(new ProcParamModel("P_CWRQ", ParameterMode.IN, JDBCType.INTEGER, model.getBillYearMonth()));
        list.add(new ProcParamModel("P_SJBM", ParameterMode.IN, JDBCType.VARCHAR, model.getPriceCode()));
        list.add(new ProcParamModel("P_SL", ParameterMode.IN, JDBCType.FLOAT, model.getQuantity()));
        list.add(new ProcParamModel("P_WSFBZ", ParameterMode.IN, JDBCType.CHAR,"1"));
        list.add(new ProcParamModel("P_JTRKSL", ParameterMode.IN, JDBCType.FLOAT, "0"));
        list.add(new ProcParamModel("P_JTZQLJL_JSQ", ParameterMode.IN, JDBCType.FLOAT, "0"));
        list.add(new ProcParamModel("P_CDL", ParameterMode.IN, JDBCType.FLOAT, "0"));
        list.add(new ProcParamModel("P_LGYSBZ", ParameterMode.IN, JDBCType.CHAR, "0"));
        list.add(new ProcParamModel("P_RD", ParameterMode.INOUT, JDBCType.JAVA_OBJECT, t));
        list.add(new ProcParamModel("P_SFCG", ParameterMode.OUT, JDBCType.VARCHAR, "0"));
        list.add(new ProcParamModel("P_MSG", ParameterMode.OUT, JDBCType.VARCHAR, "0"));
        Map map = db.executeProcedure("PROC_SLSFJS_BYSJBM", list);
*/

        List<ProcParamModel> list = new ArrayList<>();
        list.add(new ProcParamModel("P_RD", ParameterMode.INOUT, JDBCType.JAVA_OBJECT, t));
        Map map = db.executeProcedure("PROC_SLSFJS_BYSJBM", list);

        return ResultRespone.success(new CollectionData(null, 0));
    }


    @Data
    public  class  test{
        private  String SJBM;
    }

    @Data
    public class T_FYJS {
        private String SJBM;
        private Integer SL;
        private Float SJ;//          NUMBER(18, 4), --水价
        private Float SF;//        NUMBER(18, 2), --水费
        private Float WSFDJ;//    NUMBER(18, 4), --污水费单价
        private Float WSF;//    NUMBER(18, 2), --污水费
        private String LGYS_SJBM;// --两高一剩（特种用水水价编码）
        private Float LGYS_WSFDJ;// NUMBER(18, 4), --两高一剩（特种污水费单价）
        private Float LGYS_WSF;  // NUMBER(18, 22), --两高一剩（特种水价污水费）
        private Float JSLX; // NUMBER, --计算类型（0：正常；1：月阶梯；2：年阶梯；3：超定额水量；4：两高一剩）
        private Float JT1SL;  // NUMBER, --阶梯1.水量
        private Float JT1SJ;  // NUMBER(18, 4), --阶梯1.水价
        private Float JT1SF;   //NUMBER(18, 2), --阶梯1.书费
        private Float JT2SL;    // NUMBER, --阶梯2.水量
        private Float JT2SJ;   // NUMBER(18, 4), --阶梯2.水价
        private Float JT2SF;  //  NUMBER(18, 2), --阶梯2.水费
        private Float JT3SL;  // NUMBER, --阶梯3.水量
        private Float JT3SJ; //  NUMBER(18, 4), --阶梯3.水价
        private Float JT3SF;  // NUMBER(18, 2), --阶梯3.水费
        private Float JT4SL;  //  NUMBER, --阶梯4.水量
        private Float JT4SJ;  // NUMBER(18, 4), --阶梯4.水价
        private Float JT4SF;  // NUMBER(18, 2), --阶梯4.水费
        private Float JTZQLJL_JSQ;//NUMBER, --阶梯周期累计量（算费前）
        private Float JTZQLJL; // NUMBER, --阶梯周期累计量（算费后）
        private Float TAXRATE;  // NUMBER --税率，单位（%）
    }


}
