package com.tofly.fees.financialmgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import com.tofly.fees.financialmgt.model.BmPriceDetailModel;
import com.tofly.fees.financialmgt.model.BmPriceModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.BeanUtils;

/**
 * <p>
 * 水价编码
 * </p>
 *
 * @author decai
 * @since 2023-05-18
 */
@Getter
@Setter
@TableName("TF_YWYS_BM_PRICE")
@ApiModel(value = "BmPriceEntity对象", description = "水价编码")
public class BmPriceEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("水价编码")
    @TableId(type = IdType.ASSIGN_ID)
    private String code;

    @ApiModelProperty("水价名称")
    private String name;

    @ApiModelProperty("水价")
    private Double price;

    @ApiModelProperty("用水类型")
    private String useWaterType;

    @ApiModelProperty("所属公司")
    private Long companyBranch;

    @ApiModelProperty("操作人员")
    private String ocode;

    @ApiModelProperty("创建时间")
    private Date cdate;

    @ApiModelProperty("IC卡充值限量(方)")
    private Integer rechargeLimit;

    @ApiModelProperty("IC卡年充值限量(方)")
    private Integer yearLimit;

    @ApiModelProperty("阶梯标志（1是，0否）")
    private String tieredFlag;

    @ApiModelProperty("阶梯1水量止数")
    private Long tiered1Limit;

    @ApiModelProperty("阶梯1算费水价")
    private Double tiered1Price;

    @ApiModelProperty("阶梯2水量止数")
    private Long tiered2Limit;

    @ApiModelProperty("阶梯2算费水价")
    private Double tiered2Price;

    @ApiModelProperty("阶梯3水量止数")
    private Long tiered3Limit;

    @ApiModelProperty("阶梯3算费水价")
    private Double tiered3Price;

    @ApiModelProperty("阶梯4水量止数")
    private Long tiered4Limit;

    @ApiModelProperty("阶梯4算费水价")
    private Double tiered4Price;

    @ApiModelProperty("污水费单价")
    private Double sewageFeePrice;

    @ApiModelProperty("垃圾费单价")
    private Double garbageFeePrice;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("是否启用：0不启用，1启用")
    private String isdisabled;

    @ApiModelProperty("阶梯计算类型（0：正常；1：月阶梯；2：年阶梯）")
    private String tieredCalType;

    @ApiModelProperty("阶梯算费方式（SL：按水量；BL：按比例）")
    private String tieredCalMode;

    @ApiModelProperty("税率：单位（%）0,3,6,13")
    private Long taxRate;

    public static final String CODE = "CODE";

    public static final String NAME = "NAME";

    public static final String PRICE = "PRICE";

    public static final String USE_WATER_TYPE = "USE_WATER_TYPE";

    public static final String COMPANY_BRANCH = "COMPANY_BRANCH";

    public static final String OCODE = "OCODE";

    public static final String CDATE = "CDATE";

    public static final String RECHARGE_LIMIT = "RECHARGE_LIMIT";

    public static final String YEAR_LIMIT = "YEAR_LIMIT";

    public static final String TIERED_FLAG = "TIERED_FLAG";

    public static final String TIERED1_LIMIT = "TIERED1_LIMIT";

    public static final String TIERED1_PRICE = "TIERED1_PRICE";

    public static final String TIERED2_LIMIT = "TIERED2_LIMIT";

    public static final String TIERED2_PRICE = "TIERED2_PRICE";

    public static final String TIERED3_LIMIT = "TIERED3_LIMIT";

    public static final String TIERED3_PRICE = "TIERED3_PRICE";

    public static final String TIERED4_LIMIT = "TIERED4_LIMIT";

    public static final String TIERED4_PRICE = "TIERED4_PRICE";

    public static final String SEWAGE_FEE_PRICE = "SEWAGE_FEE_PRICE";

    public static final String GARBAGE_FEE_PRICE = "GARBAGE_FEE_PRICE";

    public static final String REMARK = "REMARK";

    public static final String ISDISABLED = "ISDISABLED";

    public static final String TIERED_CAL_TYPE = "TIERED_CAL_TYPE";

    public static final String TIERED_CAL_MODE = "TIERED_CAL_MODE";

    public static final String TAX_RATE = "TAX_RATE";

    public BmPriceModel toModel() {
        BmPriceModel model = new BmPriceModel();
        BeanUtils.copyProperties(this, model);
        if ("1".equals(tieredFlag)) {
            StringBuilder sbPrice = new StringBuilder();
            if (this.tiered1Price != null && this.tiered1Limit != null) {
                sbPrice.append(String.format("阶梯一:单价一(%s) 水量(%s~%s)<br/>", this.tiered1Price, 0, this.tiered1Limit));
            }
            if (this.tiered2Price != null && this.tiered2Limit != null) {
                sbPrice.append(String.format("阶梯二:单价二(%s) 水量(%s~%s)<br/>", this.tiered2Price, this.tiered1Limit + 1, this.tiered2Limit));
            }
            if (this.tiered3Price != null && this.tiered3Limit != null) {
                sbPrice.append(String.format("阶梯三:单价三(%s) 水量(%s~%s)<br/>", this.tiered3Price, this.tiered2Limit + 1, this.tiered3Limit));
            }
            if (this.tiered4Price != null && this.tiered4Limit != null) {
                sbPrice.append(String.format("阶梯四:单价四(%s) 水量(%s~%s)<br/>", this.tiered4Price, this.tiered3Limit + 1, this.tiered4Limit));
            }
            model.setPrice(sbPrice.toString());
        } else {
            model.setPrice(this.price + "");
        }
        return model;
    }
    public BmPriceDetailModel toDetailModel() {
        BmPriceDetailModel model = new BmPriceDetailModel();
        BeanUtils.copyProperties(this, model);
        return model;
    }

    public BmPriceHisEntity toHisEntity() {
        BmPriceHisEntity hisEntity = new BmPriceHisEntity();
        BeanUtils.copyProperties(this, hisEntity);
        return hisEntity;
    }
}
