package com.tofly.fees.financialmgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;

import java.io.Serializable;
import java.util.Date;

import com.tofly.fees.financialmgt.model.BmPriceHisModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.BeanUtils;

/**
 * <p>
 * 水价编码
 * </p>
 *
 * @author decai
 * @since 2023-05-30
 */
@Getter
@Setter
@TableName("TF_YWYS_BM_PRICE_HIS")
@ApiModel(value = "BmPriceHisEntity对象", description = "水价编码")
public class BmPriceHisEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("主键")
    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty("财务日期")
    private long billYearMonth;

    @ApiModelProperty("水价编码")
    private String code;

    @ApiModelProperty("水价名称")
    private String name;

    @ApiModelProperty("水价")
    private Double price;

    @ApiModelProperty("用水类型")
    private String useWaterType;

    @ApiModelProperty("所属公司")
    private String companyBranch;

    @ApiModelProperty("操作人员")
    private String operatorCode;

    @ApiModelProperty("修改时间")
    private Date operatorDate;

    @ApiModelProperty("IC卡充值限量(方)")
    private Integer rechargeLimit;

    @ApiModelProperty("IC卡年充值限量(方)")
    private Integer yearLimit;

    @ApiModelProperty("阶梯标志（1是，0否）")
    private String tieredFlag;

    @ApiModelProperty("阶梯1水量止数")
    private Long tiered1Limit;

    @ApiModelProperty("阶梯1算费水价")
    private Double tiered1Price;

    @ApiModelProperty("阶梯2水量止数")
    private Long tiered2Limit;

    @ApiModelProperty("阶梯2算费水价")
    private Double tiered2Price;

    @ApiModelProperty("阶梯3水量止数")
    private Long tiered3Limit;

    @ApiModelProperty("阶梯3算费水价")
    private Double tiered3Price;

    @ApiModelProperty("阶梯4水量止数")
    private Long tiered4Limit;

    @ApiModelProperty("阶梯4算费水价")
    private Double tiered4Price;

    @ApiModelProperty("污水费单价")
    private Double sewageFeePrice;

    @ApiModelProperty("垃圾费单价")
    private Double garbageFeePrice;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("是否启用：0不启用，1启用")
    private String isdisabled;

    @ApiModelProperty("阶梯计算类型（0：正常；1：月阶梯；2：年阶梯）")
    private String tieredCalType;

    @ApiModelProperty("阶梯算费方式（SL：按水量；BL：按比例）")
    private String tieredCalMode;

    @ApiModelProperty("税率：单位（%）0,3,6,13")
    private Long taxRate;

    public static final String ID = "ID";

    public static final String BILL_YEAR_MONTH = "BILL_YEAR_MONTH";

    public static final String CODE = "CODE";

    public static final String NAME = "NAME";

    public static final String PRICE = "PRICE";

    public static final String USE_WATER_TYPE = "USE_WATER_TYPE";

    public static final String COMPANY_BRANCH = "COMPANY_BRANCH";

    public static final String OPERATOR_CODE = "OPERATOR_CODE";

    public static final String OPERATOR_DATE = "OPERATOR_DATE";

    public static final String RECHARGE_LIMIT = "RECHARGE_LIMIT";

    public static final String YEAR_LIMIT = "YEAR_LIMIT";

    public static final String TIERED_FLAG = "TIERED_FLAG";

    public static final String TIERED1_LIMIT = "TIERED1_LIMIT";

    public static final String TIERED1_PRICE = "TIERED1_PRICE";

    public static final String TIERED2_LIMIT = "TIERED2_LIMIT";

    public static final String TIERED2_PRICE = "TIERED2_PRICE";

    public static final String TIERED3_LIMIT = "TIERED3_LIMIT";

    public static final String TIERED3_PRICE = "TIERED3_PRICE";

    public static final String TIERED4_LIMIT = "TIERED4_LIMIT";

    public static final String TIERED4_PRICE = "TIERED4_PRICE";

    public static final String SEWAGE_FEE_PRICE = "SEWAGE_FEE_PRICE";

    public static final String GARBAGE_FEE_PRICE = "GARBAGE_FEE_PRICE";

    public static final String REMARK = "REMARK";

    public static final String ISDISABLED = "ISDISABLED";

    public static final String TIERED_CAL_TYPE = "TIERED_CAL_TYPE";

    public static final String TIERED_CAL_MODE = "TIERED_CAL_MODE";

    public static final String TAX_RATE = "TAX_RATE";

    public BmPriceHisModel toModel() {
        BmPriceHisModel model = new BmPriceHisModel();
        BeanUtils.copyProperties(this, model);
        return model;
    }
}
