package com.tofly.fees.financialmgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;

import com.tofly.fees.financialmgt.model.BmUwTypeDetailModel;
import com.tofly.fees.financialmgt.model.BmUwTypeModel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.BeanUtils;

/**
 * <p>
 * 用水类型
 * </p>
 *
 * @author decai
 * @since 2023-05-30
 */
@Getter
@Setter
@TableName("TF_YWYS_BM_UW_TYPE")
@ApiModel(value = "BmUwTypeEntity对象", description = "用水类型")
public class BmUwTypeEntity implements Serializable {

    private static final long serialVersionUID = 1L;
    @ApiModelProperty("用水类型编码")
    @TableId(type = IdType.INPUT)
    private String code;

    @ApiModelProperty("用水类型名称")
    private String name;

    @ApiModelProperty("违约金费率")
    private Double penalty;

    @ApiModelProperty("违约金收取方式")
    private String penaltycode;

    @ApiModelProperty("天数、日期")
    private Long penaltyDay;

    @ApiModelProperty("所属公司")
    private Long companyBranch;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("操作人员")
    private String ocode;

    @ApiModelProperty("创建时间")
    private Date cdate;

    public static final String CODE = "CODE";

    public static final String NAME = "NAME";

    public static final String PENALTY = "PENALTY";

    public static final String PENALTYCODE = "PENALTYCODE";

    public static final String PENALTY_DAY = "PENALTY_DAY";

    public static final String COMPANY_BRANCH = "COMPANY_BRANCH";

    public static final String REMARK = "REMARK";

    public static final String OCODE = "OCODE";

    public static final String CDATE = "CDATE";

    public BmUwTypeModel toModel() {
        BmUwTypeModel model = new BmUwTypeModel();
        BeanUtils.copyProperties(this, model);
        return model;
    }
    public BmUwTypeDetailModel toDetailModel() {
        BmUwTypeDetailModel model = new BmUwTypeDetailModel();
        BeanUtils.copyProperties(this, model);
        return model;
    }
}
