/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.financialmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 违约金调整记录表
 *
 * @author sxb
 * @date Tue Jun 27 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_YWYS_SF_PENALTY",resultMap = "sfPenaltyMap")
@KeySequence("TF_YWYS_SF_PENALTY")
@ApiModel
public class SfPenalty extends Model<SfPenalty> {
    private static final long serialVersionUID = 1L;

        /**
     * 调整记录ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "调整记录ID")
                private String id;
                /**
     * 用户编号
     */
            @ApiModelProperty(value = "用户编号")
                private String customerNo;
                /**
     * 欠费流水编号(yy_qfmx.qflsbh；yy.qfmx.chbz='0')
     */
            @ApiModelProperty(value = "欠费流水编号(yy_qfmx.qflsbh；yy.qfmx.chbz='0')")
                private String feeSerialNo;
                /**
     * 所属公司
     */
            @ApiModelProperty(value = "所属公司")
                private String companyBranch;
                /**
     * 用水月份
     */
            @ApiModelProperty(value = "用水月份")
                private BigDecimal yearMonth;
                /**
     * 财务日期
     */
            @ApiModelProperty(value = "财务日期")
                private BigDecimal billYearMonth;
                /**
     * 调整前金额
     */
            @ApiModelProperty(value = "调整前金额")
                private Double beforeChangeAmount;
                /**
     * 调整金额
     */
            @ApiModelProperty(value = "调整金额")
                private Double changeAmount;
                /**
     * 调整后金额
     */
            @ApiModelProperty(value = "调整后金额")
                private Double afterChangeAmount;
                /**
     * 调整原因
     */
            @ApiModelProperty(value = "调整原因")
                private String changeReason;
                /**
     * 审核人员
     */
            @ApiModelProperty(value = "审核人员")
                private String auditCode;
                /**
     * 审核意见
     */
            @ApiModelProperty(value = "审核意见")
                private String auditSuggestion;
                /**
     * 操作人员编码
     */
            @ApiModelProperty(value = "操作人员编码")
                private String ocode;
                /**
     * 操作人员姓名
     */
            @ApiModelProperty(value = "操作人员姓名")
                private String oname;
                /**
     * 操作时间
     */
            @ApiModelProperty(value = "操作时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date cdate;
                /**
     * 有效标志(0未收费，1已收费)
     */
            @ApiModelProperty(value = "有效标志(0未收费，1已收费)")
                private String chargeFlag;
            
}
