package com.tofly.fees.financialmgt.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.util.Date;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 系统归档参数表
 * </p>
 *
 * @author decai
 * @since 2023-05-30
 */
@Getter
@Setter
@TableName("TF_YWYS_SYS_GDCSB")
@ApiModel(value = "SysGdcsbEntity对象", description = "系统归档参数表")
public class SysGdcsbEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("所属公司编码")
    private String companyBranch;

    @ApiModelProperty("财务日期")
    private long billYearMonth;

    @ApiModelProperty("账务日期（月末结转使用）")
    private String accountDate;

    @ApiModelProperty("归档日期")
    private Date gdDate;

    @ApiModelProperty("归档标志（1已归档，0未归档）")
    private String gdFlag;

    public static final String COMPANY_BRANCH = "COMPANY_BRANCH";

    public static final String BILL_YEAR_MONTH = "BILL_YEAR_MONTH";

    public static final String ACCOUNT_DATE = "ACCOUNT_DATE";

    public static final String GD_DATE = "GD_DATE";

    public static final String GD_FLAG = "GD_FLAG";
}
