package com.tofly.fees.financialmgt.model;

import com.tofly.fees.financialmgt.entity.BmPriceEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.BeanUtils;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * <p>
 * 水价编码
 * </p>
 *
 * @author decai
 * @since 2023-05-18
 */
@Getter
@Setter
public class BmPriceAddForm implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "水价名称", required = true)
    @NotBlank(message = "水价名称不能为空")
    private String name;

    @ApiModelProperty("水价")
    private Double price;

    @ApiModelProperty(value = "用水类型",required = true)
    @NotBlank(message = "用水类型不能为空")
    private String useWaterType;

    @ApiModelProperty(value = "所属公司编码",required = true)
    @NotNull(message = "所属公司编码不能为空")
    private Long companyBranch;

    @ApiModelProperty("IC卡充值限量(方)")
    private Integer rechargeLimit;

    @ApiModelProperty("IC卡年充值限量(方)")
    private Integer yearLimit;

    @ApiModelProperty("阶梯标志（1是，0否）")
    private String tieredFlag;

    @ApiModelProperty("阶梯1水量止数")
    private Long tiered1Limit;

    @ApiModelProperty("阶梯1算费水价")
    private Double tiered1Price;

    @ApiModelProperty("阶梯2水量止数")
    private Long tiered2Limit;

    @ApiModelProperty("阶梯2算费水价")
    private Double tiered2Price;

    @ApiModelProperty("阶梯3水量止数")
    private Long tiered3Limit;

    @ApiModelProperty("阶梯3算费水价")
    private Long tiered3Price;

    @ApiModelProperty("阶梯4水量止数")
    private Long tiered4Limit;

    @ApiModelProperty("阶梯4算费水价")
    private Double tiered4Price;

    @ApiModelProperty("污水费单价")
    private Double sewageFeePrice;

    @ApiModelProperty("垃圾费单价")
    private Double garbageFeePrice;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("阶梯计算类型（0：正常；1：月阶梯；2：年阶梯）")
    private String tieredCalType;

    @ApiModelProperty("阶梯算费方式（SL：按水量；BL：按比例）")
    private String tieredCalMode;

    @ApiModelProperty("税率：单位（%）0,3,6,13")
    private Long taxRate;

    public BmPriceEntity toEntity(){
        BmPriceEntity entity = new BmPriceEntity();
        BeanUtils.copyProperties(this, entity);
        return entity;
    }
}
