package com.tofly.fees.financialmgt.model;

import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 水价编码
 * </p>
 *
 * @author decai
 * @since 2023-05-18
 */
@Getter
@Setter
public class BmPriceDetailModel implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("水价编码")
    private String code;

    @ApiModelProperty("水价名称")
    private String name;

    @ApiModelProperty("水价")
    private Long price;

    @ApiModelProperty("用水类型")
    private String useWaterType;

    @ApiModelProperty("所属公司编码")
    private Long companyBranch;

    @ApiModelProperty("操作人员")
    private String ocode;

    @ApiModelProperty("创建时间")
    private Date cdate;

    @ApiModelProperty("IC卡充值限量(方)")
    private Integer rechargeLimit;

    @ApiModelProperty("IC卡年充值限量(方)")
    private Integer yearLimit;

    @ApiModelProperty("阶梯标志（1是，0否）")
    private String tieredFlag;

    @ApiModelProperty("阶梯1水量止数")
    private Long tiered1Limit;

    @ApiModelProperty("阶梯1算费水价")
    private Long tiered1Price;

    @ApiModelProperty("阶梯2水量止数")
    private Long tiered2Limit;

    @ApiModelProperty("阶梯2算费水价")
    private Long tiered2Price;

    @ApiModelProperty("阶梯3水量止数")
    private Long tiered3Limit;

    @ApiModelProperty("阶梯3算费水价")
    private Long tiered3Price;

    @ApiModelProperty("阶梯4水量止数")
    private Long tiered4Limit;

    @ApiModelProperty("阶梯4算费水价")
    private Long tiered4Price;

    @ApiModelProperty("污水费单价")
    private Double sewageFeePrice;

    @ApiModelProperty("垃圾费单价")
    private Double garbageFeePrice;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("阶梯计算类型（0：正常；1：月阶梯；2：年阶梯）")
    private String tieredCalType;

    @ApiModelProperty("阶梯算费方式（SL：按水量；BL：按比例）")
    private String tieredCalMode;

    @ApiModelProperty("税率：单位（%）0,3,6,13")
    private Long taxRate;
}
