package com.tofly.fees.financialmgt.model;

import com.tofly.fees.financialmgt.entity.BmUwTypeEntity;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.springframework.beans.BeanUtils;

import javax.validation.constraints.NotBlank;
import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 用水类型
 * </p>
 *
 * @author decai
 * @since 2023-05-18
 */
@Getter
@Setter
public class BmUwTypeUpdateForm implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty("用水类型编码")
    @NotBlank(message = "用水类型编码不能为空")
    private String code;

    @ApiModelProperty("用水类型名称")
    @NotBlank(message = "用水类型名称不能为空")
    private String name;

    @ApiModelProperty("违约金费率")
    private Double penalty;

    @ApiModelProperty("违约金收取方式")
    private String penaltycode;

    @ApiModelProperty("天数、日期")
    private Long penaltyDay;

    @ApiModelProperty("所属公司")
    private Long companyBranch;

    @ApiModelProperty("备注")
    private String remark;

    public BmUwTypeEntity toEntity(){
        BmUwTypeEntity entity = new BmUwTypeEntity();
        BeanUtils.copyProperties(this, entity);
        return entity;
    }
}
