package com.tofly.fees.financialmgt.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.fees.common.exception.FeesException;
import com.tofly.fees.common.model.CollectionData;
import com.tofly.fees.common.model.PageLink;
import com.tofly.fees.financialmgt.entity.BmUwTypeEntity;
import com.tofly.fees.financialmgt.model.BmUwTypeAddForm;
import com.tofly.fees.financialmgt.model.BmUwTypeDetailModel;
import com.tofly.fees.financialmgt.model.BmUwTypeModel;
import com.tofly.fees.financialmgt.model.BmUwTypeUpdateForm;

import java.util.Map;
import java.util.Set;

/**
 * <p>
 * 用水类型 服务类
 * </p>
 *
 * @author decai
 * @since 2023-05-30
 */
public interface IBmUwTypeService extends IService<BmUwTypeEntity> {
    
    CollectionData<BmUwTypeModel> pageList(Long companyBranch, String name, PageLink pageLink) throws FeesException;

    boolean add(BmUwTypeAddForm form, String username) throws FeesException;

    boolean update(BmUwTypeUpdateForm form, String username) throws FeesException;

    boolean delete(Set<String> codes, String username) throws FeesException;

    BmUwTypeDetailModel get(String code) throws FeesException;

    Map<String, String> getEntityMap(Set<String> codes);
}
