package com.tofly.fees.meterprofilemgt.controller_easy;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.fees.common.BaseController;
import com.tofly.fees.common.dbhelper.DbHelper;
import com.tofly.fees.common.enums.SysEnum;
import com.tofly.fees.common.model.PageLink;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.text.MessageFormat;

import static com.tofly.fees.common.ControllerConstants.*;
import static com.tofly.fees.common.ControllerConstants.PAGE_NUMBER_PARA_NAME;


/**
 * 水表档案简易处理类
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/meterprofilemgt/dameter")
@Api(tags = "水表档案-用户表计信息接口")
public class DaMeterEasyController extends BaseController {

    @ApiOperation(value = "通过用户编号查询水表档案列表")
    @PostMapping("/getMeterListByCustomerNo")
    public ResultRespone getMeterListByCustomerNo(@ApiParam(value = "用户编号", required = true) @RequestParam String customerNo) throws Exception {
        DbHelper db = DbHelper.getDbHelper();
        PageLink pg = createPageLink(20, 1);

        String strSql = String.format("select customer_No,meter_card_no,meter_card_id,meter_type,b.name as type_Name,a.meter_factory,c.name as factory_Name"
                + ",meter_model,d.name as model_Name,meter_factory_datetime,meter_no,FUN_GETWATERPRICE(METER_CARD_ID) as water_Price"
                + ",meter_mul_flag,price_code,rate,price_code1,rate1,price_code2,rate2,"
                + "meter_state,(case when meter_state='1' then '正常' when meter_state='2' then '停用' else '' end) state_Name"
                + ",mr_frequency,meter_base_reading,meter_caliber,meter_range,meter_accuracy_class,meter_position,ic_state"
                + ",ic_activate_datetime,meter_valve,ic_id,garbage_fee_flag,garbage_fee_price,sewage_fee_flag,a.remark,operator_name,operator_datetime,garbage_fee_mode"
                + " from TF_YWYS_DA_METER a "
                + "left join tf_ywys_bm_meter_type b on a.meter_type=b.code "
                + "left join tf_ywys_bm_meter_factory c on a.meter_factory=c.code "
                + "left join tf_ywys_bm_meter_model d on a.meter_model=d.code  "
                + "where customer_No='%s' order by meter_card_no", customerNo);

        Object obj = db.getPage(pg, strSql, SysEnum.MyBatis.getName());
        return ResultRespone.success(obj);
    }
}
