/*
 * Author: tfMaker
 * 生成entity
 */
package com.tofly.fees.meterprofilemgt.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

//IC表换表（含普表换表）
//@author tfMaker
//@date 2023-06-21 15:09:29

@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_BW_REPLACE_METER", resultMap = "bwReplaceMeterMap")
@KeySequence("TF_YWYS_BW_REPLACE_METER")
@ApiModel
public class BwReplaceMeter extends Model<BwReplaceMeter> {
    private static final long serialVersionUID = 1L;

    /**
     * 记录ID
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "记录ID")
    private String id;
    /**
     * 用户号
     */
    @ApiModelProperty(value = "用户号")
    private String customerNo;
    /**
     * 原客户编号
     */
    @ApiModelProperty(value = "原客户编号")
    private String customerNoOld;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    private String customerName;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    private String customerAddress;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String customerPhone;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号")
    private BigDecimal meterCardNo;
    /**
     * 抄表卡ID
     */
    @ApiModelProperty(value = "抄表卡ID")
    private BigDecimal meterCardId;
    /**
     * 原_水表类别
     */
    @ApiModelProperty(value = "原_水表类别")
    private String oldMeterType;
    /**
     * 原_水表厂家
     */
    @ApiModelProperty(value = "原_水表厂家")
    private String oldMeterFactory;
    /**
     * 原_水表型号
     */
    @ApiModelProperty(value = "原_水表型号")
    private String oldMeterModel;
    /**
     * 原_水表出厂日期
     */
    @ApiModelProperty(value = "原_水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date oldMeterFactoryDatetime;
    /**
     * 原_水表口径
     */
    @ApiModelProperty(value = "原_水表口径")
    private String oldMeterCaliber;
    /**
     * 原_水表量程
     */
    @ApiModelProperty(value = "原_水表量程")
    private String oldMeterRange;
    /**
     * 原_水表编号
     */
    @ApiModelProperty(value = "原_水表编号")
    private String oldMeterNo;
    /**
     * 原_ICKID
     */
    @ApiModelProperty(value = "原_ICKID")
    private String oldMeterCardId;
    /**
     * 原_水表起数
     */
    @ApiModelProperty(value = "原_水表起数")
    private BigDecimal oldMeterLastReading;
    /**
     * 原_水表读数
     */
    @ApiModelProperty(value = "原_水表读数")
    private BigDecimal oldMeterNowReading;
    /**
     * 原_IC表剩余水量
     */
    @ApiModelProperty(value = "原_IC表剩余水量")
    private BigDecimal oldIcMargin;
    /**
     * 原_机械表用水量
     */
    @ApiModelProperty(value = "原_机械表用水量")
    private BigDecimal oldMeterDosage;
    /**
     * 新_水表类别
     */
    @ApiModelProperty(value = "新_水表类别")
    private String newMeterType;
    /**
     * 新_水表厂家
     */
    @ApiModelProperty(value = "新_水表厂家")
    private String newMeterFactory;
    /**
     * 新_水表型号
     */
    @ApiModelProperty(value = "新_水表型号")
    private String newMeterModel;
    /**
     * 新_水表出厂日期
     */
    @ApiModelProperty(value = "新_水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date newMeterFactoryDatetime;
    /**
     * 新_水表口径
     */
    @ApiModelProperty(value = "新_水表口径")
    private String newMeterCaliber;
    /**
     * 新_水表量程
     */
    @ApiModelProperty(value = "新_水表量程")
    private String newMeterRange;
    /**
     * 新_水表编号
     */
    @ApiModelProperty(value = "新_水表编号")
    private String newMeterNo;
    /**
     * 新_ICKID
     */
    @ApiModelProperty(value = "新_ICKID")
    private String newMeterCardId;
    /**
     * 新_水表起数
     */
    @ApiModelProperty(value = "新_水表起数")
    private BigDecimal newMeterLastReading;
    /**
     * 新_水表读数
     */
    @ApiModelProperty(value = "新_水表读数")
    private BigDecimal newMeterNowReading;
    /**
     * 审批人员
     */
    @ApiModelProperty(value = "审批人员")
    private String auditorOname;
    /**
     * 换表人员
     */
    @ApiModelProperty(value = "换表人员")
    private String replaceMeterOname;
    /**
     * 换表日期
     */
    @ApiModelProperty(value = "换表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date replaceMeterDate;
    /**
     * 录入人员
     */
    @ApiModelProperty(value = "录入人员")
    private String inputOcode;
    /**
     * 录入人员姓名
     */
    @ApiModelProperty(value = "录入人员姓名")
    private String inputName;
    /**
     * 录入日期
     */
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date inputDate;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
}
