/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.meterprofilemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户表计信息
 *
 * @author admin
 * @date Wed Jun 07 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_METER", resultMap = "daMeterMap")
@KeySequence("TF_YWYS_DA_METER")
@ApiModel
public class DaMeter extends Model<DaMeter> {
    private static final long serialVersionUID = 1L;

    /**
     * 客户编号
     */
    @ApiModelProperty(value = "客户编号")
    private String customerNo;
    /**
     * 表卡号
     */
    @ApiModelProperty(value = "表卡号")
    private BigDecimal meterCardNo;
    /**
     * ID号，唯一
     */
    @TableId(value = "METER_CARD_ID", type = IdType.INPUT)
    @ApiModelProperty(value = "ID号，唯一")
    private Long meterCardId;
    /**
     * 水表类别(bm_METER_TYPE)
     */
    @ApiModelProperty(value = "水表类别")
    private String meterType;
    /**
     * 水表生产厂家(bm_METER_FACTORY)
     */
    @ApiModelProperty(value = "水表生产厂家")
    private String meterFactory;
    /**
     * 水表出厂日期
     */
    @ApiModelProperty(value = "水表出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date meterFactoryDatetime;
    /**
     * 水表型号(bm_METER_MODEL)
     */
    @ApiModelProperty(value = "水表型号")
    private String meterModel;
    /**
     * 水表口径(sys_child_code,pcid='12')
     */
    @ApiModelProperty(value = "水表口径")
    private String meterCaliber;
    /**
     * 水表编号
     */
    @ApiModelProperty(value = "水表编号")
    private String meterNo;
    /**
     * 水表量程(sys_child_code,pcid='13')
     */
    @ApiModelProperty(value = "水表量程")
    private String meterRange;
    /**
     * 表计位置(sys_child_code,pcid='15')
     */
    @ApiModelProperty(value = "表计位置")
    private String meterPosition;
    /**
     * 精度等级(sys_child_code,pcid='14')
     */
    @ApiModelProperty(value = "精度等级")
    private String meterAccuracyClass;
    /**
     * 抄表频率
     */
    @ApiModelProperty(value = "抄表频率")
    private String mrFrequency;
    /**
     * 水表起数（底数）
     */
    @ApiModelProperty(value = "水表起数（底数）")
    private BigDecimal meterBaseReading;
    /**
     * 抄表序号
     */
    @ApiModelProperty(value = "抄表序号")
    private BigDecimal mrOrderNo;
    /**
     * 一表多价标志
     */
    @ApiModelProperty(value = "一表多价标志")
    private String meterMulFlag;
    /**
     * 水价编码
     */
    @ApiModelProperty(value = "水价编码")
    private String priceCode;
    /**
     * 水量比例
     */
    @ApiModelProperty(value = "水量比例")
    private Double rate;
    /**
     * 水价编码1
     */
    @ApiModelProperty(value = "水价编码1")
    private String priceCode1;
    /**
     * 水量比例1
     */
    @ApiModelProperty(value = "水量比例1")
    private Double rate1;
    /**
     * 水价编码2
     */
    @ApiModelProperty(value = "水价编码2")
    private String priceCode2;
    /**
     * 水量比例2
     */
    @ApiModelProperty(value = "水量比例2")
    private Double rate2;
    /**
     * 水价编码3
     */
    @ApiModelProperty(value = "水价编码3")
    private String priceCode3;
    /**
     * 水量比例3
     */
    @ApiModelProperty(value = "水量比例3")
    private Double rate3;
    /**
     * 污水费标志
     */
    @ApiModelProperty(value = "污水费标志")
    private String sewageFeeFlag;
    /**
     * 垃圾费标志
     */
    @ApiModelProperty(value = "垃圾费标志")
    private String garbageFeeFlag;
    /**
     * 垃圾费收取方式:0按户收取，1 按用量收取
     */
    @ApiModelProperty(value = "垃圾费收取方式")
    private String garbageFeeMode;
    /**
     * 垃圾费单价
     */
    @ApiModelProperty(value = "垃圾费单价")
    private Double garbageFeePrice;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 计费状态（1正常，2停用）
     */
    @ApiModelProperty(value = "计费状态")
    private String meterState;
    /**
     * 开卡标志（bm_kkzt）
     */
    @ApiModelProperty(value = "开卡标志")
    private String icState;
    /**
     * 开卡日期
     */
    @ApiModelProperty(value = "开卡日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date icActivateDatetime;
    /**
     * IC卡ID
     */
    @ApiModelProperty(value = "IC卡ID")
    private String icId;
    /**
     * IC卡NO
     */
    @ApiModelProperty(value = "IC卡NO")
    private String icNo;
    /**
     * 写卡次数
     */
    @ApiModelProperty(value = "写卡次数")
    private BigDecimal icWriteTimes;
    /**
     * 补卡次数
     */
    @ApiModelProperty(value = "补卡次数")
    private BigDecimal icRepairTimes;
    /**
     * 总购水量
     */
    @ApiModelProperty(value = "总购水量")
    private Long icTotalCumQuantity;
    /**
     * 总购水金额（金额表）
     */
    @ApiModelProperty(value = "总购水金额（金额表）")
    private Double icTotalCumAmount;
    /**
     * 本年累计水量
     */
    @ApiModelProperty(value = "本年累计水量")
    private BigDecimal icYearCumQuantity;
    /**
     * 本年累计金额
     */
    @ApiModelProperty(value = "本年累计金额")
    private Double icYearCumAmount;
    /**
     * 建档人员
     */
    @ApiModelProperty(value = "建档人员")
    private String createdOcode;
    /**
     * 建档人员姓名
     */
    @ApiModelProperty(value = "建档人员姓名")
    private String createdOname;
    /**
     * 建档日期
     */
    @ApiModelProperty(value = "建档日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createdDatetime;
    /**
     * 建档批量流水号
     */
    @ApiModelProperty(value = "建档批量流水号")
    private String createdSerialNo;
    /**
     * 定检日期
     */
    @ApiModelProperty(value = "定检日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date meterPeriodicalInspeDate;
    /**
     * 水表止读
     */
    @ApiModelProperty(value = "水表止读")
    private BigDecimal meterNowReading;
    /**
     * 最新抄表日期
     */
    @ApiModelProperty(value = "最新抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date meterNowReadingDatetime;
    /**
     * 所属阀门(sys_child_code,pcid='23')
     */
    @ApiModelProperty(value = "所属阀门")
    private String meterValve;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String operatorCode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String operatorName;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date operatorDatetime;
    /**
     * 超定量
     */
    @ApiModelProperty(value = "超定量")
    private Long overQuantity;
    /**
     * 两高一剩标志:0 否，1 是
     */
    @ApiModelProperty(value = "两高一剩标志")
    private String lgysFlag;
    /**
     * 安装人员
     */
    @ApiModelProperty(value = "安装人员")
    private String installOname;
    /**
     * 安装时间
     */
    @ApiModelProperty(value = "安装时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date installDatetime;
    /**
     * 铅封号(管线号)
     */
    @ApiModelProperty(value = "铅封号(管线号)")
    private String pipelineNo;

}
