package com.tofly.fees.meterreadingmgt.controller_easy;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.fees.meterreadingmgt.entity.BwMeterReadPlan;
import com.tofly.fees.meterreadingmgt.mapper.BwMeterReadPlanMapper;
import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * 抄表计划_抄表录入
 *
 * @author xb
 * @date Thu Jun 01 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("/bwmeterreadplan")
@Api(tags = "抄表计划-抄表录入接口")
public class BwMeterReadPlanEsayController {


    private final BwMeterReadPlanMapper bwMeterReadPlanMapper;

    @ApiOperation(value = "撤销批量分配")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "customerNos", value = "撤销批量分配，多个id以逗号隔开", required = true, dataType = "String")
    })
    @PutMapping("/cancelMrBook")
    @Transactional
    public ResultRespone cancelMrBook(@RequestParam String[] customerNos) {
        String ids = "";
        if (customerNos!=null&&customerNos.length>0) {
            ids = "\'"+StringUtils.join(customerNos, "','")+"\'";
        }
        System.out.println("print:"+ids);

        int row=bwMeterReadPlanMapper.cancelMeterReadPlan(ids);
        int rows=bwMeterReadPlanMapper.cancelDaCustomerReadPlan(ids);

        boolean isTrue=false;
        if(row>0||rows>0){
            isTrue=true;
        }

        return ResultRespone.success(isTrue);
    }

    @ApiOperation(value = "批量分配")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "customerNos", value = "撤销批量分配，多个id以逗号隔开", required = true, dataType = "String"),
            @ApiImplicitParam(name = "mrBook", value = "抄表册编码", required = true, dataType = "Integer")
    })
    @PutMapping("/toMrBook")
    @Transactional
    public ResultRespone toMrBook(@RequestParam String[] customerNos, @RequestParam Integer mrBook) {
        String ids = "";
        if (customerNos!=null&&customerNos.length>0) {
            ids = "\'"+StringUtils.join(customerNos, "','")+"\'";
        }

        int row=bwMeterReadPlanMapper.toMeterReadPlan(ids,mrBook);
        int rows=bwMeterReadPlanMapper.toDaCustomerReadPlan(ids,mrBook);

        boolean isTrue=false;
        if(row>0||rows>0){
            isTrue=true;
        }
        return ResultRespone.success(isTrue);
    }

}
