/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.meterreadingmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import java.util.List;
import java.util.stream.Collectors;


/**
 * 抄表计划_抄表录入
 *
 * @author xb
 * @date Thu Jun 01 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_BW_METER_READ_PLAN", resultMap = "bwMeterReadPlanMap")
@KeySequence("TF_YWYS_BW_METER_READ_PLAN")
@ApiModel
public class BwMeterReadPlan extends Model<BwMeterReadPlan> {
    private static final long serialVersionUID = 1L;

    /**
     * 客户编号
     */
    @ApiModelProperty(value = "客户编号", required = true)
    private String customerNo;
    /**
     * 抄表卡号
     */
    @ApiModelProperty(value = "抄表卡号", required = true)
    @Min(0)
    private BigDecimal meterCardNo;
    /**
     * 抄表卡ID：TF_YWYS_DA_METER.METER_CARD_ID=TF_YWYS_BW_METER_READ_PLAN.METER_CARD_ID
     */
    @TableId(value = "METER_CARD_ID", type = IdType.INPUT)
    @ApiModelProperty(value = "抄表卡ID")
    private String meterCardId;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    @NotBlank(message = "所属公司不能为空")
    private String companyBranch;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    private BigDecimal mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private BigDecimal mrBook;
    /**
     * 财务日期
     */
    @ApiModelProperty(value = "财务日期")
    private BigDecimal yearMonth;
    /**
     * 上次读数
     */
    @ApiModelProperty(value = "上次读数")
    private BigDecimal lastReading;
    /**
     * 本次读数
     */
    @ApiModelProperty(value = "本次读数")
    private BigDecimal thisReading;
    /**
     * 本次加减量
     */
    @ApiModelProperty(value = "本次加减量")
    private BigDecimal jjl;
    /**
     * 抄表人员编码
     */
    @ApiModelProperty(value = "抄表人员编码")
    private String mrOcode;
    /**
     * 抄表人员姓名
     */
    @ApiModelProperty(value = "抄表人员姓名")
    private String mrOname;
    /**
     * 抄表日期
     */
    @ApiModelProperty(value = "抄表日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date mrDate;
    /**
     * 录入人员编码
     */
    @ApiModelProperty(value = "录入人员编码")
    private String inputOcode;
    /**
     * 录入人员姓名
     */
    @ApiModelProperty(value = "录入人员姓名")
    private String inputOname;
    /**
     * 录入日期
     */
    @ApiModelProperty(value = "录入日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date inputDate;
    /**
     * 照片地址链接
     */
    @ApiModelProperty(value = "照片地址链接")
    private String photo;
    /**
     * 抄表标志：0未抄表，1已抄表
     */
    @ApiModelProperty(value = "抄表标志：0未抄表，1已抄表")
    private String mrFlag;
    /**
     * 审核标志（0：未审核；1：审核通过；2：审核不通过）
     */
    @ApiModelProperty(value = "审核标志")
    private String auditFlag;
    /**
     * 计算标志：0未算费，1已算费
     */
    @ApiModelProperty(value = "计算标志")
    private String calFlag;
    /**
     * 抄表次数
     */
    @ApiModelProperty(value = "抄表次数")
    private BigDecimal mrTimes;
    /**
     * 抄表序号
     */
    @ApiModelProperty(value = "抄表序号")
    private BigDecimal mrOrderNo;
    /**
     * 抄表备注,存储抄表描述内容
     */
    @ApiModelProperty(value = "抄表备注,存储抄表描述内容")
    private String remark;
    /**
     * 抄表类型:BM_MR_TYPE
     */
    @ApiModelProperty(value = "抄表类型")
    private BigDecimal mrType;
    /**
     * 抄表方式:bm_MR_MODE
     */
    @ApiModelProperty(value = "抄表方式")
    private String mrMode;
    /**
     * 计费状态（1正常，2停用）
     */
    @ApiModelProperty(value = "计费状态")
    private String calState;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private BigDecimal quantity;
    /**
     * 旧表止读
     */
    @ApiModelProperty(value = "旧表止度")
    private BigDecimal oldMeterEreading;
    /**
     * 新表起度
     */
    @ApiModelProperty(value = "新表起度")
    private BigDecimal newMeterBreading;
    /**
     * 旧表编号
     */
    @ApiModelProperty(value = "旧表编号")
    private String oldMeterNo;
    /**
     * 抄表数据来源（0手工抄表，1抄表机抄表，2移动APP抄表，3远传抄表，4批量导入抄表，5换表抄,  6 一体机抄表）
     */
    @ApiModelProperty(value = "抄表数据来源")
    private String mrDataSource;
    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private String x;
    /**
     * 纬度
     */
    @ApiModelProperty(value = "纬度")
    private String y;
    /**
     * 审核人员
     */
    @ApiModelProperty(value = "审核人员")
    private String auditOcode;
    /**
     * 审核人员姓名
     */
    @ApiModelProperty(value = "审核人员姓名")
    private String auditOname;
    /**
     * 审核时间
     */
    @ApiModelProperty(value = "审核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date auditDate;
    /**
     * 审核说明
     */
    @ApiModelProperty(value = "审核说明")
    private String auditSuggestion;

}
