package com.tofly.fees.reportmgt.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.fees.common.Excel.ExcleFileUtil;
import com.tofly.fees.common.dbhelper.PageSortHelper;
import com.tofly.fees.feesmgt.entity.SfCharge;
import com.tofly.fees.feesmgt.mapper.SfChargeMapper;
import com.tofly.fees.financialmgt.entity.BmPriceEntity;
import com.tofly.fees.financialmgt.service.IBmPriceService;
import com.tofly.fees.reportmgt.entity.SfRecMonth;
import com.tofly.fees.reportmgt.entity.SfRecSelect;
import com.tofly.fees.reportmgt.mapper.SfReportMapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@AllArgsConstructor
@RequestMapping("/api/reportmgt")
@Api(tags="财务报表-业务接口")
public class reportMgtController {
    private final SfChargeMapper sfChargeMapper;
    private final SfReportMapper sfReportMapper;
    private final IBmPriceService iBmPriceService;
    /**
     *  收明细：收费日报表明细
     */
    @GetMapping("/sfdailyreport/page" )
    @ApiOperation(value = "收费日表明细-分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数",  dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型",  dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名",  dataType = "String"),
            @ApiImplicitParam(name = "companyBranch", value = "公司",  dataType = "String"),
            @ApiImplicitParam(name = "mrArea", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "mrBook", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "YearMonth", value = "财务日期",dataType = "String"),
            @ApiImplicitParam(name = "customerNo", value = "用户编号", dataType = "String"),
            @ApiImplicitParam(name = "chargeOcode", value = "收费人员", dataType = "String"),
            @ApiImplicitParam(name = "realPayMode", value = "付费方式", dataType = "String"),
            @ApiImplicitParam(name = "chargeType", value = "收费类型", dataType = "String"),
            @ApiImplicitParam(name = "chargeDate_Start", value = "收费开始日期",  dataType = "String"),
            @ApiImplicitParam(name = "chargeDate_End", value = "收费结束日期",  dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", dataType = "String")
    })
    public ResultRespone getSfDaiyReportPage(Page page, String mrArea, String mrBook, String companyBranch, String YearMonth, String customerNo, String chargeOcode, String realPayMode, String chargeType, String chargeDate_Start, String chargeDate_End, String searchText) {

        PageSortHelper.setPageSort(SfCharge.class,page);
        IPage<SfCharge> sfpage= sfChargeMapper.selectSfmxSearch(page,mrArea,mrBook,companyBranch,YearMonth,customerNo,chargeOcode,realPayMode,chargeType,chargeDate_Start,chargeDate_End,searchText,"");
        return ResultRespone.success(sfpage);
    }

    @GetMapping("/ysfreport/page" )
    @ApiOperation(value = "应收月报表明细-分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数",  dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型",  dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名",  dataType = "String"),
            @ApiImplicitParam(name = "calDate_Start", value = "计算开始日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "calDate_End", value = "计算结束日期", required = true, dataType = "String")
    })
    public ResultRespone getSfmxReportPage(Page page,@RequestParam("calDate_Start") String calDate_Start,@RequestParam("calDate_End") String calDate_End)
    {
        ResultRespone<Object> rest=new ResultRespone<>();
        if(StringUtils.isEmpty(calDate_Start)||StringUtils.isEmpty(calDate_End))
        {
            rest.setCode(-1);
            rest.setMessage("查询失败，时间段不能为空");
        }
        if(rest.getCode()!=-1)
        {
           IPage<SfRecSelect>  selectPage =sfReportMapper.selectSfmxReport(page,calDate_Start,calDate_End);
            if(selectPage.getSize() == 0)
            {
                rest.setCode(1);
                rest.setMessage("查询无数据");
            }
            else
            {
                rest.setCode(1);
                rest.setMessage("查询成功");
                rest.setResult(selectPage);
            }
        }
        else
        {
            rest.setCode(-1);
            rest.setMessage("查询失败");
        }
        return rest;
    }
    @GetMapping("/ysfreport/export" )
    @ApiOperation(value = "应收月报表明细-导出查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "calDate_Start", value = "计算开始日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "calDate_End", value = "计算结束日期", required = true, dataType = "String")
    })
    public void   export(HttpServletResponse response,@RequestParam("calDate_Start") String calDate_Start, @RequestParam("calDate_End") String calDate_End) throws IOException {
        List<SfRecSelect> selectList=sfReportMapper.selectSfmxReport(calDate_Start,calDate_End);
        ExcleFileUtil.exportExcel(response, selectList, SfRecSelect.class, "应收月报表明细.xlsx");
    }

    @GetMapping("/ysfreport/list" )
    @ApiOperation(value = "应收月报表-list查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "calDate_Start", value = "计算开始日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "calDate_End", value = "计算结束日期", required = true, dataType = "String")
    })
    public ResultRespone getSfMonthReport(String calDate_Start,String calDate_End) {

        List<SfRecMonth> selectList= sfReportMapper.selectSfMonthReport(calDate_Start,calDate_End);
        //水价编码查询
        List<BmPriceEntity> bmPrice= iBmPriceService.list();
        Map<String,String> map = new HashMap<>();
        bmPrice.forEach(e->map.put(e.getCode().toString(), e.getName()));
        for (SfRecMonth list : selectList) {
            list.setPriceCode(map.get(list.getPriceCode()));
        }
        return ResultRespone.success(selectList);
    }

    @GetMapping("/dsfreport/page" )
    @ApiOperation(value = "第三方流水明细-page分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "calDate_Start", value = "计算开始日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "calDate_End", value = "计算结束日期", required = true, dataType = "String")
    })
    public  ResultRespone getThirdPartyList()
    {

        return  null;
    }
    @GetMapping("/dsfreport/list" )
    @ApiOperation(value = "第三方汇总统计-list查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "calDate_Start", value = "计算开始日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "calDate_End", value = "计算结束日期", required = true, dataType = "String")
    })
    public  ResultRespone getThirdPartyReport()
    {

        return  null;
    }

}
