/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.fees.userprofilemgt.controller;

import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.util.ListUtils;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.fees.common.Excel.ExcleFileUtil;
import com.tofly.fees.common.Excel.NoModelDataListener;
import com.tofly.fees.common.annotate.requestPostSingle.RequestPostSingleParam;
import com.tofly.fees.common.model.CollectionData;
import com.tofly.fees.common.util.GuidGenerator;
import com.tofly.fees.meterprofilemgt.entity.DaMeter;
import com.tofly.fees.meterprofilemgt.entity.DaMeterLog;
import com.tofly.fees.meterprofilemgt.service.DaMeterLogService;
import com.tofly.fees.meterprofilemgt.service.DaMeterService;
import com.tofly.fees.meterreadingmgt.entity.BwMeterReadPlan;
import com.tofly.fees.meterreadingmgt.service.IBwMeterReadPlanService;
import com.tofly.fees.userprofilemgt.entity.*;
import com.tofly.fees.userprofilemgt.mapper.DaCustomerMapper;
import com.tofly.fees.userprofilemgt.service.DaCustomerLogService;
import com.tofly.fees.userprofilemgt.service.DaCustomerService;
import io.swagger.annotations.*;
import lombok.AllArgsConstructor;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

import static com.tofly.fees.common.ControllerConstants.*;
import static com.tofly.fees.common.ControllerConstants.PAGE_NUMBER_PARA_NAME;
import static com.tofly.fees.common.util.copyPropertiesUtils.copyProperties;

/**
 * 用户基本信息
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@RestController
@AllArgsConstructor
@RequestMapping("/api/userprofilemgt/dacustomer")
@Api(tags = "客户档案-用户基本信息接口")
public class DaCustomerController {

    private final DaCustomerService daCustomerService;

    private final DaMeterService daMeterService;

    private final IBwMeterReadPlanService iBwMeterReadPlanService;

    private final DaCustomerMapper daCustomerMapper;

    private DaCustomerLogService daCustomerLogService;
    private DaMeterLogService daMeterLogService;


    @GetMapping("/page")
    @ApiOperation(value = "page分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", dataType = "String"),
            @ApiImplicitParam(name = "companyBranch", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "mrArea", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "mrBook", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "meterModel", value = "水表型号", dataType = "String"),
            @ApiImplicitParam(name = "priceCode", value = "用水性质", dataType = "String"),
            @ApiImplicitParam(name = "customerState", value = "用户状态", dataType = "String"),
            @ApiImplicitParam(name = "garbageFeeFlag", value = "是否垃圾费", dataType = "String"),
            @ApiImplicitParam(name = "createdDatetime_start", value = "开始建档日期", dataType = "String"),
            @ApiImplicitParam(name = "createdDatetime_end", value = "结束建档日期", dataType = "String"),
            @ApiImplicitParam(name = "mrOcode", value = "抄表人员", dataType = "String")
    })
    public ResultRespone getDaCustomerPage(Page page, String searchText, String mrArea, String mrBook, String meterModel, String priceCode, String customerState, String garbageFeeFlag, String createdDatetime_start, String createdDatetime_end, String mrOcode, String companyBranch) {
        //自定义查询用户档案
        //用户编号、用户姓名、用户地址、联系电话
        //片区、抄表本、水表型号、用水性质、用户状态、是否垃圾费、建档日期、抄表人员
        IPage<DaCustomerSelect> yhdaPage = daCustomerMapper.selectDaCustomerPage(page, searchText, mrArea, mrBook, meterModel, priceCode, customerState, garbageFeeFlag, createdDatetime_start, createdDatetime_end, mrOcode, companyBranch);
        // 遍历查询结果进行赋值
        List<DaCustomerSelect> yhdaList = yhdaPage.getRecords();

        // 对 obj 进行一些操作    yhdaList.set(i, obj); // 将 obj 的新值重新赋给 yhdaList}
        for (DaCustomerSelect yhda : yhdaList) {
            //用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
            customerStateSearch(yhda);
            List<Map<String, Object>> list = daCustomerMapper.selectCardNo(yhda.getCustomerNo());
            //循环遍历，重新赋值
            StringBuilder strcbkh = new StringBuilder();
            StringBuilder strid = new StringBuilder();
            for (Map<String, Object> map : list) {
                strcbkh.append(map.get("METER_CARD_NO")).append(",");
                strid.append(map.get("METER_CARD_ID")).append(",");
            }
            yhda.setCbkhList(strcbkh.substring(0, strcbkh.length() - 1));
            yhda.setMeterCardId(strid.substring(0, strid.length() - 1));
            //查询用户是否存在多只表
        }
        return ResultRespone.success(yhdaPage);
    }

    @GetMapping("/export")
    @ApiOperation(value = "export导出")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "current", value = "当前页码", required = true, dataType = "int"),
            @ApiImplicitParam(name = "size", value = "每页显示数据条数", required = true, dataType = "int"),
            @ApiImplicitParam(name = "pages", value = "共几页,输出参数", dataType = "int"),
            @ApiImplicitParam(name = "maxLimit", value = "每页最大显示数据", dataType = "int"),
            @ApiImplicitParam(name = "orders[0].asc", value = "排序,bool类型", dataType = "String"),
            @ApiImplicitParam(name = "orders[0].column", value = "排序,字段名", dataType = "String"),
            @ApiImplicitParam(name = "searchText", value = "模糊查询(用户编号、用户姓名、用户地址、联系电话)", dataType = "String"),
            @ApiImplicitParam(name = "companyBranch", value = "公司", dataType = "String"),
            @ApiImplicitParam(name = "mrArea", value = "片区", dataType = "String"),
            @ApiImplicitParam(name = "mrBook", value = "抄表本", dataType = "String"),
            @ApiImplicitParam(name = "meterModel", value = "水表型号", dataType = "String"),
            @ApiImplicitParam(name = "priceCode", value = "用水性质", dataType = "String"),
            @ApiImplicitParam(name = "customerState", value = "用户状态", dataType = "String"),
            @ApiImplicitParam(name = "garbageFeeFlag", value = "是否垃圾费", dataType = "String"),
            @ApiImplicitParam(name = "createdDatetime_start", value = "开始建档日期", dataType = "String"),
            @ApiImplicitParam(name = "createdDatetime_end", value = "结束建档日期", dataType = "String"),
            @ApiImplicitParam(name = "mrOcode", value = "抄表人员", dataType = "String")
    })
    public void export(HttpServletResponse response, Page page, String searchText, String mrArea, String mrBook, String meterModel, String priceCode, String customerState, String garbageFeeFlag, String createdDatetime_start, String createdDatetime_end, String mrOcode, String companyBranch) throws IOException {
        List<DaCustomerSelect> yhdaList = daCustomerMapper.selectDaCustomerPage(searchText, mrArea, mrBook, meterModel, priceCode, customerState, garbageFeeFlag, createdDatetime_start, createdDatetime_end, mrOcode, companyBranch);
        // 遍历查询结果进行赋值
        // 对 obj 进行一些操作    yhdaList.set(i, obj); // 将 obj 的新值重新赋给 yhdaList}
        for (DaCustomerSelect yhda : yhdaList) {
            //用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
            customerStateSearch(yhda);
        }
        ExcleFileUtil.exportExcel(response, yhdaList, DaCustomerSelect.class, "yhdaList.xlsx");
    }

    private void customerStateSearch(DaCustomerSelect yhda) {
        if (yhda.getCustomerState().equals("0")) {
            yhda.setCustomerState("申请用户");
        }
        if (yhda.getCustomerState().equals("1")) {
            yhda.setCustomerState("正式用户");
        }
        if (yhda.getCustomerState().equals("2")) {
            yhda.setCustomerState("报停用户");
        }
        if (yhda.getCustomerState().equals("3")) {
            yhda.setCustomerState("销户用户");
        }
        if (yhda.getCustomerState().equals("4")) {
            yhda.setCustomerState("作废用户");
        }
    }


    /**
     * Excle上传文件
     */
    @ApiOperation(value = "Excel上传文件,批量建档")
    @PostMapping("/import")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "companyBranch", value = "所属公司", required = true, dataType = "String"),
            @ApiImplicitParam(name = "mrArea", value = "片区", required = true, dataType = "String"),
            @ApiImplicitParam(name = "mrBook", value = "抄表本", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterType", value = "水表类别", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterFactory", value = "水表厂家", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterModel", value = "水表型号", required = true, dataType = "String"),
            @ApiImplicitParam(name = "priceCode", value = "水价", required = true, dataType = "String"),
            @ApiImplicitParam(name = "sewageFeeFlag", value = "是否污水费", required = true, dataType = "String"),
            @ApiImplicitParam(name = "garbageFeeFlag", value = "是否垃圾费", required = true, dataType = "String"),
            @ApiImplicitParam(name = "garbageFeeMode", value = "收取方式", required = true, dataType = "String"),
            @ApiImplicitParam(name = "garbageFeePrice", value = "垃圾费单价", required = true, dataType = "String"),
            @ApiImplicitParam(name = "createdOcode", value = "创建人员编码", required = true, dataType = "String"),
            @ApiImplicitParam(name = "createdOname", value = "创建人员名称", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterState", value = "表计状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "customerState", value = "用户状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "activateState", value = "通水状态", required = true, dataType = "String"),
            @ApiImplicitParam(name = "activateDatetime", value = "通水日期", required = true, dataType = "String"),
            @ApiImplicitParam(name = "mrFrequency", value = "抄表频率", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterRange", value = "水表量程", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterPosition", value = "水表位置", required = true, dataType = "String"),
    })
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public ResultRespone importExcel(@RequestParam("file") MultipartFile file, String companyBranch, String mrArea, String mrBook, String meterType, String meterFactory, String meterModel, String priceCode, String sewageFeeFlag, String garbageFeeFlag, String createdOcode, String createdOname, String meterState, String customerState, String activateState, String activateDatetime, String mrFrequency, String meterRange, String meterPosition, String garbageFeeMode, String garbageFeePrice) {
        //传入参数校验
        ResultRespone<Object> rest = checkImportExcel(companyBranch, mrArea, mrBook, meterType, meterFactory, meterModel, priceCode, sewageFeeFlag, garbageFeeFlag, createdOcode, createdOname);
        if (StringUtils.isNotBlank(file.toString())) {
            if (rest.getCode() != -1) {
                try {
                    List<DaCustomerExcel> userList = EasyExcel.read(file.getInputStream()).head(DaCustomerExcel.class).sheet().doReadSync();
                    for (DaCustomerExcel user : userList) {
                        //数据校验
                        if (StringUtils.isEmpty(user.getCustomerNo())) {
                            rest.setCode(-1);
                            rest.setMessage("用户编号不能为空");
                        }
                        if (StringUtils.isEmpty(user.getCustomerName())) {
                            rest.setCode(-1);
                            rest.setMessage("用户名不能为空");
                        }
                        if (StringUtils.isEmpty(user.getCustomerAddress())) {
                            rest.setCode(-1);
                            rest.setMessage("用户地址不能为空");
                        }
                        if (StringUtils.isEmpty(user.getTelephone())) {
                            rest.setCode(-1);
                            rest.setMessage("用户电话不能为空");
                        }
                        if (StringUtils.isEmpty(user.getCertNo())) {
                            rest.setCode(-1);
                            rest.setMessage("证件号码不能为空");
                        }
                        if (StringUtils.isEmpty(user.getMeterNo())) {
                            rest.setCode(-1);
                            rest.setMessage("表号不能为空");
                        }
                        if (StringUtils.isEmpty(user.getCaliber())) {
                            rest.setCode(-1);
                            rest.setMessage("口径不能为空");
                        }
                        if (StringUtils.isEmpty(user.getStartingPoint())) {
                            rest.setCode(-1);
                            rest.setMessage("表起度不能为空");
                        }
                        if (StringUtils.isEmpty(user.getApplyDate())) {
                            rest.setCode(-1);
                            rest.setMessage("申请日期不能为空");
                        }
                        if (StringUtils.isEmpty(user.getMeterFactoryDatetime())) {
                            rest.setCode(-1);
                            rest.setMessage("水表出厂日期不能为空");
                        }
                        //将合法数据插入数据库
                        if (rest.getCode() != -1) {
                            //查询用户是否存在
                            int count = daCustomerMapper.selectExistCustomerNo(user.getCustomerNo());
                            if (count > 0) {
                                rest.setCode(-1);
                                rest.setMessage("添加用户编号已存在" + user.getCustomerNo());
                            } else {
                                SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
                                Date currentDate = new Date();
                                //用户档案添加
                                String strplbh = GuidGenerator.getGuid();//批次编号
                                DaCustomer daCustomer = new DaCustomer();
                                daCustomer.setBzSerialNo(strplbh);
                                daCustomer.setCreatedSerialNo(strplbh);
                                daCustomer.setCompanyBranch(companyBranch);
                                daCustomer.setMrArea(new BigDecimal(mrArea));
                                daCustomer.setMrBook(new BigDecimal(mrBook));
                                daCustomer.setCustomerNo(user.getCustomerNo());//用户编号
                                daCustomer.setCustomerNoOld(user.getCustomerNo());
                                daCustomer.setCustomerName(user.getCustomerName());//用户名称
                                daCustomer.setCustomerAddress(user.getCustomerAddress());//用户地址
                                daCustomer.setCustomerPhone(user.getTelephone());//用户电话
                                daCustomer.setCertNo(user.getCertNo());//证件号码
                                daCustomer.setCustomerState(customerState);//用户状态
                                daCustomer.setActivateState(activateState);//通水状态
                                daCustomer.setPayMode("1");//付费方式
                                if (StringUtils.isNotBlank(activateDatetime)) {
                                    daCustomer.setActivateDatetime(format.parse(activateDatetime)); // 通水时间
                                }
                                if (StringUtils.isNotBlank(user.getApplyDate())) {
                                    daCustomer.setApplyDatetime(format.parse(user.getApplyDate())); //申请日期
                                }
                                daCustomer.setCreatedDatetime(currentDate);//创建时间
                                daCustomer.setCreatedOcode(createdOcode); //创建人员编码
                                daCustomer.setCreatedOname(createdOname); //创建人员名称
                                daCustomer.setOperatorCode(createdOcode); //操作人员
                                daCustomer.setOperatorName(createdOname); //操作人员名称
                                daCustomer.setOperatorDatetime(currentDate);//操作时间
                                daCustomer.setCertType("1");//证件类型
                                daCustomerService.save(daCustomer);
                                //水表档案添加
                                DaMeter daMeter = new DaMeter();
                                daMeter.setCreatedSerialNo(strplbh);//批次号
                                daMeter.setMeterCardNo(new BigDecimal(1));
                                daMeter.setMeterCardId(new Long(user.getCustomerNo() + "1"));
                                daMeter.setCustomerNo(user.getCustomerNo());//用户编号
                                daMeter.setCreatedOcode(createdOcode); //创建人员编码
                                daMeter.setCreatedOname(createdOname); //创建人员名称
                                daMeter.setOperatorCode(createdOcode); //操作人员编码
                                daMeter.setOperatorName(createdOname);//操作人员名称
                                daMeter.setOperatorDatetime(currentDate);//操作时间

                                daMeter.setGarbageFeeMode(garbageFeeMode); //垃圾费收取方式
                                daMeter.setGarbageFeePrice(new Double(garbageFeePrice));
                                daMeter.setMeterState(meterState);//计费状态
                                daMeter.setMeterFactory(meterFactory);//水表厂家
                                if (StringUtils.isNotBlank(user.getMeterFactoryDatetime())) {
                                    daMeter.setMeterFactoryDatetime(format.parse(user.getMeterFactoryDatetime()));
                                }
                                daMeter.setMeterType(meterType); //水表类别
                                daMeter.setMeterNo(user.getMeterNo());//水表编号
                                daMeter.setMeterCaliber(user.getCaliber());//水表口径
                                daMeter.setPriceCode(priceCode);//水价
                                daMeter.setMeterModel(meterModel);//水表型号
                                daMeter.setMrFrequency(mrFrequency);//抄表频率
                                daMeter.setMeterRange(meterRange);//水表量程
                                daMeter.setMeterPosition(meterPosition); //表具位置

                                daMeter.setMeterBaseReading(new BigDecimal(user.getStartingPoint()));//起度
                                daMeter.setSewageFeeFlag(sewageFeeFlag);//污水费
                                daMeter.setGarbageFeeFlag(garbageFeeFlag);//垃圾费
                                daMeterService.save(daMeter);

                                //抄表计划添加
                                if (meterType == "0" || meterType == "2" || meterType == "3" || meterType == "4") {
                                    BwMeterReadPlan bwMeterReadPlan = new BwMeterReadPlan();
                                    bwMeterReadPlan.setCustomerNo(String.valueOf(user.getCustomerNo()));//用户编号
                                    bwMeterReadPlan.setMeterCardNo(new BigDecimal(1));//抄表卡号
                                    bwMeterReadPlan.setMeterCardId(user.getCustomerNo() + "1");//抄表卡ID

                                    Map<String, Object> mapcwrq = daCustomerMapper.selectYearMonth();//获取财务日期
                                    String strcwrq = mapcwrq.get("CWRQ").toString();//202305
                                    bwMeterReadPlan.setYearMonth(new BigDecimal(strcwrq));//财务日期
                                    bwMeterReadPlan.setCalFlag("0");//计算标志
                                    bwMeterReadPlan.setCalState(meterState);//正常状态
                                    bwMeterReadPlan.setMrFlag("0");//未抄表状态
                                    bwMeterReadPlan.setAuditFlag("0");//未审核标志
                                    bwMeterReadPlan.setCompanyBranch(companyBranch);//公司
                                    bwMeterReadPlan.setMrArea(new BigDecimal(mrArea));//片区
                                    bwMeterReadPlan.setMrBook(new BigDecimal(mrBook));//抄表本
                                    iBwMeterReadPlanService.save(bwMeterReadPlan);
                                }
                            }
                        }
                    }
                    rest.setCode(1);
                    rest.setMessage("导入成功:" + userList.size() + "条");
                } catch (IOException e) {
                    e.printStackTrace();
                    rest.setCode(-1);
                    rest.setMessage("导入失败:" + e.getMessage());
                } catch (ParseException e) {
                    throw new RuntimeException(e);
                }
            }
        }
        return ResultRespone.success(rest.getCode(), rest.getMessage());
    }

    @ApiOperation(value = "Excle模板下载")
    @GetMapping("/download")
    public void downloadExcel(HttpServletResponse response) throws IOException {

        ExcleFileUtil.exportExcel(response, data(), DaCustomerExcel.class, "用户批量建档模板.xlsx");
    }

    private List<DaCustomerExcel> data() {
        List<DaCustomerExcel> list = ListUtils.newArrayList();
        for (int i = 0; i < 5; i++) {
            DaCustomerExcel data = new DaCustomerExcel();
            data.setNumber(String.valueOf(i));
            data.setCustomerNo("20230" + i); // 用户编号 setDate(new Date());
            data.setCustomerName("张三" + i); // 用户姓名 setDoubleData(0.56);
            data.setCustomerAddress("用户地址" + i); //用户地址
            data.setTelephone("1860821171" + i); //联系电话
            data.setCertNo("51050418880223332" + i); //证件号码
            data.setApplyDate("2023-06-16 00:00:00"); //申请日期
            data.setMeterNo("20230607" + i); //水表编号
            data.setCaliber("20"); //水表口径
            data.setMeterFactoryDatetime("2023-06-16 00:00:00"); //水表出厂日期
            data.setStartingPoint("0");
            list.add(data);
        }
        return list;
    }


    public ResultRespone<Object> checkImportExcel(String companyBranch, String mrArea, String mrBook, String meterType, String meterFactory, String meterModel, String priceCode, String sewageFeeFlag, String garbageFeeFlag, String createdCode, String createdName) {
        ResultRespone<Object> rest = new ResultRespone<>();
        if (StringUtils.isEmpty(companyBranch)) {
            rest.setCode(-1);
            rest.setMessage("所属公司不能为空");
        }
        if (StringUtils.isEmpty(mrArea)) {
            rest.setCode(-1);
            rest.setMessage("所属片区参数不能为空");
        }
        if (StringUtils.isEmpty(mrBook)) {
            rest.setCode(-1);
            rest.setMessage("所属抄表本参数不能为空");
        }
        if (StringUtils.isEmpty(meterType)) {
            rest.setCode(-1);
            rest.setMessage("水表类别参数不能为空");
        }
        if (StringUtils.isEmpty(meterFactory)) {
            rest.setCode(-1);
            rest.setMessage("水表厂家参数不能为空");
        }
        if (StringUtils.isEmpty(meterModel)) {
            rest.setCode(-1);
            rest.setMessage("水表型号参数不能为空");
        }

        if (StringUtils.isEmpty(priceCode)) {
            rest.setCode(-1);
            rest.setMessage("水价参数不能为空");
        }

        if (StringUtils.isEmpty(sewageFeeFlag)) {
            rest.setCode(-1);
            rest.setMessage("是否污水费参数不能为空");
        }
        if (StringUtils.isEmpty(garbageFeeFlag)) {
            rest.setCode(-1);
            rest.setMessage("是否垃圾费参数不能为空");
        }
        if (StringUtils.isEmpty(createdCode)) {
            rest.setCode(-1);
            rest.setMessage("创建人员编码参数不能为空");
        }
        if (StringUtils.isEmpty(createdName)) {
            rest.setCode(-1);
            rest.setMessage("创建人员名称参数不能为空");
        }
        return rest;
    }

    /**
     * Excle上传文件
     */
    @ApiOperation(value = "Excel上传文件,测试接口")
    @PostMapping("/importTest")
    public String importExcel3(@RequestParam("file") MultipartFile file) {
        if (file.isEmpty()) {
            return "上传文件不能为空";
        }
        try {
            List<DaCustomerExcel> userList = EasyExcel.read(file.getInputStream()).head(DaCustomerExcel.class).sheet().doReadSync();
            // List<String> errorList = new ArrayList<>();
            //for (DaCustomerExcel user : userList) {
            //将合法数据插入数据库
            //查询用户是否存在
            //}
            return "导入成功";
        } catch (IOException e) {
            e.printStackTrace();
            return "导入失败";
        }
    }


    @ApiOperation(value = "Excel上传文件,返回json数据格式")
    @PostMapping("/importData")
    public ResultRespone importExcel2(@RequestParam("file") MultipartFile file) {
        if (file.isEmpty()) {
            return ResultRespone.failed("上传文件不能为空");
        }
        try {
            List<Map<Integer, String>> listMap = EasyExcel.read(file.getInputStream(), new NoModelDataListener()).sheet().doReadSync();
            //for (Map<Integer, String> data : listMap){
            // 返回每条数据的键值对 表示所在的列 和所在列的值
            //log.info("读取到数据:{}", JSON.toJSONString(data));
            // }
            CollectionData<?> collectionData = new CollectionData<>(listMap, listMap.size());
            return ResultRespone.success(collectionData);
        } catch (IOException e) {
            e.printStackTrace();
            return ResultRespone.failed("导入失败");
        }
    }


    /**
     * 通过id查询用户基本信息
     *
     * @param customerNo id
     * @return ResultRespone
     */
    @GetMapping("/{customerNo}")
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "customerNo", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("customerNo") String customerNo) {
        return ResultRespone.success(daCustomerService.getById(customerNo));
    }

    /**
     * 新增用户基本信息
     *
     * @param daCustomer 用户基本信息
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "新增用户基本信息")
    @ApiOperation(value = "新增用户基本信息")
    @PostMapping
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    public ResultRespone save(@RequestBody DaCustomer daCustomer) throws Exception {
        ResultRespone<Object> rest = new ResultRespone<>();
        //获取最大用户编号
        int yhbh = daCustomerMapper.selectMaxCustomerNo() + 1;
        daCustomer.setCustomerNo(String.valueOf(yhbh));
        daCustomer.setCustomerNoOld(String.valueOf(yhbh));
        //档案记录
        DaCustomerLog daCustomerLog = new DaCustomerLog();
        daCustomerLog.setCustomerNo("String.valueOf(yhbh)");
        daCustomerLog.setId(GuidGenerator.getGuid());
        // 将源对象的属性值赋值给目标对象的属性值
        copyProperties(daCustomer, daCustomerLog);
        if (daCustomerService.save(daCustomer)) {
            if (daCustomerLogService.save(daCustomerLog)) {
                rest.setCode(1);
                rest.setMessage("添加成功");
            }
        } else {
            rest.setCode(-1);
            rest.setMessage("添加失败");
        }
        return ResultRespone.success(rest);
    }

    @ToFlyAppLog(title = "(新增、修改)用户、水表基本信息")
    @ApiOperation(value = "(新增、修改)用户、水表基本信息")
    @PostMapping("/saveDaCustomerAndMeter")
    @Transactional(rollbackFor = Exception.class) //声明式事务管理
    @ApiImplicitParams({
            @ApiImplicitParam(name = "operationType", value = "save、saveUpate", required = true, dataType = "String")
    })
    public ResultRespone saveYhda(@RequestBody DaCustomerAndMeter daCustomerAndMeter, @RequestParam String operationType) throws Exception {
        //获取最大用户编号
        int yhbh = daCustomerMapper.selectMaxCustomerNo() + 1;
        // 其他业务逻辑处理
        ResultRespone<Object> rest = checkDaCustomerAndMeter(daCustomerAndMeter, operationType);
        //用户档案基础信息添加
        DaCustomer daCustomer = daCustomerAndMeter.getDaCustomer();
        //水表档案基础信息添加
        DaMeter daMeter = daCustomerAndMeter.getDaMeter();
        //抄表计划添加
        BwMeterReadPlan bwMeterReadPlan = new BwMeterReadPlan();

        if (operationType.equals("save")) {
            //用户档案
            daCustomer.setCustomerNo(String.valueOf(yhbh)); //用户编号
            daCustomer.setCustomerNoOld(String.valueOf(yhbh));//旧用户编号
            daCustomer.setCustomerState("1");//正式用户状态
            //水表档案
            daMeter.setCustomerNo(String.valueOf(yhbh));//用户编号
            daMeter.setMeterCardNo(new BigDecimal(1));//抄表卡号
            String strcbkh = String.valueOf(yhbh) + 1;
            daMeter.setMeterCardId(new Long(strcbkh));//抄表卡ID
            daMeter.setMeterState("1");//计费状态（1正常，2停用）

            bwMeterReadPlan.setCustomerNo(String.valueOf(yhbh));//用户编号
            bwMeterReadPlan.setMeterCardNo(new BigDecimal(1));//抄表卡号
            bwMeterReadPlan.setMeterCardId(strcbkh);//抄表卡ID

            Map<String, Object> mapcwrq = daCustomerMapper.selectYearMonth();//获取财务日期
            String strcwrq = mapcwrq.get("CWRQ").toString();//202305
            bwMeterReadPlan.setYearMonth(new BigDecimal(strcwrq));//财务日期
            bwMeterReadPlan.setCalFlag("0");//计算标志
            bwMeterReadPlan.setCalState("1");//正常状态
            bwMeterReadPlan.setMrFlag("0");//未抄表状态
            bwMeterReadPlan.setAuditFlag("0");//未审核标志
            bwMeterReadPlan.setCompanyBranch(daCustomerAndMeter.getDaCustomer().getCompanyBranch());//公司
            bwMeterReadPlan.setMrArea(daCustomerAndMeter.getDaCustomer().getMrArea());//片区
            bwMeterReadPlan.setMrBook(daCustomerAndMeter.getDaCustomer().getMrBook());//抄表本

            if (rest.getCode() != -1) {
                //用户档案添加执行成功
                if (daCustomerService.save(daCustomer)) {
                    //用户水表档案执行功
                    if (daMeterService.save(daMeter)) {
                        //执行抄表计划（0普表、1IC卡表、2远传表、3NB表、4流量计）
                        if (daCustomerAndMeter.getDaMeter().getMeterType().equals("0") || daCustomerAndMeter.getDaMeter().getMeterType().equals("2") || daCustomerAndMeter.getDaMeter().getMeterType().equals("3") || daCustomerAndMeter.getDaMeter().getMeterType().equals("4")) {
                            if (iBwMeterReadPlanService.save(bwMeterReadPlan)) {
                                rest.setCode(1);
                                rest.setMessage("新增用户档案成功");
                            } else {
                                rest.setCode(-1);
                                rest.setMessage("新增用户抄表计划失败");
                            }
                        } else {
                            rest.setCode(1);
                            rest.setMessage("新增用户档案成功");
                        }
                    } else {
                        rest.setCode(-1);
                        rest.setMessage("新增水表档案失败");
                    }
                } else {
                    rest.setCode(-1);
                    rest.setMessage("新增用户档案失败");
                }
            }
        } else {
            daCustomer.setCustomerNo(daCustomerAndMeter.getDaCustomer().getCustomerNo());
            daCustomer.setCustomerState(daCustomerAndMeter.getDaCustomer().getCustomerState());
            daMeter.setMeterCardId(daCustomerAndMeter.getDaMeter().getMeterCardId());
            daMeter.setCustomerNo(daCustomerAndMeter.getDaCustomer().getCustomerNo());
            //bwMeterReadPlan.setCustomerNo(daCustomerAndMeter.getDaCustomer().getCustomerNo());
            bwMeterReadPlan.setMeterCardId(daCustomerAndMeter.getDaMeter().getMeterCardId().toString());
            bwMeterReadPlan.setCalState("1");
            // bwMeterReadPlan.setAuditFlag();
            if (daCustomerAndMeter.getDaCustomer().getCustomerState().equals("4")) {
                daMeter.setMeterState("2");//停用状态
                bwMeterReadPlan.setCalState("2");//停用
            }
            if (rest.getCode() != -1) {
                //用户档案修改执行成功
                if (daCustomerService.updateById(daCustomer)) {
                    //用户水表档案执行功
                    if (daMeterService.updateById(daMeter)) {
                        if (iBwMeterReadPlanService.updateById(bwMeterReadPlan)) {
                            rest.setCode(1);
                            rest.setMessage("操作成功");
                        }
                    }
                }
            }
        }
        rest = addDaCustomerAndMeterLog(daCustomerAndMeter, operationType);//操作日志添加
        return rest;
    }

    /**
     * 用户档案水表档案日志添加
     */
    public ResultRespone<Object> addDaCustomerAndMeterLog(DaCustomerAndMeter daCustomerAndMeter, String operationType) throws Exception {
        ResultRespone<Object> rest = new ResultRespone<>();

        //操作日志记录添加
        // 将源对象的属性值赋值给目标对象的属性值
        //档案操作日志记录
        DaCustomerLog daCustomerLog = new DaCustomerLog();
        copyProperties(daCustomerAndMeter.getDaCustomer(), daCustomerLog);
        daCustomerLog.setLogCdate(new Date());//操作时间
        daCustomerLog.setLogOname(daCustomerAndMeter.getDaCustomer().getOperatorName());//操作人员
        daCustomerLog.setLogOcode(daCustomerAndMeter.getDaCustomer().getOperatorCode());//操作人员编码
        daCustomerLog.setId(GuidGenerator.getGuid());//id
        //水表档案操作日志记录
        DaMeterLog daMeterLog = new DaMeterLog();
        copyProperties(daCustomerAndMeter.getDaMeter(), daMeterLog);
        daMeterLog.setId(GuidGenerator.getGuid());//id
        daMeterLog.setLogSerialNo("");//流水编号
        daMeterLog.setLogCdate(new Date());//操作时间
        daMeterLog.setLogOname(daCustomerAndMeter.getDaMeter().getOperatorName());//操作人员
        daMeterLog.setLogOcode(daCustomerAndMeter.getDaMeter().getOperatorCode());//操作人员编码
        daMeterLog.setLogRemark("");//备注

        if (operationType.equals("save")) {
            daMeterLog.setLogCzlx("添加");
            daMeterLog.setLogCllx("添加后");//修改后
        } else {
            daMeterLog.setLogCzlx("修改");
            daMeterLog.setLogCllx("修改后");//修改后
        }
        if (daCustomerLogService.save(daCustomerLog) && daMeterLogService.save(daMeterLog)) {
            rest.setCode(1);
            rest.setMessage("操作成功");
        } else {
            rest.setCode(-1);
            rest.setMessage("操作失败--日志添加失败");
        }
        return rest;
    }

    public ResultRespone<Object> checkDaCustomerAndMeter(DaCustomerAndMeter daCustomerAndMeter, String operationType) {
        ResultRespone<Object> rest = new ResultRespone<>();
        if (StringUtils.isEmpty(operationType)) {
            rest.setCode(-1);
            rest.setMessage("操作类型不能为空");
        }
        if (!operationType.equals("save") && !operationType.equals("saveUpdate")) {
            rest.setCode(-1);
            rest.setMessage("操作类型参数不等于save或saveUpdate");
        }
        if (operationType.equals("save")) {
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaCustomer().getCompanyBranch())) {
                rest.setCode(-1);
                rest.setMessage("所属公司不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaCustomer().getMrArea().toString())) {
                rest.setCode(-1);
                rest.setMessage("片区不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaCustomer().getMrBook().toString())) {
                rest.setCode(-1);
                rest.setMessage("抄表本不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaCustomer().getCustomerName())) {
                rest.setCode(-1);
                rest.setMessage("用户姓名不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaCustomer().getCustomerAddress())) {
                rest.setCode(-1);
                rest.setMessage("用户地址不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaMeter().getMeterNo())) {
                rest.setCode(-1);
                rest.setMessage("水表编号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaMeter().getMeterType())) {
                rest.setCode(-1);
                rest.setMessage("水表类别不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaMeter().getMeterFactory())) {
                rest.setCode(-1);
                rest.setMessage("水表厂家不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaMeter().getMeterModel())) {
                rest.setCode(-1);
                rest.setMessage("水表型号不能为空");
            }
            if (StringUtils.isEmpty(daCustomerAndMeter.getDaMeter().getMeterCaliber())) {
                rest.setCode(-1);
                rest.setMessage("水表口径不能为空");
            }
        }
        return rest;
    }

    /**
     * 修改用户基本信息
     *
     * @param daCustomer 用户基本信息
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "修改用户基本信息")
    @ApiOperation(value = "修改用户基本信息")
    @PutMapping
    public ResultRespone updateById(@RequestBody DaCustomer daCustomer) {
        return ResultRespone.success(daCustomerService.updateById(daCustomer));
    }

    /**
     * 通过id删除用户基本信息
     *
     * @param customerNo id
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "通过id删除用户基本信息")
    @ApiOperation(value = "通过ID删除用户基本信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "customerNo", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{customerNo}")
    public ResultRespone removeById(@PathVariable String customerNo) {
        return ResultRespone.success(daCustomerService.removeById(customerNo));
    }

    /**
     * 通过id批量删除用户基本信息
     *
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "通过id批量删除用户基本信息")
    @ApiOperation(value = "通过ID批量删除用户基本信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(daCustomerService.removeByIds(Arrays.asList(ids.split(","))));
    }

    @ApiOperation(value = "根据用户编号获取账户余额信息")
    @GetMapping("/getCusAccById")
    public ResultRespone getCusAccById(@ApiParam(value = "customerNo", required = true) String customerNo) {
        HashMap<String, Object> obj = daCustomerService.selCustomerAcc(customerNo);
        return ResultRespone.success(obj);
    }

    @ApiOperation(value = "获取用户批量档案信息")
    @GetMapping("/getCusDaPrice")
    public ResultRespone getCusDaPrice(@ApiParam(value = "searchText", required = true)
                                       @RequestParam(value = "searchText") String searchText,
                                       @ApiParam(value = PAGE_SIZE_DESCRIPTION, required = true)
                                       @RequestParam(value = PAGE_SIZE_PARA_NAME) int pageSize,
                                       @ApiParam(value = PAGE_NUMBER_DESCRIPTION, required = true)
                                       @RequestParam(value = PAGE_NUMBER_PARA_NAME) int page,
                                       @ApiParam(value = "mrArea", required = false)
                                       @RequestParam(value = "mrArea") String mrArea,
                                       @ApiParam(value = "mrBook", required = false)
                                       @RequestParam(value = "mrBook") String mrBook

    ) {

        Page<HashMap<String, Object>> pg = new Page<HashMap<String, Object>>(page, pageSize);
        Page<List<HashMap<String, Object>>> newPage = daCustomerService.selCusPriceInfo(pg, searchText, mrArea, mrBook);

        CollectionData<List<HashMap<String, Object>>> m = new CollectionData<>(newPage.getRecords().stream().collect(Collectors.toList())
                , newPage.getTotal());
        //参数返回
        return ResultRespone.success(m);
    }


    @ApiOperation(value = "批量设置用户水价信息")
    @PostMapping("/updateSetCusDaPrice")
    @Transactional

//    @ApiParam(value = "用户编号") @RequestPostSingleParam(required = false) String customerNo,
//    @ApiParam(value = "操作类型", allowableValues = "+,-") @RequestPostSingleParam(required = false) String opt,
//    @ApiParam(value = "操作金额") @RequestPostSingleParam(required = false) Double money,
//    @ApiParam(value = "备注") @RequestPostSingleParam(required = false) String remark

    public ResultRespone updateSetCusDaPrice(@ApiParam(value = "用户编号") @RequestPostSingleParam(required = false) String customerNos,
                                             @ApiParam(value = "水价编码") @RequestPostSingleParam(required = false) String pricecode,
                                             @ApiParam(value = "水价编码1", required = false) @RequestPostSingleParam(required = false) String pricecode1,
                                             @ApiParam(value = "水价编码2", required = false) @RequestPostSingleParam(required = false) String pricecode2,
                                             @ApiParam(value = "比例", required = false) @RequestPostSingleParam(required = false) double num,
                                             @ApiParam(value = "比例1", required = false) @RequestPostSingleParam(required = false) double num1,
                                             @ApiParam(value = "比例2", required = false) @RequestPostSingleParam(required = false) double num2,
                                             @ApiParam(value = "污水费标志", required = false) @RequestPostSingleParam(required = false) String swagefeeflag
    ) {
        String[] yhbhArr = customerNos.split(",");
        if (yhbhArr == null) {
            return ResultRespone.failed("用户编号为Null");
        }

        int sucessCode = 0;
        int failCode = 0;

        for (String yhbh : yhbhArr) {
            QueryWrapper<DaMeter> wapper = new QueryWrapper<>();
            wapper.eq("customer_no", yhbh);
            DaMeter meter = daMeterService.getOne(wapper);
            if (meter != null) {

                if (!StringUtils.isBlank(pricecode)) {
                    meter.setPriceCode(pricecode);
                    meter.setRate(num);
                }

                meter.setPriceCode1(pricecode1);
                meter.setRate(num1);

                meter.setPriceCode2(pricecode2);
                meter.setRate(num2);

                meter.setSewageFeeFlag(swagefeeflag);
            }
            boolean isSave = daMeterService.update(meter, wapper);
            if (isSave) {
                sucessCode += 1;
            } else {
                failCode += 1;
            }
        }

        String msg = String.format("批量设置成功[%s]条,失败[%s]条", sucessCode, failCode);
        return ResultRespone.success(1, msg);
    }

}
