/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户报停记录
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_BT_LOG", resultMap = "daBtLogMap")
@KeySequence("TF_YWYS_DA_BT_LOG")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DaBtLog extends Model<DaBtLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID", type = IdType.INPUT)
    //@TableId(value="yh_id",type= IdType.AUTO) //自动递增,必须同数据设置自增相同
    @ApiModelProperty(value = "编号")
    @ColumnWidth(10)
    @ExcelProperty("编号")
    private String id;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    @ColumnWidth(20)
    @ExcelProperty("所属公司")
    private String companyBranch;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    @ColumnWidth(20)
    @ExcelProperty("所属抄表片区")
    private String mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    @ColumnWidth(20)
    @ExcelProperty("所属抄表本")
    private String mrBook;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @ColumnWidth(10)
    @ExcelProperty("用户编号")
    private String customerNo;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    @ColumnWidth(50)
    @ExcelProperty("用户地址")
    private String customerAddress;
    /**
     * 报停人员姓名
     */
    @ApiModelProperty(value = "报停人员姓名")
    @ColumnWidth(20)
    @ExcelProperty("报停人员姓名")
    private String customerName;
    /**
     * 报停申请人员
     */
    @ApiModelProperty(value = "报停申请人员")
    @ColumnWidth(20)
    @ExcelProperty("报停申请人员")
    private String btApplyName;
    /**
     * 报停电话
     */
    @ApiModelProperty(value = "报停电话")
    @ColumnWidth(20)
    @ExcelProperty("报停电话")
    private String phone;
    /**
     * 报停时间
     */
    @ApiModelProperty(value = "报停时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ColumnWidth(20)
    @ExcelProperty("报停时间")
    private Date applyDate;
    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    @ColumnWidth(20)
    @ExcelProperty("备注说明")
    private String remark;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    @ColumnWidth(10)
    @ExcelProperty("操作人员编码")
    private String operatorOcode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    @ColumnWidth(10)
    @ExcelProperty("操作人员姓名")
    private String operatorOname;

    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ColumnWidth(20)
    @ExcelProperty("操作时间")
    private Date operatorDate;
    /**
     * 恢复用水标志（默认为0,1是已恢复）
     */
    @ApiModelProperty(value = "恢复用水标志（默认为0,1是已恢复）")
    @ColumnWidth(10)
    @ExcelProperty("恢复用水标志")
    private String hfysFlag;
    /**
     * 恢复报停时间
     */
    @ApiModelProperty(value = "恢复报停时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ColumnWidth(20)
    @ExcelProperty("恢复报停时间")
    private Date hfbtDate;

}
