/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户基本信息
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_CUSTOMER", resultMap = "daCustomerMap")
@KeySequence("TF_YWYS_DA_CUSTOMER")
@ApiModel
public class DaCustomer extends Model<DaCustomer> {
    private static final long serialVersionUID = 1L;

    /**
     * 客户编号
     */
    @TableId(value = "CUSTOMER_NO", type = IdType.INPUT)
    @ApiModelProperty(value = "客户编号")
    private String customerNo;
    /**
     * 原客户号
     */
    @ApiModelProperty(value = "原客户号")
    private String customerNoOld;
    /**
     * 所属分公司
     */
    @ApiModelProperty(value = "所属分公司")
    private String companyBranch;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    private BigDecimal mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    private BigDecimal mrBook;
    /**
     * 申请日期
     */
    @ApiModelProperty(value = "申请日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date applyDatetime;
    /**
     * 客户姓名
     */
    @ApiModelProperty(value = "客户姓名")
    private String customerName;
    /**
     * 客户简码
     */
    @ApiModelProperty(value = "客户简码")
    private String customerNameShort;
    /**
     * 客户地址
     */
    @ApiModelProperty(value = "客户地址")
    private String customerAddress;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String customerPhone;
    /**
     * 客户数
     */
    @ApiModelProperty(value = "客户数")
    private Long population;
    /**
     * 性别（1男，2女，3未知）[sys_child_code,pcid='9']
     */
    @ApiModelProperty(value = "性别（1男，2女，3未知）[sys_child_code,pcid='9']")
    private String sex;
    /**
     * 手机
     */
    @ApiModelProperty(value = "手机")
    private String customerMobile;
    /**
     * 住宅电话
     */
    @ApiModelProperty(value = "住宅电话")
    private String homePhone;
    /**
     * 工作单位
     */
    @ApiModelProperty(value = "工作单位")
    private String workUnit;
    /**
     * 办公电话
     */
    @ApiModelProperty(value = "办公电话")
    private String workTelephone;
    /**
     * 电子邮箱
     */
    @ApiModelProperty(value = "电子邮箱")
    private String email;
    /**
     * 证件类别(sys_child_code,pcid='10')
     */
    @ApiModelProperty(value = "证件类别(sys_child_code,pcid='10')")
    private String certType;
    /**
     * 证件号码
     */
    @ApiModelProperty(value = "证件号码")
    private String certNo;
    /**
     * 与户主关系
     */
    @ApiModelProperty(value = "与户主关系")
    private String relation;
    /**
     * 用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）
     */
    @ApiModelProperty(value = "用户状态（0:申请用户,1:正式用户,2:报停用户,3:销户用户,4:作废用户）")
    private String customerState;
    /**
     * 通水标志（0：未开通，1：已开通）
     */
    @ApiModelProperty(value = "通水标志（0：未开通，1：已开通）")
    private String activateState;
    /**
     * 通水日期
     */
    @ApiModelProperty(value = "通水日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date activateDatetime;
    /**
     * 合同签订
     */
    @ApiModelProperty(value = "合同签订")
    private String contractState;
    /**
     * 合同签订日期
     */
    @ApiModelProperty(value = "合同签订日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date contractDatetime;
    /**
     * 合同编号
     */
    @ApiModelProperty(value = "合同编号")
    private String contractNo;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 报装_工程编号
     */
    @ApiModelProperty(value = "报装_工程编号")
    private String bzNo;
    /**
     * 报装_批次序列号
     */
    @ApiModelProperty(value = "报装_批次序列号")
    private String bzSerialNo;
    /**
     * 建档时间
     */
    @ApiModelProperty(value = "建档时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createdDatetime;
    /**
     * 建档人员编码
     */
    @ApiModelProperty(value = "建档人员编码")
    private String createdOcode;
    /**
     * 建档人员姓名
     */
    @ApiModelProperty(value = "建档人员姓名")
    private String createdOname;
    /**
     * 建档批次序列号
     */
    @ApiModelProperty(value = "建档批次序列号")
    private String createdSerialNo;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    private String operatorCode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    private String operatorName;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date operatorDatetime;
    /**
     * 身份证图片
     */
    @ApiModelProperty(value = "身份证图片")
    private String pCert;
    /**
     * 合同图片
     */
    @ApiModelProperty(value = "合同图片")
    private String pContract;
    /**
     * 工商执照图片
     */
    @ApiModelProperty(value = "工商执照图片")
    private String pBusLicense;
    /**
     * 房产证图片
     */
    @ApiModelProperty(value = "房产证图片")
    private String pPropeertyOwnershipCert;
    /**
     * 有效证件图片
     */
    @ApiModelProperty(value = "有效证件图片")
    private String pValidCert;
    /**
     * 信用等级（sys_child_code,pcid='20'）
     */
    @ApiModelProperty(value = "信用等级（sys_child_code,pcid='20'）")
    private String creditRating;
    /**
     * 是否特困户（1是，0否）
     */
    @ApiModelProperty(value = "是否特困户（1是，0否）")
    private String isPoorHouseholds;
    /**
     * 抄表人员姓名
     */
    @ApiModelProperty(value = "抄表人员姓名")
    private String mrOname;
    /**
     * 行政规划区域
     */
    @ApiModelProperty(value = "行政规划区域")
    private String regionCode;
    /**
     * 发票开具银行账号
     */
    @ApiModelProperty(value = "发票开具银行账号")
    private String invoiceBankAccount;
    /**
     * 发票开具银行名称
     */
    @ApiModelProperty(value = "发票开具银行名称")
    private String invoiceBankName;
    /**
     * 发票开具姓名
     */
    @ApiModelProperty(value = "发票开具姓名")
    private String invoiceName;
    /**
     * 发票开具纳税人识别号
     */
    @ApiModelProperty(value = "发票开具纳税人识别号")
    private String invoiceNsrsbh;
    /**
     * 发票开具地址
     */
    @ApiModelProperty(value = "发票开具地址")
    private String invoiceAddress;
    /**
     * 发票开具电话
     */
    @ApiModelProperty(value = "发票开具电话")
    private String invoicePhone;
    /**
     * 发票开具备注
     */
    @ApiModelProperty(value = "发票开具备注")
    private String invoiceRemark;
    /**
     * 开票类型
     */
    @ApiModelProperty(value = "开票类型")
    private String invoiceType;
    /**
     * 付费方式
     */
    @ApiModelProperty(value = "付费方式")
    private String payMode;
    /**
     * 年度累计量
     */
    @ApiModelProperty(value = "年度累计量")
    private BigDecimal yearCumQuantity;
    /**
     * 月累积量
     */
    @ApiModelProperty(value = "月累积量")
    private BigDecimal monthCumQuantity;
    /**
     * 客户类型（弱势群体，残疾，正常，低保，企业，服务）
     */
    @ApiModelProperty(value = "客户类型（弱势群体，残疾，正常，低保，企业，服务）")
    private String customerType;

    @ApiModelProperty(value = "水表数")
    private BigDecimal meterNumber;

}
