/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 用户基本信息
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_CUSTOMER", resultMap = "daCustomerMap")
@KeySequence("TF_YWYS_DA_CUSTOMER")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DaCustomerExcel extends Model<DaCustomerExcel> {

    @ColumnWidth(10)
    @ApiModelProperty(value = "序号")
    @ExcelProperty("序号")
    private String number;

    @ColumnWidth(30)
    @ApiModelProperty(value = "用户编号")
    @ExcelProperty("用户编号")
    private String customerNo;

    @ColumnWidth(30)
    @ApiModelProperty(value = "用户姓名")
    @ExcelProperty("用户姓名")
    private String customerName;

    @ColumnWidth(30)
    @ApiModelProperty(value = "用户地址")
    @ExcelProperty("用户地址")
    private String customerAddress;

    @ColumnWidth(30)
    @ApiModelProperty(value = "联系电话")
    @ExcelProperty("联系电话")
    private String telephone;

    @ColumnWidth(30)
    @ApiModelProperty(value = "证件号码")
    @ExcelProperty("证件号码")
    private String certNo;

    @ColumnWidth(30)
    @ApiModelProperty(value = "申请日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("申请日期")
    private String applyDate;

    @ColumnWidth(30)
    @ApiModelProperty(value = "水表编号")
    @ExcelProperty("水表编号")
    private String meterNo;

    @ColumnWidth(30)
    @ApiModelProperty(value = "水表口径")
    @ExcelProperty("水表口径")
    private String caliber;



    @ColumnWidth(30)
    @ApiModelProperty(value = "出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("出厂日期")
    private String meterFactoryDatetime;

    @ColumnWidth(30)
    @ApiModelProperty(value = "水表起数")
    @ExcelProperty("水表起数")
    private String startingPoint;



}
