/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.KeySequence;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 用户基本信息
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_CUSTOMER", resultMap = "daCustomerMap")
@KeySequence("TF_YWYS_DA_CUSTOMER")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DaCustomerSelect extends Model<DaCustomerSelect> {

    @ColumnWidth(20)
    @ExcelProperty("所属公司")
    @ExcelIgnore
    private String companyBranch;
    @ColumnWidth(20)
    @ExcelProperty("所属片区")
    @ExcelIgnore
    private String mrArea;
    @ColumnWidth(20)
    @ExcelProperty("所属抄表册")
    @ExcelIgnore
    private String mrBook;
    @ColumnWidth(20)
    @ExcelProperty("所属片区名称")
    private String mrAreaName;
    @ColumnWidth(20)
    @ExcelProperty("所属抄表册名称")
    private String mrBookName;
    @ColumnWidth(20)
    @ExcelProperty("用户编号")
    private String customerNo;
    @ColumnWidth(20)
    @ExcelProperty("原用户编号")
    private String customerNoOld;
    @ColumnWidth(50)
    @ExcelProperty("用户姓名")
    private String customerName;
    @ColumnWidth(50)
    @ExcelProperty("用户地址")
    private String customerAddress;
    @ColumnWidth(20)
    @ExcelProperty("联系电话")
    private String customerPhone;
    @ColumnWidth(20)
    @ExcelProperty("申请日期")
    private String applyDatetime;
    @ColumnWidth(20)
    @ExcelProperty("建档日期")
    private String createdDatetime;
    @ColumnWidth(20)
    @ExcelProperty("建档人员")
    private String createdOname;
    //@ColumnWidth(20)
    //@ExcelProperty("水表数")
    @ExcelIgnore
    private String meterNumber;
    @ColumnWidth(20)
    @ExcelProperty("用户状态")
    private String customerState;
    //@ColumnWidth(20)
    //@ExcelProperty("上次读数")
    @ExcelIgnore
    private String lastReading;
    //@ColumnWidth(20)
    // @ExcelProperty("本次读数")
    @ExcelIgnore
    private String thisReading;

    /**
     * 忽略这个字段
     */
    @ExcelIgnore
    private String cbkhList;
    /**
     * 忽略这个字段
     */
    @ExcelIgnore
    private String meterCardId;

    @ExcelIgnore
    private  String priceName;

    @ExcelIgnore
    private String  meterTypeName;

    @ColumnWidth(1)
    @ExcelProperty("证件类别")
    @ExcelIgnore
    private String certType;
    @ColumnWidth(20)
    @ExcelProperty("证件号码")
    private String certNo;

    @ExcelIgnore
    private String invoiceType;
}
