/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户过户日志
 *
 * @author sxb
 * @date Thu Jun 15 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_GH_LOG", resultMap = "daGhLogMap")
@KeySequence("TF_YWYS_DA_GH_LOG")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DaGhLog extends Model<DaGhLog> {
    private static final long serialVersionUID = 1L;


    /**
     * 编号
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "编号")
    @ExcelProperty("编号")
    @ExcelIgnore
    private String id;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    @ExcelProperty("所属公司")
    @ColumnWidth(10)
    private String companyBranch;

    /**
     * 片区
     */
    @ApiModelProperty(value = "所属片区")
    @ExcelProperty("所属片区")
    @ColumnWidth(10)
    private String mrArea;
    /**
     * 抄表本
     */
    @ApiModelProperty(value = "抄表册")
    @ExcelProperty("抄表册")
    @ColumnWidth(10)
    private String mrBook;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @ExcelProperty("用户编号")
    @ColumnWidth(10)
    private String customerNo;
    /**
     * 原用户地址
     */
    @ApiModelProperty(value = "原用户地址")
    @ExcelProperty("原用户地址")
    @ColumnWidth(30)
    private String oldCustomerAddr;
    /**
     * 原用户姓名
     */
    @ApiModelProperty(value = "原用户姓名")
    @ExcelProperty("原用户姓名")
    @ColumnWidth(30)
    private String oldCustomerName;
    /**
     * 原联系电话
     */
    @ApiModelProperty(value = "原联系电话")
    @ExcelProperty("原联系电话")
    @ColumnWidth(20)
    private String oldPhone;
    /**
     * 原证件类别
     */
    @ApiModelProperty(value = "原证件类别")
    @ExcelProperty("原证件类别")
    @ColumnWidth(10)
    private String oldCertType;
    /**
     * 原证件号码
     */
    @ApiModelProperty(value = "原证件号码")
    @ExcelProperty("原证件号码")
    @ColumnWidth(20)
    private String oldCertNo;
    /**
     * 新用户姓名
     */
    @ApiModelProperty(value = "新用户姓名")
    @ExcelProperty("新用户姓名")
    @ColumnWidth(30)
    private String newCustomerName;
    /**
     * 新联系电话
     */
    @ApiModelProperty(value = "新联系电话")
    @ExcelProperty("新联系电话")
    @ColumnWidth(10)
    private String newCustomerPhone;
    /**
     * 新证件类别
     */
    @ApiModelProperty(value = "新证件类别")
    @ExcelProperty("新证件类别")
    @ColumnWidth(10)
    private String newCertType;
    /**
     * 新证件号码
     */
    @ApiModelProperty(value = "新证件号码")
    @ExcelProperty("新证件号码")
    @ColumnWidth(20)
    private String newCertNo;
    /**
     * 操作时间
     */
    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("操作时间")
    @ColumnWidth(20)
    private Date operatorDate;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    @ExcelProperty("操作人员编码")
    @ExcelIgnore
    private String operatorOcode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    @ExcelProperty("操作人员姓名")
    @ColumnWidth(10)
    private String operatorOname;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    @ExcelProperty("备注")
    @ColumnWidth(30)
    private String remark;
    /**
     * 类型（1：更名，2：过户）
     */
    @ApiModelProperty(value = "类型（1：更名，2：过户）")
    @ExcelProperty("类型")
    @ColumnWidth(10)
    private String operatorType;
    /**
     * 发票开具纳税人识别号
     */
    @ApiModelProperty(value = "发票开具纳税人识别号")
    @ExcelIgnore
    private String oldFpNsrsbh;
    /**
     * 发票开具地址
     */
    @ApiModelProperty(value = "发票开具地址")
    @ExcelIgnore
    private String oldFpAddr;
    /**
     * 发票开具姓名
     */
    @ApiModelProperty(value = "发票开具姓名")
    @ExcelIgnore
    private String oldFpName;
    /**
     * 发票开具联系电话
     */
    @ApiModelProperty(value = "发票开具联系电话")
    @ExcelIgnore
    private String oldFpPhone;
    /**
     * 发票开具开户行
     */
    @ApiModelProperty(value = "发票开具开户行")
    @ExcelIgnore
    private String oldFpBankName;
    /**
     * 发票开具备注
     */
    @ApiModelProperty(value = "发票开具备注")
    @ExcelIgnore
    private String oldFpRemark;
    /**
     * 发票开具银行账号
     */
    @ApiModelProperty(value = "发票开具银行账号")
    @ExcelIgnore
    private String oldFpBankAccount;
    /**
     * 发票开具纳税人识别号
     */
    @ApiModelProperty(value = "发票开具纳税人识别号")
    @ExcelIgnore
    private String newFpNsrsbh;
    /**
     * 发票开具地址
     */
    @ApiModelProperty(value = "发票开具地址")
    @ExcelIgnore
    private String newFpAddr;
    /**
     * 发票开具姓名
     */
    @ApiModelProperty(value = "发票开具姓名")
    @ExcelIgnore
    private String newFpName;
    /**
     * 发票开具联系电话
     */
    @ApiModelProperty(value = "发票开具联系电话")
    @ExcelIgnore
    private String newFpPhone;
    /**
     * 发票开具开户行
     */
    @ApiModelProperty(value = "发票开具开户行")
    @ExcelIgnore
    private String newFpBankName;
    /**
     * 发票开具备注
     */
    @ApiModelProperty(value = "发票开具备注")
    @ExcelIgnore
    private String newFpRemark;
    /**
     * 发票开具银行账号
     */
    @ApiModelProperty(value = "发票开具银行账号")
    @ExcelIgnore
    private String newFpBankAccount;
    /**
     * 新用户地址
     */
    @ApiModelProperty(value = "新用户地址")
    @ExcelProperty("新用户地址")
    private String newCustomerAddr;

}
