/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户恢复用水日志
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_DA_HFYS_LOG", resultMap = "daHfysLogMap")
@KeySequence("TF_YWYS_DA_HFYS_LOG")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DaHfysLog extends Model<DaHfysLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "编号")
    @ExcelIgnore
    private String id;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    @ExcelProperty("所属公司")
    @ColumnWidth(10)
    private String companyBranch;
    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    @ExcelProperty("所属抄表片区")
    @ColumnWidth(10)
    private String mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    @ExcelProperty("所属抄表本")
    @ColumnWidth(10)
    private String mrBook;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @ExcelProperty("用户编号")
    @ColumnWidth(20)
    private String customerNo;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    @ExcelProperty("用户姓名")
    @ColumnWidth(30)
    private String customerName;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    @ExcelProperty("用户地址")
    @ColumnWidth(30)
    private String customerAddr;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    @ExcelProperty("联系电话")
    @ColumnWidth(30)
    private String phone;
    /**
     * 申请日期
     */
    @ApiModelProperty(value = "申请日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("申请日期")
    @ColumnWidth(30)
    private Date applyDate;
    /**
     * 恢复费用金额
     */
    @ApiModelProperty(value = "恢复费用金额")
    @ExcelProperty("恢复费用金额")
    @ColumnWidth(30)
    private Double restoreAmont;
    /**
     * 发票组
     */
    @ApiModelProperty(value = "发票组")
    @ExcelProperty("发票组")
    @ColumnWidth(30)
    private String invoiceGroup;
    /**
     * 发票号
     */
    @ApiModelProperty(value = "发票号")
    @ExcelProperty("发票号")
    @ColumnWidth(30)
    private String invoiceNo;
    /**
     * 打印次数
     */
    @ApiModelProperty(value = "打印次数")
    @ExcelProperty("打印次数")
    @ColumnWidth(30)
    private BigDecimal printTimes;
    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    @ExcelProperty("备注说明")
    @ColumnWidth(30)
    private String remark;
    /**
     * 收费人员姓名
     */
    @ApiModelProperty(value = "收费人员姓名")
    @ExcelProperty("收费人员姓名")
    @ColumnWidth(30)
    private String chargeOname;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    @ExcelIgnore
    private String operatorOcode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    @ExcelProperty("操作人员姓名")
    @ColumnWidth(30)
    private String operatorOname;

    @ApiModelProperty(value = "操作日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("操作日期")
    @ColumnWidth(30)
    private Date operatorDate;
}
