/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.userprofilemgt.entity;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.ContentRowHeight;
import com.alibaba.excel.annotation.write.style.HeadRowHeight;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 用户销户记录
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_YWYS_DA_XH_LOG",resultMap = "dahLogMap")
@KeySequence("TF_YWYS_DA_XH_LOG")
@ApiModel
@ContentRowHeight(20)
@HeadRowHeight(20)
@ColumnWidth(30)
public class DahLog extends Model<DahLog> {
    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID",type= IdType.INPUT)
    @ApiModelProperty(value = "编号")
    @ExcelIgnore
    private String id;
    /**
     * 所属公司
     */
    @ApiModelProperty(value = "所属公司")
    @ExcelProperty("所属公司")
    @ColumnWidth(10)
    private String companyBranch;

    /**
     * 所属抄表片区
     */
    @ApiModelProperty(value = "所属抄表片区")
    @ExcelProperty("所属抄表片区")
    @ColumnWidth(10)
    private String mrArea;
    /**
     * 所属抄表本
     */
    @ApiModelProperty(value = "所属抄表本")
    @ExcelProperty("所属抄表本")
    @ColumnWidth(10)
    private String mrBook;

    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @ExcelProperty("用户编号")
    @ColumnWidth(20)
    private String customerNo;
    /**
     * 用户地址
     */
    @ApiModelProperty(value = "用户地址")
    @ExcelProperty("用户编号")
    @ColumnWidth(30)
    private String costomerAddr;
    /**
     * 用户姓名
     */
    @ApiModelProperty(value = "用户姓名")
    @ExcelProperty("用户姓名")
    @ColumnWidth(30)
    private String customerName;
    /**
     * 申请人员
     */
    @ApiModelProperty(value = "申请人员")
    @ExcelProperty("申请人员")
    @ColumnWidth(30)
    private String applyName;
    /**
     * 电话
     */
    @ApiModelProperty(value = "电话")
    @ExcelProperty("电话")
    @ColumnWidth(20)
    private String phone;
    /**
     * 申请时间
     */
    @ApiModelProperty(value = "申请时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("申请时间")
    @ColumnWidth(30)
    private Date applyDate;
    /**
     * 备注说明
     */
    @ApiModelProperty(value = "备注说明")
    @ExcelProperty("备注说明")
    @ColumnWidth(30)
    private String remark;
    /**
     * 操作人员编码
     */
    @ApiModelProperty(value = "操作人员编码")
    @ExcelIgnore
    private String operatorOcode;
    /**
     * 操作人员姓名
     */
    @ApiModelProperty(value = "操作人员姓名")
    @ExcelProperty("操作人员姓名")
    @ColumnWidth(20)
    private String operatorOname;

    @ApiModelProperty(value = "操作时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ExcelProperty("操作时间")
    @ColumnWidth(20)
    private Date operatorDate;
    /**
     * 水表止度
     */
    @ApiModelProperty(value = "水表止度")
    @ExcelProperty("水表止度")
    @ColumnWidth(20)
    private String meterThisReading;

}
