/*
 * Author: wangjian
 * 生成mapper
 */
package com.tofly.fees.userprofilemgt.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.fees.userprofilemgt.entity.DaCustomer;
import com.tofly.fees.userprofilemgt.entity.DaCustomerSelect;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 用户基本信息
 *
 * @author sxb
 * @date Tue May 23 00:00:00 CST 2023
 */
@Repository //持久化
public interface DaCustomerMapper extends BaseMapper<DaCustomer> {

    //当前用户是否存在多只表
    List<Map<String,Object>> selectCardNo (String customer_no);

    //获取当前财务日期
    Map<String,Object> selectYearMonth();
    //用户编号已存在
     int selectExistCustomerNo(String customer_no);
    //获取最大max用户编号
    int selectMaxCustomerNo();

    //自定义分页查询用户档案查询
    Page<DaCustomerSelect> selectDaCustomerPage(@Param("page") Page<DaCustomerSelect> page, String searchText, String mr_area, String mr_book, String meter_model, String price_code, String customer_state, String garbage_fee_flag, String start_created_datetime, String end_created_datetime, String mr_ocode,String companyBranch);
    //自定义查询Excel 数据导出

    List<DaCustomerSelect> selectDaCustomerPage(String searchText, String mr_area, String mr_book, String meter_model, String price_code, String customer_state, String garbage_fee_flag, String start_created_datetime, String end_created_datetime, String mr_ocode,String companyBranch);

      /**
         * @MethodName selDaCustomerAcc
         * @Description 查询用户余额信息
         * @Author xb
         * @Date 17:37 2023-07-25
         */ 
   HashMap<String,Object> selDaCustomerAcc(String customerNo);
      /**
         * @MethodName selCusPriceInfo
         * @Description 查询用户信息   
         * @Author xb
         * @Date 17:36 2023-07-25
         */ 
    Page<List<HashMap<String, Object>>> selCusPriceInfo(Page<HashMap<String, Object>> page,@Param("searchText") String searchText,@Param("mrArea") String mrArea,@Param("mrBook") String mrBook);
}
