package com.tofly.fees.wechatbasicmgt.entity;/*
 * Author: wangjian
 * 生成entity
 */

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 微信推送停水通知
 *
 * @author sxb
 * @date Mon Jun 05 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_YWYS_WX_TS_NOTICE",resultMap = "wxTsNoticeMap")
@KeySequence("TF_YWYS_WX_TS_NOTICE")
@ApiModel
public class WxTsNotice extends Model<WxTsNotice> {
    private static final long serialVersionUID = 1L;

        /**
     * ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "ID")
                private Integer id;
                /**
     * 编辑时间
     */
            @ApiModelProperty(value = "编辑时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date editDate;
                /**
     * 编辑账号
     */
            @ApiModelProperty(value = "编辑账号")
                private String editCode;
                /**
     * 编辑人员
     */
            @ApiModelProperty(value = "编辑人员")
                private String editName;
                /**
     * 标题
     */
            @ApiModelProperty(value = "标题")
                private String title;
                /**
     * 发送状态，0未发送，1已发送
     */
            @ApiModelProperty(value = "发送状态，0未发送，1已发送")
                private String state;
                /**
     * 停水类型，0计划停水，1 临时停水
     */
            @ApiModelProperty(value = "停水类型，0计划停水，1 临时停水")
                private String stopType;
                /**
     * 停水区域
     */
            @ApiModelProperty(value = "停水区域")
                private String stopArea;
                /**
     * 停水时间
     */
            @ApiModelProperty(value = "停水时间")
                private String stopTime;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String remark;
                /**
     * 恢复用水时间
     */
            @ApiModelProperty(value = "恢复用水时间")
                private String restoreTime;
                /**
     * 恢复用水状态 0 未恢复，1 已恢复
     */
            @ApiModelProperty(value = "恢复用水状态 0 未恢复，1 已恢复")
                private String restoreState;
                /**
     * 复水备注
     */
            @ApiModelProperty(value = "复水备注")
                private String restoreRemark;
                /**
     * 审核标志：0未审核，1 审核
     */
            @ApiModelProperty(value = "审核标志：0未审核，1 审核")
                private String auditFlag;
                /**
     * 审核结果
     */
            @ApiModelProperty(value = "审核结果")
                private String auditResult;
                /**
     * 审核人员编码
     */
            @ApiModelProperty(value = "审核人员编码")
                private String auditCode;
                /**
     * 审核人员
     */
            @ApiModelProperty(value = "审核人员")
                private String auditName;
                /**
     * 审核日期
     */
            @ApiModelProperty(value = "审核日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date auditDate;
                /**
     * 审核备注
     */
            @ApiModelProperty(value = "审核备注")
                private String auditRemark;
                /**
     * 打印次数
     */
            @ApiModelProperty(value = "打印次数")
                private BigDecimal printTimes;
                /**
     * 延迟原因
     */
            @ApiModelProperty(value = "延迟原因")
                private String delayReason;
                /**
     * 延迟备注
     */
            @ApiModelProperty(value = "延迟备注")
                private String delayRemark;
            
}
