/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.fees.wechatofficalacctmgt.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.fees.common.Ftp.FtpConfig;
import com.tofly.fees.common.Ftp.FtpService;
import com.tofly.fees.wechatofficalacctmgt.entity.WxGhsq;
import com.tofly.fees.wechatofficalacctmgt.service.WxGhsqService;
import lombok.AllArgsConstructor;
import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPReply;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
/**
 * 微信-更名过户申请
 *
 * @author sxb
 * @date Thu Jul 06 00:00:00 CST 2023
 */
@RestController
/*@AllArgsConstructor*/
@RequestMapping("/api/wechatofficalacctmgt/wxghsq")
@Api(tags="微信-更名过户申请接口")
public class WxGhsqController {



   // private final  WxGhsqService wxGhsqService;
@Autowired
private  WxGhsqService wxGhsqService;


    @Value("${ftp.server}")
    private String server;
    @Value("${ftp.port}")
    private int port;
    @Value("${ftp.userName}")
    private String userName;
    @Value("${ftp.password}")
    private String password;
    /**
    * 分页查询
    * @param page 分页对象
    * @param wxGhsq 微信-更名过户申请
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getWxGhsqPage(Page page, @ModelAttribute WxGhsq wxGhsq) {
      return ResultRespone.success(wxGhsqService.page(page, Wrappers.query(wxGhsq)));
    }



    @PostMapping("/upload")
    @ApiOperation(value = "附件上传")
    public ResultRespone uploadFile(@RequestParam("file") MultipartFile file) {
        FTPClient ftpClient = new FTPClient();
        try {
            ftpClient.setControlEncoding("UTF-8");
            // 设置FTP服务器的连接信息
            FtpConfig ftp=new FtpConfig();
           // ftp.getPort();
            ftpClient.connect("192.168.2.233", 21);
            ftpClient.login("ftpuser", "ftpuser");

            // 检查连接是否成功
            int replyCode = ftpClient.getReplyCode();
            if (!FTPReply.isPositiveCompletion(replyCode)) {
                return ResultRespone.failed("FTP连接失败");
            }

            // 设置文件上传的路径
            String remoteFilePath = "/ftppath";
           String fileName = file.getOriginalFilename();
            String remoteFileName = remoteFilePath + "/" + fileName;
            // 上传文件到FTP服务器
            InputStream inputStream = file.getInputStream();
            ftpClient.storeFile(remoteFileName, inputStream);
            inputStream.close();
            // 关闭FTP连接
            ftpClient.logout();
            ftpClient.disconnect();
            return ResultRespone.success("上传成功");
        } catch (IOException e) {
            e.printStackTrace();
            return ResultRespone.failed("上传失败");
        }

    }



    /**
     * 通过id查询微信-更名过户申请
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(wxGhsqService.getById(id));
    }

    /**
     * 新增微信-更名过户申请
     * @param wxGhsq 微信-更名过户申请
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增微信-更名过户申请" )
    @ApiOperation(value = "新增微信-更名过户申请")
    @PostMapping
    public ResultRespone save(@RequestBody WxGhsq wxGhsq) {
      return ResultRespone.success(wxGhsqService.save(wxGhsq));
    }

    /**
     * 修改微信-更名过户申请
     * @param wxGhsq 微信-更名过户申请
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改微信-更名过户申请" )
    @ApiOperation(value = "修改微信-更名过户申请")
    @PutMapping
    public ResultRespone updateById(@RequestBody WxGhsq wxGhsq) {
      return ResultRespone.success(wxGhsqService.updateById(wxGhsq));
    }

    /**
     * 通过id删除微信-更名过户申请
     * @param id id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除微信-更名过户申请" )
    @ApiOperation(value = "通过ID删除微信-更名过户申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable String id) {
      return ResultRespone.success(wxGhsqService.removeById(id));
    }

    /**
     * 通过id批量删除微信-更名过户申请
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除微信-更名过户申请" )
    @ApiOperation(value = "通过ID批量删除微信-更名过户申请")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeByIds(String ids) {
        return ResultRespone.success(wxGhsqService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
