/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.fees.wechatofficalacctmgt.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Getter;
import lombok.Setter;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 微信-报装申请
 *
 * @author admin
 * @date Mon Jun 12 00:00:00 CST 2023
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_YWYS_WX_BZSQ", resultMap = "wxBzsqMap")
@KeySequence("TF_YWYS_WX_BZSQ")
@ApiModel
public class WxBzsq extends Model<WxBzsq> {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")

    private String id;
    /**
     * 编号
     */
    @ApiModelProperty(value = "编号")
    private String bh;
    /**
     * 类型
     */
    @ApiModelProperty(value = "类型")
    private String type;
    /**
     * 微信openid
     */
    @ApiModelProperty(value = "微信openid")
    private String registerOpenid;
    /**
     * 登记名称
     */
    @ApiModelProperty(value = "登记名称")
    private String registerName;
    /**
     * 申请地址
     */
    @ApiModelProperty(value = "申请地址")
    private String registerAddress;
    /**
     * 联系电话
     */
    @ApiModelProperty(value = "联系电话")
    private String registerPhone;
    /**
     * 联系人
     */
    @ApiModelProperty(value = "联系人")
    private String registerContacts;
    /**
     * 用水性质
     */
    @ApiModelProperty(value = "用水性质")
    private String registerYsxz;
    /**
     * 证件号码
     */
    @ApiModelProperty(value = "证件号码")
    private String registerCertNo;
    /**
     * 具体内容
     */
    @ApiModelProperty(value = "具体内容")
    private String registerContext;
    /**
     * 登记日期
     */
    @ApiModelProperty(value = "登记日期",hidden = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date registerDate;
    /**
     * 处理人员
     */
    @ApiModelProperty(value = "处理人员")
    private String handleName;
    /**
     * 处理日期
     */
    @ApiModelProperty(value = "处理日期",hidden = true)
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date handleDate;
    /**
     * 处理结果
     */
    @ApiModelProperty(value = "处理结果")
    private String handleResult;
    /**
     * 状态:0未处理,1处理中,2已处理,3已作废
     */
    @ApiModelProperty(value = "状态:0未处理,1处理中,2已处理,3已作废")
    private String state;

}
